<?php
// $Id: admin/index.php,v.50 2007/03/01 19:59:00 tcnet Exp $ //
// Flash Media Player by Jeroen Wijering ( http://www.jeroenwijering.com ) is licensed under a Creative Commons License (http://creativecommons.org/licenses/by-nc-sa/2.0/) //
// It allows you to use and modify the script for noncommercial purposes. //
// You must share a like any modifications. // 
// For commercial use you must purchase a license from Jereon Wijering at http://www.jeroenwijering.com/?order=form. //
// By installing and using the WebShow module you agree that you will not use it to display, distribute
// or syndicate a third party's copyright protected media without the owner's permission.  
// The WebShow software is not to be used to display or syndicate illegal or copyright protected media content.
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit artists.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //
include '../../../include/cp_header.php';
if ( file_exists("../language/".$xoopsConfig['language']."/main.php") ) {
	include "../language/".$xoopsConfig['language']."/main.php";
} else {
	include "../language/english/main.php";
}
include '../include/functions.php';
include_once XOOPS_ROOT_PATH.'/class/xoopstree.php';
include_once XOOPS_ROOT_PATH."/class/xoopslists.php";
include_once XOOPS_ROOT_PATH."/class/xoopsformloader.php";
include_once XOOPS_ROOT_PATH.'/class/module.errorhandler.php'; 
include_once XOOPS_ROOT_PATH."/include/xoopscodes.php";
include_once XOOPS_ROOT_PATH."/class/uploader.php";
$myts =& MyTextSanitizer::getInstance();
$eh = new ErrorHandler;
$cattree = new XoopsTree($xoopsDB->prefix("webshow_cat"),"cid","pid");
$linktree = new XoopsTree($xoopsDB->prefix("webshow_links"),"lid","title");
$playertree = new XoopsTree($xoopsDB->prefix("webshow_player"),"playerid","playertitle");
//** Logo Config	
$allowed_mimetypes = array('image/gif', 'image/jpeg', 'image/pjpeg', 'image/x-png', 'image/png');
$logosize = 30000;
$logowidth = $xoopsModuleConfig['logowidth'];
$logoheight = $xoopsModuleConfig['logowidth'];  //Square images
$playerlogosize = 10000;
$playerlogowidth = 48;
$playerlogoheight = 48;

//** MAIN ADMIN INDEX
function webShow()
{
global $xoopsDB, $xoopsConfig, $xoopsModule, $xoopsModuleConfig, $cattree, $playertree, $linktree, $eh;
xoops_cp_header();
adminmenu(1);
echo "<table class='outer' width='100%'><tr><th>"._MD_ADMIN."</th></tr>";
//** Links Select
echo "<tr class='odd'><td><form method=get action=\"index.php\">";
$linktree->makeMySelBox('title', 'title', 0, 1, '','window.location="index.php?op=modLink&amp;lid="+this.value');
echo "<input type=\"button\" value=\""._MD_ADDNEWLINK."\" onClick=\"location='index.php?op=newLink'\"></form></td></tr>";		
//**Category Select	
echo "<tr class=\"odd\"><td><form method=get action=\"category.php\">";
$cattree->makeMySelBox("cattitle", "cattitle",0,1,"",'window.location="category.php?op=modCat&amp;cid="+this.value');
echo "<input type=\"button\" value=\""._MD_ADDNEWCAT."\" onClick=\"location='category.php?op=newCat'\"></form></td></tr>";	
//**Player Select 		
echo "<tr class='odd'><td><form method=get action=\"player.php\">";
$playertree->makeMySelBox("playertitle","playertitle",0,1,"",'window.location="player.php?op=modPlayer&amp;playerid="+this.value');
echo "<input type=\"button\" value=\""._MD_ADDNEWPLAYER."\" onClick=\"location='player.php?op=newPlayer'\"></form></td></tr>";
//** Check Paths - code from PHPPP Article Module
echo "<tr class='odd'><td><div style='padding: 8px;'>";
$path_logo = XOOPS_ROOT_PATH . '/' . $xoopsModuleConfig['path_logo'];
$path_status = ws_admin_getPathStatus($path_logo);
echo "<label>" ._MD_PATH_LOGO .": </label><text>". $path_logo . ' ( ' . $path_status . ' )';
echo "</text><br />";
$path_media = XOOPS_ROOT_PATH."/modules/".$xoopsModule->getVar('dirname')."/".$xoopsModuleConfig['path_media'];
$path_status = ws_admin_getPathStatus($path_media);
echo "<label>" ._MD_PATH_MEDIA .": </label><text>". $path_media . ' ( ' . $path_status . ' )';
echo "</text><br />";
$path_playlist = XOOPS_ROOT_PATH."/modules/".$xoopsModule->getVar('dirname')."/playlist";
$path_status = ws_admin_getPathStatus($path_playlist);
echo "<label>" ._MD_PATH_PLAYLIST .": </label><text>". $path_playlist . " ( " . $path_status . " ) </text>";

//if(@is_dir($path_playlist)){
//   echo "<br /><br /><input type=\"button\" value=\""._MD_LISTCACHE_REFRESH."\" onClick=\"location='index.php?op=cacheAll'\">";			  
//}  //This is now in onUpdate script.

echo "</div></td></tr>";
//** Playlist Administration
$result = $xoopsDB->query("select count(*) from ".$xoopsDB->prefix("webshow_broken")."");
list($totalbrokenlinks) = $xoopsDB->fetchRow($result);
if($totalbrokenlinks>0){
	$totalbrokenlinks = "<span style='color: #ff0000; font-weight: bold'>$totalbrokenlinks</span>";
	}
$result2 = $xoopsDB->query("select count(*) from ".$xoopsDB->prefix("webshow_mod")."");
list($totalmodrequests) = $xoopsDB->fetchRow($result2);
if($totalmodrequests>0){
	$totalmodrequests = "<span style='color: #ff0000; font-weight: bold'>$totalmodrequests</span>";
	}
$result3 = $xoopsDB->query("select count(*) from ".$xoopsDB->prefix("webshow_links")." where status=0");
list($totalnewlinks) = $xoopsDB->fetchRow($result3);
if($totalnewlinks>0){
   $totalnewlinks = "<span style='color: #ff0000; font-weight: bold'>$totalnewlinks</span>";
}
echo "<tr class='odd'><td><a href=index.php?op=listNewLinks>"._MD_LINKSWAITING." ($totalnewlinks)</a> | <a href=index.php?op=listBrokenLinks>"._MD_BROKENREPORTS." ($totalbrokenlinks)</a> | <a href=index.php?op=listModReq>"._MD_MODREQUESTS." ($totalmodrequests)</a><br /></td></tr>";
//$result4 =$xoopsDB->query("select count(*) from ".$xoopsDB->prefix("webshow_links")." where status>0");
//list($numrows) = $xoopsDB->fetchRow($result4);
//echo "<tr class='even'><td>".printf(_MD_THEREARE,$numrows)."</td></tr>";		

//** MESSAGES
echo "<tr><td>"._MD_WEBSHOW_DISCLAIMER."<br /><br />"._MD_WEBSHOW_DSC." "._MD_JWFLASH."<br /><br />"._MD_WEBSHOW_GETSTARTED."</td></tr>";
xoops_cp_footer();
}

function menuLink()
{
global $xoopsDB, $xoopsModule, $eh, $myts;
$lid = isset($_GET['lid']) ? intval($_GET['lid']) : "";	
$modlid = $lid; //** MODID Highlights the entry that is active in the editor

//** Playlist Link Manager
$result=$xoopsDB->query("SELECT lid, title, status, published, expired FROM ".$xoopsDB->prefix('webshow_links')." WHERE lid>0 order by lid DESC");
   if($xoopsDB->getRowsNum($result) > 0){	
      echo "<table class='outer' style ='width: 700px; font-size: 90%;'><tr><th colspan='4'>"._MD_LINKMGMT."</th></tr>
	<tr class='head' colspan='4'>
	<td width='44px' align='center'><b>"._MD_ID."</b></td>
	<td width='316px'><b>"._MD_LINKTITLE."</b></td>
	<td width='240px'><b>"._MD_STATUSREPORT."</b></td>
	<td width='110px' align='center'><input type='button' value=\""._MD_ADDNEWLINK."\" onClick=\"location='index.php?op=newLink'\"></td></tr><tr><td colspan='5'><div style ='overflow: auto; height: 120px;'><table>";
	 while(list($lid, $title, $status, $published, $expired) = $xoopsDB->fetchRow($result)) {	 
   	     $title = $myts->makeTboxData4Show($title);
   	     $statusreport="";
   	     $statusicon = "online.gif";
   	          	      
	      if($status == 0){
	      // New Entry Waiting for Approval
   	      $statusreport = "<span style=\"color: #FFCC00;\">"._MD_STATUSWAITING."</span>";
   	      $statuslink = "admin/index.php?op=listNewLinks";
   	      $statusicon = "waiting.gif";
   	      }
   	       
  	      if($status == -1){
  	      // Entry will Auto-Publish
		  if($published > time()) {  	     
  	           $statusreport = "<span style=\"color: #FF0000; font-size: 90%;\">"._MD_STATUSAUTO.": ".formatTimestamp($published,'m')."</span>";
  	           $statuslink = "admin/index.php?op=modLink&amp;lid=".$lid;
  	           $statusicon = "offline.gif";   	           
  	        }elseif($published < time()) {		      
		      $xoopsDB->queryF("update ".$xoopsDB->prefix("webshow_links")." set status=1 where lid=".$lid."")  or $eh->show("0013");					
              }
  	      }
  	      
		if($expired < time() & $expired > 0) {
		// Entry has Expired
		$statusreport = "<span style=\"color: #FF0000; font-size: 90%;\">"._MD_STATUSEXPIRED.": ".formatTimestamp($expired,'m')."</span>";
  	      $statuslink = "admin/index.php?op=modLink&amp;lid=".$lid;
  	      $statusicon = "offline.gif";   
		$xoopsDB->queryF("update ".$xoopsDB->prefix("webshow_links")." set status=-2 where lid=".$lid."")  or $eh->show("0013");				
		}
		 
		$modresult=$xoopsDB->query("SELECT lid FROM ".$xoopsDB->prefix('webshow_mod')." WHERE lid=$lid");
		list($modrequest) = $xoopsDB->fetchRow($modresult); 	     
            if($modrequest){
            // Modification Requested
               $statusreport = "<span style=\"color: #009900; font-size: 90%;\">". _MD_USERMODREQ."</span>";
               $statuslink = "admin/index.php?op=listModReq";
            }            
          if($statusreport){
          $statusreport = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/".$statuslink."\" title=\""._MD_EDITTHISLINK."\">".$statusreport."</a>";          
          }
          if ($lid == $modlid) {
		//** MODID Highlights the entry that is active in the editor
		echo "<tr class='head' colspan='4'>";
	    }else{
   	    echo "<tr colspan='4'>";
   	    }	       	    
   	    echo "
   	    <td class = 'even' width='40px' align='right'>".$lid."</td>
   	    <td class = 'odd' width='320px'><a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/singlelink.php?lid=".$lid."\" title=\""._MD_VIEWLISTING."\" target=\"_blank\">".$title."</a></td>
   	    <td class = 'even' width='240px'>".$statusreport."</td>
   	    <td class = 'odd' width='100px' align='right'>
   	    <a href=\"index.php?lid=$lid&amp;op=modLink\" onClick=\"location='index.php?lid=$lid&amp;op=modLink'\" title=\""._MD_MODIFY."\"><img src=\"../images/modify.gif\"></a>
   	    <a href=\"index.php?lid=$lid&amp;op=delLink\" onClick=\"location='index.php?lid=$lid&amp;op=delLink'\" title=\""._MD_DELETE."\"><img src=\"../images/delete.gif\"></a>
   	    </td></tr>";     				 
   	 }
       echo "</table></div></td></tr></table><br />";
   }
} 

//** MAIN ADMIN PAGE
function newLink()
{
global $xoopsDB, $xoopsConfig, $xoopsModule, $xoopsModuleConfig, $xoopsUser, $myts, $eh, $playertree, $cattree, $linktree, $allowed_mimetypes, $logosize, $logowidth, $logoheight, $playerlogosize, $playerlogowidth, $playerlogoheight;
player1Exist();
//** Variables
$lid = "";
$cid = "0";
$title = "";
$artist = "";
$album ="";
$label="";
$listurl = "";
$listcache ="";
$cachetime = "604800";
$logolink = "";
$logourl = "";
$url = "";
$comments = 1;
$showinfo = 0;	
$description = "";
$bodytext = "";
$playerid = 1;
$chain = "0";	
$start = 0;
$shuffle = 0;
$replay = 0;
$link = 0;
$linktarget = "_self";
$stretch = "fit";
$enablejs = 0;
$captions = "";
$playerlogo = "";
$showicons = 1;
$showeq = 0;
$thumbslist = 0;
$shownav = 1;
$rotatetime = 5;
$transition = 0;
$published = 0;
$expired = 0;
//showinfo array =  description|logo|credits|statistics|submitter|pagelink|website|embedlink|downloadorwebfeed|popup|showinfobox|tags
$showinfo = "1|1|1|1|1|1|1|1|1|1|1|1"; 
$showinfo = explode("|",$showinfo);

$member_handler =& xoops_gethandler('member');
$xoopsgroups =& $member_handler->getgroups();
$count = count($xoopsgroups);
$ws_entryperm = array();
for ($i = 0; $i < $count; $i++)  $ws_entryperm[] = $xoopsgroups[$i]->getVar('groupid');

xoops_cp_header();
adminmenu(1);
//** ADMIN FORM
//Check that a category exists 
$result=$xoopsDB->query("select count(*) from ".$xoopsDB->prefix("webshow_cat")."");
list($numrows)=$xoopsDB->fetchRow($result);
 if ( $numrows == 0 ) {
     redirect_header("category.php",3,_MD_NOCAT);
     exit();	  
 } else { 
   menuLink();	
   $srctype = isset($_POST['srctype']) ? $_POST['srctype'] : '';
   $listtype = isset($_POST['listtype']) ? $_POST['listtype'] : '';    	
   if ($listtype == '') {			
   echo "<table class='outer' ><tr><td>";
   $mform = new XoopsThemeForm(_MD_ADDNEWLINK, "mediaform", XOOPS_URL.'/modules/'.$xoopsModule->getVar('dirname').'/admin/index.php?op=newLink', 'post');
   $mform->setExtra('enctype="multipart/form-data"');   
   //**SELECT PLAYLIST SOURCE
   $list_tray = new XoopsFormElementTray("<b>"._MD_LISTTYPE."</b>",'' );
   // example XoopsFormSelect($caption, $name, $value=null, $size=1, $multiple=false, $id="")
   $playlisttype=new XoopsFormSelect(_MD_LISTTYPE_DSC, 'listtype', 'feed', 1, false, $listtype);   
   $playlisttype->addOption('feed',_MD_LISTTYPE_FEED,false);		   
   $playlisttype->addOption('dir',_MD_LISTTYPE_DIR,false);
   $playlisttype->addOption('single',_MD_LISTTYPE_SINGLE,false);
   $list_tray->addElement($playlisttype, true);	
   $mform->addElement($list_tray);  
   //** Submit buttons
   $btnlabel = _MD_SUBMIT;
   $button_tray = new XoopsFormElementTray('' ,'');	
   $submit_btn = new XoopsFormButton('', 'post', $btnlabel, 'submit');
   $button_tray->addElement($submit_btn);
   $mform->addElement($button_tray);
   $mform->display();
   echo "</td></tr></table>";
   } elseif ($srctype =='' & $listtype != 'feed') {   
     echo "<table class='outer'><tr><td>";
     $mform = new XoopsThemeForm(_MD_ADDNEWLINK, "mediaform", XOOPS_URL.'/modules/'.$xoopsModule->getVar('dirname').'/admin/index.php?op=newLink', 'post');
     $mform->setExtra('enctype="multipart/form-data"');  
     //** LIST TYPE and URL
     if ($listtype == "feed") {
       $listtypename = _MD_LISTTYPE_FEED;
     }
     if ($listtype == "dir") {
       $listtypename = _MD_LISTTYPE_DIR;
     }
       if ($listtype == "single") {
       $listtypename = _MD_LISTTYPE_SINGLE;
     }
      $mform->addElement(new XoopsFormLabel("<b>"._MD_LISTTYPE."</b>",$listtypename));
      $mform->addElement(new XoopsFormHidden('listtype', $listtype), false);  
       //**SELECT MEDIA SOURCE          	
   	$source_tray = new XoopsFormElementTray("<b>"._MD_SRC."</b>",'' );
	//example XoopsFormSelect($caption, $name, $value=null, $size=1, $multiple=false, $id="")
	$sourcetype=new XoopsFormSelect(_MD_SRC_DSC, 'srctype', 'mp3', 1, false, $srctype);	   
	$sourcetype->addOption('mp3',_MD_SRC_MP3,false);		   
	$sourcetype->addOption('swf',_MD_SRC_SWF,false);
	$sourcetype->addOption('image',_MD_SRC_IMAGE,false);
	$sourcetype->addOption('flv',_MD_SRC_FLV,false);
      $source_tray->addElement($sourcetype, true);	
      $mform->addElement($source_tray);
      //** Submit buttons
     $btnlabel = _MD_SUBMIT;
     $button_tray = new XoopsFormElementTray('' ,'');	
     $submit_btn = new XoopsFormButton('', 'post', $btnlabel, 'submit');
     $button_tray->addElement($submit_btn);
     $mform->addElement($button_tray);
     $mform->display();
     echo "</td></tr></table>";  
     } else {
       //** NEW PLAYLIST FORM
       $wsformlabel =	_MD_ADDNEWLINK;	
       $wsformname = "newlinkform";
       $wsformaction = XOOPS_URL.'/modules/'.$xoopsModule->getVar('dirname').'/admin/index.php';
       $wsformmethod = "post";
       $wsformaddtoken = "false";	 			
       $op= 'addLink';
       $btnlabel = _MD_ADD;
       echo "<h3>"._MD_NEWLINK." "._MD_EDITOR."</h3>";
       echo "<table class='outer'><tr><td>";  
       include '../include/playlistform.inc.php';
       echo "</td></tr></table>";      
     }
   }	
xoops_cp_footer();	
}

//**Add NEW Link to DB
function addLink()
{
global $xoopsConfig, $xoopsDB, $myts, $xoopsUser, $xoopsModule, $xoopsModuleConfig, $eh, $allowed_mimetypes, $logosize, $logowidth, $logoheight, $playerlogosize, $playerlogowidth, $playerlogoheight;	
include '../include/playlist.php';  
$cid = $myts->makeTboxData4Save($_POST["cid"]);
$title = $myts->makeTboxData4Save($_POST["title"]);
$srctype = $myts->makeTboxData4Save($_POST["srctype"]);
$listtype = $myts->makeTboxData4Save($_POST["listtype"]);
if ( ($_POST["listurl"]) || ($_POST["listurl"]!="") ) {
    $listurl = $_POST["listurl"];
    if($listtype == "feed") {    
      $listurl = formatURL ($listurl);
    }  
    $listurl = $myts->makeTboxData4Save($listurl);    
}

//** SITE URL
  if ( ($_POST["url"]) || ($_POST["url"]!="") ) {
    $url = $_POST["url"];    
    $url = formatURL ($url);   
    $url = $myts->makeTboxData4Save($url);
  } else {
     $url = "";
  }

//** Cache Playlist Name - Name the playlist file.
if($listtype != "single") {
   $listcache = namePlaylist("",$title);
   $cachetime = "86400";    
} else {
$listcache = "";
$cachetime = "";
}	
$listcache = $myts->makeTboxData4Save($listcache);
$cachetime = $myts->makeTboxData4Save($cachetime);

//** PLAYLIST LOGO
$logourl = empty($logourl)?(empty($_POST['logourl'])?"":$_POST['logourl']):$logourl; 

//** LOGO Link from URL
$logolink =  isset($_POST['logolink']) ? $_POST['logolink'] : "";
if(!empty($logolink)){
   //$logolink = strtolower($logolink);
   $logolink = formatURL($logolink);  
   $logourl = $myts->makeTboxData4Save($logolink); 
}
//** LOGO UPLOAD
if (!empty($_FILES['userfile']['name'])) { 
//$uploader = new XoopsMediaUploader('/home/xoops/uploads', $allowed_mimetypes, $maxfilesize, $maxfilewidth, $maxfileheight);
$uploader = new XoopsMediaUploader(XOOPS_ROOT_PATH . "/".$xoopsModuleConfig['path_logo'], $allowed_mimetypes, $logosize, $logowidth, $logoheight);
   if ($uploader->fetchMedia($_POST['xoops_upload_file'][0])) {
      if (!$uploader->upload()) {
         echo $uploader->getErrors();
      } else {
       echo '<h4>'._MD_FILESUCCESS.'</h4>';
       $logourl = $uploader->getSavedFileName();
      }
   } else {
      echo $uploader->getErrors();
   }
}

$comments = $myts->makeTboxData4Save($_POST['comments']);

$artist = $myts->makeTboxData4Save($_POST["artist"]);
$album = $myts->makeTboxData4Save($_POST["album"]);
$label = $myts->makeTboxData4Save($_POST["label"]);
$chain = $myts->makeTboxData4Save($_POST["chain"]);

//**STATUS
$status = 1; //online
//** Publish/Expire code from Herve Thoussard News Module
if (!empty( $_POST['autodate'] )) {
   $publish_date=$_POST['publish_date'];
   $published = strtotime($publish_date['date']) + $publish_date['time']; 
   if($published > time()){
   $status = -1; //offline 
   }
} else {
   $published = time()-600;
}
$published = $myts->makeTboxData4Save($published);

if (!empty( $_POST['autoexpdate'] )) {
   $expiry_date=$_POST['expiry_date'];
   $expiry_date = strtotime($expiry_date['date']) + $expiry_date['time'];
   $offset = $xoopsUser -> timezone() - $xoopsConfig['server_TZ'];
   $expiry_date = $expiry_date - ( $offset * 3600 );
   $expired = $expiry_date;
} else {
    $expired = 0;
}	
$expired = $myts->makeTboxData4Save($expired);
$playerid = $myts->makeTboxData4Save($_POST["playerid"]);
$submitter = $xoopsUser->uid();

//** ws_entryperm
$ws_entryperm = $_POST['ws_entryperm'];
$ws_entryperm = (is_array($ws_entryperm)) ? implode(" ", $ws_entryperm) : '';
  
//** SHOW INFO
$showinfo = $_POST['showinfo'];
$showinfo = (is_array($showinfo)) ? implode("|", $showinfo) : '';

//** TEXT
$description = $myts->makeTareaData4Save($_POST["description"]);
$bodytext = $myts->makeTareaData4Save($_POST["bodytext"]);    

//** Error checks
$result = $xoopsDB->query("select count(*) from ".$xoopsDB->prefix("webshow_links")." where listurl='$listurl'");
list($numrows) = $xoopsDB->fetchRow($result);
$errormsg = "";
$error = 0;
    if ( $numrows > 0 ) {
	$errormsg .= "<h4 style='color: #ff0000'>";
	$errormsg .= _MD_ERROREXIST."</h4>";
	$error = 1;
    }
	// Check if Title exist
    if ( $title == "" ) {
	$errormsg .= "<h4 style='color: #ff0000'>";
	$errormsg .= _MD_ERRORTITLE."</h4>";
    	$error =1;
    }
	// Check if Playlist exist
    if ( $listurl == "" ) {
	$errormsg .= "<h4 style='color: #ff0000'>";
		$errormsg .= _MD_ERRORLINK."</h4>";
    	$error =1;
    }
	// Check if Description exist
    if ( $description == "" ) {
	$errormsg .= "<h4 style='color: #ff0000'>";
		$errormsg .= _MD_ERRORDESC."</h4>";
    	$error =1;
    } 
    if ( $error == 1 ) {
	xoops_cp_header();
	echo $errormsg;
	xoops_cp_footer();
	exit();
    }
       
//** FLASH VARIABLES
$mediatype = $myts->makeTboxData4Save($_POST["srctype"]);
$start = $myts->makeTboxData4Save($_POST["start"]);
$shuffle = $myts->makeTboxData4Save($_POST["shuffle"]); 
$replay = $myts->makeTboxData4Save($_POST["replay"]);
$link = $myts->makeTareaData4Save($_POST["link"]);
$linktarget = $myts->makeTboxData4Save($_POST["linktarget"]);  
$stretch = $myts->makeTboxData4Save($_POST["stretch"]);
$showicons = $myts->makeTboxData4Save($_POST["showicons"]);       
$showeq = $myts->makeTboxData4Save($_POST["showeq"]);
$enablejs = $myts->makeTboxData4Save($_POST["enablejs"]);
$thumbslist = $myts->makeTboxData4Save($_POST["thumbslist"]);
$transition = $myts->makeTboxData4Save($_POST["transition"]); 
$rotatetime = $myts->makeTboxData4Save($_POST['rotatetime']);
$shownav = $myts->makeTboxData4Save($_POST["shownav"]);
$captions = $myts->makeTboxData4Save( formatURL($_POST["captions"]));

//** PLAYERLOGO UPLOAD
$playerlogo = "";
  if (!empty($_FILES['userfile2']['name'])) { 
  //$uploader = new XoopsMediaUploader('/home/xoops/uploads', $allowed_mimetypes, $maxfilesize, $maxfilewidth, $maxfileheight);
  $uploader2 = new XoopsMediaUploader(XOOPS_ROOT_PATH ."/modules/".$xoopsModule->getVar('dirname')."/images/player", $allowed_mimetypes, $playerlogosize, $playerlogowidth, $playerlogoheight);
    if ($uploader2->fetchMedia($_POST['xoops_upload_file'][1])) {
      if (!$uploader2->upload()) {
         echo $uploader2->getErrors();
      } else {
         echo '<h4>'._MD_FILESUCCESS.'</h4>';
         $playerlogo = $uploader2->getSavedFileName();
      }
    } else {
      echo $uploader2->getErrors();
    }
  }
$playerlogo = empty($playerlogo)?(empty($_POST['playerlogo'])?"":$_POST['playerlogo']):$playerlogo;  

//** Generate new ID and insert data
$newid = $xoopsDB->genId($xoopsDB->prefix("webshow_links")."_lid_seq");
$sql = sprintf("INSERT INTO %s (lid, cid, title, url, srctype, listtype, listurl, listcache, showinfo, logourl, submitter, status, date, published, expired, hits, rating, votes, comments, player, chain, artist, album, label, cachetime, entryperm) VALUES (%u, %u, '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', %u, %u, %u, %u, %u, %u, %u, %u, %u, %u, %u, '%s', '%s', '%s', %u, '%s')", $xoopsDB->prefix("webshow_links"), $newid, $cid, $title, $url, $srctype, $listtype, $listurl, $listcache, $showinfo, $logourl, $submitter, $status, time(), $published, $expired, 0, 0, 0, $comments, $playerid, $chain, $artist, $album, $label, $cachetime, $ws_entryperm);
$xoopsDB->query($sql) or $eh->show("0013");
if ( $newid == 0 ) {
   $newid = $xoopsDB->getInsertId();
}

//**Insert Description and Text
$sql = sprintf("INSERT INTO %s (lid, description, bodytext) VALUES (%u, '%s', '%s')", $xoopsDB->prefix("webshow_text"), $newid, $description, $bodytext);
$xoopsDB->query($sql) or $eh->show("0013");

//**Insert Flash Variables
$sql = sprintf("INSERT INTO %s (lid, mediatype, start, shuffle, replay, link, linktarget, showicons, stretch, showeq, rotatetime, shownav, transition, thumbslist, captions, playerlogo, enablejs) VALUES (%u, '%s', %u, %u, %u, %u, '%s', %u, '%s', %u, %u, %u, '%s', %u, '%s', '%s', %u)", $xoopsDB->prefix("webshow_flashvar"), $newid, $mediatype, $start, $shuffle, $replay, $link, $linktarget, $showicons, $stretch, $showeq, $rotatetime, $shownav, $transition, $thumbslist, $captions, $playerlogo, $enablejs);
$xoopsDB->query($sql) or $eh->show("0013");

//** Save Tags requires Tag 1.60 module
$itemid=$newid;
$tag_handler = xoops_getmodulehandler('tag', 'tag');
$tag_handler->updateByItem($_POST["item_tag"], $itemid, $xoopsModule->getVar("dirname"), $catid =0);

//** Playlist feed - Fetch or create a playlist feed and save the file to path_playlist.
   if($listtype == "feed"){  
     fetchPlaylist($newid);
  }
  if($listtype == "dir"){ 
     createPlaylist($newid);
  } 
 
//** Notifications
$tags = array();
$tags['LINK_NAME'] = $title;
$tags['LINK_URL'] = XOOPS_URL . '/modules/'. $xoopsModule->getVar('dirname') . '/singlelink.php?cid=' . $cid . '&amp;lid=' . $newid;
$sql = "SELECT cattitle FROM " . $xoopsDB->prefix("webshow_cat") . " WHERE cid=" . $cid;
$result = $xoopsDB->query($sql);
$row = $xoopsDB->fetchArray($result);
$tags['CATEGORY_NAME'] = $row['cattitle'];
$tags['CATEGORY_URL'] = XOOPS_URL . '/modules/' . $xoopsModule->getVar('dirname') . '/viewcat.php?cid=' . $cid;
$notification_handler =& xoops_gethandler('notification');
$notification_handler->triggerEvent('global', 0, 'new_link', $tags);
$notification_handler->triggerEvent('category', $cid, 'new_link', $tags);

redirect_header("index.php?op=modLink&amp;lid=$newid",1,_MD_NEWLINKADDED);
}

function delLink()
{
   	global $xoopsDB, $eh, $xoopsModule;
   	include '../include/playlist.php';  
   	$lid =  isset($_POST['lid']) ? intval($_POST['lid']) : intval($_GET['lid']);
	$ok =  isset($_POST['ok']) ? intval($_POST['ok']) : 0;
    if ( $ok == 1 ) {
      deletePlaylist($lid);		
	$sql = sprintf("DELETE FROM %s WHERE lid = %u", $xoopsDB->prefix("webshow_links"), $lid);
   	$xoopsDB->query($sql) or $eh->show("0013");
	$sql = sprintf("DELETE FROM %s WHERE lid = %u", $xoopsDB->prefix("webshow_text"), $lid);
	$xoopsDB->query($sql) or $eh->show("0013");
	$sql = sprintf("DELETE FROM %s WHERE lid = %u", $xoopsDB->prefix("webshow_flashvar"), $lid);
	$xoopsDB->query($sql) or $eh->show("0013");
	$sql = sprintf("DELETE FROM %s WHERE lid = %u", $xoopsDB->prefix("webshow_votedata"), $lid);
	$xoopsDB->query($sql) or $eh->show("0013");
	// delete comments
	xoops_comment_delete($xoopsModule->getVar('mid'), $lid);
	// delete notifications
	xoops_notification_deletebyitem ($xoopsModule->getVar('mid'), 'link', $lid);
      redirect_header("index.php?op=newLink",1,_MD_LINKDELETED);
	exit();
    } else {
		xoops_cp_header();
		xoops_confirm(array('op' => 'delLink', 'lid' => $lid, 'ok' => 1), 'index.php', _MD_LINKWARNING);
		xoops_cp_footer();
    }		
}

function modLink()
{ 	
global $xoopsDB, $xoopsConfig, $xoopsUser, $xoopsModule, $xoopsModuleConfig, $myts, $eh, $cattree, $playertree, $linktree, $allowed_mimetypes, $logosize, $logowidth, $logoheight, $playerlogosize, $playerlogowidth, $playerlogoheight;
xoops_cp_header();
adminmenu(1);
menuLink();	
echo "<h3>"._MD_MODLINK." "._MD_EDITOR."</h3>";

$lid = $_GET['lid'];
$result = $xoopsDB->query("select cid, title, url, srctype, listtype, listurl, listcache, showinfo, logourl, player, chain, artist, album, label, cachetime, comments, expired, published, entryperm from ".$xoopsDB->prefix("webshow_links")." where lid=$lid") or $eh->show("0013");
list($cid, $title, $url, $srctype, $listtype, $listurl, $listcache, $showinfo, $logourl, $player, $chain, $artist, $album, $label, $cachetime, $comments, $expired, $published, $ws_entryperm) = $xoopsDB->fetchRow($result);
$listtype =  isset($_GET['listtype']) ? $_GET['listtype'] : $listtype;
$lid = $myts->makeTboxData4Edit($lid);
$cid = $myts->makeTboxData4Edit($cid);   	
$title = $myts->makeTboxData4Edit($title);
$url = $myts->makeTboxData4Edit($url);
$srctype = $myts->makeTboxData4Edit($srctype);
$listtype = $myts->makeTboxData4Edit($listtype);
$listurl = $myts->makeTboxData4Edit($listurl);
$listcache = $myts->makeTboxData4Edit($listcache);

//** Show Info
$showinfo = $myts->makeTboxData4Edit($showinfo);
$showinfo = explode("|", $showinfo);
  
$ps = strpos($logourl,"http://");
if($ps === false) {
$logourl = $myts->makeTboxData4Edit($logourl);
$logolink = "";
} else {
$logolink = $myts->makeTboxData4Edit($logourl);
}
$playerid = $myts->makeTboxData4Edit($player);
$chain = $myts->makeTboxData4Edit($chain);
$artist = $myts->makeTboxData4Edit($artist);
$album = $myts->makeTboxData4Edit($album);
$label = $myts->makeTboxData4Edit($label);
$cachetime = $myts->makeTboxData4Edit($cachetime);
$comments = $myts->makeTboxData4Edit($comments);
$expired = $myts->makeTboxData4Edit($expired);
$published = $myts->makeTboxData4Edit($published);
$ws_entryperm = explode(" ", $ws_entryperm);

//** TEXT    
$result2 = $xoopsDB->query("select description, bodytext from ".$xoopsDB->prefix("webshow_text")." where lid=$lid");
list($description, $bodytext)=$xoopsDB->fetchRow($result2);
$description = $myts->makeTareaData4Edit($description);
$bodytext = $myts->makeTareaData4Edit($bodytext);	
   
//** FLASH VARIABLES
$result3 = $xoopsDB->query("select start, shuffle, replay, link, linktarget, showicons, stretch, showeq, rotatetime, shownav, transition, thumbslist, captions, playerlogo, enablejs from ".$xoopsDB->prefix("webshow_flashvar")." where lid=$lid") or $eh->show("0013");
list($start, $shuffle, $replay, $link, $linktarget, $showicons, $stretch, $showeq, $rotatetime, $shownav, $transition, $thumbslist, $captions, $playerlogo, $enablejs)=$xoopsDB->fetchRow($result3);
$start = $myts->makeTboxData4Edit($start);
$shuffle = $myts->makeTboxData4Edit($shuffle); 
$replay = $myts->makeTboxData4Edit($replay);
$link = $myts->makeTboxData4Edit($link);
$linktarget = $myts->makeTboxData4Edit($linktarget);  
$showicons = $myts->makeTboxData4Edit($showicons);
$stretch = $myts->makeTboxData4Edit($stretch);       
$showeq = $myts->makeTboxData4Edit($showeq);
$rotatetime = $myts->makeTboxData4Edit($rotatetime);
$shownav = $myts->makeTboxData4Edit($shownav);    
$transition = $myts->makeTboxData4Edit($transition); 
$thumbslist = $myts->makeTboxData4Edit($thumbslist); 
$captions = $myts->makeTboxData4Edit($captions);
$playerlogo = $myts->makeTboxData4Edit($playerlogo);
$enablejs = $myts->makeTboxData4Edit($enablejs);	

//** MODIFY PLAYLIST FORM variables for playlistform.inc   
$wsformlabel =	_MD_MODLINK;
$wsformname = "modlinkform";
$wsformaction = XOOPS_URL.'/modules/'.$xoopsModule->getVar('dirname').'/admin/index.php';
$wsformmethod = "post";
$wsformaddtoken = "false";				
$op= 'modLinkS';
$btnlabel = _MD_MODIFY;		
echo "<table class='outer'><tr><td width='40%'>";

include '../include/playlistform.inc.php';
echo "</td></tr></table>";      
//** Stats
    $result5=$xoopsDB->query("SELECT count(*) FROM ".$xoopsDB->prefix("webshow_votedata")." WHERE lid = $lid");
    list($totalvotes) = $xoopsDB->fetchRow($result5);
    echo "<table width=100%>\n";
    echo "<tr><td colspan=7><b>";
	printf(_MD_TOTALVOTES,$totalvotes);
	echo "</b><br /><br /></td></tr>\n";
    // Show Registered Users Votes
    $result5=$xoopsDB->query("SELECT ratingid, ratinguser, rating, ratinghostname, ratingtimestamp FROM ".$xoopsDB->prefix("webshow_votedata")." WHERE lid = $lid AND ratinguser >0 ORDER BY ratingtimestamp DESC");
    $votes = $xoopsDB->getRowsNum($result5);
    echo "<tr><td colspan=7><br /><br /><b>";
	printf(_MD_USERTOTALVOTES,$votes);
	echo "</b><br /><br /></td></tr>\n";
    echo "<tr><td><b>" ._MD_USER."  </b></td><td><b>" ._MD_IP."  </b></td><td><b>" ._MD_RATING."  </b></td><td><b>" ._MD_USERAVG."  </b></td><td><b>" ._MD_TOTALRATE."  </b></td><td><b>" ._MD_DATE."  </b></td><td align=\"center\"><b>" ._MD_DELETE."</b></td></tr>\n";
    if ($votes == 0){
		echo "<tr><td align=\"center\" colspan=\"7\">" ._MD_NOREGVOTES."<br /></td></tr>\n";
    }
    $x=0;
    $colorswitch="dddddd";
    while(list($ratingid, $ratinguser, $rating, $ratinghostname, $ratingtimestamp)=$xoopsDB->fetchRow($result5)) {
		//	$ratingtimestamp = formatTimestamp($ratingtimestamp);
    	//Individual user information
    	$result2=$xoopsDB->query("SELECT rating FROM ".$xoopsDB->prefix("webshow_votedata")." WHERE ratinguser = '$ratinguser'");
        $uservotes = $xoopsDB->getRowsNum($result2);
        $useravgrating = 0;
        while ( list($rating2) = $xoopsDB->fetchRow($result2) ) {
			$useravgrating = $useravgrating + $rating2;
		}
        $useravgrating = $useravgrating / $uservotes;
        $useravgrating = number_format($useravgrating, 1);
		$ratingusername = XoopsUser::getUnameFromId($ratinguser);
        echo "<tr><td bgcolor=\"".$colorswitch."\">".$ratingusername."</td><td bgcolor=\"$colorswitch\">".$ratinghostname."</td><td bgcolor=\"$colorswitch\">$rating</td><td bgcolor=\"$colorswitch\">".$useravgrating."</td><td bgcolor=\"$colorswitch\">".$uservotes."</td><td bgcolor=\"$colorswitch\">".$ratingtimestamp."</td><td bgcolor=\"$colorswitch\" align=\"center\"><b>".myTextForm("index.php?op=delVote&lid=$lid&rid=$ratingid", "X")."</b></td></tr>\n";
    	$x++;
    	if ( $colorswitch == "dddddd" ) {
			$colorswitch="ffffff";
    	} else {
			$colorswitch="dddddd";
		}
    }
	// Show Unregistered Users Votes
    $result5=$xoopsDB->query("SELECT ratingid, rating, ratinghostname, ratingtimestamp FROM ".$xoopsDB->prefix("webshow_votedata")." WHERE lid = $lid AND ratinguser = 0 ORDER BY ratingtimestamp DESC");
    $votes = $xoopsDB->getRowsNum($result5);
    echo "<tr><td colspan=7><b><br /><br />";
	printf(_MD_ANONTOTALVOTES,$votes);
	echo "</b><br /><br /></td></tr>\n";
    echo "<tr><td colspan=2><b>" ._MD_IP."  </b></td><td colspan=3><b>" ._MD_RATING."  </b></td><td><b>" ._MD_DATE."  </b></b></td><td align=\"center\"><b>" ._MD_DELETE."</b></td><br /></tr>";
    if ( $votes == 0 ) {
		echo "<tr><td colspan=\"7\" align=\"center\">" ._MD_NOUNREGVOTES."<br /></td></tr>";
    }
    $x=0;
    $colorswitch="dddddd";
    while ( list($ratingid, $rating, $ratinghostname, $ratingtimestamp)=$xoopsDB->fetchRow($result5) ) {
		$formatted_date = formatTimestamp($ratingtimestamp);
        echo "<td colspan=\"2\" bgcolor=\"$colorswitch\">$ratinghostname</td><td colspan=\"3\" bgcolor=\"$colorswitch\">$rating</td><td bgcolor=\"$colorswitch\">$formatted_date</td><td bgcolor=\"$colorswitch\" aling=\"center\"><b>".myTextForm("index.php?op=delVote&lid=$lid&rid=$ratingid", "X")."</b></td></tr>";
    	$x++;
    	if ( $colorswitch == "dddddd" ) {
			$colorswitch="ffffff";
    	} else {
			$colorswitch="dddddd";
		}
    }
    echo "<tr><td colspan=\"6\">&nbsp;<br /></td></tr>\n";
    echo "</table>\n";
    echo"</td></tr></table>";
    xoops_cp_footer();
}

function modLinkS()
{
global $xoopsDB, $xoopsConfig, $xoopsModule, $xoopsUser, $xoopsModuleConfig, $myts, $eh, $allowed_mimetypes, $logosize, $logowidth, $logoheight, $playerlogosize, $playerlogowidth, $playerlogoheight;
include '../include/playlist.php';  
$lid = $_POST['lid'];
$cid = $_POST["cid"];
$title = $myts->makeTboxData4Save($_POST["title"]);
$srctype = $myts->makeTboxData4Save(isset($_POST['srctype']) ? $_POST['srctype'] : "");
$listtype = $myts->makeTboxData4Save($_POST["listtype"]);
if ( ($_POST["listurl"]) || ($_POST["listurl"]!="") ) {
    $listurl = $_POST["listurl"];
    if($listtype == "feed") {    
      $listurl = formatURL ($listurl);
    }  
    $listurl = $myts->makeTboxData4Save($listurl);    
}

//** SHOW INFO
$showinfo = isset($_POST['showinfo']) ? $_POST['showinfo'] : "";
   if (isset($showinfo)) {
      $showinfo = implode('|', $showinfo);
   }
    $showinfo = $myts->makeTboxData4Save($showinfo);  
       
//** CACHE PLAYLIST
$cachetime = "";
$listcache = isset($_POST['listcache']) ? $_POST['listcache'] : "";
$refreshlist = isset($_POST['refreshlist']) ? $_POST['refreshlist'] : "0";
$message = "";
if($listtype != "single") {
// Refresh the playlist file if it does not exist
  if (!file_exists(XOOPS_ROOT_PATH."/modules/".$xoopsModule->getVar("dirname")."/playlist/".$listcache)){ 
    $message .= "<br />"._MD_LISTCACHE_FILE." "._MD_NOTEXIST; 
     $refreshlist = 1;
  }    
// Refresh the playlist name if it does not exist in the db
 if ($listcache == "") {
     $message .= "<br />"._MD_LISTCACHE_NAME." "._MD_NOTEXIST; 
     $refreshlist = 1;
 }
// Refresh the playlist if cachetime has expired
$cachetime = isset($_POST['cachetime']) ? $_POST['cachetime'] : "86400";
 $cacheexpired = timePlaylist($listcache,$cachetime);
 if($cacheexpired > 0){
    $message .= "<br />"._MD_LISTCACHE_EXPIRED;
    $refreshlist = 1;
 }
// Refresh the playlist if the title changes
  $titleresult=$xoopsDB->query("select title from ".$xoopsDB->prefix("webshow_links")." where lid=$lid");
  list($origtitle)=$xoopsDB->fetchRow($titleresult);
  if ($title != $origtitle) {
    $message .= "<br />"._MD_TITLECHANGE.": New title: ".$title; 
     $refreshlist = 1;
  }
// Refresh the playlist if the media location changes
  $listurlresult=$xoopsDB->query("select listurl from ".$xoopsDB->prefix("webshow_links")." where lid=$lid");
  list($origlisturl)=$xoopsDB->fetchRow($listurlresult);
  if ($listurl != $origlisturl) {
    $message .= "<br />"._MD_LOCATIONCHANGE.": ".$listurl; 
     $refreshlist = 1;
  }
}
$listcache = $myts->makeTboxData4Save($listcache);
$cachetime = $myts->makeTboxData4Save($cachetime);
$comments = $myts->makeTboxData4Save($comments);		
$url = "";
if ( ($_POST["url"]) || ($_POST["url"]!="") ) {
    $url = $_POST["url"];    
    $url = formatURL ($url);  
    $url = $myts->makeTboxData4Save($url);    
}
//** PLAYLIST LOGO
$logourl = empty($logourl)?(empty($_POST['logourl'])?"":$_POST['logourl']):$logourl; 
//** LOGO Link from URL
$logolink =  isset($_POST['logolink']) ? $_POST['logolink'] : "";
if(!empty($logolink)){
   //$logolink = strtolower($logolink); moved
   $logolink = formatURL ($logolink);  
   $logourl = $myts->makeTboxData4Save($logolink); 
}
//** LOGO UPLOAD
  if (!empty($_FILES['userfile']['name'])) { 
  //$uploader = new XoopsMediaUploader('/home/xoops/uploads', $allowed_mimetypes, $maxfilesize, $maxfilewidth, $maxfileheight);
  $uploader = new XoopsMediaUploader(XOOPS_ROOT_PATH . "/".$xoopsModuleConfig['path_logo'], $allowed_mimetypes, $logosize, $logowidth, $logoheight);
    if ($uploader->fetchMedia($_POST['xoops_upload_file'][0])) {
    if (!$uploader->upload()) {
       echo $uploader->getErrors();
    } else {
       echo '<h4>'._MD_FILESUCCESS.'</h4>';
       $logourl = $uploader->getSavedFileName();
    }
  } else {
    echo $uploader->getErrors();
  }
  }
$artist = $myts->makeTboxData4Save($_POST["artist"]);
$album = $myts->makeTboxData4Save($_POST["album"]);
$label = $myts->makeTboxData4Save($_POST["label"]);
$chain = $_POST['chain'];
//** STATUS
/*
 -1  offline, expired 
 0  waiting approval or auto publish time
 1  online
 2  modified
*/
$status = 2;
//** Auto Publish/Expire from Herve Thouzard News Module
//** Autopublish
$autodate = isset($_POST['autodate']) ? $_POST['autodate'] : "0";
if ($autodate == 1 ) {
   $publish_date = $_POST['publish_date'];
   $pubdate = strtotime($publish_date['date']) + $publish_date['time'];
   $published = $pubdate;
} elseif($autodate == 0) {
   $published = time();  
}
$published = $myts->makeTboxData4Save($published);
if($published > time()) {
   $status= -1; 
}
//** Auto Expire
$autoexpdate = isset($_POST['autoexpdate']) ? $_POST['autoexpdate'] : "0";
if ($autoexpdate == 1 ) {
   $expiry_date=$_POST['expiry_date'];
   $expiry_date = strtotime($expiry_date['date']) + $expiry_date['time'];
   $offset = $xoopsUser -> timezone() - $xoopsConfig['server_TZ'];
   $expiry_date = $expiry_date - ( $offset * 3600 );
   $expired = $expiry_date;
} elseif($autoexpdate == 0) {
    $expired = 0;
}
$expired = $myts->makeTboxData4Save($expired);		
if($expired < time() & $expired > 0) {
   $status = -1;		
}
$status=$myts->makeTboxData4Save($status);
$ws_entryperm = $_POST['ws_entryperm'];
$ws_entryperm = (is_array($ws_entryperm)) ? implode(" ", $ws_entryperm) : '';
$description = $myts->makeTareaData4Save($_POST["description"]);
$bodytext = $myts->makeTareaData4Save($_POST["bodytext"]);
$playerid = $myts->makeTboxData4Save($_POST["playerid"]);	
$start = $myts->makeTboxData4Save($_POST["start"]);
$shuffle = $myts->makeTboxData4Save($_POST["shuffle"]);
$replay = $myts->makeTboxData4Save($_POST["replay"]);
$link = $myts->makeTboxData4Save($_POST["link"]);			
$linktarget = $myts->makeTboxData4Save($_POST["linktarget"]);
$showicons = $myts->makeTboxData4Save($_POST["showicons"]);
//** PLAYERLOGO UPLOAD
$playerlogo = "";
  if (!empty($_FILES['userfile2']['name'])) { 
  //$uploader = new XoopsMediaUploader('/home/xoops/uploads', $allowed_mimetypes, $maxfilesize, $maxfilewidth, $maxfileheight);
  $uploader2 = new XoopsMediaUploader(XOOPS_ROOT_PATH ."/modules/".$xoopsModule->getVar('dirname')."/images/player", $allowed_mimetypes, $playerlogosize, $playerlogowidth, $playerlogoheight);
    if ($uploader2->fetchMedia($_POST['xoops_upload_file'][1])) {
      if (!$uploader2->upload()) {
         echo $uploader2->getErrors();
      } else {
         echo '<h4>'._MD_FILESUCCESS.'</h4>';
         $playerlogo = $uploader2->getSavedFileName();
      }
    } else {
      echo $uploader2->getErrors();
    }
  }
$playerlogo = empty($playerlogo)?(empty($_POST['playerlogo'])?"":$_POST['playerlogo']):$playerlogo;  
$stretch = $myts->makeTboxData4Save($_POST["stretch"]);
$showeq = $myts->makeTboxData4Save(isset($_POST['showeq']) ? $_POST['showeq'] : "0");
$rotatetime = $myts->makeTboxData4Save(isset($_POST['rotatetime']) ? $_POST['rotatetime'] : "0");			
$shownav = $myts->makeTboxData4Save(isset($_POST['shownav']) ? $_POST['shownav'] : "0");
$transition = $myts->makeTboxData4Save(isset($_POST['transition']) ? $_POST['transition'] : "none");
$thumbslist = $myts->makeTboxData4Save(isset($_POST['thumbslist']) ? $_POST['thumbslist'] : "0");
$captions = $myts->makeTboxData4Save( formatURL($_POST["captions"]));
$enablejs = $myts->makeTboxData4Save($_POST["enablejs"]);   
$xoopsDB->query("update ".$xoopsDB->prefix("webshow_links")." set cid='$cid', title='$title', url='$url', logourl='$logourl', listtype='$listtype', listurl='$listurl', listcache='$listcache', showinfo='$showinfo', cachetime='$cachetime', comments='$comments', srctype='$srctype', player='$playerid', chain='$chain', status='$status', expired='$expired', published='$published', artist='$artist', album='$album', label='$label', entryperm='$ws_entryperm' where lid=".$lid."")  or $eh->show("0013");
$xoopsDB->query("update ".$xoopsDB->prefix("webshow_text")." set description='$description', bodytext='$bodytext' where lid=".$lid."")  or $eh->show("0013");
$xoopsDB->query("update ".$xoopsDB->prefix("webshow_flashvar")." set start='$start', shuffle='$shuffle', replay='$replay', link='$link', linktarget='$linktarget', showicons='$showicons', stretch='$stretch', showeq='$showeq', rotatetime='$rotatetime', shownav='$shownav', transition='$transition', thumbslist='$thumbslist', captions='$captions', playerlogo='$playerlogo', enablejs='$enablejs' where lid=".$lid."")  or $eh->show("0013");

//** Save Tags requires Tag 1.60 module
$tag_handler = xoops_getmodulehandler('tag', 'tag');
$itemid = $lid;
$catid = 0; //$cid;
$tag_handler->updateByItem($_POST["item_tag"], $lid, $xoopsModule->getVar("dirname"), $catid);

//** Refresh Playlist feed - Create or Fetch and then cache the playlist.
  // Refresh Selected
  if($refreshlist == 1) { 
     deletePlaylist($lid);     
     namePlaylist($lid,$title);    
       if($listtype == "dir") {
          createPlaylist($lid);
       } 
       if($listtype == "feed"){
          fetchPlaylist($lid);
       }
  }
redirect_header("index.php?op=modLink&amp;lid=$lid",3,_MD_DBUPDATED."<br />".$message);
}

function listNewLinks()
{
// List links waiting for validation
global $xoopsDB, $xoopsModule, $xoopsModuleConfig, $xoopsConfig, $xoopsUser, $myts, $eh, $cattree, $playertree, $linktree, $allowed_mimetypes, $logosize, $logowidth, $logoheight, $playerlogosize, $playerlogowidth, $playerlogoheight;
$result = $xoopsDB->query("select lid, cid, title, url, srctype, listtype, listurl, listcache, showinfo, logourl, submitter, player, chain, artist, album, label, cachetime, comments, published, expired, entryperm from ".$xoopsDB->prefix("webshow_links")." where status=0 order by date DESC");
$numrows = $xoopsDB->getRowsNum($result);
xoops_cp_header();
adminmenu(1);	
   if ( $numrows == 0 ) {
   echo ""._MD_NOSUBMITTED."";
   } else {
   while(list($lid, $cid, $title, $url, $srctype, $listtype, $listurl, $listcache, $showinfo, $logourl, $submitterid, $player, $chain, $artist, $album, $label, $cachetime, $comments, $published, $expired, $ws_entryperm) = $xoopsDB->fetchRow($result)) {
   $result2 = $xoopsDB->query("select description, bodytext from ".$xoopsDB->prefix("webshow_text")." where lid=$lid");
   list($description, $bodytext) = $xoopsDB->fetchRow($result2);
   $lid = $myts->makeTboxData4Edit($lid);
   $title = $myts->makeTboxData4Edit($title);
   $url = $myts->makeTboxData4Edit($url); 
   $srcttype = $myts->makeTboxData4Edit($srctype);
   $listtype = $myts->makeTboxData4Edit($listtype);
   $listurl = $myts->makeTboxData4Edit($listurl);
   $listcache = $myts->makeTboxData4Edit($listcache);
   //** Show Info
   $showinfo = $myts->makeTboxData4Edit($showinfo);
   $showinfo = explode("|", $showinfo);
   $cachetime = $myts->makeTboxData4Edit($cachetime);
   $comments = $myts->makeTboxData4Edit($comments);   
   $logourl = $myts->makeTboxData4Edit($logourl);
   $artist = $myts->makeTboxData4Edit($artist);
   $album = $myts->makeTboxData4Edit($album); 
   $label = $myts->makeTboxData4Edit($label);      
   $player = $myts->makeTboxData4Edit($player);
   $playerid = $player;   
   $chain = $myts->makeTboxData4Edit($chain);
   $published = $myts->makeTboxData4Edit($published);
   $expired = $myts->makeTboxData4Edit($expired);
   $ws_entryperm = explode(" ", $ws_entryperm);
   $description = $myts->makeTareaData4Edit($description);
   $bodytext = $myts->makeTareaData4Edit($bodytext);       
   $result3 = $xoopsDB->query("select start, shuffle, replay, link, linktarget, showicons, stretch, showeq, rotatetime, shownav, transition, thumbslist, captions, playerlogo, enablejs from ".$xoopsDB->prefix("webshow_flashvar")." where lid=$lid") or $eh->show("0013");
   list($start, $shuffle, $replay, $link, $linktarget, $showicons, $stretch, $showeq, $rotatetime, $shownav, $transition, $thumbslist, $captions, $playerlogo, $enablejs)=$xoopsDB->fetchRow($result3);
   //** FLASH VARIABLES  
  $start = $myts->makeTboxData4Edit($start);
  $shuffle = $myts->makeTboxData4Edit($shuffle); 
  $replay = $myts->makeTboxData4Edit($replay);
  $link = $myts->makeTareaData4Edit($link);
  $linktarget = $myts->makeTboxData4Edit($linktarget);  
  $showicons = $myts->makeTboxData4Edit($showicons);
  $stretch = $myts->makeTareaData4Edit($stretch);       
  $showeq = $myts->makeTboxData4Edit($showeq);
  $rotatetime = $myts->makeTboxData4Edit($rotatetime);
  $shownav = $myts->makeTboxData4Edit($shownav);    
  $transition = $myts->makeTboxData4Edit($transition); 
  $thumbslist = $myts->makeTboxData4Edit($thumbslist);
  $captions = $myts->makeTboxData4Edit($captions);
  $playerlogo = $myts->makeTboxData4Edit($playerlogo);
  $enablejs = $myts->makeTboxData4Edit($enablejs);	 	   	
  $submitter = XoopsUser::getUnameFromId($submitterid);
  //** Modify Playlist Form
  $wsformlabel =	 _MD_LINKSWAITING;	
  $wsformname = "linkwaitingform";
  $wsformaction = XOOPS_URL.'/modules/'.$xoopsModule->getVar('dirname').'/admin/index.php';
  $wsformmethod = "post";
  $wsformaddtoken = "false";	 			
  $op= 'approve';
  $btnlabel = _MD_APPROVE;
  echo "<h3>". _MD_LINKSWAITING."</h3>";	  	
  echo "<table class='outer'><tr><td>";  
  include '../include/playlistform.inc.php';
  echo "</td></tr></table>";      
  }  
 }
xoops_cp_footer();
}

function delVote()
{
	global $xoopsDB, $eh;
    $rid = $_GET['rid'];
    $lid = $_GET['lid'];
	$sql = sprintf("DELETE FROM %s WHERE ratingid = %u", $xoopsDB->prefix("webshow_votedata"), $rid);
    $xoopsDB->query($sql) or $eh->show("0013");
    updaterating($lid);
    redirect_header("index.php",1,_MD_VOTEDELETED);
    exit();
}

function listBrokenLinks()
{
   	global $xoopsDB, $xoopsModule, $eh;
   	$result = $xoopsDB->query("select * from ".$xoopsDB->prefix("webshow_broken")." group by lid order by reportid DESC");
   	$totalbrokenlinks = $xoopsDB->getRowsNum($result);
	xoops_cp_header();
   	adminmenu(1);	
	echo "<h4>"._MD_WEBSHOWCONF."</h4>";
	echo"<table width='100%' border='0' cellspacing='1' class='outer'>"
	."<tr class=\"odd\"><td>";
	echo "<h4>"._MD_BROKENREPORTS." ($totalbrokenlinks)</h4><br />";
   	if ( $totalbrokenlinks == 0 ) {
		echo _MD_NOBROKEN;
    } else {
		echo "<center>
		"._MD_IGNOREDESC."<br />
		"._MD_DELETEDESC."</center><br /><br /><br />";
        $colorswitch="dddddd";
		echo "<table align=\"center\" width=\"90%\">";
        echo "
        <tr>
        <td><b>Link Name</b></td>
        <td><b>" ._MD_REPORTER."</b></td>
        <td><b>" ._MD_SUBMITTER."</b></td>
        <td><b>" ._MD_IGNORE."</b></td>
        <td><b>" ._EDIT."</b></td>
        <td><b>" ._MD_DELETE."</b></td>
        </tr>";
        while ( list($reportid, $lid, $sender, $ip)=$xoopsDB->fetchRow($result) ) {
			$result2 = $xoopsDB->query("select title, url, submitter from ".$xoopsDB->prefix("webshow_links")." where lid=$lid");
			if ( $sender != 0 ) {
				$result3 = $xoopsDB->query("select uname, email from ".$xoopsDB->prefix("users")." where uid=$sender");
				list($uname, $email)=$xoopsDB->fetchRow($result3);
			}
    		list($title, $url, $ownerid)=$xoopsDB->fetchRow($result2);
			//			$url=urldecode($url);
    		$result4 = $xoopsDB->query("select uname, email from ".$xoopsDB->prefix("users")." where uid='$ownerid'");
    		list($owner, $owneremail)=$xoopsDB->fetchRow($result4);
    		echo '<tr><td bgcolor=$colorswitch><a href="'.XOOPS_URL.'/modules/'.$xoopsModule->getVar("dirname").'/singlelink.php?lid='.$lid.'" target="_blank">'.$title.'</a></td>';
    		if ( $email=='' ) {
				echo "<td bgcolor=\"".$colorswitch."\">".$sender." (".$ip.")";
			} else {
				echo "<td bgcolor=\"".$colorswitch."\"><a href=\"mailto:".$email."\">".$uname."</a> (".$ip.")";
			}
   			echo "</td>";
   			if ( $owneremail == '' ) {
				echo "<td bgcolor=\"".$colorswitch."\">".$owner."";
			} else {
				echo "<td bgcolor=\"".$colorswitch."\"><a href=\"mailto:".$owneremail."\">".$owner."</a>";
			}
			echo "</td><td bgcolor='$colorswitch' align='center'>\n";
			echo myTextForm("index.php?op=ignoreBrokenLinks&lid=$lid" , "X");
			echo "</td><td bgcolor='$colorswitch' align='center'>\n";
			echo myTextForm("index.php?op=modLink&lid=$lid" , "X");
			echo "</td><td align='center' bgcolor='$colorswitch'>\n";
			echo myTextForm("index.php?op=delBrokenLinks&lid=$lid" , "X");
			echo "</td></tr>\n";
    		if ( $colorswitch == "#dddddd" ) {
				$colorswitch="#ffffff";
			} else {
				$colorswitch="#dddddd";
			}
    	}
		echo "</table>";
    }
	echo"</td></tr></table>";
	xoops_cp_footer();
}

function delBrokenLinks()
{
//** NEEDS WORK add tag sync
global $xoopsDB, $eh;
include '../include/playlist.php'; 
$lid = $_GET['lid'];
deletePlaylist($lid);		
$sql = sprintf("DELETE FROM %s WHERE lid = %u", $xoopsDB->prefix("webshow_broken"), $lid);
$xoopsDB->query($sql) or $eh->show("0013");
$sql = sprintf("DELETE FROM %s WHERE lid = %u", $xoopsDB->prefix("webshow_links"), $lid);
$xoopsDB->query($sql) or $eh->show("0013");
$sql = sprintf("DELETE FROM %s WHERE lid = %u", $xoopsDB->prefix("webshow_text"), $lid);
$xoopsDB->query($sql) or $eh->show("0013");
$sql = sprintf("DELETE FROM %s WHERE lid = %u", $xoopsDB->prefix("webshow_flashvar"), $lid);
$xoopsDB->query($sql) or $eh->show("0013");
$sql = sprintf("DELETE FROM %s WHERE lid = %u", $xoopsDB->prefix("webshow_votedata"), $lid);
$xoopsDB->query($sql) or $eh->show("0013");   
redirect_header("index.php",1,_MD_LINKDELETED);
	exit();
}

function ignoreBrokenLinks()
{
	global $xoopsDB, $eh;
	$sql = sprintf("DELETE FROM %s WHERE lid = %u", $xoopsDB->prefix("webshow_broken"), $_GET['lid']);
    $xoopsDB->query($sql) or $eh->show("0013");
    redirect_header("index.php",1,_MD_BROKENDELETED);
	exit();
}

function listModReq()
{
//** NEEDS WORK ADD TAG handler for $ws_tag
    global $xoopsDB, $myts, $eh, $cattree, $playertree, $linktree, $xoopsModule, $xoopsModuleConfig;
    $modresult = $xoopsDB->query("SELECT requestid, lid, cid, title, url, listurl, logourl, artist, album, label, description, bodytext, modifysubmitter, ws_tag FROM ".$xoopsDB->prefix("webshow_mod")." order by requestid");
    $totalmodrequests = $xoopsDB->getRowsNum($modresult);
	xoops_cp_header();
	adminmenu(1);	
	echo "<h4>"._MD_WEBSHOWCONF."</h4>";
	echo"<table width='100%' border='0' cellspacing='1' class='outer'>"
	."<tr class=\"odd\"><td>";
    echo "<h4>"._MD_USERMODREQ." ($totalmodrequests)</h4><br />";
	if ( $totalmodrequests > 0 ) {
		echo "<table width=95%><tr><td>";
		$lookup_lid = array();
		while (list($requestid, $lid, $cid, $title, $url, $listurl, $logourl, $artist, $album, $label, $description, $bodytext, $submitterid, $ws_tag)=$xoopsDB->fetchRow($modresult)) {
			$lookup_lid[$requestid] = $lid; //** ??
			$origresult1 = $xoopsDB->query("SELECT cid, title, url, listurl, logourl, submitter, player, artist, album, label FROM ".$xoopsDB->prefix("webshow_links")." WHERE lid=$lid");
			list($origcid, $origtitle, $origurl, $origlisturl, $origlogourl, $ownerid, $origplayer, $origartist, $origalbum, $origlabel)=$xoopsDB->fetchRow($origresult1);
			$origresult2 = $xoopsDB->query("select description, bodytext from ".$xoopsDB->prefix("webshow_text")." where lid=$lid");
			list($origdescription, $origbodytext) = $xoopsDB->fetchRow($origresult2);
			$result7 = $xoopsDB->query("select uname, email from ".$xoopsDB->prefix("users")." where uid='$submitterid'");
			$result8 = $xoopsDB->query("select uname, email from ".$xoopsDB->prefix("users")." where uid='$ownerid'");
			list($submitter, $submitteremail)=$xoopsDB->fetchRow($result7);
			list($owner, $owneremail)=$xoopsDB->fetchRow($result8);

		$cattitle=$cattree->getPathFromId($cid, "cattitle");
		$origcattitle=$cattree->getPathFromId($origcid, "cattitle");
    		$title = $myts->makeTboxData4Show($title);
     		$origtitle = $myts->makeTboxData4Show($origtitle);
    		$artist = $myts->makeTboxData4Show($artist);
     		$origartist = $myts->makeTboxData4Show($origartist);
    		$album = $myts->makeTboxData4Show($album);
     		$origalbum = $myts->makeTboxData4Show($origalbum);
    		$label = $myts->makeTboxData4Show($label);
     		$origlabel = $myts->makeTboxData4Show($origlabel);     							
    		$url = $myts->makeTboxData4Show($url);
     		$origurl = $myts->makeTboxData4Show($origurl);  	   		 		
    		$listurl = $myts->makeTboxData4Show($listurl);
    		$origlisturl = $myts->makeTboxData4Show($origlisturl);    			   	    		    			 						
    		$logourl = $myts->makeTboxData4Show($logourl);		
		$origlogourl = $myts->makeTboxData4Show($origlogourl);		
    		$description = $myts->makeTareaData4Show($description,0);	
    		$origdescription = $myts->makeTareaData4Show($origdescription,0);
    		$bodytext = $myts->makeTareaData4Show($bodytext,0);	
    		$origbodytext = $myts->makeTareaData4Show($origbodytext,0);    	
    		
    		echo "<table border=1 bordercolor=black cellpadding=5 cellspacing=0 align=center width=100%><tr><td>
    	   	<table style=\"width:100%; text-size: 85%; background-color:#dddddd; \">
    	   	<style>
    	   	.same {border: 1px; vertical-align:top;}
    	   	.change { border: 4px solid yellow; vertical-align: top;}
    	   	</style>
    	    <tr colspan='3'><td width=10%></td><td width=45%><b>"._MD_ORIGINAL."</b></td><td width=45%><b>"._MD_PROPOSED."</b></td></tr>   	    
    	    <tr colspan='3'><td><b>"._MD_SITETITLE."</b></td><td>".$origtitle."</td>";
    	    if ($title != $origtitle) {
	        echo "<td class=\"change\">".$title."</td></tr>";
	        } else {
           echo "<td class=\"same\">".$title."</td></tr>";
           }
    	    echo "<tr colspan='3'><td><b>"._MD_artist."</b></td><td>".$origartist."</td>";
    	    if ($artist != $origartist) {
	        echo "<td class=\"change\">".$artist."</td></tr>";
	        } else {
           echo "<td class=\"same\">".$artist."</td></tr>";
           }
    	    echo "<tr colspan='3'><td><b>"._MD_ALBUM."</b></td><td>".$origalbum."</td>";
    	    if ($album != $origalbum) {
	        echo "<td class=\"change\">".$album."</td></tr>";
	        } else {
           echo "<td class=\"same\">".$album."</td></tr>";
           }
          echo "<tr colspan='3'><td><b>"._MD_LABEL."</b></td><td>".$origlabel."</td>";
    	    if ($label != $origlabel) {
	        echo "<td class=\"change\">".$label."</td></tr>";
	        } else {
           echo "<td class=\"same\">".$label."</td></tr>";
           }
    	    echo "<tr colspan='3'><td><b>"._MD_SITEURL."</b></td><td>".$origurl."</td>";
    	    if ($url != $origurl) {
	        echo "<td class=\"change\">".$url."</td></tr>";
	        } else {
           echo "<td class=\"same\">".$url."</td></tr>";
           }    	    
    	    echo "<tr colspan='3'><td><b>"._MD_LISTURL."</b></td><td>".$origlisturl."</td>";
    	    if ($listurl != $origlisturl) {
	        echo "<td class=\"change\">".$listurl."</td></tr>";
	        } else {
           echo "<td class=\"same\">".$listurl."</td></tr>";
           }      	    
	     	echo "<tr colspan='3'><td><b>"._MD_CATEGORYC."</b></td><td>".$origcattitle."</b></td>";
	     	 if ($cattitle != $origcattitle) {
	        echo "<td class=\"change\">".$cattitle."</td></tr>";
	        } else {
           echo "<td class=\"same\">".$cattitle."</td></tr>";
           } 
	     	echo "<tr colspan='3'><td><b>"._MD_LOGOIMAGE."</b></td><td>";
	                  $path_image = $xoopsModuleConfig["path_logo"];	     				
			if ( $xoopsModuleConfig['path_logo'] && !empty($origlogourl) ) {
			echo "<img src=\"".XOOPS_URL."/".$path_image."/".$origlogourl."\" />";
			} else {
				echo "&nbsp;";
			}
			echo "</td><td width=45%>";
			if ( $xoopsModuleConfig['path_logo'] && !empty($logourl) ) {
				echo "<img src=\"".XOOPS_URL."/".$path_image."/".$logourl."\" />";
			} else {
				echo "&nbsp;";
			}
			echo "</td></tr>";
			echo "<tr colspan='3'><td align=left><b>"._MD_DESCRIPTION.": </b></td><td>".$origdescription."</td>";	        
	        if ($description != $origdescription) {
	        echo "<td class=\"change\">".$description."</td></tr>";
	        } else {
           echo "<td class=\"same\">".$description."</td></tr>";
           }	
     	    echo "<tr colspan='3'><td align=left><b>"._MD_LINKTEXTC."</b></td><td>".$origbodytext."</td>";
	        if ($bodytext != $origbodytext) {     	       	    
	        echo "<td class=\"change\">".$bodytext."</td></tr>";
	        } else {
           echo "<td class=\"same\">".$bodytext."</td></tr>";
           }	        
    	   	echo "</table></td></tr></table>
    		<table align=center width=100%>
    	  	<tr>";
    		if ( $submitteremail == "" ) {
				echo "<td align=left>"._MD_SUBMITTER."$submitter</td>";
			} else {
				echo "<td align=left>"._MD_SUBMITTER."<a href=mailto:".$submitteremail.">".$submitter."</a></td>";
			}
    		if ( $owneremail == "" ) {
				echo "<td align=center>"._MD_OWNER."".$owner."</td>";
			} else {
				echo "<td align=center>"._MD_OWNER."<a href=mailto:".$owneremail.">".$owner."</a></td>";
			}
			echo "<td align=right>\n";
			echo "<table><tr><td>\n";
			echo myTextForm("index.php?op=changeModReq&requestid=$requestid" , _MD_APPROVE);
			echo "</td><td>\n";
			echo myTextForm("index.php?op=modLink&lid=$lookup_lid[$requestid]", _EDIT);
			echo "</td><td>\n";
			echo myTextForm("index.php?op=ignoreModReq&requestid=$requestid", _MD_IGNORE);
			echo "</td></tr></table>\n";
			echo "</td></tr>\n";
    		echo "</table><br /><br />";
    	}
    	echo "</td></tr></table>";
	} else {
		echo _MD_NOMODREQ;
	}
	echo"</td></tr></table>";
	xoops_cp_footer();
}

function changeModReq()
{
    global $xoopsDB, $eh, $myts;
    $requestid = $_GET['requestid'];
    $query = "select lid, cid, title, url, srctype, listurl, logourl, player, chain, artist, album, label, description, bodytext from ".$xoopsDB->prefix("webshow_mod")." where requestid=".$requestid."";
    $result = $xoopsDB->query($query);
    while ( list($lid, $cid, $title, $url, $srctype, $listurl, $logourl, $player, $chain, $artist, $album, $label, $description, $bodytext)=$xoopsDB->fetchRow($result) ) {
		if ( get_magic_quotes_runtime() ) {
		$title = stripslashes($title);
		$artist = stripslashes($artist);
		$album = stripslashes($album);
		$label = stripslashes($label);
		$url = stripslashes($url);  		
    		$listurl = stripslashes($listurl);    		
    		$logourl = stripslashes($logourl);
    		$description = stripslashes($description);
    		$bodytext = stripslashes($bodytext);    		
		}
		$title = addslashes($title);
    	$url = addslashes($url);    	
    	$listurl = addslashes($listurl);
    	$logourl = addslashes($logourl);
    	$description = addslashes($description);
    	$bodytext = addslashes($bodytext);    	
		$sql= sprintf("UPDATE %s SET cid = %u, title = '%s', url = '%s', srctype='%s', listurl = '%s', logourl = '%s', status = %u, date = %u, player=%u, chain = %u, artist = '%s', album = '%s', label = '%s' WHERE lid = %u", $xoopsDB->prefix("webshow_links"), $cid, $title, $url, $srctype, $listurl, $logourl, 2, time(), $player, $chain, $artist, $album, $label, $lid);
    		$xoopsDB->query($sql) or $eh->show("0013");
		$sql = sprintf("UPDATE %s SET description = '%s' , bodytext = '%s' WHERE lid = %u", $xoopsDB->prefix("webshow_text"), $description, $bodytext, $lid);
		$xoopsDB->query($sql) or $eh->show("0013");		
		$sql = sprintf("DELETE FROM %s WHERE requestid = %u", $xoopsDB->prefix("webshow_mod"), $requestid);
		$xoopsDB->query($sql) or $eh->show("0013");
    }
    redirect_header("index.php?op= listModReq",1,_MD_DBUPDATED);
	exit();
}

function ignoreModReq()
{
	global $xoopsDB, $eh;
	$sql = sprintf("DELETE FROM %s WHERE requestid = %u", $xoopsDB->prefix("webshow_mod"), $_GET['requestid']);
    $xoopsDB->query($sql) or $eh->show("0013");
    redirect_header("index.php?op=listModReq",1,_MD_MODREQDELETED);
	exit();
}

function approve()
{
global $xoopsConfig, $xoopsModule, $xoopsDB, $myts, $eh, $allowed_mimetypes, $logosize, $logowidth, $logoheight, $playerlogosize, $playerlogowidth, $playerlogoheight;
$lid = $_POST['lid'];
$cid = $_POST['cid'];
   if ( empty($cid) ) {
      $cid = 0;
   }
$title = $myts->makeTboxData4Save($_POST["title"]);
//** CACHE PLAYLIST
$cachetime = "";
$listcache = isset($_POST['listcache']) ? $_POST['listcache'] : "";
$refreshlist = isset($_POST['refreshlist']) ? $_POST['refreshlist'] : "0";
$message = "";
if($listtype != "single") {
// Refresh the playlist file if it does not exist
  if (!file_exists(XOOPS_ROOT_PATH."/modules/".$xoopsModule->getVar("dirname")."/playlist/".$listcache)){ 
    $message .= "<br />"._MD_LISTCACHE_FILE." "._MD_NOTEXIST; 
     $refreshlist = 1;
  }
// Refresh the playlist name if it does not exist in the db
 if ($listcache == "") {
     $message .= "<br />"._MD_LISTCACHE_NAME." "._MD_NOTEXIST; 
     $refreshlist = 1;
 }
// Refresh the playlist if cachetime has expired
$cachetime = isset($_POST['cachetime']) ? $_POST['cachetime'] : "86400";
 $cacheexpired = timePlaylist($listcache,$cachetime);
 if($cacheexpired > 0){
 $message .= "<br />"._MD_LISTCACHE_EXPIRED;
 $refreshlist = 1;
 }
// Refresh the playlist if the title changes
  $titleresult=$xoopsDB->query("select title from ".$xoopsDB->prefix("webshow_links")." where lid=$lid");
  list($origtitle)=$xoopsDB->fetchRow($titleresult);
  if ($title != $origtitle) {
    $message .= "<br />"._MD_TITLECHANGE.": New title: ".$title; 
     $refreshlist = 1;
  }
}
$listtype = $myts->makeTboxData4Save($_POST["listtype"]);
if ( ($_POST["listurl"]) || ($_POST["listurl"]!="") ) {
    $listurl = $_POST["listurl"];
    if($listtype == "feed") {    
      $listurl = formatURL ($listurl);
    }  
    $listurl = $myts->makeTboxData4Save($listurl);    
}
$listcache = $myts->makeTboxData4Save($listcache);
$showinfo = $myts->makeTboxData4Save($_POST["showinfo"]);
$cachetime = $myts->makeTboxData4Save($cachetime);
$comments = $myts->makeTboxData4Save($comments);	
 if (($_POST["url"]) || ($_POST["url"]!="")) {
     $url= $_POST["url"];     
     $url= formatURL($url);
     $url = $myts->makeTboxData4Save($_POST["url"]); 
  } 
$srctype = $myts->makeTboxData4Save($_POST["srctype"]);
$artist = $myts->makeTboxData4Save($_POST["artist"]);
$album = $myts->makeTboxData4Save($_POST["album"]);
$label = $myts->makeTboxData4Save($_POST["label"]);
 
//** PLAYLIST LOGO
$logourl = empty($logourl)?(empty($_POST['logourl'])?"":$_POST['logourl']):$logourl; 
//** LOGO Link from URL
$logolink =  isset($_POST['logolink']) ? $_POST['logolink'] : "";
if(!empty($logolink)){
   //$logolink = strtolower($logolink);
   $logolink = formatURL ($logolink);  
   $logourl = $myts->makeTboxData4Save($logolink); 
}
//** LOGO UPLOAD
if (!empty($_FILES['userfile']['name'])) { 
//$uploader = new XoopsMediaUploader('/home/xoops/uploads', $allowed_mimetypes, $maxfilesize, $maxfilewidth, $maxfileheight);
$uploader = new XoopsMediaUploader(XOOPS_ROOT_PATH . "/".$xoopsModuleConfig['path_logo'], $allowed_mimetypes, $logosize, $logowidth, $logoheight);
   if ($uploader->fetchMedia($_POST['xoops_upload_file'][0])) {
      if (!$uploader->upload()) {
         echo $uploader->getErrors();
      } else {
       echo '<h4>'._MD_FILESUCCESS.'</h4>';
       $logourl = $uploader->getSavedFileName();
      }
   } else {
      echo $uploader->getErrors();
   }
}
$artist = $myts->makeTboxData4Save($_POST["artist"]);
$album = $myts->makeTboxData4Save($_POST["album"]);
$label = $myts->makeTboxData4Save($_POST["label"]); 
$chain = $_POST['chain'];
if (!empty( $_POST['autodate'] )) {
   $publish_date=$_POST['publish_date'];
   $pubdate = strtotime($publish_date['date']) + $publish_date['time'];
   $published = $pubdate;
}
//** Publish/Expire code from Herve Thoussard News Module
if (!empty( $_POST['autoexpdate'] )) {
   $expiry_date=$_POST['expiry_date'];
   $expiry_date = strtotime($expiry_date['date']) + $expiry_date['time'];
   $offset = $xoopsUser -> timezone() - $xoopsConfig['server_TZ'];
   $expiry_date = $expiry_date - ( $offset * 3600 );
   $expired = $expirydate;
} else {
    $expired = 0;
}
$player = $myts->makeTboxData4Save($_POST["player"]);
$playerid = $myts->makeTboxData4Save($_POST["playerid"]);

//** ws_entryperm
$ws_entryperm = $_POST['ws_entryperm'];
$ws_entryperm = (is_array($ws_entryperm)) ? implode(" ", $ws_entryperm) : '';

//** TEXT
$description = $myts->makeTareaData4Save($_POST['description']);
$bodytext = $myts->makeTareaData4Save($_POST['bodytext']);

//**Flash Variables
$start = $myts->makeTboxData4Save($start);
$shuffle = $myts->makeTboxData4Save($shuffle); 
$replay = $myts->makeTboxData4Save($replay);
$link = $myts->makeTboxData4Save($link);
$linktarget = $myts->makeTboxData4Save($linktarget);  
$showicons = $myts->makeTboxData4Save($showicons);
$stretch = $myts->makeTboxData4Save($stretch);       
$showeq = $myts->makeTboxData4Save($showeq);
$rotatetime = $myts->makeTboxData4Save($rotatetime);
$shownav = $myts->makeTboxData4Save($shownav);    
$transition = $myts->makeTboxData4Save($transition); 
$thumbslist = $myts->makeTboxData4Save($thumbslist); 
$captions = $myts->makeTboxData4Save(formatURL($captions)); 
//** PLAYERLOGO UPLOAD
$playerlogo = "";
  if (!empty($_FILES['userfile2']['name'])) { 
  $uploader2 = new XoopsMediaUploader(XOOPS_ROOT_PATH ."/modules/".$xoopsModule->getVar('dirname')."/images/player", $allowed_mimetypes, $playerlogosize, $playerlogowidth, $playerlogoheight);
    if ($uploader2->fetchMedia($_POST['xoops_upload_file'][1])) {
      if (!$uploader2->upload()) {
         echo $uploader2->getErrors();
      } else {
         echo '<h4>'._MD_FILESUCCESS.'</h4>';
         $playerlogo = $uploader2->getSavedFileName();
      }
    } else {
      echo $uploader2->getErrors();
    }
  }
$playerlogo = empty($playerlogo)?(empty($_POST['playerlogo'])?"":$_POST['playerlogo']):$playerlogo;
$enablejs = $myts->makeTboxData4Save($enablejs);
//** Query db   		
$query = "update ".$xoopsDB->prefix("webshow_links")." set cid='$cid', title='$title', url='$url', srctype='$srctype', listurl='$listurl', listcache='$listcache', showinfo='$showinfo', logourl='$logourl', chain='$chain', status=1, date=".time().", published='$published', expired='$expired', player='$player', artist='$artist', album='$album', label='$label', cachetime='$cachetime', entryperm='$ws_entryperm' where lid=".$lid."";
$xoopsDB->query($query) or $eh->show("0013");
$query = "update ".$xoopsDB->prefix("webshow_text")." set description='$description', bodytext='$bodytext' where lid=".$lid."";
$xoopsDB->query($query) or $eh->show("0013");	
$query = "update ".$xoopsDB->prefix("webshow_flashvar")." set start='$start', shuffle='$shuffle', replay='$replay', link='$link', linktarget='$linktarget', showicons='$showicons', stretch='$stretch', showeq='$showeq', rotatetime='$rotatetime', shownav='$shownav', transition='$transition', thumbslist='$thumbslist', captions='$captions', playerlogo='$playerlogo', enablejs='$enablejs'  where lid=".$lid."";
$xoopsDB->query($query) or $eh->show("0013");	

//** Save Tags requires Tag 1.60 module
$tag_handler = xoops_getmodulehandler('tag', 'tag');
$tag_handler->updateByItem($_POST["item_tag"], $lid, $xoopsModule->getVar("dirname"), $catid =0);

//** Notifications
$tags=array();
$tags['LINK_NAME'] = $title;
$tags['LINK_URL'] = XOOPS_URL . '/modules/'. $xoopsModule->getVar('dirname') . '/singlelink.php?cid=' . $cid . '&amp;lid=' . $lid;
$sql = "SELECT cattitle FROM " . $xoopsDB->prefix("webshow_cat") . " WHERE cid=" . $cid;
$result = $xoopsDB->query($sql);
$row = $xoopsDB->fetchArray($result);
$tags['CATEGORY_NAME'] = $row['cattitle'];
$tags['CATEGORY_URL'] = XOOPS_URL . '/modules/' . $xoopsModule->getVar('dirname') . '/viewcat.php?cid=' . $cid;
$notification_handler =& xoops_gethandler('notification');
$notification_handler->triggerEvent('global', 0, 'new_link', $tags);
$notification_handler->triggerEvent('category', $cid, 'new_link', $tags);
$notification_handler->triggerEvent('link', $lid, 'approve', $tags);
//** Refresh Playlist feed - Create or Fetch and then cache the new playlist.
  if($refreshlist == 1) { 
     $listcache = deletePlaylist($lid);     
     $listcache = namePlaylist($lid,$title); 
     $message .= "<br />"._MD_LISTCACHE_REFRESH.": ".$listcache;        
       if($listtype == "dir") {
          createPlaylist($lid);
       } 
       if($listtype == "feed"){
          fetchPlaylist($lid);
       }
  }
redirect_header("index.php?op=listModReq",2,_MD_MODLINK);
}

function webShowHelp()
{
	global $xoopsConfig, $xoopsModule;
	xoops_cp_header();
	adminmenu(1);
	include "docs/help.html";	
	xoops_cp_footer();	
}

/**
 * Function to check status of a folder
 * Code from PHPPP Article Module 
 * @return bool
 */
function ws_admin_getPathStatus($path)
{
   global $xoopsModule;
	if(empty($path)) return false;
	if(@is_writable($path)){
		$path_status = _MD_AVAILABLE;
	}elseif(!@is_dir($path)){
		$path_status = "<font color=\"red\">"._MD_NOTAVAILABLE."</font> <a href=".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/admin/index.php?op=createdir&amp;path=$path>"._MD_CREATETHEDIR."</a>";
	}else{
		$path_status = "<font color=\"red\">"._MD_NOTWRITABLE."</font> <a href=".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/admin/index.php?op=setperm&amp;path=$path>"._MD_SETMPERM."</a>";
	}
	return $path_status;
}

function createdir($path)
{
  global $xoopsDB, $xoopsConfig, $xoopsModule, $xoopsModuleConfig;
      $path_status_msg = "path: " .$path;               
      if(!is_dir($path)){
       mkdir($path, 755);
      }
}

function cacheAll()
{
  global $xoopsDB, $xoopsConfig, $xoopsModule, $xoopsModuleConfig;
  include '../include/playlist.php';
  createdir( XOOPS_ROOT_PATH."/modules/".$xoopsModule->getVar("dirname")."/playlist");
  cacheAllplaylist();
redirect_header("index.php",2,_MD_LISTCACHE_REFRESH);
}

if(!isset($_POST['op'])) {
	$op = isset($_GET['op']) ? $_GET['op'] : 'main';
} else {
	$op = $_POST['op'];
}

switch ($op) {
case "webShow":
	webShow();
	break;

case "menuLink":
	menuLink();
	break;

case "newLink":
	newLink();	
	break;
	
case "addLink":
	addLink();
	break;

case "modLink": 
	modLink();
	break;

case "modLinkS":
	modLinkS();
	break;
	
case "listNewLinks":
	listNewLinks();
	break;	

case "approve":
	approve();
	break;	
	
case "listBrokenLinks":
	listBrokenLinks();
	break;
	
case "delBrokenLinks":
	delBrokenLinks();
	break;
	
case "ignoreBrokenLinks":
	ignoreBrokenLinks();
	break;
	
case "listModReq":
	listModReq();
	break;
	
case "changeModReq":
	changeModReq();
	break;
	
case "ignoreModReq":
	ignoreModReq();
	break;

case "delVote":
	delVote();
	break;
			
case "delLink":
	delLink();
	break;

case "webShowHelp":
	webShowHelp();
	break;

case "cacheAll":
	cacheAll();
	break;

case "createdir":
	$path = isset($_GET['path']) ? $_GET['path'] : $path;
	createdir($path);
	break;
				
case 'main':
default:  
	webShow();
	break;
}
?>