<?php
// $Id: webshow_playit.php,v.50 2007/03/01 19:59:00 tcnet Exp $ //
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //
/******************************************************************************
 * Function: b_webshow_spotlight_show
 * Input   : $options[0] = Choose to select a playlist by hits, rating, random or specific link.
 *           $options[1] = Select a specific playlist
 *           $options[2]   = Show title
  *           $options[3]   = Show logo
   *           $options[4]   = Show description
    *           $options[5]   = Show popup player link
 * Output  : Displays the link content and loads it in the flash player
 ******************************************************************************/
 if (!defined('XOOPS_ROOT_PATH')){ exit(); }
 
function b_webshow_playit_show($options) {
 global $xoopsDB, $xoopsConfig, $xoopsModule, $xoopsModuleConfig;
 $myts =& MyTextSanitizer::getInstance();
 $path_webshow = XOOPS_URL."/modules/webshow";
 $path_logo = XOOPS_URL."/uploads/webshow/logo";

// if (!is_object($GLOBALS['xoopsModule']) || $GLOBALS['xoopsModule']->getVar('dirname') != "webshow") {
 // $modhandler = &xoops_gethandler('module');
 // $module = &$modhandler->getByDirname("webshow");
//  $config_handler = &xoops_gethandler('config');
//  $moduleConfig = &$config_handler->getConfigsByCat(0,$module->getVar('mid'));
//} else {
//  $moduleConfig =& $GLOBALS['xoopsModuleConfig'];
//}
//$modname = $moduleConfig['dirname'];

//** View Permissions
// $groups = is_object($xoopsUser) ? $xoopsUser->getGroups() : XOOPS_GROUP_ANONYMOUS;
// $gperm_handler =& xoops_gethandler('groupperm');

$block = array();

//** Sort by
   if($options[0] == "link"){
      //** SPECIFIC
      $lid = $options[1];
      $where = "and lid = ".$lid." LIMIT 1";
   }elseif($options[0] == "random"){
       //** RANDOM
       //** Category Limit         
       if($options['2'] != 0 ){
          list ( $numrows ) = $xoopsDB -> fetchRow( $xoopsDB -> query ( "SELECT COUNT(*) FROM ".$xoopsDB->prefix("webshow_links")." WHERE status > 0 and cid = ".$options[2].""));
       }else{
          list ( $numrows ) = $xoopsDB -> fetchRow( $xoopsDB -> query ( "SELECT COUNT(*) FROM ".$xoopsDB->prefix("webshow_links")." WHERE status > 0 and cid > 0 "));
       }
	$numrows = $numrows - 1;
	mt_srand((double)microtime()*1000000);
	$entrynumber = mt_rand(0, $numrows);
      $where = "LIMIT ".$entrynumber.", 1";
   }else{
      //** OTHER SORTS date, rating, hits, vote
      $where = "ORDER BY ".$options[0]." DESC LIMIT 1";
   }

   if($options['2'] != 0 ){
       //** Category Limit   
       $result = $xoopsDB ->query("SELECT lid, cid, title, listurl, srctype, listtype, listcache, showinfo, logourl, date, hits, rating, votes, entryperm FROM ".$xoopsDB->prefix("webshow_links")." WHERE status > 0 and cid = ".$options[2]." ".$where."");
   }else{
       $result = $xoopsDB->query("SELECT lid, cid, title, listurl, srctype, listtype, listcache, showinfo, logourl, date, hits, rating, votes, entryperm FROM ".$xoopsDB->prefix('webshow_links')." WHERE status>0 and cid>0 ".$where."");
   }

 $myrow = $xoopsDB->fetchArray($result);

 //**Group Category Permissions - Needs work.
 //** example checkRight($gperm_name, $gperm_itemid, $gperm_groupid, $gperm_modid = 1)
 // if (!$gperm_handler->checkRight('webshow_view', $myrow['cid'], $groups, $xoopsModule->getVar('mid'))) {
 //    $myrow = $xoopsDB->fetchArray($result); //** ??   fetch array again if no perm in category
 // }
 
 //** Entry Permission - Needs work
//$group = is_object($xoopsUser) ? $xoopsUser->getGroups() : array(XOOPS_GROUP_ANONYMOUS);
//$ws_entryperm = explode(" ",$ws_entryperm);
//if (count(array_intersect($group,$ws_entryperm)) > 0)
//{
//       $myrow = $xoopsDB->fetchArray($result); //** ?? . Fetch again if no entry perm
//   }

//** in case random returns empty
    if($myrow['lid'] == ""){
    echo "playit.php line 102 EMPTY RESULT";
         //** NEEDS WORK . Fetch again if result is empty
         //$myrow = $xoopsDB->fetchArray($result);
         b_webshow_playit_show($options); 
   }

  $link = array();
  $link['path'] = $path_webshow;
  $link['id'] = $myrow['lid'];

  //** SHOW TITLE
  if ( $options[4] == 1) {	
  $link['ltitle'] = $title = $myts->makeTboxData4Show($myrow["title"]);
  } else {
  $link['ltitle'] = "";
  }  

  //** Option 5 ENTRY LOGO
  $logourl = $myrow['logourl'];
  if($logourl != ""){
     $ps = strpos($logourl,"http://");
      if($ps === false) {
         $logourl = XOOPS_URL."/uploads/webshow/logo/".$logourl;
      }
      if($options[5] == 1){
         $link['logo'] = $logourl;
      } else {
         $link['logo'] = "";
      }
  }

  //** Option 6 Description  
  if ( $options[6] == 1) {	
  list ( $description ) = $xoopsDB -> fetchRow( $xoopsDB -> query ( "SELECT description FROM ".$xoopsDB->prefix("webshow_text")." WHERE lid =".$link['id']." "));
  $link['description'] = $myts->makeTareaData4Show($description,0);
  } else {
  $link['description'] = "";
  }
  
  //** OPTION 7 POPUP BUTTON.	
  //** Java script opens popmovie.php in a new window.
  if($options[7] == 1) {
      $link['popbutton'] = "<a href=\" \" onClick= \"window.open('".XOOPS_URL."/modules/webshow/popmovie.php?lid=".$link['id']."','popMovie','directories=no,toolbar=no,location=no,menubar=no'); return false;\"><img src=\"".XOOPS_URL."/modules/webshow/images/popbutton.png\" align=\"center\" alt=\""._MB_WEBSHOW_POPUP." "._MB_WEBSHOW_PLAYER."\" /></a>";   
  } else {
    $link['popbutton'] = "";
  }

 //** OPTION 8 Show STATISTICS
  if ($options[8] == 1) {
    $link['stats'] = 1;
       if($options[0] == "date") {
         $link['date'] = "("._MB_LASTUPDATE.": ".formatTimestamp($myrow['date'],'s').")";
       } elseif ($options[0] == "hits" ) {
         $link['hits'] =  "("._MB_WEBSHOW_HITS.": ".$myrow['hits'].")";
       } elseif ($options[0] == "rating") {
         $link['rating'] = "("._MB_WEBSHOW_RATING.": ".$myrow['rating'].")";
         $link['votes'] = "("._MB_WEBSHOW_VOTES.": ".$myrow['votes'].")";
       } elseif ($options[0] == "link" || $options[0] == "random") {
         $link['date'] = "("._MB_LASTUPDATE.": ".formatTimestamp($myrow['date'],'s').")";
         $link['hits'] =  "("._MB_WEBSHOW_HITS.": ".$myrow['hits'].")";
         $link['rating'] = "("._MB_WEBSHOW_RATING.": ".$myrow['rating'].")";
         $link['votes'] = "("._MB_WEBSHOW_VOTES.": ".$myrow['votes'].")";
       }
  } else {
    $link['stats'] = "";
  }
  
  //** Option 3 SHOW MOVIE
  if($options[3] != "0") {
     //** Load and show the flash player.
      $playerid = $options[3];
      $playerresult = $xoopsDB->query("select styleoption, bgcolor, backcolor, frontcolor, lightcolor, width, height, displaywidth, displayheight, showdigits, showfsbutton, scroll, largecontrol from ".$xoopsDB->prefix("webshow_player")." where playerid=$playerid");
      list($styleoption, $bgcolor, $backcolor, $frontcolor, $lightcolor, $width, $height, $displaywidth, $displayheight, $showdigits, $showfsbutton, $scroll, $largecontrol) = $xoopsDB->fetchRow($playerresult);

      //** Player Color Options
      //** Player color from theme
      if($styleoption == "2") {
         $theme = $xoopsConfig['theme_set'];
         $themeresult = $xoopsDB->query("select themeid, bgcolor, backcolor, frontcolor, lightcolor from ".$xoopsDB->prefix("webshow_theme")." where themetitle = \"$theme\"");
         list($themeid, $bgcolor, $backcolor, $frontcolor, $lightcolor) = $xoopsDB->fetchRow($themeresult);
      }

      //** PAGE THEME FROM PLAYER
      //** Uses the color style from this links player for the page color style.
      if($styleoption == "4") {
      include XOOPS_ROOT_PATH."/modules/".$xoopsModule->getVar("dirname")."/include/playerstyle.inc.php";	
      } 

      //** Set the Color Variables.
      $bgcolor = 's'.$link['id'].'.addParam("bgcolor","'.$bgcolor.'");';
      $backcolor = str_replace ( '#','',$backcolor);
      $backcolor = '0x'.$backcolor;
      $backcolor = 's'.$link['id'].'.addVariable("backcolor","'.$backcolor.'");';
      $frontcolor = str_replace ( '#','',$frontcolor);
      $frontcolor = '0x'.$frontcolor;
      $frontcolor = 's'.$link['id'].'.addVariable("frontcolor","'.$frontcolor.'");';
      $lightcolor = str_replace ( '#','',$lightcolor);
      $lightcolor = '0x'.$lightcolor;
      $lightcolor = 's'.$link['id'].'.addVariable("lightcolor","'.$lightcolor.'");';

      //** Monochrome - Flash script default, so no color variables.
      if($styleoption == "1") {
      $bgcolor = "";
      $backcolor = "";
      $frontcolor = "";
      $lightcolor = "";
      }

      $flashresult = $xoopsDB->query("select start, shuffle, replay, showicons, stretch, showeq, thumbslist, rotatetime, shownav, transition, captions, playerlogo, enablejs from ".$xoopsDB->prefix("webshow_flashvar")." where lid=".$link['id']."");
      list($start, $shuffle, $replay, $showicons, $stretch, $showeq, $thumbslist, $rotatetime, $shownav, $transition, $captions, $playerlogo, $enablejs )=$xoopsDB->fetchRow($flashresult);     

      //** FLASH SCRIPT - pick a Jeroen Wijering Flash script according to file type and transition
      $srctype = $myrow['srctype'];
      if($transition != "0" & $srctype == "image") {
         $flashplayer = "imagerotator.swf";
      } else {
         $flashplayer = "mediaplayer.swf";
      }

      //** LISTTYPE and LISTURL
      $listtype = $myrow['listtype'];
      $listurl = $myrow['listurl'];
      $listcache = $myrow['listcache'];
      if ($listtype != 'single') {
         $playlisttype = 'playlist';
         $listcache = XOOPS_URL.'/modules/webshow/playlist/'.$listcache;
         $fileurl = urlencode($listcache);
      }

      if ($listtype == 'single' & $srctype != 'image'){
      //** if single file entry, check for file extension, if no file extension add file type variable to the movie link.
      //**NEEDS WORK TO PLAY SINGLE IMAGES
      $playlisttype = "single";
      $singletitle = 's'.$link['id'].'.addVariable("title","'.$title.'");';
      $fileurl = urlencode($listurl);
      $listurl = strtolower($listurl);
      $listurlext = substr($listurl, -3);
      $ps = strpos($listurlext,$srctype);        
         if ($ps === false) {
             $type = 's'.$link['id'].'.addVariable("type","'.$srctype.'");';
         } else {
             $type = "";
         }
      } else {
      $type = "";
      $singletitle = "";
      }

      //** If this entry has a logo, display it by adding the image variable to the movie link
      if ($logourl != "") {
         $image = 's'.$link['id'].'.addVariable("image","'.$logourl.'");';
      } else {
         $image = "";
      }
      if($showdigits == 0) {
          $showdigits = 's'.$link['id'].'.addVariable("showdigits","false");';
      } else {
         $showdigits =""; //default = true
      }
      if($showfsbutton == 0) {
         $showfsbutton = 's'.$link['id'].'.addVariable("showfsbutton","false");';
      } else {
         $showfsbutton = "";//default = true
      } 
      if($scroll == 1) { 
         $scroll = 's'.$link['id'].'.addVariable("autoscroll","true");';
      } else { 
         $scroll = ""; //disable autoscroll. default=false
      } 
      if($largecontrol == 1) { 
         $largecontrols = 's'.$link['id'].'.addVariable("largecontrols","true");';
      } else {
         $largecontrols = ""; //default = false
      }
      //** Playlist Flash Variables
      if($start == 0) {
         $autostart = 's'.$link['id'].'.addVariable("autostart","false");';
      } else {
         $autostart = "";// default = true
      }
      if($shuffle == 1) {
         $shuffle = 's'.$link['id'].'.addVariable("shuffle","true");';
      } else {
         $shuffle = "";// default = false
      }
      if($replay == 1) {
         $replay = 's'.$link['id'].'.addVariable("repeat","true");';
      } else {
         $replay = "";// default = false
      }  
      if($showicons == 0) {
         $showicons = 's'.$link['id'].'.addVariable("showicons","false");';
      } else {
         $showicons = "";// default = true
      }     
      if($stretch != "fit") {
         $overstretch = 's'.$link['id'].'.addVariable("overstretch","'.$stretch.'");';
      } else {
         $overstretch = ""; //default = false
      }
      if($showeq == 1 & $srctype == "mp3") {
         $showeq = 's'.$link['id'].'.addVariable("showeq","true");';
      } else {
         $showeq = "";// default = false
      }   
      if($thumbslist == 1) {
         $thumbsinplaylist = 's'.$link['id'].'.addVariable("thumbsinplaylist","true");';
      } else {
         $thumbsinplaylist = "";// default = false
      }    
      if($rotatetime !="0") {
         $rotatetime = 's'.$link['id'].'.addVariable("rotatetime","'.$rotatetime.'");';
      } else {
         $rotatetime = ""; //default = 0
      }
      if($shownav != "0") {
         $shownavigation = 's'.$link['id'].'.addVariable("shownavigation","true");';
      } else {
         $shownavigation = "";
      }        
      if($transition != "0" & $srctype == "image") {
         $transition = 's'.$link['id'].'.addVariable("transition","'.$transition.'");';
      } else {
         $transition = ""; //default = "none"; 0
      }
      if($captions != "" ) {
         $captions = 's'.$link['id'].'.addVariable("captions","'.$captions.'");';
      } else {
         $captions = "";// default = ""
      } 
      //**Player Logo
      if($playerlogo != "") {
         $playerlogo = urlencode($path_webshow.'/images/player/'.$playerlogo);      
         $playerlogo = 's'.$link['id'].'.addVariable("logo","'.$playerlogo.'");';
      } else {
         $playerlogo = "";
      }
      //if($enablejs == 1) {  
      //   $enablejs = 's'.$link['id'].'.addVariable("enablejs","true");';
      //   include "mplay.inc.php";
      //} else {
         $enablejs = ""; //default = false
      //}

      //** SHOWINFO
      //$showinfo = explode("|",$showinfo);
     // if($showinfo[8] == 1 && $listtype == "single") {
          $showdownload = 's'.$link['id'].'.addVariable("showdownload","false");';
      //} else {
          //$showdownload =""; //default = true
     // }
      
      //** Make movie Link
      $movie = '<script type="text/javascript" src="'.$path_webshow.'/swfobject.js"></script>
      <div id="playit'.$link['id'].'"><a href="http://www.macromedia.com/go/getflashplayer">Get the Flash Player</a> to see this player.</div>';
      $movie .='<script type="text/javascript">
   	var s'.$link['id'].' = new SWFObject("'.$path_webshow.'/'.$flashplayer.'","playit'.$link['id'].'","'.$width.'","'.$height.'","7");s'.$link['id'].'.addParam("allowfullscreen","true");'.$bgcolor.
	's'.$link['id'].'.addVariable("file","'.$fileurl.'");s'.$link['id'].'.addVariable("displaywidth","'.$displaywidth.'");s'.$link['id'].'.addVariable("displayheight","'.$displayheight.'");'.$backcolor.$frontcolor.$lightcolor.$type.$singletitle.$image.$showdigits.$showfsbutton.$scroll.$largecontrols.$autostart.$shuffle.$replay.$showicons.$overstretch.$showeq.$thumbsinplaylist.$rotatetime.$shownavigation.$transition.$captions.$playerlogo.$showdownload.'
	s'.$link['id'].'.write("playit'.$link['id'].'");
      </script>'; 
      $link['movie'] = $movie;      
  } else {
      $link['movie'] = ""; 
  }      
  
$block['links'][] = $link;
return $block;
}

//**********************************
//** PLAY IT BLOCK ADMIN
//**********************************
function b_webshow_playit_edit($options) {
global $xoopsDB, $xoopsConfig;
include_once XOOPS_ROOT_PATH."/class/xoopstree.php";

//** Play It Form
$form = _MB_WEBSHOW_SORTDSC.'<br /><br />';
//** OPTION 0  SPOTLIGHT selected by sort.   	  
$form .= _MB_WEBSHOW_SORT."&nbsp;<select name='options[]'>";     
$form .= "<option value='date'";
    if ( $options[0] == "date" ) {
        $form .= " selected='selected'";
    }
    $form .= ">"._MB_WEBSHOW_DATE."</option>\n";

    $form .= "<option value='hits'";
    if($options[0] == "hits"){
        $form .= " selected='selected'";
    }
    $form .= ">"._MB_WEBSHOW_HITS."</option>";

    $form .= "<option value='rating'";
    if ( $options[0] == "rating" ) {
        $form .= " selected='selected'";
    }
    $form .= ">" . _MB_WEBSHOW_RATING . "</option>";

    $form .= "<option value='random'";
    if ( $options[0] == "random" ) {
        $form .= " selected='selected'";
    }
    $form .= ">" . _MB_WEBSHOW_RANDOM . "</option>";

    $form .= "<option value='link'";
    if ( $options[0] == "link" ) {
        $form .= " selected='selected'";
    }
    $form .= ">"._MB_WEBSHOW_SPECIFIC."</option>\n";    
    
    $form .= "</select><br /><br />\n";

//** OPTION1 Link select box
$linktree = new XoopsTree($xoopsDB->prefix("webshow_links"),"lid","title");    
$form .=_MB_WEBSHOW_SPECIFIC."&nbsp;&nbsp;&nbsp;";	
ob_start();
//** example makeMySelBox($title,$order="",$preset_id=0, $none=0, $sel_name="", $onchange="")
$linktree->makeMySelBox("title","title",$options[1],1,"options[1]");
$linkselbox = ob_get_contents();
ob_end_clean();
$form .= $linkselbox."<br /><br />";

//**OPTION2 Category Select
$cattree = new XoopsTree($xoopsDB->prefix("webshow_cat"),"cid","pid");    
$form .= _MB_WEBSHOW_CATLIMIT;	
	ob_start();	
	$cattree->makeMySelBox("cattitle","cattitle",$options[2],1,"options[2]");
	$catselbox = ob_get_contents();
	ob_end_clean();
	$form .= $catselbox."<br /><br />";

//**OPTION3 Player Select Box
$playertree = new XoopsTree($xoopsDB->prefix("webshow_player"),"playerid","playertitle");    
$form .=_MB_WEBSHOW_PLAYER."&nbsp;&nbsp;&nbsp;";	
ob_start(); 
$playertree->makeMySelBox("playertitle","playerid",$options[3],1,"options[3]");
$playerselbox = ob_get_contents();	
ob_end_clean();		 
$form .= $playerselbox;
$form .=_MB_WEBSHOW_PLAYERDSC."&nbsp;&nbsp;&nbsp;<br /><br />";

//** OPTION4 Show Title
$form .= "<input type='radio' name='options[4]' value='1'";
    if ($options[4] == 1) {
        $form .= " checked='checked'";
    }
    $form .= " />"._YES;
$form .= "<input type='radio' name='options[4]' value='0'";
    if ($options[4] == 0) {
        $form .= " checked='checked'";
    }
    $form .= " />"._NO."&nbsp;&nbsp;&nbsp;"._MB_WEBSHOW_SHOWLINKTITLE."<br /><br />";
    
//**OPTION5 Show Logo
$form .= "<input type='radio' name='options[5]' value='1'";
    if ($options[5] == 1) {
        $form .= " checked='checked'";
    }
    $form .= " />"._YES;
$form .= "<input type='radio' name='options[5]' value='0'";
    if ($options[5] == 0) {
        $form .= " checked='checked'";
    }
    $form .= " />"._NO."&nbsp;&nbsp;&nbsp;"._MB_WEBSHOW_SHOWLINKLOGO."<br /><br />";

//**OPTION6 Show DESCRIPTION
$form .= "<input type='radio' name='options[6]' value='1'";
    if ($options[6] == 1) {
        $form .= " checked='checked'";
    }
    $form .= " />"._YES;
$form .= "<input type='radio' name='options[6]' value='0'";
    if ($options[6] == 0) {
        $form .= " checked='checked'";
    }
    $form .= " />"._NO."&nbsp;&nbsp;&nbsp;"._MB_WEBSHOW_SHOWLINKDSC."<br /><br />";

//**OPTION7 Show Pop Up Player Link
$form .= "<input type='radio' name='options[7]' value='1'";
   if ($options[7] == 1) {
        $form .= " checked='checked'";
   }
    $form .= " />"._YES;
$form .= "<input type='radio' name='options[7]' value='0'";
    if ($options[7] == 0) {
        $form .= " checked='checked'";
    }
    $form .= " />"._NO."&nbsp;&nbsp;&nbsp;"._MB_WEBSHOW_SHOWPOPUP."<br /><br />";

//** OPTION8 Show the link statistics
    $form .= "<input type='radio' name='options[8]' value='1'";
    if ($options[8] == 1) {
        $form .= " checked='checked'";
    }
    $form .= " />"._YES;
    $form .= "<input type='radio' name='options[8]' value='0'";
    if ($options[8] == 0) {
      $form .= " checked='checked'";
    }
    $form .= " />"._NO."&nbsp;&nbsp;&nbsp"._MB_WEBSHOW_SHOWLINKSTATS;	
return $form;
}
?>