<?php
// $Id: movie.php,v.50 2007/03/01 19:59:00 tcnet Exp $ //
// Flash Media Player by Jereon Wijering ( http://www.jeroenwijering.com ) is licensed under a Creative Commons License (http://creativecommons.org/licenses/by-nc-sa/2.0/) //
// It allows you to use and modify the script for noncommercial purposes. //
// You must share a like any modifications. // 
// For commercial use you must purchase a license from Jereon Wijering at http://www.jeroenwijering.com/?order=form. //
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //

if (!defined('XOOPS_ROOT_PATH')){ exit(); }

//** Load and show the flash player.
$styleoption = isset($_GET['styleoption']) ? intval($_GET['styleoption']) : $styleoption;
if($styleoption == "") {
   $playerresult = $xoopsDB->query("select styleoption from ".$xoopsDB->prefix("webshow_player")." where playerid=$player");
   list($styleoption) = $xoopsDB->fetchRow($playerresult); 
}

$playerresult = $xoopsDB->query("select bgcolor, backcolor, frontcolor, lightcolor, width, height, displaywidth, displayheight, showdigits, showfsbutton, scroll, largecontrol from ".$xoopsDB->prefix("webshow_player")." where playerid=$player");
list($bgcolor, $backcolor, $frontcolor, $lightcolor, $width, $height, $displaywidth, $displayheight, $showdigits, $showfsbutton, $scroll, $largecontrol) = $xoopsDB->fetchRow($playerresult); 

//** THEMESTYLE
// style option 2: Use colors assigned per theme
if($styleoption == "2") {
   $theme = isset($_GET['theme']) ? $_GET['theme'] : $xoopsConfig['theme_set'];
   $themeresult = $xoopsDB->query("select bgcolor, backcolor, frontcolor, lightcolor from ".$xoopsDB->prefix("webshow_theme")." where themetitle = \"$theme\"");
   list($bgcolor, $backcolor, $frontcolor, $lightcolor) = $xoopsDB->fetchRow($themeresult);
}

//** THEME FROM PLAYER
//** Uses the color style from this player for the page color style.
$themefromplayer = "";
if($styleoption == "4") {
include XOOPS_ROOT_PATH."/modules/".$xoopsModule->getVar("dirname")."/include/playerstyle.inc.php";	  
} 

//** Set the Color Variables for flash script.
$bgcolor = 's'.$lid.'.addParam("bgcolor","'.$bgcolor.'");';
$backcolor = str_replace ( '#','',$backcolor);	
$backcolor = '0x'.$backcolor;
$backcolor = 's'.$lid.'.addVariable("backcolor","'.$backcolor.'");';
$frontcolor = str_replace ( '#','',$frontcolor);
$frontcolor = '0x'.$frontcolor;
$frontcolor = 's'.$lid.'.addVariable("frontcolor","'.$frontcolor.'");';
$lightcolor = str_replace ( '#','',$lightcolor);
$lightcolor = '0x'.$lightcolor;
$lightcolor = 's'.$lid.'.addVariable("lightcolor","'.$lightcolor.'");';

if($styleoption == "1") {
$bgcolor = "";
$backcolor = "";
$frontcolor = "";
$lightcolor = "";
}

$flashresult = $xoopsDB->query("select start, shuffle, replay, link, linktarget, showicons, showeq, stretch, thumbslist, rotatetime, shownav, transition, captions, playerlogo, enablejs from ".$xoopsDB->prefix("webshow_flashvar")." where lid=$lid");
list($start, $shuffle, $replay, $link, $linktarget, $showicons, $showeq, $stretch, $thumbslist, $rotatetime, $shownav, $transition, $captions, $playerlogo, $enablejs)=$xoopsDB->fetchRow($flashresult);

//** FLASH SCRIPT - pick a Jeroen Wijering Flash script according to file type and transition 
if($transition != "0" & $srctype == "image") {
   $flashplayer = "imagerotator.swf";
} else {
   $flashplayer = "mediaplayer.swf";
}

//**Check PLAYLIST CACHE and set fileurl
$cachereport = "";
if($listtype != "single"){
   include 'playlist.php';
   $expired = timePlaylist($listcache,$cachetime);
   if($expired > 0){
      if($listtype == "dir") {     
         createPlaylist($lid);
         $listurl = XOOPS_URL."/modules/".$xoopsModule->getVar("dirname")."/playlist/".$listcache;
      } 
      if($listtype == "feed"){
         fetchPlaylist($lid);
      }
   }   
   $fileurl = urlencode(XOOPS_URL."/modules/".$xoopsModule->getVar("dirname")."/playlist/".$listcache);
}

if ($listtype == 'single' & $srctype != 'image'){
//**NEEDS WORK TO PLAY SINGLE IMAGES
$singletitle = 's'.$lid.'.addVariable("title","'.$ltitle.'");'; 
// check for file extension, if no file extension add file type variable to the movie link.
$fileurl = urlencode($listurl);
$listurl = strtolower($listurl);
$listurlext = substr($listurl, -3);  
$ps = strpos($listurlext,$srctype);
   if ($ps === false) {  
       $type = 's'.$lid.'.addVariable("type","'.$srctype.'");'; 
   } else {
          $type = "";
   }	
} else {
$type = "";
$singletitle = "";
} 

//** SHOWINFO
//$showinfo = explode("|",$showinfo);
if($showinfo[9] == 1 && $listtype == "single") {
    $showdownload = 's'.$lid.'.addVariable("showdownload","false");';
} else {
   $showdownload =""; //default = true
}

//** Playlist Logo
//** If this entry has a logo, display it by adding the image variable to the movie link
if ($logourl != "") {
$ps = strpos($logourl,"http://");
    if($ps === false) {
       $logourl = XOOPS_URL."/".$xoopsModuleConfig['path_logo']."/".$logourl;
    }
$image = 's'.$lid.'.addVariable("image","'.$logourl.'");';  
} else {
    $image ="";
}

if($showdigits == 0) {
    $showdigits = 's'.$lid.'.addVariable("showdigits","false");';
} else {
   $showdigits =""; //default = true
}
if($showfsbutton == 0) {   
   $showfsbutton = 's'.$lid.'.addVariable("showfsbutton","false");';
} else {
   $showfsbutton = "";//default = true
} 
if($scroll == 1) {        
   $scroll = 's'.$lid.'.addVariable("autoscroll","true");';
} else { 
   $scroll = ""; //disable autoscroll. default=false
} 
if($largecontrol == 1) {          
   $largecontrols = 's'.$lid.'.addVariable("largecontrols","true");';
} else { 
   $largecontrols = ""; //default = false
}
if($start == 0) {  
   $autostart = 's'.$lid.'.addVariable("autostart","false");';
} else { 
   $autostart = 's'.$lid.'.addVariable("autostart","true");';
}  
if($shuffle == 1) {  
   $shuffle = 's'.$lid.'.addVariable("shuffle","true");';
} else { 
   $shuffle = "";// default = false
}      
if($replay == 1) {  
   $replay = 's'.$lid.'.addVariable("repeat","true");';
} else { 
   $replay = "";// default = false
}  
if($link == 1) {  
   $linkfromdisplay = 's'.$lid.'.addVariable("linkfromdisplay","true");';
} else { 
   $linkfromdisplay = "";// default = false
} 
if($linktarget != "_self") {
   $linktarget =  's'.$lid.'.addVariable("linktarget","'.$linktarget.'");';
} else {
   $linktarget = ""; //default = _self
}
if($showicons == 0) {  
   $showicons = 's'.$lid.'.addVariable("showicons","false");';
} else { 
   $showicons = "";// default = true
}     
if($stretch != "fit") {
   $overstretch = 's'.$lid.'.addVariable("overstretch","'.$stretch.'");';
} else {
   $overstretch = ""; //default = false
}
if($showeq == 1) {  
   $showeq = 's'.$lid.'.addVariable("showeq","true");';
   } else { 
   $showeq = "";// default = false
}   
if($thumbslist == 1) {  
   $thumbsinplaylist = 's'.$lid.'.addVariable("thumbsinplaylist","true");';
   } else { 
   $thumbsinplaylist = "";// default = false
}    
if($rotatetime !="0") {
   $rotatetime = 's'.$lid.'.addVariable("rotatetime","'.$rotatetime.'");';
   } else {
   $rotatetime = ""; //default = 0
}
if($shownav != "0") { 
   $shownavigation = 's'.$lid.'.addVariable("shownavigation","true");'; 
} else { 
   $shownavigation = "";
}        
if($transition != "0" & $srctype == "image") {
   $transition = 's'.$lid.'.addVariable("transition","'.$transition.'");';
} else {
   $transition = ""; //default = "none"; 0
}
if($captions != "" ) {  
   $captions = 's'.$lid.'.addVariable("captions","'.$captions.'");';
   } else { 
   $captions = "";// default = ""
} 
//**Player Logo
if($playerlogo != "") {
   $playerlogo = urlencode(XOOPS_URL.'/modules/'.$xoopsModule->getVar('dirname').'/images/player/'.$playerlogo);          
   $playerlogo = 's'.$lid.'.addVariable("logo","'.$playerlogo.'");';
} else {
   $playerlogo = "";
}
if($enablejs != 0) {          
   $enablejs = 's'.$lid.'.addVariable("enablejs","true");';   
   $jsid = 's'.$lid.'.addVariable("javascriptid","play'.$lid.'");';
   include 'mplay.inc.php';  
} else { 
   $enablejs = ""; //default = false
   $mplayjs = "";
   $jsid = "";
}

//** Make movie Link
   $movie = '<script type="text/javascript" src="'.XOOPS_URL . '/modules/'. $xoopsModule->getVar('dirname') . '/swfobject.js"></script>
   <div id="play'.$lid.'"><a href="http://www.macromedia.com/go/getflashplayer">Get the Flash Player</a> to see this player.</div>';
   $movie .='<script type="text/javascript">
	var s'.$lid.' = new SWFObject("'.XOOPS_URL.'/modules/'.$xoopsModule->getVar('dirname').'/'.$flashplayer.'","play'.$lid.'","'.$width.'","'.$height.'","7");s'.$lid.'.addParam("allowfullscreen","true");'.$bgcolor.
	's'.$lid.'.addVariable("file","'.$fileurl.'");s'.$lid.'.addVariable("displaywidth","'.$displaywidth.'");s'.$lid.'.addVariable("displayheight","'.$displayheight.'");'.$backcolor.$frontcolor.$lightcolor.$jsid.$type.$singletitle.$image.$showdigits.$showfsbutton.$scroll.$largecontrols.$autostart.$shuffle.$replay.$linkfromdisplay.$linktarget.$showicons.$overstretch.$showeq.$thumbsinplaylist.$rotatetime.$shownavigation.$transition.$captions.$playerlogo.$enablejs.$showdownload.'
	s'.$lid.'.write("play'.$lid.'");
      </script>';	

//** Set pop up window dimensions   
$moviewidth = $width;   
$movieheight = $height;

//** SHOW CHAIN MEDIA
if($chainid != "0") {
//** Load and show the first link in the player chain.
//** The color variables have been removed so that the chain player inherits the first player's color style.
$player2result = $xoopsDB->query("select width, height, displaywidth, displayheight, showdigits, showfsbutton, scroll, largecontrol from ".$xoopsDB->prefix("webshow_player")." where playerid=$chainplayer");
list($width, $height, $displaywidth, $displayheight, $showdigits, $showfsbutton, $scroll, $largecontrol) = $xoopsDB->fetchRow($player2result);
 
$flash2result = $xoopsDB->query("select start, shuffle, replay, link, linktarget, showicons, showeq, stretch, thumbslist, rotatetime, shownav, transition, captions, playerlogo, enablejs from ".$xoopsDB->prefix("webshow_flashvar")." where lid=$chainid");
list($start, $shuffle, $replay, $link, $linktarget, $showicons, $showeq, $stretch, $thumbslist, $rotatetime, $shownav, $transition, $captions, $playerlogo, $enablejs)=$xoopsDB->fetchRow($flash2result);

//** FLASH SCRIPT - pick a Jeroen Wijering Flash script according to file type and transition 
if($transition != "0" & $chainsrctype == "image") {
   $flashplayer = "imagerotator.swf";
} else {
   $flashplayer = "mediaplayer.swf";
}

//** LISTTYPE, LISTURL
//** If $listtype is a directory use the cached playlist
if ($chainlisttype != 'single'){
$chainlistcache = XOOPS_URL."/modules/".$xoopsModule->getVar("dirname").'/playlist/'.$chainlistcache; 
$chainlisturl = $chainlistcache;
$chainfileurl = urlencode($chainlistcache);
}

if ($chainlisttype == 'single' & $chainsrctype != 'image'){
// if single file entry, check for file extension, if no file extension add file type to the movie link.
$singletitle = 's'.$lid.'.addVariable("title","'.$ltitle.'");'; 
$chainfileurl = urlencode($chainlisturl);
$chainlisturl = strtolower($chainlisturl);
$chainlisturlext = substr($chainlisturl, -3);  
$ps = strpos($chainlisturlext,$chainsrctype);
   if ($ps === false) {  
       $type = 's'.$lid.'.addVariable("type","'.$chainsrctype.'");'; 
   } else {
          $type = "";
   }					  
} else {
$type = "";
$singletitle = "";
}

if($styleoption == "1") {
$bgcolor = "";
$backcolor = "";
$frontcolor = "";
$lightcolor = "";
}

//** PLAYER VARIABLES
//**  If the setting = player default, then it is set to "" and excluded from the link.

//** Playlist Logo
//** If this entry has a logo, display it by adding the image variable to the movie link
if ($chainlogourl != "") {
$ps = strpos($chainlogourl,"http://");
    if($ps === false) {
       $chainlogourl = XOOPS_URL."/".$xoopsModuleConfig['path_logo']."/".$chainlogourl;
    }
$image = 's'.$lid.'.addVariable("image","'.$chainlogourl.'");';  
} else {
    $image ="";
}
//** FLASH VARIABLES
if($showdigits == 0) {
    $showdigits = 's'.$lid.'.addVariable("showdigits","false");';
} else {
   $showdigits =""; //default = true
}
if($showfsbutton == 0) {   
   $showfsbutton = 's'.$lid.'.addVariable("showfsbutton","false");';
} else {
   $showfsbutton = "";//default = true
} 
if($scroll == 1) {        
   $scroll = 's'.$lid.'.addVariable("autoscroll","true");';
} else { 
   $scroll = ""; //disable autoscroll. default=false
} 
if($largecontrol == 1) {          
   $largecontrols = 's'.$lid.'.addVariable("largecontrols","true");';
} else { 
   $largecontrols = ""; //default = false
}
if($start == 0) {  
   $autostart = 's'.$lid.'.addVariable("autostart","false");';
} else { 
   $autostart = 's'.$lid.'.addVariable("autostart","true");';
}  
if($shuffle == 1) {  
   $shuffle = 's'.$lid.'.addVariable("shuffle","true");';
} else { 
   $shuffle = "";// default = false
}      
if($replay == 1) {  
   $replay = 's'.$lid.'.addVariable("repeat","true");';
} else { 
   $replay = "";// default = false
}  
if($link == 1) {  
   $linkfromdisplay = 's'.$lid.'.addVariable("linkfromdisplay","true");';
} else { 
   $linkfromdisplay = "";// default = false
} 
if($linktarget != "_self") {
   $linktarget =  's'.$lid.'.addVariable("linktarget","'.$linktarget.'");';
} else {
   $linktarget = ""; //default = _self
}
if($showicons == 0) {  
   $showicons = 's'.$lid.'.addVariable("showicons","false");';
} else { 
   $showicons = "";// default = true
}     
if($stretch != "fit") {
   $overstretch = 's'.$lid.'.addVariable("overstretch","'.$stretch.'");';
} else {
   $overstretch = ""; //default = false
}
if($showeq == 1) {  
   $showeq = 's'.$lid.'.addVariable("showeq","true");';
   } else { 
   $showeq = "";// default = false
}   
if($thumbslist == 1) {  
   $thumbsinplaylist = 's'.$lid.'.addVariable("thumbsinplaylist","true");';
   } else { 
   $thumbsinplaylist = "";// default = false
}    
if($rotatetime !="0") {
   $rotatetime = 's'.$lid.'.addVariable("rotatetime","'.$rotatetime.'");';
   } else {
   $rotatetime = ""; //default = 0
}
if($shownav != "0") { 
   $shownavigation = 's'.$lid.'.addVariable("shownavigation","true");'; 
} else { 
   $shownavigation = "";
}        
if($transition != "0" & $chainsrctype == "image") {
   $transition = 's'.$lid.'.addVariable("transition","'.$transition.'");';
} else {
   $transition = ""; //default = "none"; 0
}
if($captions != "" ) {  
   $captions = 's'.$lid.'.addVariable("captions","'.$captions.'");';
   } else { 
   $captions = "";// default = ""
} 
//**Player Logo
if($playerlogo != "") {
   $playerlogo = urlencode(XOOPS_URL.'/modules/'.$xoopsModule->getVar('dirname').'/images/player/'.$playerlogo);          
   $playerlogo = 's'.$lid.'.addVariable("logo","'.$playerlogo.'");';
} else {
   $playerlogo = "";
}
if($enablejs != 0) {          
   $enablejs = 's'.$lid.'.addVariable("enablejs","true");';   
   $jsid = 's'.$lid.'.addVariable("javascriptid","play'.$lid.'");';
   include 'mplay.inc.php';  
} else { 
   $enablejs = ""; //default = false
   $mplayjs = "";
   $jsid = "";
}

//** Make movie Link
   $chainmovie ='<div id="play'.$chainid.'"><a href="http://www.macromedia.com/go/getflashplayer">Get the Flash Player</a> to see this player.</div>
      <script type="text/javascript">
	var s'.$lid.' = new SWFObject("'.XOOPS_URL.'/modules/'.$xoopsModule->getVar('dirname').'/'.$flashplayer.'","play'.$lid.'","'.$width.'","'.$height.'","7");s'.$lid.'.addParam("allowfullscreen","true");'.$bgcolor.'
 	s'.$lid.'.addVariable("file","'.$chainfileurl.'");s'.$lid.'.addVariable("displaywidth","'.$displaywidth.'");s'.$lid.'.addVariable("displayheight","'.$displayheight.'");'.$backcolor.$frontcolor.$lightcolor.$type.$singletitle.$image.$showdigits.$showfsbutton.$scroll.$largecontrols.$autostart.$shuffle.$replay.$linkfromdisplay.$linktarget.$showicons.$overstretch.$showeq.$thumbsinplaylist.$rotatetime.$shownavigation.$transition.$captions.$playerlogo.$enablejs.'
	s'.$lid.'.write("play'.$chainid.'");
      </script>';	

//** Set pop up window dimensions
if($width > $moviewidth) {
    $moviewidth = $width;
}    
$movieheight = $movieheight + $height + 30;     
}else{ 
$chainmovie = "";
}
?>