<?php
// $Id: admin/index.php,v.50 2007/03/01 19:59:00 tcnet Exp $ //
// Flash Media Player by Jeroen Wijering ( http://www.jeroenwijering.com ) is licensed under a Creative Commons License (http://creativecommons.org/licenses/by-nc-sa/2.0/) //
// It allows you to use and modify the script for noncommercial purposes. //
// You must share alike any modifications. // 
// For commercial use you must purchase a license from Jereon Wijering at http://www.jeroenwijering.com/?order=form. //
// By installing and using the WebShow module you agree that you will not use it to display, distribute
// or syndicate a third party's copyright protected media without the owner's permission.  
// The WebShow software is not to be used to display or syndicate illegal or copyright protected media content.
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //
//** Updates to the latest WebShow version
if (!defined('XOOPS_ROOT_PATH')){ exit(); }

include 'functions.php'; 
include_once XOOPS_ROOT_PATH.'/class/module.errorhandler.php';
$eh = new ErrorHandler;

global $xoopsDB, $xoopsConfig, $xoopsModule, $xoopsModuleConfig;

//******  All Updates  *****//
//** Clear Tpl Cache code from Herve Thoussard News Module
	$tpllist=array('webshow_brokenlink.html','webshow_block_billboard.html','webshow_block_links.html','webshow_block_playit.html','webshow_tag_block_cloud.html','webshow_tag_block_top.html');
	include_once XOOPS_ROOT_PATH."/class/xoopsblock.php";
	include_once XOOPS_ROOT_PATH.'/class/template.php';
	// Clear blocks cache
	xoops_template_clear_module_cache($xoopsModule->getVar('mid'));
	// Clear pages cache
	$xoopsTpl = new XoopsTpl();
	foreach ($tpllist as $onetemplate) {
		$xoopsTpl->clear_cache('db:'.$onetemplate);
	}
	
// update version .53 to .55
//** Check and Alter DB tables
//** Create the webshow_theme table
$themeresult=$xoopsDB->queryF("SHOW TABLES LIKE 'webshow_theme'");
if (!$xoopsDB->getRowsNum($themeresult) > 0) {
	$xoopsDB->queryF("CREATE TABLE ".$xoopsDB->prefix('webshow_theme')." (
     themeid int(11) unsigned NOT NULL auto_increment,
     themetitle varchar(24) NOT NULL default '',
     bgcolor varchar(7) NOT NULL default '',
     backcolor varchar(7) NOT NULL default '',
     frontcolor varchar(7) NOT NULL default '',
     lightcolor varchar(7) NOT NULL default '',
     PRIMARY KEY  (themeid),
     KEY themetitle (themetitle(24))
     ) TYPE=MyISAM;");
}

//** Add new db fields
      $result14 = $xoopsDB->queryF("SHOW COLUMNS FROM ".$xoopsDB->prefix('webshow_player')." LIKE 'styleoption'");
	if (!$xoopsDB->getRowsNum($result14) > 0) {
	$xoopsDB->queryF("ALTER TABLE " . $xoopsDB->prefix('webshow_player') . " ADD styleoption TINYINT( 2 ) DEFAULT '0' NOT NULL;") or $eh->show("0013");
	$xoopsDB->queryF("UPDATE ".$xoopsDB->prefix('webshow_player')." SET styleoption = 2") or $eh->show("0013");	
	} 	

      $result13 = $xoopsDB->queryF("SHOW COLUMNS FROM ".$xoopsDB->prefix('webshow_links')." LIKE 'entryperm'");
	if (!$xoopsDB->getRowsNum($result13) > 0) {
	$xoopsDB->queryF("ALTER TABLE " . $xoopsDB->prefix('webshow_links') . " ADD entryperm VARCHAR( 64 ) DEFAULT '' NOT NULL;") or $eh->show("0013");
	$xoopsDB->queryF("UPDATE ".$xoopsDB->prefix('webshow_links')." SET entryperm = '1 2 3' ") or $eh->show("0013");
	} 

      $result12 = $xoopsDB->queryF("SHOW COLUMNS FROM ".$xoopsDB->prefix('webshow_links')." LIKE 'published'");
	if (!$xoopsDB->getRowsNum($result12) > 0) {
	$xoopsDB->queryF("ALTER TABLE " . $xoopsDB->prefix('webshow_links') . " ADD published INT( 10 ) DEFAULT '0' NOT NULL;") or $eh->show("0013");
	$xoopsDB->queryF("UPDATE ".$xoopsDB->prefix('webshow_links')." SET published =0 ") or $eh->show("0013");
	} 

      $result11 = $xoopsDB->queryF("SHOW COLUMNS FROM ".$xoopsDB->prefix('webshow_links')." LIKE 'expired'");
	if (!$xoopsDB->getRowsNum($result11) > 0) {
	$xoopsDB->queryF("ALTER TABLE " . $xoopsDB->prefix('webshow_links') . " ADD expired INT( 10 ) DEFAULT '0' NOT NULL;") or $eh->show("0013");
	} 
	
	$result10 = $xoopsDB->queryF("SHOW COLUMNS FROM ".$xoopsDB->prefix('webshow_links')." LIKE 'cachetime'");
	if (!$xoopsDB->getRowsNum($result10) > 0) {
	$xoopsDB->queryF("ALTER TABLE " . $xoopsDB->prefix('webshow_links') . " ADD cachetime INT( 11 ) DEFAULT '86400' NOT NULL;") or $eh->show("0013");
	} 

//** Add playlist cache field and make directory
	$result9 = $xoopsDB->queryF("SHOW COLUMNS FROM ".$xoopsDB->prefix('webshow_links')." LIKE 'listcache'");
	if (!$xoopsDB->getRowsNum($result9) > 0) {
	   $xoopsDB->queryF("ALTER TABLE " . $xoopsDB->prefix('webshow_links') . " ADD listcache VARCHAR( 250 ) DEFAULT '' NOT NULL;") or $eh->show("0013");
         echo "This version of WebShow plays from a directory of cached playlists.<br />You must click the button below to create the cache of your playlists.<br/>Depending on the number of external playlists in use and the speed of your server, this may take some time.<br />";
         echo "<form method=get action=\"../webshow/admin/index.php\"><input type=\"button\" value=\"Create the Playlist Cache\" onClick=\"location='../webshow/admin/index.php?op=cacheAll'\"></form>";		
         }

	$result8 = $xoopsDB->queryF("SHOW COLUMNS FROM ".$xoopsDB->prefix('webshow_links')." LIKE 'author'");
	if ($xoopsDB->getRowsNum($result8) > 0) {
	$xoopsDB->queryF("ALTER TABLE " . $xoopsDB->prefix('webshow_links') . " CHANGE `author` `artist` VARCHAR( 100 ) DEFAULT '' NOT NULL;") or $eh->show("0013");
	}
	
	$result81 = $xoopsDB->queryF("SHOW COLUMNS FROM ".$xoopsDB->prefix('webshow_links')." LIKE 'artist'");
	if (!$xoopsDB->getRowsNum($result81) > 0) {	
	    $xoopsDB->queryF("ALTER TABLE " . $xoopsDB->prefix('webshow_links') . " ADD artist VARCHAR( 100 ) DEFAULT '' NOT NULL;") or $eh->show("0013");
	}

	$result7 = $xoopsDB->queryF("SHOW COLUMNS FROM ".$xoopsDB->prefix('webshow_links')." LIKE 'album'");
	if (!$xoopsDB->getRowsNum($result7) > 0) {
	$xoopsDB->queryF("ALTER TABLE " . $xoopsDB->prefix('webshow_links') . " ADD album VARCHAR( 100 ) DEFAULT '' NOT NULL;") or $eh->show("0013");
	}
	
	$result6 = $xoopsDB->queryF("SHOW COLUMNS FROM ".$xoopsDB->prefix('webshow_links')." LIKE 'label'");
	if (!$xoopsDB->getRowsNum($result6) > 0) {
	$xoopsDB->queryF("ALTER TABLE " . $xoopsDB->prefix('webshow_links') . " ADD label VARCHAR( 100 ) DEFAULT '' NOT NULL;") or $eh->show("0013");
	} 
	
	$result5 = $xoopsDB->queryF("SHOW COLUMNS FROM ".$xoopsDB->prefix('webshow_flashvar')." LIKE 'enablejs'");
	if (!$xoopsDB->getRowsNum($result5) > 0) {
	$xoopsDB->queryF("ALTER TABLE " . $xoopsDB->prefix('webshow_flashvar') . " ADD enablejs TINYINT( 2 ) DEFAULT '0' NOT NULL;") or $eh->show("0013");
	}	

	$result4 = $xoopsDB->queryF("SHOW COLUMNS FROM ".$xoopsDB->prefix('webshow_flashvar')." LIKE 'captions'");
	if (!$xoopsDB->getRowsNum($result4) > 0) {
	$xoopsDB->queryF("ALTER TABLE " . $xoopsDB->prefix('webshow_flashvar') . " ADD captions VARCHAR( 255 ) DEFAULT '' NOT NULL;") or $eh->show("0013");
	}

	$result3 = $xoopsDB->queryF("SHOW COLUMNS FROM ".$xoopsDB->prefix('webshow_flashvar')." LIKE 'playerlogo'");
	if (!$xoopsDB->getRowsNum($result3) > 0) {
	$xoopsDB->queryF("ALTER TABLE " . $xoopsDB->prefix('webshow_flashvar') . " ADD playerlogo VARCHAR( 255 ) DEFAULT '' NOT NULL;") or $eh->show("0013");
	$xoopsDB->queryF("ALTER TABLE " . $xoopsDB->prefix('webshow_player') . " DROP playerlogo") or $eh->show("0013");		
	}

	$result2 = $xoopsDB->queryF("SHOW COLUMNS FROM ".$xoopsDB->prefix('webshow_player')." LIKE 'displaywidth'");
	if (!$xoopsDB->getRowsNum($result2) > 0) {		
	$xoopsDB->queryF("ALTER TABLE " . $xoopsDB->prefix('webshow_player') . " ADD displaywidth INT( 4 ) DEFAULT '0' NOT NULL;") or $eh->show("0013");
      $result21 = $xoopsDB->queryF("SELECT (playerid) FROM ".$xoopsDB->prefix('webshow_player')." WHERE displaywidth = 0 ");
        while(list($playerid)=$xoopsDB->fetchRow($result21)) {
          echo _MD_MODIFY._MD_PLAYER.": Setting default displaywidth values.<br />";
          $xoopsDB->queryF("UPDATE ".$xoopsDB->prefix('webshow_player')." SET displaywidth = width") or $eh->show("0013");			
        } 	
	} 	

	$result1 = $xoopsDB->queryF("SHOW COLUMNS FROM ".$xoopsDB->prefix('webshow_player')." LIKE 'largecontrol'");
	if (!$xoopsDB->getRowsNum($result1) > 0) {		
      $xoopsDB->queryF("ALTER TABLE " . $xoopsDB->prefix('webshow_player') . " ADD largecontrol TINYINT( 2 ) DEFAULT '0' NOT NULL;") or $eh->show("0013");
      } 

   if(@is_dir(XOOPS_ROOT_PATH."/modules/webshow/playlist")){
      //if theplaylist directory exists check if it contains files. it is assumed that the directory has one dummy index.html file
      $dir = opendir(XOOPS_ROOT_PATH."/modules/webshow/playlist");
      $i=0;
      while (($file = readdir($dir)) !== false) {
        $i++;
      }closedir($dir); 
      if($i < 3) {
         define("_MD_LISTCACHE_UPDATE","Create Playlist Cache");
         define("_MD_LISTCACHE_UPDATEDSC","Click the button to fetch/create a cache of your playlists.  WebShow v.55 requires a cache of all internal and external playlists.  This only needs to be done one time when updating from v.53 to v.55.  This may take a long time depending on server speed and the number of playlists in use.");   
         echo _MD_LISTCACHE_UPDATEDSC."<br /><br /><input type=\"button\" value=\""._MD_LISTCACHE_UPDATE."\" onClick=\"location='".XOOPS_ROOT_PATH."/modules/webshow/admin/index.php?op=cacheAll'\"></input><br /><br />";			  
      }
   } else {
     echo "<font color=\"red\">The directory webshow/playlist does not exist! Please create webshow/playlist directory and set its write permissions.</font><br /><br />";
   }

  // Delete old files
  if (file_exists(XOOPS_ROOT_PATH."/modules/webshow/dirplaylist.php")) {
    unlink(XOOPS_ROOT_PATH."/modules/webshow/dirplaylist.php"); 
  }
  if (file_exists(XOOPS_ROOT_PATH."/modules/webshow/fullscreen.html")) {
    unlink(XOOPS_ROOT_PATH."/modules/webshow/fullscreen.html"); 
  }
  if (file_exists(XOOPS_ROOT_PATH."/modules/webshow/ufo.js")) {
    unlink(XOOPS_ROOT_PATH."/modules/webshow/ufo.js"); 
  }
    if (file_exists(XOOPS_ROOT_PATH."/modules/webshow/change_log.txt")) {
    unlink(XOOPS_ROOT_PATH."/modules/webshow/change_log.txt"); 
  }
    if (file_exists(XOOPS_ROOT_PATH."/modules/webshow/readme.txt")) {
    unlink(XOOPS_ROOT_PATH."/modules/webshow/readme.txt"); 
  }
  if (file_exists(XOOPS_ROOT_PATH."/modules/webshow/xspfgen.php")) {
    unlink(XOOPS_ROOT_PATH."/modules/webshow/xspfgen.php"); 
  }
  if (file_exists(XOOPS_ROOT_PATH."/modules/webshow/templates/playerstyle.inc.php")) {
    unlink(XOOPS_ROOT_PATH."/modules/webshow/templates/playerstyle.inc.php"); 
  }
  if (file_exists(XOOPS_ROOT_PATH."/modules/webshow/include/update.inc.php")) {
    unlink(XOOPS_ROOT_PATH."/modules/webshow/include/update.inc.php"); 
  }
  if (file_exists(XOOPS_ROOT_PATH."/modules/webshow/include/xspfgen.inc.php")) {
    unlink(XOOPS_ROOT_PATH."/modules/webshow/include/xspfgen.inc.php"); 
  }
  
//** update v.55 to v.57
// Add showinfo to links table
$result15 = $xoopsDB->queryF("SHOW COLUMNS FROM ".$xoopsDB->prefix('webshow_links')." LIKE 'showinfo'");
   if (!$xoopsDB->getRowsNum($result15) > 0) {
      $xoopsDB->queryF("ALTER TABLE " . $xoopsDB->prefix('webshow_links') . " ADD showinfo VARCHAR( 24 ) DEFAULT '1|1|1|1|1|1|1|1|1|1|1|1' NOT NULL;") or $eh->show("0013");
   } else {    
       $xoopsDB->queryF("UPDATE ".$xoopsDB->prefix('webshow_links')." SET showinfo =  '1|1|1|1|1|1|1|1|1|1|1|1' ") or $eh->show("0013");
   }
$result15a = $xoopsDB->queryF("SHOW COLUMNS FROM ".$xoopsDB->prefix('webshow_links')." LIKE 'down'");
if ($xoopsDB->getRowsNum($result15a) > 0) {
   $xoopsDB->queryF("ALTER TABLE " . $xoopsDB->prefix('webshow_links') . " DROP down") or $eh->show("0013");
} 

//******************************* update v.57 to v.61 *****************************//
// Add showinfo to links table
$result61 = $xoopsDB->queryF("SHOW COLUMNS FROM ".$xoopsDB->prefix('webshow_mod')." LIKE 'author'");
if ($xoopsDB->getRowsNum($result61) > 0) {
  $xoopsDB->queryF("ALTER TABLE " . $xoopsDB->prefix('webshow_mod') . " CHANGE `author` `artist` VARCHAR( 100 ) DEFAULT '' NOT NULL;") or $eh->show("0013");
}
$result61a = $xoopsDB->queryF("SHOW COLUMNS FROM ".$xoopsDB->prefix('webshow_mod')." LIKE 'label'");
if (!$xoopsDB->getRowsNum($result61a) > 0) {
   $xoopsDB->queryF("ALTER TABLE " . $xoopsDB->prefix('webshow_mod') . " ADD  label VARCHAR( 100 ) DEFAULT '' NOT NULL;") or $eh->show("0013");
} 
$result61b = $xoopsDB->queryF("SHOW COLUMNS FROM ".$xoopsDB->prefix('webshow_mod')." LIKE 'ws_tag'");
if (!$xoopsDB->getRowsNum($result61b) > 0) {
   $xoopsDB->queryF("ALTER TABLE " . $xoopsDB->prefix('webshow_mod') . " ADD  ws_tag VARCHAR( 250 ) DEFAULT '' NOT NULL;") or $eh->show("0013");
} 

$xoopsDB->queryF("UPDATE ".$xoopsDB->prefix('webshow_links')." SET comments = 1") or $eh->show("0013");	

//** Delete old files
  if (file_exists(XOOPS_ROOT_PATH."/modules/webshow/include/wsdwnlod.php")) {
    unlink(XOOPS_ROOT_PATH."/modules/webshow/include/wsdwnlod.php"); 
  }

?>