<?php
// $Id: index.php,v.50 2007/03/01 19:59:00 tcnet Exp $ //
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
// ------------------------------------------------------------------------- //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //
include "header.php";
$myts =& MyTextSanitizer::getInstance(); // MyTextSanitizer object
include_once XOOPS_ROOT_PATH."/class/xoopstree.php";
$mytree = new XoopsTree($xoopsDB->prefix("webshow_cat"),"cid","pid");
$xoopsOption['template_main'] = 'webshow_index.html';
include XOOPS_ROOT_PATH."/header.php";
$groups = is_object($xoopsUser) ? $xoopsUser->getGroups() : XOOPS_GROUP_ANONYMOUS;
$gperm_handler =& xoops_gethandler('groupperm');
$count = 1;
$content=""; // build string for keywords

$modname = $myts->makeTboxData4Show($xoopsModule->getVar('name'));
$xoopsTpl->assign('modname', $modname);

$moddesc = $myts->makeTareaData4Show($xoopsModuleConfig['moddesc'],0);
$xoopsTpl->assign('moddesc', $moddesc);

$result=$xoopsDB->query("SELECT cid, cattitle, imgurl FROM ".$xoopsDB->prefix("webshow_cat")." WHERE pid = 0 ORDER BY cattitle") or exit("Error");
while($myrow = $xoopsDB->fetchArray($result)) {
   //**Permissions
   // example checkRight($gperm_name, $gperm_itemid, $gperm_groupid, $gperm_modid = 1)
   if ($gperm_handler->checkRight('webshow_view', $myrow['cid'], $groups, $xoopsModule->getVar('mid'))) {
	$imgurl = '';
	if ($myrow['imgurl'] && $myrow['imgurl'] != ""){
		$imgurl = $myts->makeTboxData4Show($myrow['imgurl']);
	}
	$totallink = getTotalItems($myrow['cid'], 1);
	// get child category objects
	$arr = array();
	$arr = $mytree->getFirstChild($myrow['cid'], "cattitle");
	$space = 0;
	$chcount = 0;
	$subcategories = '';
	foreach($arr as $ele){
	  if ($gperm_handler->checkRight('webshow_view', $ele['cid'], $groups, $xoopsModule->getVar('mid'))) {
		$chtitle = $myts->makeTboxData4Show($ele['cattitle']);
		if ($chcount > 5) {
			$subcategories .= "...";
			break;
		}
		if ($space>0) {
			$subcategories .= "<br /> ";
		}
		$subcategories .= "--<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/viewcat.php?cid=".$ele['cid']."\">".$chtitle."</a>";
		$space++;
		$chcount++;
	    }
	}
	$xoopsTpl->append('categories', array('image' => $imgurl, 'id' => $myrow['cid'], 'cattitle' => $myts->makeTboxData4Show($myrow['cattitle']), 'subcategories' => $subcategories, 'totallink' => $totallink, 'count' => $count));
      $content.=$myts->makeTboxData4Show($myrow['cattitle']).' ';
	$count++;
   }
}

$numrows=0;
//** ADMIN
   $isadmin = "";
   $adminlink = "";
   	
list($numrows) = $xoopsDB->fetchRow($xoopsDB->query("select count(*) from ".$xoopsDB->prefix("webshow_links")." where status>0"));
if($numrows != 0) {
$xoopsTpl->assign('thereare', sprintf(_MD_THEREARE,$numrows));

$result = $xoopsDB->query("SELECT l.lid, l.cid, l.title, l.url, l.listurl, l.showinfo, l.srctype, l.listtype, l.listcache, l.logourl, l.status, l.date, l.hits, l.rating, l.votes, l.comments, l.submitter, l.entryperm, t.description FROM ".$xoopsDB->prefix("webshow_links")." l, ".$xoopsDB->prefix("webshow_text")." t where l.status>0 and cid >0 and l.lid=t.lid ORDER BY date DESC", $xoopsModuleConfig['newlinks'], 0);
while(list($lid, $cid, $title, $url, $listurl, $showinfo, $srctype, $listtype, $listcache, $logourl, $status, $time, $hits, $rating, $votes, $comments, $submitter, $ws_entryperm, $description) = $xoopsDB->fetchRow($result)) {

  if(!$listurl){
     // Missing media/playlist url reset status
     $status = -3;
     $xoopsDB->queryF("update ".$xoopsDB->prefix("webshow_links")." set status=-3 where lid=".$lid."");
  }
  if($listtype == "feed" && $listtype == "dir") {
     if(!$listcache){
        // Missing listcache reset status
        $status = -4;
        $xoopsDB->queryF("update ".$xoopsDB->prefix("webshow_links")." set status=-4 where lid=".$lid."");
     }
  } 
  
//**Permissions
$groups = is_object($xoopsUser) ? $xoopsUser->getGroups() : XOOPS_GROUP_ANONYMOUS;
$gperm_handler =& xoops_gethandler('groupperm');
// example checkRight($gperm_name, $gperm_itemid, $gperm_groupid, $gperm_modid = 1)
if ($gperm_handler->checkRight('webshow_view', $cid, $groups, $xoopsModule->getVar('mid'))) {

//** Entry Permission
$group = is_object($xoopsUser) ? $xoopsUser->getGroups() : array(XOOPS_GROUP_ANONYMOUS);
$ws_entryperm = explode(" ",$ws_entryperm);
if (count(array_intersect($group,$ws_entryperm)) > 0)
{

//** ADMIN
if ($xoopsUser && $xoopsUser->isAdmin($xoopsModule->mid())) {
   $isadmin = true;
   $adminlink = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/admin/index.php?op=modLink&amp;lid=".$lid."\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/editicon.gif\" border=\"0\" alt=\""._MD_EDITTHISLINK."\" /></a>";
}

$ltitle = $myts->makeTboxData4Show($title);
$new = newlinkgraphic($time, $status);
$pop = popgraphic($hits);
$title = $ltitle.$new.$pop;
$title = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/singlelink.php?lid=".$lid."\" target=\"_self\" title=\""._MD_VIEWLISTING." - ".$ltitle."\">".$title."</a>";
$url = $myts->makeTboxData4Show($url);
$listurl = $myts->makeTboxData4Show($listurl);
if($listtype == "dir") { 
  $listurl =  XOOPS_URL."/modules/".$xoopsModule->getVar("dirname")."/playlist/".$listcache;
}

$path = $mytree->getPathFromId($cid, "cattitle");
$path = substr($path, 1);
$path = str_replace("/"," <img src='".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/arrow.gif' border='0' alt=''> ",$path);

//** MODIFY ENTRY LINK. Display to admin and submitter only.
if ($xoopsUser) {
$user = $xoopsUser->getVar('uid');
   if ($user == $submitter | $isadmin) {
       $modlink = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/modlink.php?lid=".$lid."\" title=\""._MD_MODIFY."\">"._MD_MODIFY."<img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/modify.gif\" border=\"0\" alt=\""._MD_MODIFY."\" /></a>";  
   } else {
       $modlink = "";
   }
}

//** SHOWINFO  Displays selected information.
//$showinfo = array();
//$showinfo = explode("|",$showinfo);

//** INFORMATION BOX OFF
//$infobox = 1;
//if ($showinfo[0] != 1) {
//   $infobox="";
//}

//** Block Description
$description = $myts->makeTareaData4Show($description,0);
$metadesc = strip_tags($description);
if(!$showinfo[1]){
   $description = "";
}

//** ENTRY LOGO
if($showinfo[2] == 1 & $logourl != ""){
   $ps = strpos($logourl,"http://");
   if($ps === false) {
      $logourl = XOOPS_URL."/".$xoopsModuleConfig['path_logo']."/".$logourl;
   }
   $logourl = $myts->makeTboxData4Show($logourl);
}else{
$logourl = "";
}

//** CREDITS (C) //Needs work for enablejs
if($showinfo[3] == 1){
  //** Javascript enabled.  If enablejs is true in movie.php then include/mplayjs.inc.php.  Replaces credits from db with credits from xml playlist.
  if($mplayjs !="") {
     $xoopsTpl->assign('mplayjs',$mplayjs);
  }else{
     $artist = $myts->makeTboxData4Show($artist);
     $album = $myts->makeTboxData4Show($album);
     $label = $myts->makeTboxData4Show($label);
  }
}else{
  $artist = "";
  $album = "";
  $label = "";
} 

//STATISTICS
if($showinfo[4] == 1){
$updated = formatTimestamp($time,"m");
   if ($votes == 1) {
        $votestring = _MD_ONEVOTE;
   } else {
        $votestring = sprintf(_MD_NUMVOTES,$votes);
   } 
}else{
$hits = "";
$votestring = "";
$updated = "";
}

//** SUBMITTER
$submittername = "";
if($showinfo[5] == 1){
   $submittername = xoops_getLinkedUnameFromId($submitter);
}

//** PAGE LINK
$pagelink = "";
if($showinfo[6] == 1){
$pagelink = 1;
}

//** WEB SITE LINK & BUTTON
$sitelink = "";
$sitebutton = "";
if($showinfo[7] == 1 &&$url !="" ){
   $sitelink = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/visit.php?cid=".$cid."&amp;lid=".$lid."\" target=\"_blank\" title=\""._MD_VISIT." "._MD_WEBSITE.": ".$url."\">"._MD_WEBSITE."</a>";
   $sitebutton = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/visit.php?cid=".$cid."&amp;lid=".$lid."\" target=\"_blank\" title=\""._MD_VISIT." "._MD_WEBSITE.": ".$url."\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/link.gif\" border=\"0\" alt=\""._MD_VISIT." "._MD_WEBSITE." ".$url."\"> </a>";
}

//** EMBED LINK BOX
//if $listurl is from this domain, show embed link
//Disabled.  Available in singlelink.php only

//$embed = "";
//if($showinfo[8] == 1){
//   $ps = strpos(strtolower($listurl), XOOPS_URL); //Embed link for local media only.
//   if (!($ps === false)) {  
//      $embed = "&lt;embed src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar("dirname")."/mediaplayer.swf\" width=\"".$width."\" height=\"".$height."\" type=\"application/x-shockwave-flash\" pluginspage=\"http://www.macromedia.com/go/getflashplayer\" flashvars=\"file=".$listurl."&displayheight=".$displayheight."\" /&gt;";
//   }
//}
   
//** DOWNLOAD LINK AND BUTTON.  For single file entry only.  Other entries use web feed link and button instead.
$downlink = "";
$downbutton = "";
if($showinfo[9] == 1){
//** Download Permission
$groups = is_object($xoopsUser) ? $xoopsUser->getGroups() : XOOPS_GROUP_ANONYMOUS;
$gperm_handler =& xoops_gethandler('groupperm');
   if ($gperm_handler->checkRight('webshow_download', $cid, $groups, $xoopsModule->getVar('mid'))) {    
      if($listtype == "single"){
         //** Allowed file extensions
         $allowext = " mp3 | jpg | gif | png | swf | flv";
         $ext = strToLower(substr($listurl,strlen($listurl)-3, 3));
         $extok = strpos($allowext,$ext);
         if($extok != ""){
            $downlink = "<a href=\"#\" title=\"".$ltitle." "._MD_DOWNLOAD."\" onClick= \"location='".XOOPS_URL."/modules/".$xoopsModule->getVar("dirname")."/wsdwnlod.php?lid=".$lid."'\">"._MD_DOWNLOAD."</a>";
            $downbutton = "<a href=\"#\" title=\"".$ltitle." "._MD_DOWNLOAD."\" onClick= \"location='".XOOPS_URL."/modules/".$xoopsModule->getVar("dirname")."/wsdwnlod.php?lid=".$lid."'\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/download.png\" border=\"0\" alt=\"".$ltitle." "._MD_DOWNLOAD."\" /> </a>"; 
         }
      } 
   }
}
       
//** WEB FEED LINK & BUTTON
$feedlink = "";
$feedbutton = "";
if($showinfo[9] == 1 && $listtype != "single") {
  $feedlink = "<a href=\"".$listurl."\" target=\"_blank\" title=\"".$ltitle." "._MD_WEBFEED."\">"._MD_WEBFEED."</a>"; 
  $feedbutton = "<a href=\"".$listurl."\" target=\"_blank\" title=\"".$ltitle." "._MD_WEBFEED."\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/webfeed.png\" border=\"0\" alt=\"".$ltitle." "._MD_WEBFEED."\" /> </a>"; 
}

//** POPUP PLAYER BUTTON
//** Java script opens popmovie.php in a new window.
if ($showinfo[10] == 1) {
   $popbutton = "<span onClick= \"window.open('popmovie.php?lid=".$lid."','popmovie".$lid."','directories=no,toolbar=no,location=no,menubar=no');return false;\" style=\"cursor:hand;\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/popbutton.png\" alt=\"".$ltitle." "._MD_POPUP." "._MD_PLAYER."\" /></span>";
}else{
   $popbutton ="";  
}

//** TAGS
if($xoopsModuleConfig['tags']){
   if ($showinfo[11] == 1) {
      $itemid = $lid;
      include_once XOOPS_ROOT_PATH."/modules/tag/include/tagbar.php";
      $xoopsTpl->assign('tagbar', tagBar($itemid, $catid = 0));
   }
}

$xoopsTpl->append('links', array('id' => $lid, 'cid' => $cid, 'rating' => number_format($rating, 2), 'ltitle' => $ltitle, 'title' => $title, 'srctype'=> $srctype, 'listtype'=> $listtype, 'url'=> $url, 'category' => $path, 'listurl' => $listurl, 'logourl' => $logourl, 'popbutton' => $popbutton, 'feedlink' => $feedlink, 'feedbutton' => $feedbutton, 'sitelink'=> $sitelink, 'sitebutton'=> $sitebutton, 'updated' => $updated, 'description' => $description, 'adminlink' => $adminlink, 'modlink' => $modlink, 'hits' => $hits, 'votes' => $votestring, 'submitter' => $submitter, 'submittername' => $submittername, 'comments' => $comments, 'mail_subject' => rawurlencode(sprintf(_MD_INTRESTLINK,$xoopsConfig['sitename'])), 'mail_body' => rawurlencode(sprintf(_MD_INTLINKFOUND,$xoopsConfig['sitename']).':  '.XOOPS_URL.'/modules/'.$xoopsModule->getVar("dirname").'/singlelink.php?lid='.$lid)));
$content .= $ltitle." ";
}
}
}

//**ADMIN
$admintable = "";
if($isadmin=true){
$admintable = "<div style='width: 99%; text-align:center;'>
<table class='outer' style=\"font-size: 90%;\">
<th colspan='4'>"._MD_ADMINTABLE."</th>
<tr class='head' colspan='4'><td>"._MD_STATUS."</td><td>"._MD_ID."</td><td>"._MD_TITLE."</td><td>"._MD_STATUSREPORT."</td></tr>";
$amresult = $xoopsDB->query("SELECT lid, title, status, date, submitter, published, expired FROM ".$xoopsDB->prefix("webshow_links")." WHERE status<1 and lid>0 ORDER BY date DESC");
while(list($lid, $title, $status, $date, $submitter, $published, $expired) = $xoopsDB->fetchRow($amresult)) {
   $title = $myts->makeTboxData4Show($title);
   if($status == 0){
   $statusreport = "<span style=\"color: #FFCC00;\">"._MD_STATUSWAITING." | "._MD_SUBMITTER.": ".$submitter." | ".formatTimestamp($date,"m")."</span>";
   $statuslink = "admin/index.php?op=listNewLinks";
   $statusicon = "waiting.gif";
   }   	      
   if($status == -1){
   $statusreport = "<span style=\"color: #FF0000;\">"._MD_STATUSAUTO.": ".formatTimestamp($published,'m')."</span>";
   $statuslink = "admin/index.php?op=modLink&amp;lid=".$lid;
   $statusicon = "offline.gif";    
   }		
   if($status == -2){
   $statusreport = "<span style=\"color: #FF0000;\">"._MD_STATUSEXPIRED.": ". formatTimestamp($expired,'m')."</span>";
   $statuslink = "admin/index.php?op=modLink&amp;lid=".$lid;
   $statusicon = "offline.gif";    
   }
   if($status == -3){
   $statusreport = "<span style=\"color: #FF0000;\">"._MD_STATUSNOMEDIAURL."</span>";
   $statuslink = "admin/index.php?op=modLink&amp;lid=".$lid;
   $statusicon = "offline.gif";    
   }
   if($status == -4){
   $statusreport = "<span style=\"color: #FF0000;\">"._MD_STATUSNOCACHE."</span>";
   $statuslink = "admin/index.php?op=modLink&amp;lid=".$lid;
   $statusicon = "offline.gif";    
   }
	
   $admintable .= "<tr colspan='4'>
   <td class = 'even'><a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/".$statuslink."\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/".$statusicon."\"></a></td>
   <td class = 'odd'>".$lid."</td>
   <td class = 'even'>
   <a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/singlelink.php?lid=$lid\" target=\"_self\" title=\""._MD_EDITTHISLINK."\">".$title."</a>
   </td>
   <td class = 'odd'>
   <a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/".$statuslink."\">".$statusreport."</a>     
   </td></tr>";     				 
}
//** MOD REQUESTED
$modresult = $xoopsDB->query("SELECT lid, title FROM ".$xoopsDB->prefix("webshow_mod")." WHERE lid>0");
while(list($lid, $title) = $xoopsDB->fetchRow($modresult)) {      
   $statusreport =  "<span style=\"color: #009900;\">"._MD_USERMODREQ."</span>";
   $statuslink = "admin/index.php?op=listModReq";
   $title = $myts->makeTboxData4Show($title);
   $admintable .= "<tr colspan='4'>
   <td class = 'even'><a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/".$statuslink."\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/online.gif\"></a></td>
   <td class = 'odd'>".$lid."</td>
   <td class = 'even'>
   <a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/".$statuslink."\" target=\"_self\" title=\""._MD_MODLINK."\">".$title."</a>
   </td>
   <td class = 'odd'>
   <a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/".$statuslink."\">".$statusreport."</a>     
   </td></tr>";     				 
}
$admintable .= "</table></div><br />";  
$xoopsTpl->assign('admintable', $admintable);
}

//** Category Select
ob_start();
//**function makeMySelBox($title,$order="",$preset_id=0, $none=0, $sel_name="", $onchange="")	
$mytree->makeMySelBox('cattitle','cattitle',$cid,0,'cid', 'window.location="viewcat.php?cid="+this.value');	
$catselbox = ob_get_contents();	
ob_end_clean();
$xoopsTpl->assign('category_select', $catselbox);

//** METATAGS
// Page Title by Xoops-France & Herv Thouzard
$metatitle = $myts->makeTboxData4Show($xoopsModule->getVar('name'));
$xoopsTpl->assign('xoops_pagetitle',$metatitle); 
// Meta Description from module config description
$metadesc = strip_tags($moddesc);
$metadesc = $myts->makeTboxData4Show($metadesc);
// Meta Keywords
include_once XOOPS_ROOT_PATH . '/modules/'.$xoopsModule->getVar('dirname').'/include/functions.php';
$metakey = webshow_extract_keywords($metatitle." ".$metadesc." ".$content);
//** Assign meta tags 
   if (is_object($xoTheme)) { 
    $xoTheme->addMeta( 'meta', 'keywords',$metakey);
    $xoTheme->addMeta( 'meta', 'description',$metadesc);     
    $xoTheme->addMeta( 'meta', 'title', $metatitle); 
    } else { 
    $xoopsTpl->assign('xoops_meta_keywords',$metakey);
    $xoopsTpl->assign('xoops_meta_description',$metadesc);       
    } 

}
include XOOPS_ROOT_PATH.'/footer.php';
?>