
<?php
// $Id: modlink.php,v.50 2007/03/01 19:59:00 tcnet Exp $
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //

/* modlink.php allows submitter and admin to modify an entry. */

include "header.php";
include_once XOOPS_ROOT_PATH.'/class/xoopstree.php';
include_once XOOPS_ROOT_PATH."/class/xoopslists.php";
include_once XOOPS_ROOT_PATH."/class/xoopsformloader.php";
include_once XOOPS_ROOT_PATH."/class/uploader.php";
include_once XOOPS_ROOT_PATH.'/class/module.errorhandler.php'; 
include_once XOOPS_ROOT_PATH."/include/xoopscodes.php";

$myts =& MyTextSanitizer::getInstance();
$eh = new ErrorHandler;
$cattree = new XoopsTree($xoopsDB->prefix("webshow_cat"),"cid","pid");
$linktree = new XoopsTree($xoopsDB->prefix("webshow_links"),"lid","title");
$playertree = new XoopsTree($xoopsDB->prefix("webshow_player"),"playerid","playertitle");

//** Logo Config	
$allowed_mimetypes = array('image/gif', 'image/jpeg', 'image/pjpeg', 'image/x-png', 'image/png');
$logosize = 30000;
$logowidth = $xoopsModuleConfig['logowidth'];
$logoheight = $xoopsModuleConfig['logowidth'];  //Square image area
$playerlogosize = 10000;
$playerlogowidth = 48;
$playerlogoheight = 48;

if (!$xoopsUser) {      
   redirect_header("javascript:history.go(-1)", 3,_MD_REQUESTDENIED.'<br />'._NOPERM);
   exit();
} 

//** Redirect admin to the admin form. Disabled. uncomment to use.
//if ($xoopsUser && $xoopsUser->isAdmin($xoopsModule->mid())) {      
//redirect_header(XOOPS_URL . '/modules/' . $xoopsModule->getVar('dirname') . '/admin/index.php?lid='.$lid.'&amp;op=modLink',2,_FETCHING.' '._MD_ADMIN.': '._MD_MODLINK);
//exit();
//} 

function modLink()
{
   global $xoopsDB, $xoopsConfig, $xoopsModule, $xoopsModuleConfig, $xoopsUser, $myts, $eh, $cattree, $playertree, $linktree, $allowed_mimetypes, $logosize, $logowidth, $logoheight, $playerlogosize, $playerlogowidth, $playerlogoheight;

   //*****  Modify Link Form 
   $xoopsOption['template_main'] = 'webshow_modlink.html';
   include XOOPS_ROOT_PATH."/header.php";	
   $lid = intval($_GET['lid']);

   $result = $xoopsDB->query("select cid, title, url, srctype, listtype, listurl, listcache, showinfo, logourl, submitter, player, chain, artist, album, label, cachetime, expired, published, entryperm from ".$xoopsDB->prefix("webshow_links")." where lid=$lid") or $eh->show("0013");
   list($cid, $title, $url, $srctype, $listtype, $listurl, $listcache, $showinfo, $logourl, $submitter, $player, $chain, $artist, $album, $label, $cachetime, $expired, $published, $ws_entryperm) = $xoopsDB->fetchRow($result);
  
   //**Permissions 
    $groups = is_object($xoopsUser) ? $xoopsUser->getGroups() : XOOPS_GROUP_ANONYMOUS;
    $gperm_handler =& xoops_gethandler('groupperm');
    // example checkRight($gperm_name, $gperm_itemid, $gperm_groupid, $gperm_modid = 1)
    if (!$gperm_handler->checkRight('webshow_submit', $cid, $groups, $xoopsModule->getVar('mid'))) {
        redirect_header("javascript:history.go(-1)", 3,_MD_REQUESTDENIED.'<br />'._NOPERM);
        exit();
    }

   //** Check if submitter owns the link
   if ($xoopsUser && !$xoopsUser->isAdmin($xoopsModule->mid())) {
      $user = $xoopsUser->getVar('uid');   
         if ($submitter != $user) {
            redirect_header("javascript:history.go(-1)",2,_MD_REQUESTDENIED.'<br />'._MD_NOTOWNER);
            exit();
         }
   }

   $lid = $myts->makeTboxData4Edit($lid);
   //$linkcid = $myts->makeTboxData4Edit($cid); ?? Remnant
   $cid = $myts->makeTboxData4Edit($cid);
   $listtype =  isset($_GET['listtype']) ? $_GET['listtype'] : $listtype;
   $listtype = $myts->makeTboxData4Edit($listtype);	 
   //$srctype =  isset($_GET['srctype']) ? $_GET['srctype'] : $srctype;
   $srctype = $myts->makeTboxData4Edit($srctype); 
   $title = $myts->makeTboxData4Edit($title);
   $url = $myts->makeTboxData4Edit($url);
   $listurl = $myts->makeTboxData4Edit($listurl);
   $listcache = $myts->makeTboxData4Edit($listcache);
   $showinfo = $myts->makeTboxData4Edit($showinfo);
   $showinfo = explode("|", $showinfo);  
   $ps = strpos($logourl,"http://");
   if($ps === false) {
      $logourl = $myts->makeTboxData4Edit($logourl);
      $logolink = "";
   } else {
      $logolink = $myts->makeTboxData4Edit($logourl);
   }
   $playerid = $myts->makeTboxData4Edit($player);
   $chain = $myts->makeTboxData4Edit($chain);
   $artist = $myts->makeTboxData4Edit($artist);
   $album = $myts->makeTboxData4Edit($album);
   $label = $myts->makeTboxData4Edit($label);
   $cachetime = $myts->makeTboxData4Edit($cachetime);
   $expired = $myts->makeTboxData4Edit($expired);
   $published = $myts->makeTboxData4Edit($published);
   $ws_entryperm = explode(" ", $ws_entryperm);

   //** TEXT    
   $result2 = $xoopsDB->query("select description, bodytext from ".$xoopsDB->prefix("webshow_text")." where lid=$lid");
   list($description, $bodytext)=$xoopsDB->fetchRow($result2);
   $description = $myts->makeTareaData4Edit($description);
   $bodytext = $myts->makeTareaData4Edit($bodytext);	
   
   //** FLASH VARIABLES
   $result3 = $xoopsDB->query("select start, shuffle, replay, link, linktarget, showicons, stretch, showeq, rotatetime, shownav, transition, thumbslist, captions, playerlogo, enablejs from ".$xoopsDB->prefix("webshow_flashvar")." where lid=$lid") or $eh->show("0013");
   list($start, $shuffle, $replay, $link, $linktarget, $showicons, $stretch, $showeq, $rotatetime, $shownav, $transition, $thumbslist, $captions, $playerlogo, $enablejs)=$xoopsDB->fetchRow($result3);

   $start = $myts->makeTboxData4Edit($start);
   $shuffle = $myts->makeTboxData4Edit($shuffle); 
   $replay = $myts->makeTboxData4Edit($replay);
   $link = $myts->makeTboxData4Edit($link);
   $linktarget = $myts->makeTboxData4Edit($linktarget);  
   $showicons = $myts->makeTboxData4Edit($showicons);
   $stretch = $myts->makeTboxData4Edit($stretch);       
   $showeq = $myts->makeTboxData4Edit($showeq);
   $rotatetime = $myts->makeTboxData4Edit($rotatetime);
   $shownav = $myts->makeTboxData4Edit($shownav);    
   $transition = $myts->makeTboxData4Edit($transition); 
   $thumbslist = $myts->makeTboxData4Edit($thumbslist); 
   $captions = $myts->makeTboxData4Edit($captions);
   $playerlogo = $myts->makeTboxData4Edit($playerlogo);
   $enablejs = $myts->makeTboxData4Edit($enablejs);	

   //** MODIFY PLAYLIST FORM variables for playlistform.inc   			
   $wsformlabel =	_MD_MODLINK;
   $wsformname = "usermodform";
   $wsformaction = XOOPS_URL.'/modules/'.$xoopsModule->getVar('dirname').'/modlink.php';
   $wsformmethod = "post";
   $wsformaddtoken = "false";	
   $op= 'modLinkS';
   $btnlabel = _MD_MODIFY;		
   echo "<table class='outer'><tr><td width='98%'>";  
   include 'include/playlistform.inc.php';
   echo "</td></tr></table>";   

   //** META Tags
  $xoopsTpl->assign('xoops_pagetitle', $myts->makeTboxData4Show($xoopsModule->getVar('name')).' '._MD_MODLINK);
  $xoopsTpl->assign('xoops_meta_keywords', $myts->makeTboxData4Show($xoopsModule->getVar('name')).' '._MD_MODLINK);
  $xoopsTpl->assign('xoops_meta_description', $myts->makeTboxData4Show($xoopsModule->getVar('name')).' '._MD_MODLINK); 

   include XOOPS_ROOT_PATH.'/footer.php';
}

function modLinkS()
{
   global $xoopsDB, $xoopsConfig, $xoopsModule, $xoopsUser, $xoopsModuleConfig, $myts, $eh, $allowed_mimetypes, $logosize, $logowidth, $logoheight, $playerlogosize, $playerlogowidth, $playerlogoheight;

/*
   //** CAPTCHA verification:
   if(@include_once XOOPS_ROOT_PATH."/Frameworks/captcha/captcha.php") {
      $xoopsCaptcha = XoopsCaptcha::instance();
      if(! $xoopsCaptcha->verify() ) {
         echo $xoopsCaptcha->getMessage();
         redirect_header(XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/index.php", 3, _NOPERM);
      }
   }

 SUBMITTER CHECK NEEDS WORK
   // if ($xoopsUser->isAdmin($xoopsModule->mid())) ADD THIS
   $modifysubmitter = $xoopsUser->getVar('uid');   
   $submitter = !empty($xoopsUser) ? $xoopsUser->getVar('uid') : 0;
   if (!$_POST['submitter'] and $xoopsUser) {
      $submitter = $xoopsUser->uid();
   }elseif(!$_POST['submitter'] and !$xoopsUser) {
      $submitter = 0;
   }else{
      $submitter = intval($_POST['submitter']);
   }
*/

   $lid = intval($_POST["lid"]);

   //** Category
   if ( !empty($_POST['cid']) ) {
      $cid = intval($_POST['cid']);
   } else {
      $cid = "0";
   }

   // Check if Title exist
   if ($_POST["title"]=="") {
      $eh->show("1001");
   }
   $title = $myts->makeTboxData4Save($_POST["title"]);
   // SOURCE TYPE
   $srctype = $myts->makeTboxData4Save($_POST["srctype"]);	
   // LIST TYPE
   $listtype = $myts->makeTboxData4Save($_POST["listtype"]);
   // LISTURL 		
   if ( ($_POST["listurl"]) || ($_POST["listurl"]!="") ) {
      $listurl = $_POST["listurl"];
      if($listtype == "feed") {    
         $listurl = formatURL ($listurl);
      }  
      $listurl = $myts->makeTboxData4Save($listurl);    
   } else {
         $eh->show("1016");
   }   	

   //** SHOW INFO
   $showinfo = isset($_POST['showinfo']) ? $_POST['showinfo'] : "";
   if (isset($showinfo)) {
      $showinfo = implode('|', $showinfo);
   }
    $showinfo = $myts->makeTboxData4Save($showinfo);  
       
   //** CACHE PLAYLIST
   include 'include/playlist.php';
   $cachetime = "";
   $listcache = isset($_POST['listcache']) ? $_POST['listcache'] : "";
   $refreshlist = isset($_POST['refreshlist']) ? $_POST['refreshlist'] : "0";
   $message = "";
   if($listtype != "single") {
      // Refresh the playlist file if it does not exist
      if (!file_exists(XOOPS_ROOT_PATH."/modules/".$xoopsModule->getVar("dirname")."/playlist/".$listcache)){ 
         $message .= "<br />"._MD_LISTCACHE_FILE." "._MD_NOTEXIST; 
         $refreshlist = 1;
      }    
      // Refresh the playlist name if it does not exist in the db
      if ($listcache == "") {
         $message .= "<br />"._MD_LISTCACHE_NAME." "._MD_NOTEXIST; 
         $refreshlist = 1;
      }
      // Refresh the playlist if cachetime has expired
      $cachetime = isset($_POST['cachetime']) ? $_POST['cachetime'] : "86400";
      $cacheexpired = timePlaylist($listcache,$cachetime);
      if($cacheexpired > 0){
         $message .= "<br />"._MD_LISTCACHE_EXPIRED;
         $refreshlist = 1;
      }
      // Refresh the playlist if the title changes
      $titleresult=$xoopsDB->query("select title from ".$xoopsDB->prefix("webshow_links")." where lid=$lid");
      list($origtitle)=$xoopsDB->fetchRow($titleresult);
      if ($title != $origtitle) {
         $message .= "<br />"._MD_TITLECHANGE.": New title: ".$title; 
         $refreshlist = 1;
      }
   }
   $listcache = $myts->makeTboxData4Save($listcache);
   $cachetime = $myts->makeTboxData4Save($cachetime);	
   $url = "";
   if ( ($_POST["url"]) || ($_POST["url"]!="") ) {
      $url = $_POST["url"];    
      $url = formatURL ($url);  
      $url = $myts->makeTboxData4Save($url);    
   }

   //** ENTRY LOGO
   $logourl = empty($logourl)?(empty($_POST['logourl'])?"":$_POST['logourl']):$logourl; 
   //** LOGO Link from URL
   $logolink =  isset($_POST['logolink']) ? $_POST['logolink'] : "";
   if(!empty($logolink)){
      $logolink = formatURL ($logolink);  
      $logourl = $myts->makeTboxData4Save($logolink); 
   }
   //** LOGO UPLOAD
  if (!empty($_FILES['userfile']['name'])) { 
  //$uploader = new XoopsMediaUploader('/home/xoops/uploads', $allowed_mimetypes, $maxfilesize, $maxfilewidth, $maxfileheight);
  $uploader = new XoopsMediaUploader(XOOPS_ROOT_PATH . "/".$xoopsModuleConfig['path_logo'], $allowed_mimetypes, $logosize, $logowidth, $logoheight);
    if ($uploader->fetchMedia($_POST['xoops_upload_file'][0])) {
    if (!$uploader->upload()) {
       echo $uploader->getErrors();
    } else {
       echo '<h4>'._MD_FILESUCCESS.'</h4>';
       $logourl = $uploader->getSavedFileName();
    }
  } else {
    echo $uploader->getErrors();
  }
  }
   $artist = $myts->makeTboxData4Save($_POST["artist"]);
   $album = $myts->makeTboxData4Save($_POST["album"]);
   $label = $myts->makeTboxData4Save($_POST["label"]);
   $chain = $_POST['chain'];

   //** STATUS
   $status = 2;   // 2 = modified
   //** Auto Publish/Expire from Herve Thouzard News Module
   //** Autopublish
   $autodate = isset($_POST['autodate']) ? $_POST['autodate'] : "0";
   if ($autodate == 1 ) {
      $publish_date = $_POST['publish_date'];
      $pubdate = strtotime($publish_date['date']) + $publish_date['time'];
      $published = $pubdate;
   } elseif($autodate == 0) {
      $published = time();  
   }
   $published = $myts->makeTboxData4Save($published);
   if($published > time()) {
      $status= -1; 
   }

   //** Auto Expire
   $autoexpdate = isset($_POST['autoexpdate']) ? $_POST['autoexpdate'] : "0";
   if ($autoexpdate == 1 ) {
      $expiry_date=$_POST['expiry_date'];
      $expiry_date = strtotime($expiry_date['date']) + $expiry_date['time'];
      $offset = $xoopsUser -> timezone() - $xoopsConfig['server_TZ'];
      $expiry_date = $expiry_date - ( $offset * 3600 );
      $expired = $expiry_date;
   } elseif($autoexpdate == 0) {
      $expired = 0;
   }
   $expired = $myts->makeTboxData4Save($expired);		
   if($expired < time() & $expired > 0) {
      $status = -1;		
   }
   $status=$myts->makeTboxData4Save($status);

   //** ws_entryperm
   $ws_entryperm = $_POST['ws_entryperm'];
   $ws_entryperm = (is_array($ws_entryperm)) ? implode(" ", $ws_entryperm) : '';

   //** TEXT
   // Check if Description exist
   if ($_POST['description']=="") {
      $eh->show("1008");
   }
   $description = $myts->makeTareaData4Save($_POST["description"]);       
   $bodytext = $myts->makeTareaData4Save($_POST["bodytext"]);

   $playerid = $myts->makeTboxData4Save($_POST["playerid"]);	

   //** FLASH VARIABLES
   $start = $myts->makeTboxData4Save($_POST["start"]);
   $shuffle = $myts->makeTboxData4Save($_POST["shuffle"]);
   $replay = $myts->makeTboxData4Save($_POST["replay"]);
   $link = $myts->makeTboxData4Save($_POST["link"]);			
   $linktarget = $myts->makeTboxData4Save($_POST["linktarget"]);
   $showicons = $myts->makeTboxData4Save($_POST["showicons"]);
   //** PLAYERLOGO UPLOAD
   $playerlogo = "";
   if (!empty($_FILES['userfile2']['name'])) { 
   //$uploader = new XoopsMediaUploader('/home/xoops/uploads', $allowed_mimetypes, $maxfilesize, $maxfilewidth, $maxfileheight);
   $uploader2 = new XoopsMediaUploader(XOOPS_ROOT_PATH ."/modules/".$xoopsModule->getVar('dirname')."/images/player", $allowed_mimetypes, $playerlogosize, $playerlogowidth, $playerlogoheight);
   if ($uploader2->fetchMedia($_POST['xoops_upload_file'][1])) {
      if (!$uploader2->upload()) {
         echo $uploader2->getErrors();
      } else {
         echo '<h4>'._MD_FILESUCCESS.'</h4>';
         $playerlogo = $uploader2->getSavedFileName();
      }
   } else {
      echo $uploader2->getErrors();
   }
  }
   $playerlogo = empty($playerlogo)?(empty($_POST['playerlogo'])?"":$_POST['playerlogo']):$playerlogo;  
   $stretch = $myts->makeTboxData4Save($_POST["stretch"]);
   $showeq = $myts->makeTboxData4Save(isset($_POST['showeq']) ? $_POST['showeq'] : "0");
   $rotatetime = $myts->makeTboxData4Save(isset($_POST['rotatetime']) ? $_POST['rotatetime'] : "0");			
   $shownav = $myts->makeTboxData4Save(isset($_POST['shownav']) ? $_POST['shownav'] : "0");
   $transition = $myts->makeTboxData4Save(isset($_POST['transition']) ? $_POST['transition'] : "none");
   $thumbslist = $myts->makeTboxData4Save(isset($_POST['thumbslist']) ? $_POST['thumbslist'] : "0");
   $captions = $myts->makeTboxData4Save( formatURL($_POST["captions"]));
   $enablejs = $myts->makeTboxData4Save($_POST["enablejs"]); 
   $date = time();
   $notify = !empty($_POST['notify']) ? 1 : 0;	
 
   //** AUTO APPROVE PERMISSIONS
   // If auto_approve then $status = 1 (online)
   $groups = is_object($xoopsUser) ? $xoopsUser->getGroups() : XOOPS_GROUP_ANONYMOUS;
   $gperm_handler =& xoops_gethandler('groupperm');
   if ($gperm_handler->checkRight('webshow_approve', $cid, $groups, $xoopsModule->getVar('mid'))) {
      //** UPDATE DATA
      $status = 2;
      $xoopsDB->query("update ".$xoopsDB->prefix("webshow_links")." set cid='$cid', title='$title', url='$url', logourl='$logourl', listtype='$listtype', listurl='$listurl', listcache='$listcache', showinfo='$showinfo', cachetime='$cachetime', srctype='$srctype', player='$playerid', chain='$chain', status='$status', expired='$expired', published='$published', artist='$artist', album='$album', label='$label', entryperm='$ws_entryperm' where lid=".$lid."")  or $eh->show("0013");
      $xoopsDB->query("update ".$xoopsDB->prefix("webshow_text")." set description='$description', bodytext='$bodytext' where lid=".$lid."")  or $eh->show("0013");
      $xoopsDB->query("update ".$xoopsDB->prefix("webshow_flashvar")." set start='$start', shuffle='$shuffle', replay='$replay', link='$link', linktarget='$linktarget', showicons='$showicons', stretch='$stretch', showeq='$showeq', rotatetime='$rotatetime', shownav='$shownav', transition='$transition', thumbslist='$thumbslist', captions='$captions', playerlogo='$playerlogo', enablejs='$enablejs' where lid=".$lid."")  or $eh->show("0013");
      //** Save Tags requires phppp's Tag module
      $itemid = $lid;
      $catid = 0;
      $tag_handler = xoops_getmodulehandler('tag', 'tag');
      $tag_handler->updateByItem($_POST["item_tag"], $itemid, $xoopsModule->getVar("dirname"), $catid);
   } else {
      // Submission must be approved by an admin so save data to the mod_link table instead of the link table.
      $newid = $xoopsDB->genId($xoopsDB->prefix("webshow_mod")."_requestid_seq");      
      $ws_tag = $myts->makeTboxData4Save($_POST["item_tag"]); // Store tags in mod table until mod request is approved        
      $sql = sprintf("INSERT INTO %s (requestid, lid, cid, title, url, srctype, listurl, logourl, description, bodytext, modifysubmitter, artist, album, label, ws_tag) VALUES (%u, %u, %u, '%s', '%s', '%s', '%s', '%s', '%s', '%s', %u, '%s', '%s', '%s', '%s')", $xoopsDB->prefix("webshow_mod"), $newid, $lid, $cid, $title, $url, $srctype, $listurl, $logourl, $description, $bodytext, $modifysubmitter, $artist, $album, $label, $ws_tag);
      $xoopsDB->query($sql) or $eh->show("0013");      
      //** Save Flash Vars  // NEEDS WORK should be temp saved as array in the mod table
      $xoopsDB->query("update ".$xoopsDB->prefix("webshow_flashvar")." set start='$start', shuffle='$shuffle', replay='$replay', link='$link', linktarget='$linktarget', showicons='$showicons', stretch='$stretch', showeq='$showeq', rotatetime='$rotatetime', shownav='$shownav', transition='$transition', thumbslist='$thumbslist', captions='$captions', playerlogo='$playerlogo', enablejs='$enablejs' where lid=".$lid."")  or $eh->show("0013");
   }	 

//** Refresh Playlist feed - Create or Fetch and then cache the playlist.
  // Refresh Selected
  if($refreshlist == 1) { 
     deletePlaylist($lid);     
     namePlaylist($lid,$title); 
     $message .= "<br />"._MD_LISTCACHE_REFRESH.": ".$listcache;        
       if($listtype == "dir") {
          createPlaylist($lid);
       } 
       if($listtype == "feed"){
          fetchPlaylist($lid);
       }
  }

   // RMV-NEW
   // Notify of modify link request (anywhere) and modify link approved.
   $notification_handler =& xoops_gethandler('notification');
   $tags = array();
   $tags['LINK_NAME'] = $title;

   if ($gperm_handler->checkRight('webshow_approve', $cid, $groups, $xoopsModule->getVar('mid'))) {
      $notification_handler->triggerEvent('global', 0, 'new_link', $tags);
      $notification_handler->triggerEvent('category', $cid, 'new_link', $tags);
      $tags['LINK_URL'] = XOOPS_URL . '/modules/'. $xoopsModule->getVar('dirname') . '/singlelink.php?lid='.$lid;
      redirect_header("singlelink.php?lid=$lid",3,_MD_RECEIVED."<br />"._MD_ISAPPROVED."");
   } else {
      $tags['LINK_URL'] = XOOPS_URL . '/modules/'. $xoopsModule->getVar('dirname') . '/singlelink.php?lid='.$newid;
      $tags['MODIFYREPORTS_URL'] = XOOPS_URL . '/modules/' . $xoopsModule->getVar('dirname') . '/admin/index.php?op=listModReq';
      $notification_handler->triggerEvent('global', 0, 'link_modify', $tags);
      if ($notify) {
         include_once XOOPS_ROOT_PATH . '/include/notification_constants.php';
         $notification_handler->subscribe('link', $lid, 'approve', XOOPS_NOTIFICATION_MODE_SENDONCETHENDELETE);
      }
         redirect_header("singlelink.php?lid='.$lid",3,_MD_RECEIVED.'<br />'._MD_ALLPENDING);
   }
   exit();
}

if(!isset($_POST['op'])) {
	$op = isset($_GET['op']) ? $_GET['op'] : 'main';
} else {
	$op = $_POST['op'];
}

switch ($op) {
case "modLinkS":
	modLinkS();
	break;

case 'main':
default:  
	modLink();
	break;
}
?>
