<?php
// $Id: playposter.php,v.61 2007/08/11 19:59:00 tcnet Exp $ //
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
// ------------------------------------------------------------------------- //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //

include "header.php";
$xoopsOption['template_main'] = 'webshow_playposter.html';
$myts =& MyTextSanitizer::getInstance(); // MyTextSanitizer object
include XOOPS_ROOT_PATH."/header.php";
include_once XOOPS_ROOT_PATH."/class/xoopstree.php";
$mytree = new XoopsTree($xoopsDB->prefix("webshow_cat"),"cid","pid");
$xoopsTpl->assign('ws_name', $xoopsModule->getVar('name'));
$metakey = "";//Collects keyword content
$displaylid="";
$count = 1;

$uid = isset($_GET['uid']) ? intval($_GET['uid']) : '';
if($uid == ""){
redirect_header("javascript:history.go(-1)", 2, _MD_NOTEXIST);
}

$submittername = xoops_getLinkedUnameFromId($uid);  
$xoopsTpl->assign('submittername', $submittername);
$xoopsTpl->assign('submitterid', $uid);
$xoopsTpl->assign('ws_pagetitle', sprintf(_MD_POSTERTITLE,$submittername));

if (isset($_GET['show'])) {
        $show = intval($_GET['show']);
} else {
        $show = $xoopsModuleConfig['perpage'];
}
$min = isset($_GET['min']) ? intval($_GET['min']) : 0;
if (!isset($max)) {
        $max = $min + $show;
}
if(isset($_GET['orderby'])) {
   $orderby = convertorderbyin($_GET['orderby']);
} else {
    $orderby = "date DESC";
}

//** Link Listing
$numrows="";
$fullcountresult=$xoopsDB->query("select count(*) from ".$xoopsDB->prefix("webshow_links")." where submitter=".$uid." and cid>0 and status>0");
list($numrows) = $xoopsDB->fetchRow($fullcountresult);
$page_nav = '';
if($numrows == 0){
redirect_header("javascript:history.go(-1)", 1, _MD_NOTEXIST);
}

if($numrows>0){
    $xoopsTpl->assign('show_links', true);
    $xoopsTpl->assign('thereareby', sprintf(_MD_THEREAREBY,$numrows, $submittername));
    //if 2 or more items in result, show the sort menu
    if($numrows>1) {
        $xoopsTpl->assign('show_nav', true);
        $orderbyTrans = convertorderbytrans($orderby);
        $xoopsTpl->assign('lang_cursortedby', sprintf(_MD_CURSORTEDBY, convertorderbytrans($orderby)));
    }

//** ENTRY LOOP
$sql = "select l.lid, l.cid, l.title, l.showinfo, l.logourl, l.submitter, l.status, l.date, l.hits, l.rating, l.votes, l.entryperm, t.description from ".$xoopsDB->prefix("webshow_links")." l, ".$xoopsDB->prefix("webshow_text")." t where l.submitter=".$uid." and l.status>0 and l.cid>0 and l.lid=t.lid order by $orderby";
$result=$xoopsDB->query($sql,$show,$min);
while(list($lid, $cid, $title, $showinfo, $logourl, $submitter, $status, $time, $hits, $rating, $votes, $ws_entryperm, $description) = $xoopsDB->fetchRow($result)) {

//**Permissions
$groups = is_object($xoopsUser) ? $xoopsUser->getGroups() : XOOPS_GROUP_ANONYMOUS;
$gperm_handler =& xoops_gethandler('groupperm');
// example checkRight($gperm_name, $gperm_itemid, $gperm_groupid, $gperm_modid = 1)
if ($gperm_handler->checkRight('webshow_view', $cid, $groups, $xoopsModule->getVar('mid'))) {

//** Entry Permission
$group = is_object($xoopsUser) ? $xoopsUser->getGroups() : array(XOOPS_GROUP_ANONYMOUS);
$ws_entryperm = explode(" ",$ws_entryperm);
if (count(array_intersect($group,$ws_entryperm)) > 0)
{
$ltitle = $myts->makeTboxData4Show($title);
$new = newlinkgraphic($time, $status);
$pop = popgraphic($hits);
$title = $ltitle.$new.$pop;
$title = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/playposter.php?uid=$uid&amp;lid=$lid\" target=\"_self\" title=\""._MD_VIEWLISTING." - ".$ltitle."\">".$title."</a>";

//** Block Description
$description = $myts->makeTareaData4Show($description,0);

//** EMBED LINK BOX
//if $listurl is from this domain, show embed link
//Disabled.  Available in singlelink.php only

//$embed = "";
//if($showinfo[8] == 1){
//   $ps = strpos(strtolower($listurl), XOOPS_URL); //Embed link for local media only.
//   if (!($ps === false)) {  
//      $embed = "&lt;embed src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar("dirname")."/mediaplayer.swf\" width=\"".$width."\" height=\"".$height."\" type=\"application/x-shockwave-flash\" pluginspage=\"http://www.macromedia.com/go/getflashplayer\" flashvars=\"file=".$listurl."&displayheight=".$displayheight."\" /&gt;";
//   }
//}

if(!$displaylid){
$displaylid = isset($_GET['lid']) ? intval($_GET['lid']) : $lid;   
}

//** Link Array for loop
$metakey .= $ltitle." ".strip_tags($description)." "; //Collect meta keywords.
$xoopsTpl->append('links', array('id' => $lid, 'cid' => $cid, 'ltitle' => $ltitle, 'title' => $title, 'description' => $description));
}
}
}

    $orderby = convertorderbyout($orderby);
    //Calculates how many pages exist.  Which page one should be on, etc...
    $linkpages = ceil($numrows / $show);
    //Page Numbering
    if ($linkpages!=1 && $linkpages!=0) {
		$uid = intval($_GET['uid']);
    		$xoopsTpl->assign('lang_pagenav',_MD_PAGENAV);			
        $prev = $min - $show;
        if ($prev>=0) {
            $page_nav .= "<a href='playposter.php?uid=$uid&amp;min=$prev&amp;orderby=$orderby&amp;show=$show'><b><u>&laquo;</u></b></a>&nbsp;";
        }
        $counter = 1;
        $currentpage = ($max / $show);
        while ( $counter<=$linkpages ) {
            $mintemp = ($show * $counter) - $show;
            if ($counter == $currentpage) {
                $page_nav .= "<b>($counter)</b>&nbsp;";
            } else {
                $page_nav .= "<a href='playposter.php?uid=$uid&amp;min=$mintemp&amp;orderby=$orderby&amp;show=$show'>$counter</a>&nbsp;";
            }
            $counter++;
        }
        if ( $numrows>$max ) {
            $page_nav .= "<a href='playposter.php?uid=$uid&amp;min=$max&amp;orderby=$orderby&amp;show=$show'>";
            $page_nav .= "<b><u>&raquo;</u></b></a>";
        }
    }
}
$xoopsTpl->assign('page_nav', $page_nav);

//** Get the entry data to display.
$result = $xoopsDB->query("select l.lid, l.cid, l.title, l.url, l.srctype, l.listtype, l.listurl, l.showinfo, l.listcache, l.cachetime, l.logourl, l.artist, l.album, l.label, l.submitter, l.status, l.date, l.hits, l.rating, l.votes, l.comments, l.player, l.chain, l.entryperm, t.description, t.bodytext from ".$xoopsDB->prefix("webshow_links")." l, ".$xoopsDB->prefix("webshow_text")." t where l.lid=$displaylid and l.lid=t.lid ");
list($lid, $cid, $title, $url, $srctype, $listtype, $listurl, $showinfo, $listcache, $cachetime, $logourl, $artist, $album, $label, $submitter, $status, $time, $hits, $rating, $votes, $comments, $player, $chainid, $ws_entryperm, $description, $bodytext) = $xoopsDB->fetchRow($result);

$ltitle = $myts->makeTboxData4Show($title);
$new = newlinkgraphic($time, $status);
$pop = popgraphic($hits);
$title = $ltitle.$new.$pop;
$title = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/singlelink.php?cid=$cid&amp;lid=$lid\" target=\"_self\" title=\""._MD_VIEWLISTING." - ".$ltitle."\">".$title."</a>";
$url = $myts->makeTboxData4Show($url);
$listurl = $myts->makeTboxData4Show($listurl);

//** Category: Media Path
$path = $mytree->getPathFromId($cid,"cattitle");
$path = str_replace("/","",$path);
$catpath = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/viewcat.php?cid=".$cid."\" target=\"_self\" title=\"".$path."\">".$path."</a>";
$path = $catpath.": ".$title;

if($listtype == "dir") { 
  $listurl =  XOOPS_URL."/modules/".$xoopsModule->getVar("dirname")."/playlist/".$listcache;
}

//** LOAD MEDIA PLAYERS 
$styleoption = "";
$chainid = 0;
$player =1;
include "include/movie.php";
$xoopsTpl->assign('movie',$movie);
$xoopsTpl->assign('moviewidth',$moviewidth);
$xoopsTpl->assign('movieheight',$movieheight);

//** ADMIN
if ($xoopsUser && $xoopsUser->isAdmin($xoopsModule->mid())) {
   $isadmin = true;
   $adminlink = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/admin/index.php?op=modLink&amp;lid=".$lid."\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/editicon.gif\" border=\"0\" alt=\""._MD_EDITTHISLINK."\" /></a>";
} else {
   $isadmin = false;
   $adminlink = "";
}

//** MODIFY ENTRY LINK. Display to admin and submitter only.
if ($xoopsUser) {
$user = $xoopsUser->getVar('uid');
   if ($user == $submitter | $isadmin) {
       $modlink = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/modlink.php?lid=".$lid."\" title=\""._MD_MODIFY."\">"._MD_MODIFY."<img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/modify.gif\" border=\"0\" alt=\""._MD_MODIFY."\" /></a>";  
   } else {
       $modlink = "";
   }
}

//** SHOWINFO  Displays selected information.
$showinfo = explode('|', $showinfo);

//** INFORMATION BOX OFF
$infobox = 1;
if ($showinfo[0] != 1) {
   $infobox="";
}

//** Block Description
$description = $myts->makeTareaData4Show($description,0);
if(!$showinfo[1]){
   $description = "";
}

//** ENTRY LOGO
if($showinfo[2] == 1 & $logourl != ""){
   $ps = strpos($logourl,"http://");
   if($ps === false) {
      $logourl = XOOPS_URL."/".$xoopsModuleConfig['path_logo']."/".$logourl;
   }
   $logourl = $myts->makeTboxData4Show($logourl);
}else{
$logourl = "";
}

//** CREDITS (C) //Needs work for enablejs
if($showinfo[3] == 1){
  //** Javascript enabled.  If enablejs is true in movie.php then include/mplayjs.inc.php.  Replaces credits from db with credits from xml playlist.
  if($mplayjs !="") {
     $xoopsTpl->assign('mplayjs',$mplayjs);
  }else{
     $artist = $myts->makeTboxData4Show($artist);
     $album = $myts->makeTboxData4Show($album);
     $label = $myts->makeTboxData4Show($label);
  }
}else{
  $artist = "";
  $album = "";
  $label = "";
} 

//STATISTICS
if($showinfo[4] == 1){
$updated = formatTimestamp($time,"m");
   if ($votes == 1) {
        $votestring = _MD_ONEVOTE;
   } else {
        $votestring = sprintf(_MD_NUMVOTES,$votes);
   } 
}else{
$hits = "";
$votestring = "";
$updated = "";
}

//** PAGE LINK
$pagelink = "";
if($showinfo[6] == 1){
$pagelink = 1;
}

//** WEB SITE LINK & BUTTON
$sitelink = "";
$sitebutton = "";
if($showinfo[7] == 1 &&$url !="" ){
   $sitelink = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/visit.php?cid=".$cid."&amp;lid=".$lid."\" target=\"_blank\" title=\""._MD_VISIT." "._MD_WEBSITE.": ".$url."\">"._MD_WEBSITE."</a>";
   $sitebutton = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/visit.php?cid=".$cid."&amp;lid=".$lid."\" target=\"_blank\" title=\""._MD_VISIT." "._MD_WEBSITE.": ".$url."\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/link.gif\" border=\"0\" alt=\""._MD_VISIT." "._MD_WEBSITE." ".$url."\" /> </a>";
}

//** EMBED LINK BOX
//if $listurl is from this domain, show embed link
$embed = "";
$embedjs = "";
if($showinfo[8] == 1){
   $ps = strpos(strtolower($listurl), XOOPS_URL); //Embed link for local media only.
   if (!($ps === false)) {
      //old v.57 $embed = "&lt;embed src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar("dirname")."/mediaplayer.swf\" width=\"".$width."\" height=\"".$height."\" type=\"application/x-shockwave-flash\" pluginspage=\"http://www.macromedia.com/go/getflashplayer\" flashvars=\"file=".$listurl."&displayheight=".$displayheight."\" /&gt;";
      $embed = "<object codebase=\"http://fpdownload.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=8,0,0,0\" width=\"".$width."\" height=\"".$height."\" classid=\"clsid:d27cdb6e-ae6d-11cf-96b8-444553540000\">
      <param value=\"".XOOPS_URL."/modules/".$xoopsModule->getVar("dirname")."/mediaplayer.swf\" name=\"movie\" />
      <param value=\"false\" name=\"menu\" />
      <param value=\"low\" name=\"quality\" />
      <param value=\"file=".$listurl."&amp;autostart=false&amp;displayheight=".$displayheight."&amp;displaywidth=".$displaywidth."\" name=\"flashvars\" /></object>";
      //** Embed javascript
      $embedjs = htmlEntities($movie);
   }
}
   
//** DOWNLOAD LINK AND BUTTON.  For single file entry only.  Other entries use web feed link and button instead.
$downlink = "";
$downbutton = "";
if($showinfo[9] == 1){
//** Download Permission
$groups = is_object($xoopsUser) ? $xoopsUser->getGroups() : XOOPS_GROUP_ANONYMOUS;
$gperm_handler =& xoops_gethandler('groupperm');
   if ($gperm_handler->checkRight('webshow_download', $cid, $groups, $xoopsModule->getVar('mid'))) {    
      if($listtype == "single"){
         //** If the file is from the wf downloads module.
         $searchstring = strToLower($listurl);
         $searchpattern = "wfdownloads/visit";
         $wfdwnok = strpos($searchstring,$searchpattern);
         if($wfdwnok != ""){
            $downlink = "<a href=\"#\" title=\"".$ltitle." "._MD_DOWNLOAD."\" onClick= \"location='".$listurl."'\">"._MD_DOWNLOAD."</a>";
            $downbutton = "<a href=\"#\" title=\"".$ltitle." "._MD_DOWNLOAD."\" onClick= \"location='".$listurl."'\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/download.png\" border=\"0\" alt=\"".$ltitle." "._MD_DOWNLOAD."\" /> </a>"; 
         } else {
            //** Allowed file extensions
            //$allowext = " mp3 | jpg | gif | png | swf | flv";
            //$ext = strToLower(substr($listurl,strlen($listurl)-3, 3));
            //$extok = strpos($allowext,$ext);
            //if($extok != ""){
               $downlink = "<a href=\"#\" title=\"".$ltitle." "._MD_DOWNLOAD."\" onClick= \"location='".XOOPS_URL."/modules/".$xoopsModule->getVar("dirname")."/wsdwnlod.php?lid=".$lid."'\">"._MD_DOWNLOAD."</a>";
               $downbutton = "<a href=\"#\" title=\"".$ltitle." "._MD_DOWNLOAD."\" onClick= \"location='".XOOPS_URL."/modules/".$xoopsModule->getVar("dirname")."/wsdwnlod.php?lid=".$lid."'\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/download.png\" border=\"0\" alt=\"".$ltitle." "._MD_DOWNLOAD."\" /> </a>"; 
            //}
         }     
      } 
   }
}
       
//** WEB FEED LINK & BUTTON
$feedlink = "";
$feedbutton = "";
if($showinfo[9] == 1 && $listtype != "single") {
  $feedlink = "<a href=\"".$listurl."\" target=\"_blank\" title=\"".$ltitle." "._MD_WEBFEED."\">"._MD_WEBFEED."</a>"; 
  $feedbutton = "<a href=\"".$listurl."\" target=\"_blank\" title=\"".$ltitle." "._MD_WEBFEED."\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/webfeed.png\" border=\"0\" alt=\"".$ltitle." "._MD_WEBFEED."\" /> </a>"; 
}

//** POPUP PLAYER BUTTON
//** Java script opens popmovie.php in a new window.
if ($showinfo[10] == 1) {
   $popbutton = "<span onClick= \"window.open('popmovie.php?lid=".$lid."','popmovie".$lid."','directories=no,toolbar=no,location=no,menubar=no');return false;\" style=\"cursor:hand;\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/popbutton.png\" alt=\"".$ltitle." "._MD_POPUP." "._MD_PLAYER."\" /></span>";
}else{
   $popbutton ="";  
}

//** TAGS
if($xoopsModuleConfig['tags']){
   if ($showinfo[11] == 1) {
      $itemid = $lid;
      $catid = 0;
      include_once XOOPS_ROOT_PATH."/modules/tag/include/tagbar.php";
      $tagbar = tagBar($itemid, $catid);
      if($tagbar){
         $xoopsTpl->assign('tagbar',$tagbar);
         $metakey .= implode(' ',$tagbar["tags"]);
      }
   }
}
//** END INFO BOX

//** Body Text
$bodytext = $myts -> displayTarea( $bodytext, 1 );

// LINK ARRAY
$xoopsTpl->assign('link', array('id' => $lid, 'cid' => $cid, 'rating' => number_format($rating, 2), 'ltitle' => $ltitle, 'title' => $title, 'srctype'=> $srctype, 'listtype'=> $listtype, 'url'=> $url, 'category' => $path, 'listurl' => $listurl, 'infobox' => $infobox, 'description' => $description, 'artist' => $artist, 'album' => $album, 'label' => $label, 'logourl' => $logourl, 'hits' => $hits, 'votes' => $votestring, 'updated' => $updated, 'submitter' => $submitter, 'submittername' => $submittername, 'pagelink' => $pagelink, 'sitelink'=>$sitelink, 'sitebutton'=>$sitebutton, 'embed'=>$embed, 'embedjs'=>$embedjs, 'downlink' => $downlink, 'downbutton' => $downbutton, 'feedlink' => $feedlink, 'feedbutton' => $feedbutton, 'popbutton'=>$popbutton, 'bodytext' => $bodytext, 'adminlink' => $adminlink, 'modlink' => $modlink, 'comments' => $comments, 'mail_subject' => rawurlencode(sprintf(_MD_INTRESTLINK,$xoopsConfig['sitename'])), 'mail_body' => rawurlencode(sprintf(_MD_INTLINKFOUND,$xoopsConfig['sitename']).':  '.XOOPS_URL.'/modules/'.$xoopsModule->getVar("dirname").'/singlelink.php?lid='.$lid)));

//** Select Menu
ob_start();
//** Example makeMySelBox($title,$order="",$preset_id=0, $none=0, $sel_name="", $onchange="")	
$cattree = new XoopsTree($xoopsDB->prefix("webshow_cat"),"cid","pid");
$cattree->makeMySelBox("cattitle","cattitle",$cid,0,"cid", 'window.location="viewcat.php?cid="+this.value');	
$catselbox = ob_get_contents();	
ob_end_clean();
$xoopsTpl->assign('category_select', $catselbox);

//** Main Path
$pathstring = "<a href=\"index.php\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/home.png\" border=\"0\" alt=\""._MD_MAIN."\" />" ._MD_MAIN."</a>&nbsp;:&nbsp;";
$xoopsTpl->assign('main_path', $pathstring);


//** METATAGS modified from code by Xoops-France & Herv Thouzard
// Page Title 
$metatitle = strip_tags(sprintf(_MD_POSTERTITLE,$submittername));
$metatitle = $myts->makeTboxData4Show($metatitle);
$xoopsTpl->assign('xoops_pagetitle',$metatitle); 

// Meta Description
$metadesc = strip_tags(sprintf(_MD_THEREAREBY,$numrows, $submittername));
$metadesc = $myts->makeTboxData4Show($metadesc);


// Meta Keywords
include_once XOOPS_ROOT_PATH . '/modules/'.$xoopsModule->getVar('dirname').'/include/functions.php';
$metakey = webshow_extract_keywords($metatitle." ".$metadesc." ".$metakey);

//** Assign meta tags 
   if (is_object($xoTheme)) { 
    $xoTheme->addMeta( 'meta', 'keywords',$metakey);
    $xoTheme->addMeta( 'meta', 'description',$metadesc);     
    $xoTheme->addMeta( 'meta', 'title', $metatitle); 
    } else { 
    $xoopsTpl->assign('xoops_pagetitle',$metatitle); 
    $xoopsTpl->assign('xoops_meta_keywords',$metakey);
    $xoopsTpl->assign('xoops_meta_description',$metadesc);       
    } 

include XOOPS_ROOT_PATH.'/footer.php';
?>