<?php
// $Id: popmovie.php,v.50 2007/03/01 19:59:00 tcnet Exp $ //
// Flash Media Player by Jereon Wijering ( http://www.jeroenwijering.com ) is licensed under a Creative Commons License (http://creativecommons.org/licenses/by-nc-sa/2.0/) //
// It allows you to use and modify the script for noncommercial purposes. //
// You must share a like any modifications. // 
// For commercial use you must purchase a license from Jereon Wijering at http://www.jeroenwijering.com/?order=form. //
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //

include 'header.php';
$myts =& MyTextSanitizer::getInstance(); // MyTextSanitizer object
$lid = intval($_GET['lid']);

//** Get Playlist data
$result = $xoopsDB->query("select cid, title, srctype, listtype, listurl, listcache, cachetime, showinfo, logourl, player, chain, entryperm from ".$xoopsDB->prefix("webshow_links")." where lid=$lid and status>0");
list($cid, $title, $srctype, $listtype, $listurl, $listcache, $cachetime, $showinfo, $logourl, $player, $chainid, $ws_entryperm) = $xoopsDB->fetchRow($result);

//** Category Permission
$groups = is_object($xoopsUser) ? $xoopsUser->getGroups() : XOOPS_GROUP_ANONYMOUS;
$gperm_handler =& xoops_gethandler('groupperm');
// example checkRight($gperm_name, $gperm_itemid, $gperm_groupid, $gperm_modid = 1)
if (!$gperm_handler->checkRight('webshow_view', $cid, $groups, $xoopsModule->getVar('mid'))) {
   echo"<script language=JavaScript>self.close(); </script>";
   exit();
}

//** Entry Permission
$group = is_object($xoopsUser) ? $xoopsUser->getGroups() : array(XOOPS_GROUP_ANONYMOUS);
$ws_entryperm = explode(" ",$ws_entryperm);
if (count(array_intersect($group,$ws_entryperm)) < 1){
   echo"<script language=JavaScript>self.close(); </script>";
   exit();
}

if($chainid != 0) {
   //** Get chain data
$chainresult = $xoopsDB->query("select title, srctype, listtype, listurl, listcache, cachetime, logourl, player, entryperm from ".$xoopsDB->prefix("webshow_links")." where lid=$chainid");
list($chaintitle, $chainsrctype, $chainlisttype, $chainlisturl, $chainlistcache, $chaincachetime, $chainlogourl, $chainplayer, $chainentryperm) = $xoopsDB->fetchRow($chainresult);
$chaintitle = $myts->makeTboxData4Show($chaintitle);	
}

$ltitle = $myts->makeTboxData4Show($title);
$styleoption = "";
include "include/movie.php";

$pagestyle = XOOPS_URL.'/themes/'.$xoopsConfig['theme_set'].'/style.css';

//** Set popup dimensions according to movie.php dimensions  
$popwidth= $moviewidth + 20;
$popheight= $movieheight + 90;

//** WINDOW		
echo '<html>
   <head>
<meta http-equiv="content-type" content="text/html; charset='._CHARSET.'" />
<meta name="robots" content="noindex,nofollow,noarchive" />
<meta http-equiv="content-language" content="'._LANGCODE.'" />
<link rel="stylesheet" type="text/css" media="all" href="'.XOOPS_URL.'/xoops.css" />
<link rel="stylesheet" type="text/css" media="screen" href="'.$pagestyle.'" />
<title>'.$ltitle.'</title>';
echo "</head><body class=\"item\" align=\"left\" onLoad=\"resizeTo($popwidth,$popheight), self.focus()\">".$themefromplayer;
echo "<div class=\"itemHead\" style=\"float: left; width: ".$moviewidth."px; margin: 5px 5px 0px 0px;\">
         <div class=\"itemTitle\" style=\"float: left; width: ".moviewidth."px; text-align: center; font-size: 90%;\"><a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/singlelink.php?lid=".$lid."\" target=\"_blank\" title=\""._MD_VIEWLISTING.": ".$ltitle."\" >".$ltitle."</a></div>
         </div>
          <div class=\"itemBody\" style=\"width: ".moviewidth."px; text-align: center;\">".$movie."</div>";
if($chainid != 0) {
   $chaintitle = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/singlelink.php?lid=".$chainid."\" target=\"_blank\" title=\""._MD_VIEWLISTING.": ".$chaintitle."\" >".$chaintitle."</a>";
   echo "<div class=\"itemHead\" style=\"float: left; width: ".$moviewidth."px; margin: 5px 5px 0px 0px;\">
           <div class=\"itemTitle\" style=\"float: left; width: ".moviewidth."px; text-align: center; font-size: 90%;\">".$chaintitle."</div>
         </div>
         <div class=\"itemBody\" style=\"width: ".moviewidth."px; text-align: center;\">".$chainmovie."</div>";
}  
exit();
?>