<?php
// $Id: submit.php,v.50 2007/03/01 19:59:00 tcnet Exp $ //
// Flash Media Player by Jereon Wijering ( http://www.jeroenwijering.com ) is licensed under a Creative Commons License (http://creativecommons.org/licenses/by-nc-sa/2.0/) //
// It allows you to use and modify the script for noncommercial purposes. //
// You must share a like any modifications. // 
// For commercial use you must purchase a license from Jereon Wijering at http://www.jeroenwijering.com/?order=form. //
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //
include "header.php";
include_once XOOPS_ROOT_PATH.'/class/xoopstree.php';
include_once XOOPS_ROOT_PATH."/class/xoopslists.php";
include_once XOOPS_ROOT_PATH."/class/xoopsformloader.php";
include_once XOOPS_ROOT_PATH."/class/uploader.php";
include_once XOOPS_ROOT_PATH.'/class/module.errorhandler.php'; 
include_once XOOPS_ROOT_PATH."/include/xoopscodes.php";

$myts =& MyTextSanitizer::getInstance();
$eh = new ErrorHandler;
$allowed_mimetypes = array('image/gif', 'image/jpeg', 'image/pjpeg', 'image/x-png', 'image/png');
$logosize = 30000;
$logowidth = $xoopsModuleConfig['logowidth'];
$logoheight = $xoopsModuleConfig['logowidth'];

if (!empty($_POST['submit'])) {
   //** CAPTCHA verification
      if(@include_once XOOPS_ROOT_PATH."/Frameworks/captcha/captcha.php") {
         $xoopsCaptcha = XoopsCaptcha::instance();
            if(! $xoopsCaptcha->verify($_POST["skipmember"]) ) {
               echo $xoopsCaptcha->getMessage();
               redirect_header(XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/submit.php", 3, _MD_CAPTCHA_INCORRECT."<br />"._NOPERM);
            }
      }

   $submitter = !empty($xoopsUser) ? $xoopsUser->getVar('uid') : 0;

   // Check if Title exist
   if ($_POST["title"]=="") {
      $eh->show("1001");
   }
   $title = $myts->makeTboxData4Save($_POST["title"]); 	
   $artist = $myts->makeTboxData4Save($_POST["artist"]);
   $album = $myts->makeTboxData4Save($_POST["album"]);
   $label = $myts->makeTboxData4Save($_POST["label"]);   	 
   // Website URL
   $url = $myts->makeTboxData4Save($_POST["url"]);
   $url= formatURL($url); 	
   // SOURCE TYPE
   $srctype = $myts->makeTboxData4Save($_POST["srctype"]);	
   // LIST TYPE
   $listtype = 'feed';	
   // LISTURL 		
   if ( ($_POST["listurl"]) || ($_POST["listurl"]!="") ) {
      $listurl = $_POST["listurl"];
      if($listtype = "feed") {    
         $listurl = formatURL ($listurl);
      }  
         $listurl = $myts->makeTboxData4Save($listurl);    
   } else {
      $eh->show("1016");
   }   			
	    	
   // Check if Description exist
   if ($_POST['description']=="") {
      $eh->show("1008");
   }
   $description = $myts->makeTareaData4Save($_POST["description"]);       
   $bodytext = $myts->makeTareaData4Save($_POST["bodytext"]);

   //** ENTRY LOGO
   $logourl = empty($logourl)?(empty($_POST['logourl'])?"":$_POST['logourl']):$logourl; 

   //** if LOGO Link from URL
   $logolink =  isset($_POST['logolink']) ? $_POST['logolink'] : "";
   if(!empty($logolink)){
      $logolink = formatURL ($logolink);  
      $logourl = $myts->makeTboxData4Save($logolink); 
   }

   //** if LOGO UPLOAD
   if (!empty($_FILES['userfile']['name'])) { 
      //$uploader = new XoopsMediaUploader('/home/xoops/uploads', $allowed_mimetypes, $maxfilesize, $maxfilewidth, $maxfileheight);
      $uploader = new XoopsMediaUploader(XOOPS_ROOT_PATH . "/".$xoopsModuleConfig['path_logo'], $allowed_mimetypes, $logosize, $logowidth, $logoheight);
      if ($uploader->fetchMedia($_POST['xoops_upload_file'][0])) {
         if (!$uploader->upload()) {
            echo $uploader->getErrors();
         } else {
             echo '<h4>'._MD_FILESUCCESS.'</h4>';
            $logourl = $uploader->getSavedFileName();
         }
      } else {
         echo $uploader->getErrors();
      }
   }

   $comments = intval($_POST['comments']); 

   $playerid = 1;

   //** Category
   if ( !empty($_POST['cid']) ) {
      $cid = intval($_POST['cid']);
   } else {
      $cid = "0";
   }

   //** SHOW INFORMATION
   //** On/Off for contents of the Show Info Box
   // $showinfo is set in theadministrators media editor.   	.
   // 'showinfobox|description|logo|credits|statistics|submitter|pagelink|website|embedlink|download or webfeed|popup|tags'      	
   $showinfo = "1|1|1|1|1|1|1|1|1|1|1|1"; 

   $date = time();
   $newid = $xoopsDB->genId($xoopsDB->prefix("webshow_links")."_lid_seq");

   //** AUTO APPROVE PERMISSIONS
   // If auto_approve then $status = 1 (online)
   $groups = is_object($xoopsUser) ? $xoopsUser->getGroups() : XOOPS_GROUP_ANONYMOUS;
   $gperm_handler =& xoops_gethandler('groupperm');
   if ($gperm_handler->checkRight('webshow_approve', $cid, $groups, $xoopsModule->getVar('mid'))) {
      $status = 1;

   } else {
      $status = 0; //OFFLINE
   }	

   //** SET VIEW ENTRY PERMISSIONS
   // Which groups can view this submission before admin intervention.            
   $ws_entryperm = $gperm_handler->getGroupIds('webshow_view', $cid, $xoopsModule->getVar('mid'));
   $ws_entryperm = implode (' ',$ws_entryperm);
   $ws_entryperm = $myts->makeTboxData4Save($ws_entryperm);

   $notify = !empty($_POST['notify']) ? 1 : 0;	
	
   $sql = sprintf("INSERT INTO %s (lid, cid, title, url, srctype, listtype, listurl, logourl, comments, submitter, status, date, player, artist, album, label, entryperm, showinfo) VALUES (%u, %u, '%s', '%s', '%s', '%s', '%s', '%s', %u, %u, %u, %u, %u, '%s', '%s', '%s', '%s', '%s')", $xoopsDB->prefix("webshow_links"), $newid, $cid, $title, $url, $srctype, $listtype, $listurl, $logourl, $comments, $submitter, $status, $date, $playerid, $artist, $album, $label, $ws_entryperm, $showinfo);
   $xoopsDB->query($sql) or $eh->show("0013");
   if ($newid == 0) {
   $newid = $xoopsDB->getInsertId();
   }
   $sql = sprintf("INSERT INTO %s (lid, description, bodytext) VALUES (%u, '%s', '%s')", $xoopsDB->prefix("webshow_text"), $newid, $description, $bodytext);
   $xoopsDB->query($sql) or $eh->show("0013");

   //** FLASH VARIABLES
   $mediatype = $srctype;
   $showeq = 0; //Fake spectrum analyzer animation
   $thumbslist = 0; //Show thumbnails from a playlist
   $link = 0; //Make the screen into hyperlink.
   $linktarget = "_blank"; //Frame to open hyperlink
   $start = 0; //Auto Start
   $shuffle = 0;
   $replay = 0;
   $rotatetime = "5"; //Image rotation time
   $shownav = 0; //For image only shows.  Transition must be set.
   $transition = "0"; //For Image Only Shows. Set to a transition name, i.e. "fade". When a transition is set the Image Rotator swf is activated.  
   $showicons = 1; //Show Activity Icons
   $stretch = "false"; //Image stretch
   $captions = ""; //Absolute Url of an xml captions file.
   $playerlogo = ""; //Enter just the name of an image file ( myimage.png ) that is located in webshow/images/player/
   $enablejs = "0";  //Not functioning atm.  Leave off.   

   //**Insert Flash Variables
   $sql = sprintf("INSERT INTO %s (lid, mediatype, start, shuffle, replay, link, linktarget, showicons, stretch, showeq, rotatetime, shownav, transition, thumbslist, captions) VALUES (%u, '%s', %u, %u, %u, %u, '%s', %u, '%s', %u, %u, %u, '%s', %u, '%s')", $xoopsDB->prefix("webshow_flashvar"), $newid, $mediatype, $start, $shuffle, $replay, $link, $linktarget, $showicons, $stretch, $captions, $showeq, $rotatetime, $shownav, $transition, $thumbslist, $captions);
   $xoopsDB->query($sql) or $eh->show("0013");

   //** Save Tags requires phppp's Tag module
   $itemid =$newid;
   $catid = $cid;
   $tag_handler = xoops_getmodulehandler('tag', 'tag');
   $tag_handler->updateByItem($_POST["item_tag"], $itemid, $xoopsModule->getVar("dirname"), $catid =0);

   // RMV-NEW
   // Notify of new link (anywhere) and new link in category.
   $notification_handler =& xoops_gethandler('notification');
   $tags = array();
   $tags['LINK_NAME'] = $title;
   $tags['LINK_URL'] = XOOPS_URL . '/modules/'. $xoopsModule->getVar('dirname') . '/singlelink.php?cid=' . $cid . '&lid=' . $newid;
   $sql = "SELECT cattitle FROM " . $xoopsDB->prefix("webshow_cat") . " WHERE cid=" . $cid;
   $result = $xoopsDB->query($sql);
   $row = $xoopsDB->fetchArray($result);
   $tags['CATEGORY_NAME'] = $row['cattitle'];
   $tags['CATEGORY_URL'] = XOOPS_URL . '/modules/' . $xoopsModule->getVar('dirname') . '/viewcat.php?cid=' . $cid;
    if ($gperm_handler->checkRight('webshow_approve', $cid, $groups, $xoopsModule->getVar('mid'))) {
      $notification_handler->triggerEvent('global', 0, 'new_link', $tags);
      $notification_handler->triggerEvent('category', $cid, 'new_link', $tags);
      redirect_header("singlelink.php?lid=$newid",5,_MD_RECEIVED."<br />"._MD_ISAPPROVED."");
   } else {
      $tags['WAITINGLINKS_URL'] = XOOPS_URL . '/modules/' . $xoopsModule->getVar('dirname') . '/admin/index.php?op=listNewLinks';
      $notification_handler->triggerEvent('global', 0, 'link_submit', $tags);
      $notification_handler->triggerEvent('category', $cid, 'link_submit', $tags);
      if ($notify) {
         include_once XOOPS_ROOT_PATH . '/include/notification_constants.php';
         $notification_handler->subscribe('link', $newid, 'approve', XOOPS_NOTIFICATION_MODE_SENDONCETHENDELETE);
      }
      redirect_header("index.php",5,_MD_RECEIVED.'<br />'._MD_ALLPENDING);
	}
   exit();
} else {
   //*****  START ENTRY FORM  ******************//
   $xoopsOption['template_main'] = 'webshow_submit.html';   
   include XOOPS_ROOT_PATH."/header.php";
   $playertree = new XoopsTree($xoopsDB->prefix("webshow_player"),"playerid","playertitle");	      

   //** Set Entry Variables (links table) 
   $title = "";
   $artist = "";
   $album = "";
   $label="";
   $cid = "";    
   $listurl = "";
   $srctype = "mp3";
   $logourl = "";
   $comments=1;
   $url = "";
   $description = "";
   $bodytext = "";	
   $formlabel = _MD_ADDNEWLINK;
   // Link to admin entry form.
   if ($xoopsUser && $xoopsUser->isAdmin($xoopsModule->mid())) {
     $adminlink = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/admin/index.php?op=newLink\">"._MD_ADMIN."<img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/editicon.gif\" border=\"0\" alt=\""._MD_EDITTHISLINK."\" /></a>";
     $xoopsTpl->assign('adminlink', $adminlink);
   } 
   $btnlabel = _MD_ADD;					
   $sform = new XoopsThemeForm($formlabel, "playlistform", XOOPS_URL.'/modules/'.$xoopsModule->getVar('dirname').'/submit.php', 'post');
   $sform->setExtra('enctype="multipart/form-data"');

   //** Playlist Title
   $sform->addElement(new XoopsFormText("<b>"._MD_SITETITLE."*</b>", 'title', 40, 60, $title), true);

   //** LIST TYPE and URL
   $sform->addElement(new XoopsFormText("<b>"._MD_LISTURL."*</b><br /><span style=\"font-size: 85%; font-weight: 500;\">"._MD_LISTTYPE_FEED_DSC."</span>", 'listurl', 40, 250, $listurl), true);

   //**SELECT MEDIA FILE TYPE    
   $source_tray = new XoopsFormElementTray("<b>"._MD_SRC."*</b><br /><span style=\"font-size:90%; font-weight: 500;\">"._MD_SRC_DSC."</span>","" );
   // example XoopsFormSelect($caption, $name, $value=null, $size=1, $multiple=false, $id="")
   $sourcetype=new XoopsFormSelect('', 'srctype', $srctype, 1, false, $srctype);   
   $sourcetype->addOption('mp3',_MD_SRC_MP3,false);		   
   $sourcetype->addOption('image',_MD_SRC_IMAGE,false);
   $sourcetype->addOption('flv',_MD_SRC_FLV,false);
   $sourcetype->addOption('swf',_MD_SRC_SWF,false);
   //$sourcetype->addOption('all',_MD_SRC_ALLMEDIA,false);
   $source_tray->addElement($sourcetype, true);
   $sform->addElement($source_tray); 

   //** Description
   $sform->addElement(new XoopsFormTextArea("<b>"._MD_BLOCKDESCRIPTION.": *</b><br /><span style=\"font-size: 85%; font-weight: 500;\">"._MD_BLOCKDESCRIPTION_DSC."</span>", 'description',$description,2,40), true);								

   //** TAGS
   if($xoopsModuleConfig['tags']){
      $itemid = "";
      $catid = "";
      include_once XOOPS_ROOT_PATH."/modules/tag/include/formtag.php";
      // example XoopsFormTag($name, $size, $maxlength, $value = null, $catid = 0)
      $sform->addElement(new XoopsFormTag("item_tag", 60, 255, $itemid, $catid));
   }

   //** CREDITS
   //** Artist
   $sform->addElement(new XoopsFormText("<b>"._MD_ARTIST."</b>", 'artist', 40, 100, $artist), false);
   //** Album
   $sform->addElement(new XoopsFormText("<b>"._MD_ALBUM."</b>", 'album', 40, 100, $album), false);
   //** Label
   $sform->addElement(new XoopsFormText("<b>"._MD_LABEL."</b>", 'label', 40, 100, $label), false);
   //** Website URL	
   $sform->addElement(new XoopsFormText("<b>"._MD_SITEURL."</b>", 'url', 40, 250, $url), false);

   //**Category Select
   $groups = is_object($xoopsUser) ? $xoopsUser->getGroups() : XOOPS_GROUP_ANONYMOUS;
   $gperm_handler =& xoops_gethandler('groupperm'); 
   // getItemIds($gperm_name, $gperm_groupid, $gperm_modid = 1)
   $catpermid = $gperm_handler->getItemIds('webshow_submit', $groups, $xoopsModule->getVar('mid'));
   if(empty($catpermid)){
     redirect_header(XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/index.php", 3, _NOPERM);
   }else{
      $cat_tray = new XoopsFormElementTray("<b>"._MD_CATEGORYC."</b>","" );
      // example XoopsFormSelect($caption, $name, $value=null, $size=1, $multiple=false, $id="")
      $catselect=new XoopsFormSelect('', 'cid', $cid, 1, false, $cid);   
      foreach ($catpermid as $k => $cid) {
         $result=$xoopsDB->query("SELECT cattitle FROM ".$xoopsDB->prefix("webshow_cat")." WHERE cid = $cid");
         list($cattitle) = $xoopsDB->fetchRow($result);
         $catselect->addOption($cid,$cattitle,false);

         //$catselect->addOptionArray($catpermid);	   
      }
      $cat_tray->addElement($catselect, true);
      $sform->addElement($cat_tray);
   }

   //** LOGO IMAGE 
   if(!empty($xoopsModuleConfig["path_logo"])){
      $logo_image_tray = new XoopsFormElementTray("<b>"._MD_LOGOIMAGE."</b><br /><br /><span style=\"font-size: 90%; font-weight: 500;\"><b>"._MD_LOGOURL."</b><br />"._MD_LOGOURL_DSC."<br /><br /><b>"._MD_LOGOUPLOAD."</b><br />"._MD_LOGOSIZE." ".$logosize."bytes<br />"._MD_LOGODIM." ".$logowidth."px<br /><br /><b>"._MD_LOGOSELECT."</b><br />"._MD_LOGOPATH_DSC." ".$xoopsModuleConfig["path_logo"]."</span>", "");

      //** LINK to LOGO URL
      //If logourl is an external link $logolink = $logourl;
     $ps = strpos($logourl, 'http://');
      if (!($ps === false)) { 
         $logolink = $logourl;
      } else {
         $logolink = "";
      }
      $image_option_tray = new XoopsFormElementTray("<span style=\"font-size: 90%; font-weight: 500;\">"._MD_LOGOIMAGE_DSC."</span><br /><br /><b>"._MD_LOGOURL."</b>", "");
      $image_option_tray->addElement(new XoopsFormText("", 'logolink', 50, 250, $logolink), false);
      $logo_image_tray->addElement($image_option_tray);
    
      //** UPLOAD LOGO 
      //** code borrowed from Article module by phppp
      unset($image_option_tray);  
      $image_option_tray = new XoopsFormElementTray("<br /><br /><b>"._MD_LOGOUPLOAD."</b>", ""); 
      $image_option_tray->addElement(new XoopsFormFile("", "userfile",""));
      $logo_image_tray->addElement($image_option_tray);
    
      //** SELECT LOGO
      unset($image_tray);
      unset($image_option_tray);
      $path_image = $xoopsModuleConfig["path_logo"];
      $image_option_tray = new XoopsFormElementTray("<br /><br /><b>"._MD_LOGOSELECT."</b>", "");
      $image_array =& XoopsLists::getImgListAsArray(XOOPS_ROOT_PATH . "/". $path_image."/");
      array_unshift($image_array, _NONE);
      $image_select = new XoopsFormSelect("", "logourl", $logourl);
      $image_select->addOptionArray($image_array);
      $image_select->setExtra("onchange=\"showImgSelected('img', 'logourl', '/".$path_image."/', '', '" . XOOPS_URL . "')\"");
      $image_tray = new XoopsFormElementTray("", "");
      $image_tray->addElement($image_select);

      //** IMAGE PREVIEW  
      if (!empty($logourl) && file_exists(XOOPS_ROOT_PATH . "/" .$path_image."/" . $logourl)){
         $image_tray->addElement(new XoopsFormLabel("", "<div style=\"padding: 8px;\"><img src=\"" . XOOPS_URL . "/" .$path_image."/" . $logourl . "\" name=\"img\" id=\"img\" alt=\"\" /></div>"));
      }elseif(!empty($logolink)){
         $image_tray->addElement(new XoopsFormLabel("", "<div style=\"padding: 8px;\"><img src=\"" .$logolink. "\" name=\"img\" id=\"img\" alt=\"\" /></div>"));  
      }else{
         $image_tray->addElement(new XoopsFormLabel("", "<div style=\"padding: 8px;\"><img src=\"" . XOOPS_URL . "/images/blank.gif\" name=\"img\" id=\"img\" alt=\"\" /></div>"));
      }
      $image_option_tray->addElement($image_tray);
        
      $logo_image_tray->addElement($image_option_tray);
      $sform->addElement($logo_image_tray);
   }  

   $sform->addElement(new XoopsFormRadioYN("<b>"._MD_ALLOWCOMMENTS."</b>", 'comments', $comments, _YES, _NO));		
   
   //**Body Text - Disabled.  User must access thru modify form.
      $sform->addElement(new XoopsFormHidden('bodytext', ''), false);  // To display text editor on the submit form, remove this line and uncomment below.  
   /*    
   if(file_exists(XOOPS_ROOT_PATH."/class/xoopseditor/xoopseditor.php")) {
      //** Text Editor Requires class/xoopseditor
      include_once XOOPS_ROOT_PATH."/Frameworks/xoops22/class/xoopsformloader.php";
      $editor = $xoopsModuleConfig["texteditor"];
      // options for the editor
      //required configs
      $options['name'] ='bodytext';
      //$options['value'] = empty($_REQUEST['bodytext'])? "" : $_REQUEST['bodytext'];
      $options['value'] = $bodytext;
      //optional configs
      $options['rows'] = 25; // default value = 5
      $options['cols'] = 60; // default value = 50
      $options['width'] = '550px'; // default value = 100%
      $options['height'] = '400px'; // default value = 400px
      $editor_configs = $options;
      $sform->addElement(new XoopsFormEditor(_MD_LINKTEXTC, $editor, $editor_configs, $nohtml = false, $onfailure = "textarea"), false);
   }else{
      //** example XoopsFormDhtmlTextArea($caption, $name, $value, $rows=5, $cols=50, $hiddentext="xoopsHiddenText")
      $sform->addElement(new XoopsFormDhtmlTextArea("<b>"._MD_LINKTEXTC."</b>", 'bodytext',$bodytext,10,10), false);	
   }
   */

   //** CAPTCHA requires Frameworks Captcha
   // Set $xoopsModuleConfig["captcha"] in module preferences;
   // Defaults are set in Frameworks/captcha/config.php
   $ws_captcha = $xoopsModuleConfig["captcha"];
   if($ws_captcha != 0 ) {
      include_once XOOPS_ROOT_PATH."/Frameworks/captcha/formcaptcha.php";
      $skipmember = 1;   
      if($ws_captcha == 2) {
         $skipmember = 0;     
      }
      // example $sform->addElement(new XoopsFormCaptcha($caption, $name,$skipmember,$numchar, $minfontsize,$maxfontsize,$backgroundtype,$backgroundnum));
      $sform->addElement(new XoopsFormCaptcha("", "wscaptcha", $skipmember));   
      $sform->addElement(new XoopsFormHidden('skipmember', $skipmember), false);
   }

   //** Hidden Variables
   $sform->addElement(new XoopsFormHidden('playerid', '1'), false); //Use default player.		
   $sform->addElement(new XoopsFormHidden('submit', '1'), false);		     

   //** Submit buttons
   $button_tray = new XoopsFormElementTray(_MD_REQUIRED,'');
   $submit_btn = new XoopsFormButton('', 'post', $btnlabel, 'submit');
   $button_tray->addElement($submit_btn);
   $sform->addElement($button_tray);		
   $xoopsTpl->assign('sform',$sform->render());

   //$xoopsTpl->assign('notify_show', !empty($xoopsUser) && !$xoopsModuleConfig['autoapprove'] ? 1 : 0); NEEDS WORK. Should use grp perm approve.
     
   //** META TAGS
   //** Title
   $metatitle = $myts->makeTboxData4Show($xoopsModule->getVar('name') . ' ' . $myts->makeTboxData4Show(_MD_SUBMITLINKHEAD));
   $xoopsTpl->assign('xoops_pagetitle',$metatitle); 
   // Description from module config description
   $metadesc = $myts->makeTareaData4Show($xoopsModuleConfig['moddesc'],0);
   // Keywords
   include_once XOOPS_ROOT_PATH . '/modules/'.$xoopsModule->getVar('dirname').'/include/functions.php';
   $metakey = webshow_extract_keywords($metadesc);
   //** Assign meta tags 
   if (is_object($xoTheme)) { 
       $xoTheme->addMeta( 'meta', 'keywords',$metakey);
       $xoTheme->addMeta( 'meta', 'description',$metadesc);     
       $xoTheme->addMeta( 'meta', 'title', $metatitle); 
   } else { 
       $xoopsTpl->assign('xoops_meta_keywords',$keywords);
       $xoopsTpl->assign('xoops_meta_description',$metadesc);       
   }  

   include XOOPS_ROOT_PATH.'/footer.php';		
}   	
?>