<?php
// $Id: utube_submit.php,v.59 2007/03/01 19:59:00 tcnet Exp $ //
// Flash Media Player by Jereon Wijering ( http://www.jeroenwijering.com ) is licensed under a Creative Commons License (http://creativecommons.org/licenses/by-nc-sa/2.0/) //
// It allows you to use and modify the script for noncommercial purposes. //
// You must share a like any modifications. // 
// For commercial use you must purchase a license from Jereon Wijering at http://www.jeroenwijering.com/?order=form. //
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //

// SET the PLAYER by ID
//** Use player editor to create a custom player for youtube videos and enter the player ID here.
$playerid = 1;

//** SET the FLASH VARIABLES
$start = 1; 
$shuffle = 0;
$replay = 0;
$showicons = 0; //Show Activity Icons
$stretch = "none"; //Image overstretch
$rotatetime = "0";

include "header.php";
$xoopsOption['template_main'] = 'webshow_submit.html';
include_once XOOPS_ROOT_PATH.'/class/xoopstree.php';
include_once XOOPS_ROOT_PATH."/class/xoopslists.php";
include_once XOOPS_ROOT_PATH."/class/xoopsformloader.php";
include_once XOOPS_ROOT_PATH."/class/uploader.php";
include_once XOOPS_ROOT_PATH.'/class/module.errorhandler.php'; 
include_once XOOPS_ROOT_PATH."/include/xoopscodes.php";
$myts =& MyTextSanitizer::getInstance();
$eh = new ErrorHandler;
//$cattree = new XoopsTree($xoopsDB->prefix("webshow_cat"),"cid","pid");
$allowed_mimetypes = array('image/gif', 'image/jpeg', 'image/pjpeg', 'image/x-png', 'image/png');
$logosize = 30000;
$logowidth = $xoopsModuleConfig['logowidth'];
$logoheight = $xoopsModuleConfig['logowidth'];
   
//** UTUBE USER SUBMIT SAVE **
if (!empty($_POST['submit'])) {
   //** CAPTCHA verification
      if(@include_once XOOPS_ROOT_PATH."/Frameworks/captcha/captcha.php") {
         $xoopsCaptcha = XoopsCaptcha::instance();
            if(! $xoopsCaptcha->verify($_POST["skipmember"]) ) {
               echo $xoopsCaptcha->getMessage();
               redirect_header(XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/submit.php", 3, _MD_CAPTCHA_INCORRECT."<br />"._NOPERM);
            }
      }
      
   //** SUBMITTER
   $submitter = !empty($xoopsUser) ? $xoopsUser->getVar('uid') : 0;

   //** CATEGORY
   if ( !empty($_POST['cid']) ) {
         $cid = intval($_POST['cid']);
   } else {
         $cid = "0"; //OFFLINE!
   } 

   //** TITLE
   if ($_POST["title"]=="") {
      $eh->show("1001");
   }
   $title = $myts->makeTboxData4Save($_POST["title"]);
 
   //** SOURCE TYPE
   $srctype = 'swf';	

   //** LIST TYPE	
   $listtype = 'single';	

   // WEBSITE URL
   if ($_POST['url']=="" ) {
      $eh->show("1016");
   } else {  
   $url= formatURL($_POST['url']); 	   
   $url = $myts->makeTboxData4Save($url);
   }

   // Get video id from url
   $vidid = preg_match("/v=(.*)/", $url, $matches);
   if ($vidid == true) {
      $vidid = $matches['1'];
   }

   //** LOGO IMAGE
   $logourl = $myts->makeTboxData4Save("http://img.youtube.com/vi/".$vidid."/2.jpg"); 

   //** LISTURL 
   $listurl = $myts->makeTboxData4Save("http://youtube.com/v/".$vidid);    

   // BLOCK DESCRIPTION used in catalog, blocks and as page meta description. 
   if ($_POST["description"]=="") {
      $eh->show("1008");
   }
   $description = $myts->makeTareaData4Save($_POST["description"]);       
       
   //**Body Text disabled for utube.  
   //$bodytext = $myts->makeTareaData4Save($_POST["bodytext"]);
   $bodytext = "";

   // Credits disabled for utube
   $artist = "";
   //$artist = $myts->makeTboxData4Save($_POST["artist"]);
   $album = "";
   //$album = $myts->makeTboxData4Save($_POST["album"]);
   $label = "";
   //$label = $myts->makeTboxData4Save($_POST["label"]);   		
	
   //** SHOW INFORMATION
   // On/Off switch for contents of the Show Info Box.
   // 'showinfobox|description|logo|credits|statistics|submitter|pagelink|website|embedlink|download or webfeed|popup|tags'      	
   $showinfo = "1|1|1|1|1|1|1|1|0|0|1|1"; 

   $date = time();
   $newid = $xoopsDB->genId($xoopsDB->prefix("webshow_links")."_lid_seq");	

    //** AUTO APPROVE PERMISSIONS
   // If auto_aprrove then $status = 1 (online)
   $groups = is_object($xoopsUser) ? $xoopsUser->getGroups() : XOOPS_GROUP_ANONYMOUS;
   $gperm_handler =& xoops_gethandler('groupperm');
   if ($gperm_handler->checkRight('webshow_approve', $cid, $groups, $xoopsModule->getVar('mid'))) {
      $status = 1;
         //** SET VIEW ENTRY PERMISSIONS
        // Which groups can view this submission before admin intervention.            
        $ws_entryperm = $gperm_handler->getGroupIds('webshow_view', $cid, $xoopsModule->getVar('mid'));
        $ws_entryperm = implode (' ',$ws_entryperm); 
   } else {
      $status = 0; //OFFLINE
   }

   //** QUERY Links Table   
   $sql = sprintf("INSERT INTO %s (lid, cid, title, url, srctype, listtype, listurl, logourl, submitter, status, date, player, artist, album, label, entryperm, showinfo) VALUES (%u, %u, '%s', '%s', '%s', '%s', '%s', '%s', %u, %u, %u, %u, '%s', '%s', '%s', '%s', '%s')", $xoopsDB->prefix("webshow_links"), $newid, $cid, $title, $url, $srctype, $listtype, $listurl, $logourl, $submitter, $status, $date, $playerid, $artist, $album, $label, $ws_entryperm, $showinfo);
   $xoopsDB->query($sql) or $eh->show("0013");
   if ($newid == 0) {
      $newid = $xoopsDB->getInsertId();
   }
   $sql = sprintf("INSERT INTO %s (lid, description, bodytext) VALUES (%u, '%s', '%s')", $xoopsDB->prefix("webshow_text"), $newid, $description, $bodytext);
   $xoopsDB->query($sql) or $eh->show("0013");
   $mediatype = $srctype;
   
   //** QUERY FLASHVAR TABLE
   $sql = sprintf("INSERT INTO %s (lid, mediatype, start, shuffle, replay, showicons, stretch, rotatetime) VALUES (%u, '%s', %u, %u, %u, %u, '%s', %u)", $xoopsDB->prefix("webshow_flashvar"), $newid, $mediatype, $start, $shuffle, $replay, $showicons, $stretch, $rotatetime);
   $xoopsDB->query($sql) or $eh->show("0013");

   //** Save Tags requires phppp's Tag module
   $itemid =$newid;
   $tag_handler = xoops_getmodulehandler('tag', 'tag');
   $tag_handler->updateByItem($_POST["item_tag"], $itemid, $xoopsModule->getVar("dirname"), $catid =0);

   // NOTIFICATIONS
   // Notify of new link (anywhere) and new link in category.
   $notify = !empty($_POST['notify']) ? 1 : 0;
   $notification_handler =& xoops_gethandler('notification');
   $tags = array();
   $tags['LINK_NAME'] = $title;
   $tags['LINK_URL'] = XOOPS_URL . '/modules/'. $xoopsModule->getVar('dirname') . '/singlelink.php?cid=' . $cid . '&lid=' . $newid;
   $sql = "SELECT cattitle FROM " . $xoopsDB->prefix("webshow_cat") . " WHERE cid=" . $cid;
   $result = $xoopsDB->query($sql);
   $row = $xoopsDB->fetchArray($result);
   $tags['CATEGORY_NAME'] = $row['cattitle'];
   $tags['CATEGORY_URL'] = XOOPS_URL . '/modules/' . $xoopsModule->getVar('dirname') . '/viewcat.php?cid=' . $cid;

   //** Actions according to webshow_autoapprove group permission
   if ($gperm_handler->checkRight('webshow_approve', $cid, $groups, $xoopsModule->getVar('mid'))) {
      $notification_handler->triggerEvent('global', 0, 'new_link', $tags);
      $notification_handler->triggerEvent('category', $cid, 'new_link', $tags);
      redirect_header("index.php",5,_MD_RECEIVED."<br />"._MD_ISAPPROVED."");
   } else {
      $tags['WAITINGLINKS_URL'] = XOOPS_URL . '/modules/' . $xoopsModule->getVar('dirname') . '/admin/index.php?op=listNewLinks';
      $notification_handler->triggerEvent('global', 0, 'link_submit', $tags);
      $notification_handler->triggerEvent('category', $cid, 'link_submit', $tags);
      if ($notify) {
         include_once XOOPS_ROOT_PATH . '/include/notification_constants.php';
         $notification_handler->subscribe('link', $newid, 'approve', XOOPS_NOTIFICATION_MODE_SENDONCETHENDELETE);
      }
      redirect_header("index.php",5,_MD_RECEIVED.'<br />'._MD_ALLPENDING);
   }
      exit();
} else {
   /* 
   *** UTUBE USER SUBMIT FORM ***
   */
   include XOOPS_ROOT_PATH."/header.php";   
   $cattree = new XoopsTree($xoopsDB->prefix("webshow_cat"),"cid","pid");
   $playertree = new XoopsTree($xoopsDB->prefix("webshow_player"),"playerid","playertitle");	      
   $xoopsTpl->assign('notify_show', !empty($xoopsUser));
   $xoopsTpl->assign('submit_utube',1);   

   //** Declare Entry Variables (links table) 
   $title = "";
   $cid = "";   
   $listurl = "";
   $url = "";
   $description = "";

   //** **** START FORM *****	
   $formlabel =	_MD_UTUBE_SUBMIT;
   $btnlabel = _MD_ADD;					
   $sform = new XoopsThemeForm($formlabel, "playlistform", XOOPS_URL.'/modules/'.$xoopsModule->getVar('dirname').'/submit_utube.php', 'post');
   $sform->setExtra('enctype="multipart/form-data"');

   //** ENTRY TITLE
   $sform->addElement(new XoopsFormText("<b>"._MD_SITETITLE."*</b>", 'title', 60, 60, $title), true);

  //** Website URL
   $sform->addElement(new XoopsFormText("<b>"._MD_UTUBE_URL."*</b><br /><span style=\"font-size: 85%; font-weight: 500;\">"._MD_UTUBE_URL_DSC."</span>", 'url', 50, 250, $url), true);  

   //** Description
   $sform->addElement(new XoopsFormTextArea("<b>"._MD_BLOCKDESCRIPTION.": *</b><br /><span style=\"font-size: 85%; font-weight: 500;\">"._MD_BLOCKDESCRIPTION_DSC."</span>", 'description',$description,2,40), true);								

   //** TAGS
   if($xoopsModuleConfig['tags']){
   $itemid = "";
   include_once XOOPS_ROOT_PATH."/modules/tag/include/formtag.php";
   // example XoopsFormTag($name, $size, $maxlength, $value = null, $catid = 0)
   $sform->addElement(new XoopsFormTag("item_tag", 60, 255, $itemid, $catid = 0));
   }

   //**Category Select
   $groups = is_object($xoopsUser) ? $xoopsUser->getGroups() : XOOPS_GROUP_ANONYMOUS;
   $gperm_handler =& xoops_gethandler('groupperm'); 
   // getItemIds($gperm_name, $gperm_groupid, $gperm_modid = 1)
   $catpermid = $gperm_handler->getItemIds('webshow_submit', $groups, $xoopsModule->getVar('mid'));
   if(empty($catpermid)){
     redirect_header(XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/index.php", 3, _NOPERM);
   }else{
      $cat_tray = new XoopsFormElementTray("<b>"._MD_CATEGORYC."</b>","" );
      // example XoopsFormSelect($caption, $name, $value=null, $size=1, $multiple=false, $id="")
      $catselect=new XoopsFormSelect('', 'cid', $cid, 1, false, $cid);   
      foreach ($catpermid as $k => $cid) {
         $result=$xoopsDB->query("SELECT cattitle FROM ".$xoopsDB->prefix("webshow_cat")." WHERE cid = $cid");
         list($cattitle) = $xoopsDB->fetchRow($result);
         $catselect->addOption($cid,$cattitle,false);

         //$catselect->addOptionArray($catpermid);	   
      }
      $cat_tray->addElement($catselect, true);
      $sform->addElement($cat_tray);
   }

   //** CAPTCHA requires Frameworks Captcha
   // Set $xoopsModuleConfig["captcha"] in module preferences;
   // Defaults are set in Frameworks/captcha/config.php
   $ws_captcha = $xoopsModuleConfig["captcha"];
   if($ws_captcha != 0 ) {
      include_once XOOPS_ROOT_PATH."/Frameworks/captcha/formcaptcha.php";
      $skipmember = 1;   
      if($ws_captcha == 2) {
         $skipmember = 0;     
      }
      // example $sform->addElement(new XoopsFormCaptcha($caption, $name,$skipmember,$numchar, $minfontsize,$maxfontsize,$backgroundtype,$backgroundnum));
      $sform->addElement(new XoopsFormCaptcha("", "wscaptcha", $skipmember));   
      $sform->addElement(new XoopsFormHidden('skipmember', $skipmember), false);
   }
   
   //** Hidden Variables	
   $sform->addElement(new XoopsFormHidden('submit', '1'), false);		     

   //** Submit buttons
   $button_tray = new XoopsFormElementTray(_MD_REQUIRED,'');
   $submit_btn = new XoopsFormButton('', 'post', $btnlabel, 'submit');
   $button_tray->addElement($submit_btn);
   $sform->addElement($button_tray);		
   $xoopsTpl->assign('sform',$sform->render());
   //** END SUBMIT FORM
 
   //** META TAGS
   //** Title
   $metatitle = $myts->makeTboxData4Show($xoopsModule->getVar('name') . ' ' . $myts->makeTboxData4Show(_MD_SUBMITLINKHEAD));
   $xoopsTpl->assign('xoops_pagetitle',$metatitle); 
   // Description from module config description
   $metadesc = $myts->makeTareaData4Show($xoopsModuleConfig['moddesc'],0);
   // Keywords
   include_once XOOPS_ROOT_PATH . '/modules/'.$xoopsModule->getVar('dirname').'/include/functions.php';
   $metakey = webshow_extract_keywords($metadesc);
   //** Assign meta tags 
   if (is_object($xoTheme)) { 
       $xoTheme->addMeta( 'meta', 'keywords',$metakey);
       $xoTheme->addMeta( 'meta', 'description',$metadesc);     
       $xoTheme->addMeta( 'meta', 'title', $metatitle); 
    } else { 
       $xoopsTpl->assign('xoops_meta_keywords',$keywords);
       $xoopsTpl->assign('xoops_meta_description',$metadesc);       
    }  
   include XOOPS_ROOT_PATH.'/footer.php';		
}   	
?>