<?php
// $Id: xoops_version.php,v.61 2007/08/08 12:00:00 tcnet Exp $ //
// for XOOPS v2.0.16 and 2.2.4
// Flash Media Player by Jereon Wijering ( http://www.jeroenwijering.com ) is licensed under a Creative Commons License (http://creativecommons.org/licenses/by-nc-sa/2.0/) //
// It allows you to use and modify the script for noncommercial purposes. //
// You must share a like any modifications. // 
// For commercial use of this module you must purchase a license from Jereon Wijering at http://www.jeroenwijering.com/?order=form. //
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //
$modversion['name'] = _MI_WEBSHOW_NAME;
$modversion['version'] = .61;
$modversion['description'] = _MI_WEBSHOW_DESC;
$modversion['credits'] = "TCNet";
$modversion['help'] = "webshow_help.html";
$modversion['license'] = "GPL see LICENSE";
$modversion['official'] = 1;
$modversion['image'] = "images/webshow_slogo.png";
$modversion['dirname'] = "webshow";

// Sql file (must contain sql generated by phpMyAdmin or phpPgAdmin)
// All tables should not have any prefix!
$modversion['sqlfile']['mysql'] = "sql/mysql.sql";

// Tables created by sql file (without prefix!)
$modversion['tables'][0] = "webshow_broken";
$modversion['tables'][1] = "webshow_cat";
$modversion['tables'][2] = "webshow_links";
$modversion['tables'][3] = "webshow_mod";
$modversion['tables'][4] = "webshow_text";
$modversion['tables'][5] = "webshow_votedata";
$modversion['tables'][6] = "webshow_player";
$modversion['tables'][7] = "webshow_flashvar";
$modversion['tables'][8] = "webshow_theme";

// Admin things
$modversion['hasAdmin'] = 1;
$modversion['adminindex'] = "admin/index.php";
$modversion['adminmenu'] = "admin/menu.php";
$modversion['admincategory'] = "admin/category.php";
$modversion['adminplaylist'] = "admin/index.php?op=newLink";
$modversion['adminplayer'] = "admin/player.php";
$modversion['adminperm'] = "admin/perm.php";
$modversion['adminhelp'] = "admin/index.php?op=webShowHelp";

// Update
$modversion['onUpdate'] = 'include/onupdate.php';

// Blocks
$modversion['blocks'][1]['file'] = "webshow_links.php";
$modversion['blocks'][1]['name'] = _MI_WEBSHOW_BNAME1;
$modversion['blocks'][1]['description'] = "Shows playlist links by date, hits, rating per category";
$modversion['blocks'][1]['show_func'] = "b_webshow_links_show";
$modversion['blocks'][1]['edit_func'] = "b_webshow_links_edit";
$modversion['blocks'][1]['options'] = "date|3|1|40|1|0|1";
$modversion['blocks'][1]['template'] = 'webshow_block_links.html';

$modversion['blocks'][2]['file'] = "webshow_playit.php";
$modversion['blocks'][2]['name'] = _MI_WEBSHOW_BNAME2;
$modversion['blocks'][2]['description'] = "Loads the selected mp3 files or playlist into the selected flashplayer";
$modversion['blocks'][2]['show_func'] = "b_webshow_playit_show";
$modversion['blocks'][2]['edit_func'] = "b_webshow_playit_edit";
$modversion['blocks'][2]['options'] = "''|''|0|1|1|0|0|0|0";
$modversion['blocks'][2]['template'] = 'webshow_block_playit.html';

$modversion['blocks'][3]['file'] = "webshow_billboard.php";
$modversion['blocks'][3]['name'] = _MI_WEBSHOW_BNAME3;
$modversion['blocks'][3]['description'] = "Display title, logo, description and player popup button for a featured link or by db sort";
$modversion['blocks'][3]['show_func'] = "b_webshow_billboard_show";
$modversion['blocks'][3]['edit_func'] = "b_webshow_billboard_edit";
$modversion['blocks'][3]['options'] = "''|''|''|1|1|1|1|1";
$modversion['blocks'][3]['template'] = 'webshow_block_billboard.html';
$modversion["blocks"][4]	= array(
	"file"			=> "webshow_block_tag.php",
	"name"			=> "WebShow Tag Cloud",
	"description"	=> "Show tag cloud",
	"show_func"		=> "webshow_tag_block_cloud_show",
	"edit_func"		=> "webshow_tag_block_cloud_edit",
	"options"		=> "100|0|150|80",
	"template"		=> "webshow_tag_block_cloud.html",
	);
$modversion["blocks"][5]	= array(
	"file"			=> "webshow_block_tag.php",
	"name"			=> "WebShow Top Tags",
	"description"	=> "Show top tags",
	"show_func"		=> "webshow_tag_block_top_show",
	"edit_func"		=> "webshow_tag_block_top_edit",
	"options"		=> "50|30|c",
	"template"		=> "webshow_tag_block_top.html",
	);

// Menu
$modversion['hasMain'] = 1;

//** Permission to add submit link.  Adapted from Herve Thouzard News Module
$module_handler =& xoops_gethandler('module');
$module =& $module_handler->getByDirname($modversion['dirname']);
if ($module) {
    global $xoopsUser;
    $groups = is_object($xoopsUser) ? $xoopsUser->getGroups() : XOOPS_GROUP_ANONYMOUS;
    $gperm_handler =& xoops_gethandler('groupperm');
    if ($gperm_handler->checkRight("webshow_submit", 0, $groups, $module->getVar('mid'))) {
       $modversion['sub'][1]['name'] = _MI_WEBSHOW_SMNAME1;
       $modversion['sub'][1]['url'] = "submit.php"; 
    }
}

$modversion['sub'][2]['name'] = _MI_WEBSHOW_SMNAME2;
$modversion['sub'][2]['url'] = "topten.php?hit=1";
$modversion['sub'][3]['name'] = _MI_WEBSHOW_SMNAME3;
$modversion['sub'][3]['url'] = "topten.php?rate=1";

// Search
$modversion['hasSearch'] = 1;
$modversion['search']['file'] = "include/search.inc.php";
$modversion['search']['func'] = "webshow_search";

// Comments
$modversion['hasComments'] = 1;
$modversion['comments']['itemName'] = 'lid';
$modversion['comments']['pageName'] = 'singlelink.php';
$modversion['comments']['extraParams'] = array('cid');

// Comment callback functions
$modversion['comments']['callbackFile'] = 'include/comment_functions.php';
$modversion['comments']['callback']['approve'] = 'webshow_com_approve';
$modversion['comments']['callback']['update'] = 'webshow_com_update';

// Templates
$modversion['templates'][1]['file'] = 'webshow_brokenlink.html';
$modversion['templates'][1]['description'] = '';
$modversion['templates'][2]['file'] = 'webshow_link.html';
$modversion['templates'][2]['description'] = '';
$modversion['templates'][3]['file'] = 'webshow_index.html';
$modversion['templates'][3]['description'] = '';
$modversion['templates'][4]['file'] = 'webshow_modlink.html';
$modversion['templates'][4]['description'] = '';
$modversion['templates'][5]['file'] = 'webshow_ratelink.html';
$modversion['templates'][5]['description'] = '';
$modversion['templates'][6]['file'] = 'webshow_singlelink.html';
$modversion['templates'][6]['description'] = '';
$modversion['templates'][7]['file'] = 'webshow_submit.html';
$modversion['templates'][7]['description'] = '';
$modversion['templates'][8]['file'] = 'webshow_topten.html';
$modversion['templates'][8]['description'] = '';
$modversion['templates'][9]['file'] = 'webshow_viewcat.html';
$modversion['templates'][9]['description'] = '';
$modversion['templates'][10]['file'] = 'webshow_poster.html';
$modversion['templates'][10]['description'] = '';
$modversion['templates'][11]['file'] = 'webshow_playcat.html';
$modversion['templates'][11]['description'] = '';
$modversion['templates'][12]['file'] = 'webshow_linklite.html';
$modversion['templates'][12]['description'] = '';
$modversion['templates'][13]['file'] = 'webshow_playposter.html';
$modversion['templates'][13]['description'] = '';

// Config Settings (only for modules that need config settings generated automatically)

// name of config option for accessing its specified value. i.e. $xoopsModuleConfig['storyhome']
$modversion['config'][1]['name'] = 'popular';

// title of this config option displayed in config settings form
$modversion['config'][1]['title'] = '_MI_WEBSHOW_POPULAR';

// description of this config option displayed under title
$modversion['config'][1]['description'] = '_MI_WEBSHOW_POPULARDSC';

// form element type used in config form for this option. can be one of either textbox, textarea, select, select_multi, yesno, group, group_multi
$modversion['config'][1]['formtype'] = 'select';

// value type of this config option. can be one of either int, text, float, array, or other
// form type of 'group_multi', 'select_multi' must always be 'array'
// form type of 'yesno', 'group' must be always be 'int'
$modversion['config'][1]['valuetype'] = 'int';

// the default value for this option
// ignore it if no default
// 'yesno' formtype must be either 0(no) or 1(yes)
$modversion['config'][1]['default'] = 100;

// options to be displayed in selection box
// required and valid for 'select' or 'select_multi' formtype option only
// language constants can be used for both array keys and values
$modversion['config'][1]['options'] = array('5' => 5, '10' => 10, '50' => 50, '100' => 100, '200' => 200, '500' => 500, '1000' => 1000);

$modversion['config'][2]['name'] = 'newlinks';
$modversion['config'][2]['title'] = '_MI_WEBSHOW_NEWLINKS';
$modversion['config'][2]['description'] = '_MI_WEBSHOW_NEWLINKSDSC';
$modversion['config'][2]['formtype'] = 'select';
$modversion['config'][2]['valuetype'] = 'int';
$modversion['config'][2]['default'] = 10;
$modversion['config'][2]['options'] = array('5' => 5, '10' => 10, '15' => 15, '20' => 20, '25' => 25, '30' => 30, '50' => 50);

$modversion['config'][3]['name'] = 'perpage';
$modversion['config'][3]['title'] = '_MI_WEBSHOW_PERPAGE';
$modversion['config'][3]['description'] = '_MI_WEBSHOW_PERPAGEDSC';
$modversion['config'][3]['formtype'] = 'select';
$modversion['config'][3]['valuetype'] = 'int';
$modversion['config'][3]['default'] = 10;
$modversion['config'][3]['options'] = array('5' => 5, '10' => 10, '15' => 15, '20' => 20, '25' => 25, '30' => 30, '50' => 50);

$modversion['config'][4]['name'] = 'moddesc';
$modversion['config'][4]['title'] = '_MI_WEBSHOW_MODDESC';
$modversion['config'][4]['description'] = '_MI_WEBSHOW_MODDESC_DSC';
$modversion['config'][4]['formtype'] = 'textarea';
$modversion['config'][4]['valuetype'] = 'text';
$modversion['config'][4]['default'] = _MI_WEBSHOW_DESC;

$modversion['config'][5]['name'] = 'path_logo';
$modversion['config'][5]['title'] = '_MI_WEBSHOW_LOGOPATH';
$modversion['config'][5]['description'] = '_MI_WEBSHOW_LOGOPATHDSC';
$modversion['config'][5]['formtype'] = 'textbox';
$modversion['config'][5]['valuetype'] = 'text';
$modversion['config'][5]['default'] = 'uploads/webshow/logo';

$modversion['config'][6]['name'] = 'logowidth';
$modversion['config'][6]['title'] = '_MI_WEBSHOW_LOGOWIDTH';
$modversion['config'][6]['description'] = '_MI_WEBSHOW_LOG0WIDTHDSC';
$modversion['config'][6]['formtype'] = 'textbox';
$modversion['config'][6]['valuetype'] = 'int';
$modversion['config'][6]['default'] = 150;

$modversion['config'][7]['name'] = 'path_media';
$modversion['config'][7]['title'] = '_MI_WEBSHOW_MEDIAPATH';
$modversion['config'][7]['description'] = '_MI_WEBSHOW_MEDIAPATHDSC';
$modversion['config'][7]['formtype'] = 'textbox';
$modversion['config'][7]['valuetype'] = 'text';
$modversion['config'][7]['default'] = 'media';

$modversion['config'][8]['name'] = 'captcha';
$modversion['config'][8]['title'] = '_MI_WEBSHOW_CAPTCHA';
$modversion['config'][8]['description'] = '_MI_WEBSHOW_CAPTCHADSC';
$modversion['config'][8]['formtype'] = 'select';
$modversion['config'][8]['valuetype'] = 'int';
$modversion['config'][8]['default'] = 1;
$modversion['config'][8]['options'] = array('_NONE' => 0,'_GUESTS' => 1, '_ALL' => 2);

$modversion['config'][9]['name'] = 'tags';
$modversion['config'][9]['title'] = '_MI_WEBSHOW_TAGS';
$modversion['config'][9]['description'] = '_MI_WEBSHOW_TAGSDSC';
$modversion['config'][9]['formtype'] = 'yesno';
$modversion['config'][9]['valuetype'] = 'int';
$modversion['config'][9]['default'] = 0;

$modversion['config'][10]['name'] = 'texteditor';
$modversion['config'][10]['title'] = '_MI_WEBSHOW_TEXTEDITOR';
$modversion['config'][10]['description'] = '_MI_WEBSHOW_TEXTEDITORDSC';
$modversion['config'][10]['formtype'] = 'select';
$modversion['config'][10]['valuetype'] = 'text';
$modversion['config'][10]['default'] = "FCKeditor";
$modversion['config'][10]['options'] = array('FCKeditor' => 'FCKeditor', 'koivi' => 'koivi', 'tinymce' => 'tinymce', 'koivi' => 'koivi', 'dhtmlext' => 'dhtmlext', 'dhtmltextarea' => 'dhtmltextarea', 'textarea' => 'textarea');

$modversion['config'][11]['name'] = 'ws_keyword_count';
$modversion['config'][11]['title'] = '_MI_WEBSHOW_KEYCOUNT';
$modversion['config'][11]['description'] = '_MI_WEBSHOW_KEYDSC';
$modversion['config'][11]['formtype'] = 'select';
$modversion['config'][11]['valuetype'] = 'int';
$modversion['config'][11]['default'] = 15;
$modversion['config'][11]['options'] = array('5' => 5, '10' => 10, '15' => 15, '20' => 20, '25' => 25);

$modversion['config'][12]['name'] = 'ws_keyword_limit';
$modversion['config'][12]['title'] = '_MI_WEBSHOW_KEYLIMIT';
$modversion['config'][12]['description'] = '_MI_WEBSHOW_KEYDSC';
$modversion['config'][12]['formtype'] = 'textbox';
$modversion['config'][12]['valuetype'] = 'text';
$modversion['config'][12]['default'] = '3';

$modversion['config'][13]['name'] = 'ws_keyword_common';
$modversion['config'][13]['title'] = '_MI_WEBSHOW_KEYCOMMON';
$modversion['config'][13]['description'] = '_MI_WEBSHOW_KEYDSC';
$modversion['config'][13]['formtype'] = 'textarea';
$modversion['config'][13]['valuetype'] = 'text';
$modversion['config'][13]['default'] = 'the,and,you,that,was,for,are,with,they,have,this,from,had,but,some,what,there,can,other,were,your,when,use,how,said,each,which,their,time,will,way,about,many,then,them,would,like,these,see,has,more,could,come,did,most,who,over,know,than,may,been,any,take,get,made,where,back,only,came,show,every,give,our,very,just,much,also,want,here';

// Notification
$modversion['hasNotification'] = 1;
$modversion['notification']['lookup_file'] = 'include/notification.inc.php';
$modversion['notification']['lookup_func'] = 'webshow_notify_iteminfo';

$modversion['notification']['category'][1]['name'] = 'global';
$modversion['notification']['category'][1]['title'] = _MI_WEBSHOW_GLOBAL_NOTIFY;
$modversion['notification']['category'][1]['description'] = _MI_WEBSHOW_GLOBAL_NOTIFYDSC;
$modversion['notification']['category'][1]['subscribe_from'] = array('index.php','viewcat.php','singlelink.php');

$modversion['notification']['category'][2]['name'] = 'category';
$modversion['notification']['category'][2]['title'] = _MI_WEBSHOW_CATEGORY_NOTIFY;
$modversion['notification']['category'][2]['description'] = _MI_WEBSHOW_CATEGORY_NOTIFYDSC;
$modversion['notification']['category'][2]['subscribe_from'] = array('viewcat.php', 'singlelink.php');
$modversion['notification']['category'][2]['item_name'] = 'cid';
$modversion['notification']['category'][2]['allow_bookmark'] = 1;

$modversion['notification']['category'][3]['name'] = 'link';
$modversion['notification']['category'][3]['title'] = _MI_WEBSHOW_LINK_NOTIFY;
$modversion['notification']['category'][3]['description'] = _MI_WEBSHOW_LINK_NOTIFYDSC;
$modversion['notification']['category'][3]['subscribe_from'] = 'singlelink.php';
$modversion['notification']['category'][3]['item_name'] = 'lid';
$modversion['notification']['category'][3]['allow_bookmark'] = 1;

$modversion['notification']['event'][1]['name'] = 'new_category';
$modversion['notification']['event'][1]['category'] = 'global';
$modversion['notification']['event'][1]['title'] = _MI_WEBSHOW_GLOBAL_NEWCATEGORY_NOTIFY;
$modversion['notification']['event'][1]['caption'] = _MI_WEBSHOW_GLOBAL_NEWCATEGORY_NOTIFYCAP;
$modversion['notification']['event'][1]['description'] = _MI_WEBSHOW_GLOBAL_NEWCATEGORY_NOTIFYDSC;
$modversion['notification']['event'][1]['mail_template'] = 'global_newcategory_notify';
$modversion['notification']['event'][1]['mail_subject'] = _MI_WEBSHOW_GLOBAL_NEWCATEGORY_NOTIFYSBJ;

$modversion['notification']['event'][2]['name'] = 'link_modify';
$modversion['notification']['event'][2]['category'] = 'global';
$modversion['notification']['event'][2]['admin_only'] = 1;
$modversion['notification']['event'][2]['title'] = _MI_WEBSHOW_GLOBAL_LINKMODIFY_NOTIFY;
$modversion['notification']['event'][2]['caption'] = _MI_WEBSHOW_GLOBAL_LINKMODIFY_NOTIFYCAP;
$modversion['notification']['event'][2]['description'] = _MI_WEBSHOW_GLOBAL_LINKMODIFY_NOTIFYDSC;
$modversion['notification']['event'][2]['mail_template'] = 'global_linkmodify_notify';
$modversion['notification']['event'][2]['mail_subject'] = _MI_WEBSHOW_GLOBAL_LINKMODIFY_NOTIFYSBJ;

$modversion['notification']['event'][3]['name'] = 'link_broken';
$modversion['notification']['event'][3]['category'] = 'global';
$modversion['notification']['event'][3]['admin_only'] = 1;
$modversion['notification']['event'][3]['title'] = _MI_WEBSHOW_GLOBAL_LINKBROKEN_NOTIFY;
$modversion['notification']['event'][3]['caption'] = _MI_WEBSHOW_GLOBAL_LINKBROKEN_NOTIFYCAP;
$modversion['notification']['event'][3]['description'] = _MI_WEBSHOW_GLOBAL_LINKBROKEN_NOTIFYDSC;
$modversion['notification']['event'][3]['mail_template'] = 'global_linkbroken_notify';
$modversion['notification']['event'][3]['mail_subject'] = _MI_WEBSHOW_GLOBAL_LINKBROKEN_NOTIFYSBJ;

$modversion['notification']['event'][4]['name'] = 'link_submit';
$modversion['notification']['event'][4]['category'] = 'global';
$modversion['notification']['event'][4]['admin_only'] = 1;
$modversion['notification']['event'][4]['title'] = _MI_WEBSHOW_GLOBAL_LINKSUBMIT_NOTIFY;
$modversion['notification']['event'][4]['caption'] = _MI_WEBSHOW_GLOBAL_LINKSUBMIT_NOTIFYCAP;
$modversion['notification']['event'][4]['description'] = _MI_WEBSHOW_GLOBAL_LINKSUBMIT_NOTIFYDSC;
$modversion['notification']['event'][4]['mail_template'] = 'global_linksubmit_notify';
$modversion['notification']['event'][4]['mail_subject'] = _MI_WEBSHOW_GLOBAL_LINKSUBMIT_NOTIFYSBJ;

$modversion['notification']['event'][5]['name'] = 'new_link';
$modversion['notification']['event'][5]['category'] = 'global';
$modversion['notification']['event'][5]['title'] = _MI_WEBSHOW_GLOBAL_NEWLINK_NOTIFY;
$modversion['notification']['event'][5]['caption'] = _MI_WEBSHOW_GLOBAL_NEWLINK_NOTIFYCAP;
$modversion['notification']['event'][5]['description'] = _MI_WEBSHOW_GLOBAL_NEWLINK_NOTIFYDSC;
$modversion['notification']['event'][5]['mail_template'] = 'global_newlink_notify';
$modversion['notification']['event'][5]['mail_subject'] = _MI_WEBSHOW_GLOBAL_NEWLINK_NOTIFYSBJ;

$modversion['notification']['event'][6]['name'] = 'link_submit';
$modversion['notification']['event'][6]['category'] = 'category';
$modversion['notification']['event'][6]['admin_only'] = 1;
$modversion['notification']['event'][6]['title'] = _MI_WEBSHOW_CATEGORY_LINKSUBMIT_NOTIFY;
$modversion['notification']['event'][6]['caption'] = _MI_WEBSHOW_CATEGORY_LINKSUBMIT_NOTIFYCAP;
$modversion['notification']['event'][6]['description'] = _MI_WEBSHOW_CATEGORY_LINKSUBMIT_NOTIFYDSC;
$modversion['notification']['event'][6]['mail_template'] = 'category_linksubmit_notify';
$modversion['notification']['event'][6]['mail_subject'] = _MI_WEBSHOW_CATEGORY_LINKSUBMIT_NOTIFYSBJ;

$modversion['notification']['event'][7]['name'] = 'new_link';
$modversion['notification']['event'][7]['category'] = 'category';
$modversion['notification']['event'][7]['title'] = _MI_WEBSHOW_CATEGORY_NEWLINK_NOTIFY;
$modversion['notification']['event'][7]['caption'] = _MI_WEBSHOW_CATEGORY_NEWLINK_NOTIFYCAP;
$modversion['notification']['event'][7]['description'] = _MI_WEBSHOW_CATEGORY_NEWLINK_NOTIFYDSC;
$modversion['notification']['event'][7]['mail_template'] = 'category_newlink_notify';
$modversion['notification']['event'][7]['mail_subject'] = _MI_WEBSHOW_CATEGORY_NEWLINK_NOTIFYSBJ;

$modversion['notification']['event'][8]['name'] = 'approve';
$modversion['notification']['event'][8]['category'] = 'link';
$modversion['notification']['event'][8]['invisible'] = 1;
$modversion['notification']['event'][8]['title'] = _MI_WEBSHOW_LINK_APPROVE_NOTIFY;
$modversion['notification']['event'][8]['caption'] = _MI_WEBSHOW_LINK_APPROVE_NOTIFYCAP;
$modversion['notification']['event'][8]['description'] = _MI_WEBSHOW_LINK_APPROVE_NOTIFYDSC;
$modversion['notification']['event'][8]['mail_template'] = 'link_approve_notify';
$modversion['notification']['event'][8]['mail_subject'] = _MI_WEBSHOW_LINK_APPROVE_NOTIFYSBJ;
?>