<?php
// $Id: admin/player.php,v.50 2007/03/01 19:59:00 tcnet Exp $ //
// Flash Media Player by Jereon Wijering ( http://www.jeroenwijering.com ) is licensed under a Creative Commons License (http://creativecommons.org/licenses/by-nc-sa/2.0/) //
// It allows you to use and modify the script for noncommercial purposes. //
// You must share a like any modifications. // 
// For commercial use you must purchase a license from Jereon Wijering at http://www.jeroenwijering.com/?order=form. //
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //
include '../../../include/cp_header.php';
if ( file_exists("../language/".$xoopsConfig['language']."/main.php") ) {
	include "../language/".$xoopsConfig['language']."/main.php";
} else {
	include "../language/english/main.php";
}
include '../include/functions.php';
include_once XOOPS_ROOT_PATH.'/class/xoopstree.php';
include_once XOOPS_ROOT_PATH."/class/xoopslists.php";
include_once XOOPS_ROOT_PATH."/class/xoopsformloader.php";  
include_once XOOPS_ROOT_PATH."/include/xoopscodes.php";
include_once XOOPS_ROOT_PATH.'/class/module.errorhandler.php';
$myts =& MyTextSanitizer::getInstance();
$eh = new ErrorHandler;
$playertree= new XoopsTree($xoopsDB->prefix("webshow_player"),"playerid","playertitle");
$linktree = new XoopsTree($xoopsDB->prefix("webshow_links"),"lid","title");

//**Player Menu
function menuPlayer()
{
global $xoopsDB, $xoopsModule;
$playerid = isset($_GET['playerid']) ? intval($_GET['playerid']) : 1;
$lid = isset($_GET['lid']) ? intval($_GET['lid']) : 1;
$styleoption = "";
$lang_styleoption = "";
echo "<table class='outer' style='font-size: 90%;'>
<tr><th colspan='6'>"._MD_PLAYERMGMT."</th></tr>
<tr class='head' colspan='6'>
<td class='even' width='30px'><b>"._MD_ID."</b></td>
<td class='odd' width='232 px'><b>"._MD_PLAYERTITLE."</b></td>
<td class='even' width='165px'><b>"._MD_PLAYERSTYLE."</b></td>
<td class='odd' width='55px'><b>"._MD_WIDTH."</b></td>
<td class='even' width='50px'><b>"._MD_HEIGHT."</b></td>
<td class='odd' width='195px'><input type=\"button\" value=\""._MD_ADDNEWPLAYER."\" onClick=\"location='player.php?lid=$lid'\"></td></tr>
<tr><td colspan='6'><div style ='overflow: auto; height: 90px; width: 100%;'><table>";

$result=$xoopsDB->query("select playerid, playertitle, styleoption, width, height from ".$xoopsDB->prefix("webshow_player")." where playerid>0 order by playertitle");
while(list($playerid, $playertitle, $styleoption, $width, $height) = $xoopsDB->fetchRow($result)) {
if($styleoption == 1){
$lang_styleoption = _MD_PLAYERSTYLE_OPT1;
}
if($styleoption == 2){
$lang_styleoption = _MD_PLAYERSTYLE_OPT2;
}
if($styleoption == 3){
$lang_styleoption = _MD_PLAYERSTYLE_OPT3;
}
if($styleoption == 4){
$lang_styleoption = _MD_PLAYERSTYLE_OPT4;
}

echo "<tr><td class='even' width='30px' align='right'>".$playerid."</td>
<td class='odd' width='250px'>".$playertitle."</td>
<td class='even' width='180px'>".$lang_styleoption."</td>
<td class='odd' width='60px' align='right'>".$width."</td>
<td class='even' width='60px' align='right'>".$height."</td>
<td class='odd' width='180px'>
<input type=\"button\" value=\""._MD_MODIFY."\" onClick=\"location='player.php?op=modPlayer&amp;playerid=$playerid&amp;lid=$lid'\">
<input type=\"button\" value=\""._MD_CLONE."\" onClick=\"location='player.php?op=clonePlayer&amp;playerid=$playerid&amp;lid=$lid'\">";
   if ($playerid != 1) {
      echo "<input type=\"button\" value=\""._MD_DELETE."\" onClick=\"location='player.php?op=delPlayer&amp;playerid=$playerid&amp;lid=$lid'\"></td></tr>";
   }
 }		
echo "</table></div></td></tr></table><br />";
}
	
//** NEW PLAYER EDITOR
function newPlayer()
{
   global $xoopsDB, $xoopsConfig, $xoopsModule, $xoopsModuleConfig, $myts, $eh, $linktree;
   xoops_cp_header();
   adminmenu(1);
   player1Exist();
   $lid = isset($_GET['lid']) ? intval($_GET['lid']) : 1;	
   $playerid = isset($_GET['playerid']) ? intval($_GET['playerid']) : 1;
   $styleoption = isset($_GET['styleoption']) ? intval($_GET['styleoption']) : 1;
   $playertitle = "";
   $result=$xoopsDB->query("select bgcolor, backcolor, frontcolor, lightcolor, displayheight, showdigits, showfsbutton, scroll, width, height, displaywidth, largecontrol from ".$xoopsDB->prefix("webshow_player")." where playerid=$playerid");
   list($bgcolor, $backcolor, $frontcolor, $lightcolor, $displayheight, $showdigits, $showfsbutton, $scroll, $width, $height, $displaywidth, $largecontrol) = $xoopsDB->fetchRow($result);			
   //** NEW PLAYER TABLE
   echo "<table class='outer'><tr><td colspan='2'>";
   menuPlayer();
   echo "</td></tr>";
   echo "<tr><td width='40%'>";
   //** NEW PLAYER FORM	
   $formlabel = _MD_NEWPLAYER." "._MD_EDITOR;
   $op = "newPlayerS";
   $btnlabel = _MD_ADDNEWPLAYER;
   echo "<div>";  	
   include '../include/playerform.inc.php';
   echo "</div>";
   echo "</td><td align='center'>";
   //** PLAYER DEMO
   $player = $playerid;
   $chainid = 0;
   //** THEMESTYLE
   // style option 2: Colors from theme css
   if($styleoption == "2") {
      $theme = isset($_GET['theme']) ? $_GET['theme'] : $xoopsConfig['theme_set'];
      //** THEME COLOR EDITOR
      include 'themestyle.php';
      //** example themeTable($theme,$lid,$playerid,$playerop);
      themeTable($theme,$lid,$playerid,"newPlayer");
   }else{
      $linkresult = $xoopsDB->query("select title, listurl, srctype, listtype, listcache, showinfo, logourl from ".$xoopsDB->prefix("webshow_links")." where lid=$lid");
      list($title, $listurl, $srctype, $listtype, $listcache, $showinfo, $logourl) = $xoopsDB->fetchRow($linkresult);
      $ltitle = $myts->makeTboxData4Show($title);
      include '../include/movie.php';
      //** THEME FROM PLAYER
      //** Uses the color style from this player for the page color style.
      if($styleoption == "4") {
         echo $themefromplayer;
      }
     echo "<div class=\"item\"><div class=\"itemHead\"><h3 style=\"margin:0px; padding:0px\">"._MD_PREVIEW."</h3></div>";
     echo "<div class=\"itemBody\" style=\"margin: 0px; padding: 5px\">".$movie;   
     //** LINK SELECT
     $linktree = new XoopsTree($xoopsDB->prefix("webshow_links"),"lid","title");    
     $form =_MD_PREVIEWLINK."&nbsp;&nbsp;&nbsp;";	
     ob_start();
     //**function makeMySelBox($title,$order="",$preset_id=0, $none=0, $sel_name="", $onchange="")
     $linktree->makeMySelBox('title', 'lid',$lid,0,'lid','window.location="player.php?op=newPlayer&amp;lid="+this.value');
     $linkselbox = ob_get_contents();
     ob_end_clean();
     $form .= $linkselbox;
     echo "<br />".$form;   
     echo "<br />"._MD_PREVIEW_DSC."</div></div>";
   }
echo "</td></tr></table>";
xoops_cp_footer();
}

//**CLONE PLAYER EDITOR
function clonePlayer()
{
global $xoopsDB, $xoopsConfig, $xoopsModule, $xoopsModuleConfig, $myts, $eh;
xoops_cp_header();
adminmenu(1);
$lid = isset($_GET['lid']) ? intval($_GET['lid']) : 1;	
$playerid = isset($_GET['playerid']) ? intval($_GET['playerid']) : "";
$playertitle = "";	
$result=$xoopsDB->query("select styleoption, bgcolor, backcolor, frontcolor, lightcolor, displayheight, showdigits, showfsbutton, scroll, width, height, displaywidth, largecontrol from ".$xoopsDB->prefix("webshow_player")." where playerid=$playerid");
list($styleoption, $bgcolor, $backcolor, $frontcolor, $lightcolor, $displayheight, $showdigits, $showfsbutton, $scroll, $width, $height, $displaywidth, $largecontrol) = $xoopsDB->fetchRow($result);
$styleoption = isset($_GET['styleoption']) ? intval($_GET['styleoption']) : $styleoption;

echo "<table class='outer'><tr><td colspan='2'>";
menuPlayer();
echo "</td></tr><tr><td width='40%'>";

//** CLONE PLAYER FORM	
$formlabel = _MD_CLONE." "._MD_PLAYER;
$op = "clonePlayerS";
$btnlabel = _MD_ADDNEWPLAYER;
include '../include/playerform.inc.php';

echo "</td><td align='center'>";
//** PLAYER DEMO
$player = $playerid;
$chainid = 0;
   //** THEMESTYLE
   // style option 2: Colors from theme css
   if($styleoption == "2") {
      $theme = isset($_GET['theme']) ? $_GET['theme'] : $xoopsConfig['theme_set'];
      //** THEME COLOR EDITOR
      include 'themestyle.php';
      //** example themeTable($theme,$lid,$playerid,$playerop);
      themeTable($theme,$lid,$playerid,"clonePlayer");
   }else{
      $linkresult = $xoopsDB->query("select title, listurl, srctype, listtype, listcache, showinfo, logourl from ".$xoopsDB->prefix("webshow_links")." where lid=$lid");
      list($title, $listurl, $srctype, $listtype, $listcache, $showinfo, $logourl) = $xoopsDB->fetchRow($linkresult);
      $ltitle = $myts->makeTboxData4Show($title);
      include '../include/movie.php';
      //** THEME FROM PLAYER
      //** Uses the color style from this player for the page color style.
      if($styleoption == "4") {
         echo $themefromplayer;
      }
     echo "<div class=\"item\"><div class=\"itemHead\"><h3 style=\"margin:0px; padding:0px\">"._MD_PREVIEW."</h3></div>";
     echo "<div class=\"itemBody\" style=\"margin: 0px; padding: 5px\">".$movie;   
     //** LINK SELECT
     $linktree = new XoopsTree($xoopsDB->prefix("webshow_links"),"lid","title");    
     $form =_MD_PREVIEWLINK."&nbsp;&nbsp;&nbsp;";	
     ob_start();
     //**function makeMySelBox($title,$order="",$preset_id=0, $none=0, $sel_name="", $onchange="")
     $linktree->makeMySelBox('title', 'lid',$lid,0,'lid','window.location="player.php?op=clonePlayer&amp;playerid='.$playerid.'&amp;lid="+this.value');
     $linkselbox = ob_get_contents();
     ob_end_clean();
     $form .= $linkselbox;
     echo "<br />".$form;   
     echo "<br />"._MD_PREVIEW_DSC."</div></div>";
   }
echo "</td></tr></table>";	
}

function newPlayerS()
{
global $xoopsDB, $myts, $eh, $xoopsModule;
$pid = isset($_POST['pid']) ? $_POST['pid'] : "";  //Unused atm
$playertitle = isset($_POST['playertitle']) ? $_POST['playertitle'] : "";
   if (empty($playertitle)) {
   redirect_header("player.php",2,_MD_ERRORTITLE);
   exit();
   }

$playertitleresult=$xoopsDB->queryF("SELECT (playertitle) from ".$xoopsDB->prefix("webshow_player")." WHERE playertitle=\"$playertitle\"");
list($origplayertitle)=$xoopsDB->fetchRow($playertitleresult);
   if ( $origplayertitle == $playertitle ) {
   redirect_header("player.php",2,_MD_ERROREXIST);
   exit();
   }
$playertitle = $myts->makeTboxData4Save($playertitle);
$styleoption = $myts->makeTboxData4Save($_POST["styleoption"]);
$bgcolor = $myts->makeTboxData4Save($_POST["bgcolor"]);	
$backcolor = $myts->makeTboxData4Save($_POST["backcolor"]);
$frontcolor = $myts->makeTboxData4Save($_POST["frontcolor"]);
$lightcolor = $myts->makeTboxData4Save($_POST["lightcolor"]);
$displayheight = $myts->makeTboxData4Save($_POST["displayheight"]);
$showdigits = $myts->makeTboxData4Save($_POST["showdigits"]);	    
$showfsbutton = $myts->makeTboxData4Save($_POST["showfsbutton"]);     
$scroll = $myts->makeTboxData4Save($_POST["scroll"]);
$width = $myts->makeTboxData4Save($_POST["width"]);
$height = $myts->makeTboxData4Save($_POST["height"]);
$displaywidth = $myts->makeTboxData4Save($_POST["displaywidth"]);
$largecontrol = $myts->makeTboxData4Save($_POST["largecontrol"]);
$newid = $xoopsDB->genId($xoopsDB->prefix("webshow_player")."_playerid_seq");

$sql = sprintf("INSERT INTO %s (playerid, pid, playertitle, styleoption, bgcolor, backcolor, frontcolor, lightcolor, displaywidth, displayheight, showdigits, showfsbutton, scroll, width, height, largecontrol) VALUES (%u, %u, '%s', %u, '%s', '%s', '%s', '%s', %u, %u, %u, %u, %u, %u, %u, %u)", $xoopsDB->prefix("webshow_player"), $newid, $pid, $playertitle, $styleoption, $bgcolor, $backcolor, $frontcolor, $lightcolor, $displaywidth, $displayheight, $showdigits, $showfsbutton, $scroll, $width, $height, $largecontrol);
$xoopsDB->query($sql) or $eh->show("0013");	
   if ($newid == 0) {
       $newid = $xoopsDB->getInsertId();
   }
redirect_header("player.php?op=modPlayer&amp;playerid=".$newid."",3,_MD_NEWPLAYERADDED);				
}

//** MODIFY PLAYER
function modPlayer()
{
global $xoopsDB, $xoopsConfig, $xoopsModule, $xoopsModuleConfig, $myts, $eh;
xoops_cp_header();
adminmenu(1);
$lid = isset($_GET['lid']) ? intval($_GET['lid']) : 1;
$playerid = isset($_GET['playerid']) ? intval($_GET['playerid']) : 1;
$result=$xoopsDB->query("select playertitle, styleoption, bgcolor, backcolor, frontcolor, lightcolor, displayheight, showdigits, showfsbutton, scroll, width, height, displaywidth, largecontrol from ".$xoopsDB->prefix("webshow_player")." where playerid=$playerid");
list($playertitle, $styleoption, $bgcolor, $backcolor, $frontcolor, $lightcolor, $displayheight, $showdigits, $showfsbutton, $scroll, $width, $height, $displaywidth, $largecontrol) = $xoopsDB->fetchRow($result);					
$styleoption = isset($_GET['styleoption']) ? intval($_GET['styleoption']) : $styleoption;

echo "<table class='outer'>";
echo "<tr><td colspan='2'>";
menuPlayer();
echo "</td></tr>";
echo "<tr><td width='35%'>";

//** MODIFY PLAYER FORM	
$formlabel = _MD_MODPLAYER." ".$playertitle;	
$op = "modPlayerS";
$btnlabel = _MD_MODPLAYER;
include '../include/playerform.inc.php';

echo "</td><td align='center'>";
   //** PLAYER DEMO
   $player = $playerid;
   $chainid = 0;
   //** THEMESTYLE
   // style option 2: Colors from theme css
   if($styleoption == 2) {
      $theme = isset($_GET['theme']) ? $_GET['theme'] : $xoopsConfig['theme_set'];
      //** THEME COLOR EDITOR
      include 'themestyle.php';      
      //** example themeTable($theme,$lid,$playerid,$playerop);
      themeTable($theme,$lid,$playerid,"modPlayer");
   }else{
      $linkresult = $xoopsDB->query("select title, listurl, srctype, listtype, listcache, showinfo, logourl from ".$xoopsDB->prefix("webshow_links")." where lid=$lid");
      list($title, $listurl, $srctype, $listtype, $listcache, $showinfo, $logourl) = $xoopsDB->fetchRow($linkresult);
      $ltitle = $myts->makeTboxData4Show($title);
      include '../include/movie.php';
      //** THEME FROM PLAYER
      //** Uses the color style from this player for the page color style.
      if($styleoption == "4") {
         echo $themefromplayer;
      }

     echo "<div class=\"item\"><div class=\"itemHead\"><h3 style=\"margin:0px; padding:0px\">"._MD_PREVIEW."</h3></div>";
     echo "<div class=\"itemBody\" style=\"margin: 0px; padding: 5px\">".$movie;   
     //** LINK SELECT
     $linktree = new XoopsTree($xoopsDB->prefix("webshow_links"),"lid","title");    
     $form =_MD_PREVIEWLINK."&nbsp;&nbsp;&nbsp;";	
     ob_start();
     //**function makeMySelBox($title,$order="",$preset_id=0, $none=0, $sel_name="", $onchange="")
     $linktree->makeMySelBox('title', 'lid',$lid,0,'lid','window.location="player.php?op=modPlayer&amp;playerid='.$playerid.'&amp;lid="+this.value');
     $linkselbox = ob_get_contents();
     ob_end_clean();
     $form .= $linkselbox;
     echo "<br />".$form;   
     echo "<br />"._MD_PREVIEW_DSC."</div></div>";
   }

xoops_cp_footer();
}

function modPlayerS()
{
global $xoopsDB, $myts, $eh, $xoopsModule;
$lid = isset($_POST['lid']) ? intval($_POST['lid']) : "";
$playerid = $_POST['playerid'];
$pid = ""; //$pid = $_POST['pid'];  //unused atm
$playertitle = isset($_POST['playertitle']) ? $_POST['playertitle'] : "";
   if (empty($playertitle)) {
   redirect_header("player.php",2,_MD_ERRORTITLE);
   exit();
   }

$playertitle = $myts->makeTboxData4Save($playertitle);
$styleoption = $myts->makeTboxData4Save($_POST["styleoption"]);
$bgcolor = $myts->makeTboxData4Save($_POST["bgcolor"]);
$backcolor = $myts->makeTboxData4Save($_POST["backcolor"]);
$frontcolor = $myts->makeTboxData4Save($_POST["frontcolor"]);
$lightcolor = $myts->makeTboxData4Save($_POST["lightcolor"]);
$displayheight = $myts->makeTboxData4Save($_POST["displayheight"]);
$showdigits = $myts->makeTboxData4Save($_POST["showdigits"]);	    
$showfsbutton = $myts->makeTboxData4Save($_POST["showfsbutton"]);     
$scroll = $myts->makeTboxData4Save($_POST["scroll"]);
$width = $myts->makeTboxData4Save($_POST["width"]);
$height = $myts->makeTboxData4Save($_POST["height"]);
$displaywidth = $myts->makeTboxData4Save($_POST["displaywidth"]);
$largecontrol = $myts->makeTboxData4Save($_POST["largecontrol"]);

$xoopsDB->query("update ".$xoopsDB->prefix("webshow_player")." set pid='$pid', playertitle='$playertitle', styleoption='$styleoption', bgcolor='$bgcolor', backcolor='$backcolor', frontcolor='$frontcolor', lightcolor='$lightcolor', displayheight='$displayheight', showdigits='$showdigits', showfsbutton = '$showfsbutton', scroll='$scroll', width='$width', height='$height', displaywidth='$displaywidth', largecontrol='$largecontrol' WHERE playerid=$playerid") or $eh->show("0013");
redirect_header("player.php?op=modPlayer&amp;lid=".$lid."&amp;playerid=".$playerid,3,_MD_PLAYERMODIFIED);	
}

function delPlayer()
{
   	global $xoopsDB, $eh, $xoopsModule;
   	$playerid =  isset($_POST['playerid']) ? intval($_POST['playerid']) : intval($_GET['playerid']);
	$ok =  isset($_POST['ok']) ? intval($_POST['ok']) : 0;
      if ( $ok == 1 ) {
		$sql = sprintf("DELETE FROM %s WHERE playerid = %u", $xoopsDB->prefix("webshow_player"), $playerid);
	    $xoopsDB->query($sql) or $eh->show("0013");
        redirect_header("player.php",1,_MD_PLAYERDELETED);
		exit();		
       } else {
		xoops_cp_header();
		xoops_confirm(array('op' => 'delPlayer', 'playerid' => $playerid, 'ok' => 1), 'player.php', _MD_PLAYERWARNING);
		xoops_cp_footer();
      }
}

if(!isset($_POST['op'])) {
	$op = isset($_GET['op']) ? $_GET['op'] : 'main';
} else {
	$op = $_POST['op'];
}

switch ($op) {
case "menuPlayer":
	menuPlayer();
	break;

case "newPlayer":
	newPlayer();
	break;

case "newPlayerS":
	newPlayerS();
	break;	

case "modPlayer":
	modPlayer();
	break;

case "modPlayerS":
	modPlayerS();
	break;

case "clonePlayer":
	clonePlayer();
	break;	

case "clonePlayerS":
	newPlayerS();
	break;	
	
case "delPlayer":
	delPlayer();
	break;		
	
case "main":
default:
	newPlayer();
	break;
}
?>