<?php
// $Id: functions.php,v.50 2007/03/01 19:59:00 tcnet Exp $ //
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //

if (!defined('XOOPS_ROOT_PATH')){ exit(); }

/*
//** Admin menu for xoops 2.2.4 only
function adminmenu ($currentoption = -1)
{
	$GLOBALS["xTheme"]->loadModuleAdminMenu($currentoption, "");
	return;
}
*/

//** Admin menu for 2.0.16
function adminMenu ( $currentoption = -1, $breadcrumb = '' )
{
	global $xoopsModule, $xoopsConfig, $xoopsModuleConfig;
	$tblColors = Array();
	$tblColors[0]=$tblColors[1]=$tblColors[2]=$tblColors[3]=$tblColors[4]=$tblColors[5]=$tblColors[6]=$tblColors[7]=$tblColors[8]='#DDE';
    $tblColors[$currentoption] = '#DDE';
    if (file_exists(XOOPS_ROOT_PATH.'/modules/'.$xoopsModule->getVar('dirname').'/language/'.$xoopsConfig['language'].'/modinfo.php')) {
		include_once '../language/'.$xoopsConfig['language'].'/modinfo.php';
    } else {
		include_once '../language/english/modinfo.php';
    }
	echo "<div id=\"navcontainer\"><ul style=\"padding: 3px 0; margin-left: 0; font: bold 10px Verdana, sans-serif; \">";
	echo "<li style=\"list-style: none; margin: 0; display: inline; \"><a href=\"index.php\" style=\"padding: 3px 0.5em; margin-left: 0; border: 1px solid #778; background: ".$tblColors[0]."; text-decoration: none; white-space: nowrap; \">"._MI_WEBSHOW_ADMENU1."</a></li>";
	echo "<li style=\"list-style: none; margin: 0; display: inline; \"><a href=\"category.php\" style=\"padding: 3px 0.5em; margin-left: 3px; border: 1px solid #778; background: ".$tblColors[1]."; text-decoration: none; white-space: nowrap; \">"._MI_WEBSHOW_ADMENU2."</a></li>";
	echo "<li style=\"list-style: none; margin: 0; display: inline; \"><a href=\"index.php?op=newLink\" style=\"padding: 3px 0.5em; margin-left: 3px; border: 1px solid #778; background: ".$tblColors[2]."; text-decoration: none; white-space: nowrap; \">"._MI_WEBSHOW_ADMENU3."</a></li>";
	echo "<li style=\"list-style: none; margin: 0; display: inline; \"><a href=\"player.php\" style=\"padding: 3px 0.5em; margin-left: 3px; border: 1px solid #778; background: ".$tblColors[3]."; text-decoration: none; white-space: nowrap; \">"._MI_WEBSHOW_ADMENU4."</a></li>";
	echo "<li style=\"list-style: none; margin: 0; display: inline; \"><a href=\"perm.php\" style=\"padding: 3px 0.5em; margin-left: 3px; border: 1px solid #778; background: ".$tblColors[4]."; text-decoration: none; white-space: nowrap; \">"._MI_WEBSHOW_ADMENU5."</a></li>";
	echo "<li style=\"list-style: none; margin: 0; display: inline; \"><a href=\"index.php?op=listNewLinks\" style=\"padding: 3px 0.5em; margin-left: 3px; border: 1px solid #778; background: ".$tblColors[4]."; text-decoration: none; white-space: nowrap; \">"._MI_WEBSHOW_ADMENU6."</a></li>";
	echo "<li style=\"list-style: none; margin: 0; display: inline; \"><a href=\"index.php?op=listBrokenLinks\" style=\"padding: 3px 0.5em; margin-left: 3px; border: 1px solid #778; background: ".$tblColors[5]."; text-decoration: none; white-space: nowrap; \">"._MI_WEBSHOW_ADMENU7."</a></li>";
	echo "<li style=\"list-style: none; margin: 0; display: inline; \"><a href=\"index.php?op=listModReq\" style=\"padding: 3px 0.5em; margin-left: 3px; border: 1px solid #778; background: ".$tblColors[6]."; text-decoration: none; white-space: nowrap; \">"._MI_WEBSHOW_ADMENU8."</a></li>";
	echo "<li style=\"list-style: none; margin: 0; display: inline; \"><a href=\"index.php?op=webShowHelp\" style=\"padding: 3px 0.5em; margin-left: 3px; border: 1px solid #778; background: ".$tblColors[7]."; text-decoration: none; white-space: nowrap; \">"._MI_WEBSHOW_ADMENU9."</a></li>";
	echo "<li style=\"list-style: none; margin: 0; display: inline; \"><a href=\"../index.php\" style=\"padding: 3px 0.5em; margin-left: 3px; border: 1px solid #778; background: ".$tblColors[8]."; text-decoration: none; white-space: nowrap; \">"._MI_WEBSHOW_ADMENU10."</a></li></ul></div><br />";
}

/**
 * Returns a module's option
 */
function webshow_getmoduleoption($option, $repmodule='webshow')
{
	global $xoopsModuleConfig, $xoopsModule;
	static $tbloptions= Array();
	if(is_array($tbloptions) && array_key_exists($option,$tbloptions)) {
		return $tbloptions[$option];
	}

	$retval=false;
	if (isset($xoopsModuleConfig) && (is_object($xoopsModule) && $xoopsModule->getVar('dirname') == $repmodule && $xoopsModule->getVar('isactive'))) {
		if(isset($xoopsModuleConfig[$option])) {
			$retval= $xoopsModuleConfig[$option];
		}
	} else {
		$module_handler =& xoops_gethandler('module');
		$module =& $module_handler->getByDirname($repmodule);
		$config_handler =& xoops_gethandler('config');
		if ($module) {
		    $moduleConfig =& $config_handler->getConfigsByCat(0, $module->getVar('mid'));
	    	if(isset($moduleConfig[$option])) {
	    		$retval= $moduleConfig[$option];
	    	}
		}
	}
	$tbloptions[$option]=$retval;
	return $retval;
}

function newlinkgraphic($time, $status) {
	$count = 7;
	$new = '';
	$startdate = (time()-(86400 * $count));
	if ($startdate < $time) {
		if($status==1){
			$new = "&nbsp;<img src=\"".XOOPS_URL."/modules/webshow/images/new.gif\" alt=\""._MD_NEWTHISWEEK."\" />";
		}elseif($status==2){
			$new = "&nbsp;<img src=\"".XOOPS_URL."/modules/webshow/images/update.gif\" alt=\""._MD_UPTHISWEEK."\" />";
		}
	}
	return $new;
}

function popgraphic($hits) {
	global $xoopsModuleConfig;
	if ($hits >= $xoopsModuleConfig['popular']) {
		return "&nbsp;<img src=\"".XOOPS_URL."/modules/webshow/images/pop.gif\" alt=\""._MD_POPULAR."\" />";
	}
	return '';
}

//Reusable Link Sorting Functions
function convertorderbyin($orderby) {
	switch (trim($orderby)) {
	case "titleA":
		$orderby = "title ASC";
		break;
	case "dateA":
		$orderby = "date ASC";
		break;
	case "hitsA":
		$orderby = "hits ASC";
		break;
	case "ratingA":
		$orderby = "rating ASC";
		break;
	case "titleD":
		$orderby = "title DESC";
		break;
	case "hitsD":
		$orderby = "hits DESC";
		break;
	case "ratingD":
		$orderby = "rating DESC";
		break;
	case"dateD":
	default:
		$orderby = "date DESC";
		break;
	}
	return $orderby;
}

function convertorderbytrans($orderby) {
            if ($orderby == "hits ASC")   $orderbyTrans = ""._MD_POPULARITYLTOM."";
            if ($orderby == "hits DESC")    $orderbyTrans = ""._MD_POPULARITYMTOL."";
            if ($orderby == "title ASC")    $orderbyTrans = ""._MD_TITLEATOZ."";
            if ($orderby == "title DESC")   $orderbyTrans = ""._MD_TITLEZTOA."";
            if ($orderby == "date ASC") $orderbyTrans = ""._MD_DATEOLD."";
            if ($orderby == "date DESC")   $orderbyTrans = ""._MD_DATENEW."";
            if ($orderby == "rating ASC")  $orderbyTrans = ""._MD_RATINGLTOH."";
            if ($orderby == "rating DESC") $orderbyTrans = ""._MD_RATINGHTOL."";
            return $orderbyTrans;
}

function convertorderbyout($orderby) {
            if ($orderby == "title ASC")            $orderby = "titleA";
            if ($orderby == "date ASC")            $orderby = "dateA";
            if ($orderby == "hits ASC")          $orderby = "hitsA";
            if ($orderby == "rating ASC")        $orderby = "ratingA";
            if ($orderby == "title DESC")              $orderby = "titleD";
            if ($orderby == "date DESC")            $orderby = "dateD";
            if ($orderby == "hits DESC")          $orderby = "hitsD";
            if ($orderby == "rating DESC")        $orderby = "ratingD";
            return $orderby;
}

//updates rating data in itemtable for a given item
function updaterating($sel_id){
        global $xoopsDB;
        $query = "select rating FROM ".$xoopsDB->prefix("webshow_votedata")." WHERE lid = ".$sel_id."";
        $voteresult = $xoopsDB->query($query);
            $votesDB = $xoopsDB->getRowsNum($voteresult);
        $totalrating = 0;
            while(list($rating)=$xoopsDB->fetchRow($voteresult)){
                $totalrating += $rating;
            }
        $finalrating = $totalrating/$votesDB;
        $finalrating = number_format($finalrating, 4);
        $query =  "UPDATE ".$xoopsDB->prefix("webshow_links")." SET rating=$finalrating, votes=$votesDB WHERE lid = $sel_id";
        $xoopsDB->query($query) or exit();
}

//returns the total number of items in items table that are accociated with a given table $table id
function getTotalItems($sel_id, $status=""){
        global $xoopsDB, $mytree;
        $count = 0;
        $arr = array();
        $query = "select count(*) from ".$xoopsDB->prefix("webshow_links")." where cid=".$sel_id."";
        if($status!=""){
                $query .= " and status>=$status";
        }
        $result = $xoopsDB->query($query);
        list($thing) = $xoopsDB->fetchRow($result);
        $count = $thing;
        $arr = $mytree->getAllChildId($sel_id);
        $size = count($arr);
        for($i=0;$i<$size;$i++){
                $query2 = "select count(*) from ".$xoopsDB->prefix("webshow_links")." where cid=".$arr[$i]."";
                if($status!=""){
                        $query2 .= " and status>=$status";
                }
                $result2 = $xoopsDB->query($query2);
                list($thing) = $xoopsDB->fetchRow($result2);
                $count += $thing;
        }
        return $count;
}

/**
 * Meta keywords automatic's creation
 *  Original Code by Herve Thoussard (hervet)
 */
function webshow_extract_keywords($content)
{
	global $xoopsModuleConfig;
	$tmp=array();
	$myts =& MyTextSanitizer::getInstance();
	$content = str_replace ("<br />", " ", $content);
	$content= strip_tags($content);
	$content= $myts->undoHtmlSpecialChars($content);
	$content=strtolower($content);
	$search_pattern=array("&nbsp;","\t","\r\n","\r","\n",",",".","'",";",":",")","(",'"','?','!','{','}','[',']','<','>','/','+','-','_','\\','*');
	$replace_pattern=array(' ',' ',' ',' ',' ',' ',' ',' ','','','','','','','','','','','','','','','','','','','');
	$content = str_replace($search_pattern, $replace_pattern, $content);
	$keywords=explode(' ',$content);
	$keywords=array_unique($keywords);	
      // filter for length and common words.  Set in mod preference
	$commonwords = str_replace(array(",","|")," ", $xoopsModuleConfig['ws_keyword_common']);
	foreach($keywords as $keyword) {
	      // Keyword Length Limit 
		if(strlen($keyword)>=$xoopsModuleConfig['ws_keyword_limit'] && !is_numeric($keyword)) {
	            // Remove common words.
	            $strpos = strpos($commonwords,$keyword);	    
			if ($strpos === false) { 
			   $tmp[]=$keyword;			
			}					              		
		}             	      	
	}
	
      // Keyword Count
	$tmp=array_slice($tmp,0,$xoopsModuleConfig['ws_keyword_count']);	

	if(count($tmp)>0) {
		return implode(',',$tmp);	
	} else {
		if(!isset($config_handler) || !is_object($config_handler)) {
			$config_handler =& xoops_gethandler('config');
		}
		$xoopsConfigMetaFooter =& $config_handler->getConfigsByCat(XOOPS_CONF_METAFOOTER);
		return $xoopsConfigMetaFooter['meta_keywords'];
	}
}

function autoPublish()
{
   global $xoopsDB, $eh;
   $result=$xoopsDB->query("select lid, published from ".$xoopsDB->prefix("webshow_links")." where published>0 order by lid");
   while(list($lid, $published) = $xoopsDB->fetchRow($result)) {				
      if($published < time()) {
          $xoopsDB->queryF("update ".$xoopsDB->prefix("webshow_links")." set status=1, date=".time().", published=0 where lid=".$lid."")  or $eh->show("0013");					
      }
   }
}

function autoExpire()
{
   global $xoopsDB, $eh;
   $result=$xoopsDB->query("select lid, expired from ".$xoopsDB->prefix("webshow_links")." where expired>0 order by lid");
   while(list($lid, $expired) = $xoopsDB->fetchRow($result)) {				
      if($expired <= time() & $expired > 0) {
		$xoopsDB->queryF("update ".$xoopsDB->prefix("webshow_links")." set status=-2 where lid=".$lid."")  or $eh->show("0013");					
      }
   }
}

//** Check that default playerid1 exists, if not create it.
function player1Exist()
{
	global $xoopsDB;
	$player1result = $xoopsDB->queryF("SELECT (playerid) FROM ".$xoopsDB->prefix('webshow_player')." WHERE playerid = 1");
	list($playerid)=$xoopsDB->fetchRow($player1result);
	if ($playerid == 0) {		
     $xoopsDB->queryF("INSERT INTO " . $xoopsDB->prefix('webshow_player') . " VALUES (1, 0, 'Default', 1, '#CCCCCC', '#5780C0', '#FFFFFF', '#FEDA0A', 180, 1, 1, 0, 240, 240, 240, 0);")  or $eh->show("0013");
      }
}  
?>