<?php
// $Id: include/playlistform.php,v.50 2007/03/01 19:59:00 tcnet Exp $ //
// Flash Media Player by Jereon Wijering ( http://www.jeroenwijering.com ) is licensed under a Creative Commons License (http://creativecommons.org/licenses/by-nc-sa/2.0/) //
// It allows you to use and modify the script for noncommercial purposes. //
// You must share a like any modifications. // 
// For commercial use you must purchase a license from Jereon Wijering at http://www.jeroenwijering.com/?order=form. //

//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //

if (!defined('XOOPS_ROOT_PATH')){ exit(); }
//  example XoopsForm($title, $name, $action, $method="post", $addtoken=false)
$sform = new XoopsThemeForm($wsformlabel, $wsformname, $wsformaction, $wsformmethod, $wsformaddtoken = "false");  
$sform->setExtra('enctype="multipart/form-data"');
//** Playlist Title
if($op == "modLinkS" || $op == "approve"){
$viewentry = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/singlelink.php?lid=".$lid."\" title=\""._MD_VISIT." ".$title." "._MD_LINK."\" target=\"_blank\">("._MD_VIEWLISTING.")</a>";
}else{
$viewentry = "";
}
$sform->addElement(new XoopsFormText("<b>"._MD_SITETITLE."*</b>".$viewentry, 'title', 40, 60, $title), true);

//** LIST TYPE LANGUAGE 
if ($listtype == "feed") {
  $listtypename = _MD_LISTTYPE_FEED;
  $listtypedsc = _MD_LISTTYPE_FEED_DSC;
  $srctype = "feed";	
}
if ($listtype == "dir") {
  $listtypename = _MD_LISTTYPE_DIR;
  $listtypedsc = _MD_LISTTYPE_DIR_LOC." ".$xoopsModule->getVar('dirname')."/".$xoopsModuleConfig['path_media']."/.<br />"._MD_LISTTYPE_DIR_DSC;
}
  if ($listtype == "single") {
  $listtypename = _MD_LISTTYPE_SINGLE;
  $listtypedsc = _MD_LISTTYPE_SINGLE_DSC;	
}

if($op == "modLinkS") {
   //**SELECT PLAYLIST SOURCE
   $list_tray = new XoopsFormElementTray("<b>"._MD_LISTTYPE."*</b><br /><span style=\"font-size:90%; font-weight: 500;\">"._MD_LISTTYPE_DSC,'' );
   // example XoopsFormSelect($caption, $name, $value=null, $size=1, $multiple=false, $id="")
   $playlisttype=new XoopsFormSelect('', 'listtype', $listtype, 1, false, $listtype);
   $playlisttype->setExtra("onchange='window.location=\"".$wsformaction."?op=modLink&amp;lid=".$lid."&amp;listtype=\"+this.value'");   
   $playlisttype->addOption('feed',_MD_LISTTYPE_FEED,false);		   
   if($xoopsUser->isAdmin($xoopsModule->mid())){
      $playlisttype->addOption('dir',_MD_LISTTYPE_DIR,false);
   }
   $playlisttype->addOption('single',_MD_LISTTYPE_SINGLE,false); 
   $list_tray->addElement($playlisttype, true);	
   $sform->addElement($list_tray);     
   if($listtype != "feed") {
      //**SELECT MEDIA FILE TYPE    
      $source_tray = new XoopsFormElementTray("<b>"._MD_SRC."*</b><br /><span style=\"font-size:90%; font-weight: 500;\">"._MD_SRC_DSC."</span>","" );
      // example XoopsFormSelect($caption, $name, $value=null, $size=1, $multiple=false, $id="")
      $sourcetype=new XoopsFormSelect('', 'srctype', $srctype, 1, false, $srctype);   
      $sourcetype->addOption('mp3',_MD_SRC_MP3,false);		   
      $sourcetype->addOption('image',_MD_SRC_IMAGE,false);
      $sourcetype->addOption('flv',_MD_SRC_FLV,false);
      $sourcetype->addOption('swf',_MD_SRC_SWF,false);
      //$sourcetype->addOption('all',_MD_SRC_ALLMEDIA,false); //not needed
      $source_tray->addElement($sourcetype, true);
      $sform->addElement($source_tray); 
   }   
} else {
   $sform->addElement(new XoopsFormLabel("<b>"._MD_LISTTYPE."</b><br /><span style=\"font-size:90%; font-weight: 500;\"></span>",$listtypename));
   $sform->addElement(new XoopsFormHidden('listtype', $listtype), true);
  // if($listtype == "feed") {
      $srctype = isset($_POST['srctype']) ? $_POST['srctype'] : $srctype;
      $sform->addElement(new XoopsFormLabel("<b>"._MD_SRC."</b><br /><span style=\"font-size:90%; font-weight: 500;\"></span>",$srctype));
      $sform->addElement(new XoopsFormHidden('srctype', $srctype), true);
 //  } else {	
  //    $sform->addElement(new XoopsFormLabel("<b>"._MD_SRC."</b><br /><span style=\"font-size:90%; font-weight: 500;\"></span>",$srctype));
  //    $sform->addElement(new XoopsFormHidden('srctype', $srctype), true);
  // }	
}

//**List URL		
$sform->addElement(new XoopsFormText("<b>".$listtypename." "._MD_LISTURL."*</b><br /><span style=\"font-size:90%; font-weight: 500;\">".$listtypedsc."</span>", 'listurl', 60, 250, $listurl), true);  

//** Description
$sform->addElement(new XoopsFormTextArea("<b>"._MD_BLOCKDESCRIPTION.":*</b><br /><span style=\"font-size:90%; font-weight: 500;\">"._MD_BLOCKDESCRIPTION_DSC."</span>", 'description',$description,3,40), true);	

//** TAGS
if($xoopsModuleConfig['tags']){
   $itemid = $lid;
   $catid = 0;
   include_once XOOPS_ROOT_PATH."/modules/tag/include/formtag.php";
   $sform->addElement(new XoopsFormTag("item_tag", 60, 255, $itemid, $catid));
}

//**Category Select
ob_start();
//**example makeMySelBox($title,$order="",$preset_id=0, $none=0, $sel_name="", $onchange="")	
$cattree->makeMySelBox("cattitle","cattitle",$cid,1,"cid");
$catselbox = ob_get_contents();	
ob_end_clean();
$sform->addElement(new XoopsFormLabel("<b>"._MD_CAT."* </b><br /><span style=\"font-size:90%; font-weight: 500;\">"._MD_CATEGORY_DSC."</span>",$catselbox));	

//** Website URL	
$sform->addElement(new XoopsFormText("<b>"._MD_SITEURL."</b>", 'url', 60, 250, $url), false);

//** Credits
//** Artist or Creator
$sform->addElement(new XoopsFormText("<b>"._MD_ARTIST."</b>", 'artist', 50, 100, $artist), false);
//** Album or Classification
$sform->addElement(new XoopsFormText("<b>"._MD_ALBUM."</b>", 'album', 50, 100, $album), false);
//** Record Label or Copyright
$sform->addElement(new XoopsFormText("<b>"._MD_LABEL."</b>", 'label', 50, 100, $label), false);							

//** LOGO IMAGE 
if(!empty($xoopsModuleConfig["path_logo"])){
$logo_image_tray = new XoopsFormElementTray("<b>"._MD_LOGOIMAGE."</b><br /><br /><span style=\"font-size: 90%; font-weight: 500;\"><b>"._MD_LOGOURL."</b><br />"._MD_LOGOURL_DSC."<br /><br /><b>"._MD_LOGOUPLOAD."</b><br />"._MD_LOGOSIZE." ".$logosize."bytes<br />"._MD_LOGODIM." ".$logowidth."px<br /><br /><b>"._MD_LOGOSELECT."</b><br />"._MD_LOGOPATH_DSC." ".$xoopsModuleConfig["path_logo"]."</span>", "");

  //** LINK to LOGO URL
  //If logourl is an external link $logolink = $logourl;
  $ps = strpos($logourl, 'http://');
  if (!($ps === false)) { 
  $logolink = $logourl;
  } else {
  $logolink = "";
  }
  $image_option_tray = new XoopsFormElementTray("<span style=\"font-size: 90%; font-weight: 500;\">"._MD_LOGOIMAGE_DSC."</span><br /><br /><b>"._MD_LOGOURL."</b>", "");
  $image_option_tray->addElement(new XoopsFormText("", 'logolink', 50, 250, $logolink), false);
    $logo_image_tray->addElement($image_option_tray);
    
  //** UPLOAD LOGO 
  //** code borrowed from Article module by phppp
  unset($image_option_tray);  
  $image_option_tray = new XoopsFormElementTray("<br /><br /><b>"._MD_LOGOUPLOAD."</b>", ""); 
  $image_option_tray->addElement(new XoopsFormFile("", "userfile",""));
  $logo_image_tray->addElement($image_option_tray);
    
  //** SELECT LOGO
  unset($image_tray);
  unset($image_option_tray);
  $path_image = $xoopsModuleConfig["path_logo"];
  $image_option_tray = new XoopsFormElementTray("<br /><br /><b>"._MD_LOGOSELECT."</b>", "");
  $image_array =& XoopsLists::getImgListAsArray(XOOPS_ROOT_PATH . "/". $path_image."/");
  array_unshift($image_array, _NONE);
  $image_select = new XoopsFormSelect("", "logourl", $logourl);
  $image_select->addOptionArray($image_array);
  $image_select->setExtra("onchange=\"showImgSelected('img', 'logourl', '/".$path_image."/', '', '" . XOOPS_URL . "')\"");
  $image_tray = new XoopsFormElementTray("", "");
  $image_tray->addElement($image_select);
  //** IMAGE PREVIEW  
  if (!empty($logourl) && file_exists(XOOPS_ROOT_PATH . "/" .$path_image."/" . $logourl)){
      $image_tray->addElement(new XoopsFormLabel("", "<div style=\"padding: 8px;\"><img src=\"" . XOOPS_URL . "/" .$path_image."/" . $logourl . "\" name=\"img\" id=\"img\" alt=\"\" /></div>"));
  }elseif(!empty($logolink)){
      $image_tray->addElement(new XoopsFormLabel("", "<div style=\"padding: 8px;\"><img src=\"" .$logolink. "\" name=\"img\" id=\"img\" alt=\"\" /></div>"));  
    }else{
      $image_tray->addElement(new XoopsFormLabel("", "<div style=\"padding: 8px;\"><img src=\"" . XOOPS_URL . "/images/blank.gif\" name=\"img\" id=\"img\" alt=\"\" /></div>"));
  }
  $image_option_tray->addElement($image_tray);
  
  $logo_image_tray->addElement($image_option_tray);

  $sform->addElement($logo_image_tray);
}   

$sform->addElement(new XoopsFormRadioYN("<b>"._MD_ALLOWCOMMENTS."</b>", 'comments', $comments, _YES, _NO));			

if($xoopsUser){ //start block from guest
//** SHOW INFO
$shownfo_tray = new XoopsFormElementTray("<b>"._MD_SHOWINFO."</b><br /><span style=\"font-size:90%; font-weight: 500;\">"._MD_SHOWINFO_DSC."</span>","" );
$shownfo_tray->addElement(new XoopsFormRadioYN(_MD_SHOWINFOBOX, "showinfo[0]", $showinfo[0], _YES, _NO));
$shownfo_tray->addElement(new XoopsFormRadioYN("<br />"._MD_DESCRIPTION, "showinfo[1]", $showinfo[1], _YES, _NO));
$shownfo_tray->addElement(new XoopsFormRadioYN("<br />"._MD_LOGOIMAGE, "showinfo[2]", $showinfo[2], _YES, _NO));
$shownfo_tray->addElement(new XoopsFormRadioYN("<br />"._MD_CREDITS, "showinfo[3]", $showinfo[3], _YES, _NO));
$shownfo_tray->addElement(new XoopsFormRadioYN("<br />"._MD_STATISTICS, "showinfo[4]", $showinfo[4], _YES, _NO));
$shownfo_tray->addElement(new XoopsFormRadioYN("<br />"._MD_SUBMITTER, "showinfo[5]", $showinfo[5], _YES, _NO));
$shownfo_tray->addElement(new XoopsFormRadioYN("<br />"._MD_PAGELINK, "showinfo[6]", $showinfo[6], _YES, _NO));
$shownfo_tray->addElement(new XoopsFormRadioYN("<br />"._MD_WEBSITE, "showinfo[7]", $showinfo[7], _YES, _NO));
$shownfo_tray->addElement(new XoopsFormRadioYN("<br />"._MD_EMBEDLINK, "showinfo[8]", $showinfo[8], _YES, _NO));
if($listtype == "single"){
$shownfo_tray->addElement(new XoopsFormRadioYN("<br />"._MD_DOWNLOAD, "showinfo[9]", $showinfo[9], _YES, _NO));
}else{
$shownfo_tray->addElement(new XoopsFormRadioYN("<br />"._MD_WEBFEED, "showinfo[9]", $showinfo[9], _YES, _NO));
}
$shownfo_tray->addElement(new XoopsFormRadioYN("<br />"._MD_POPUP, "showinfo[10]", $showinfo[10], _YES, _NO));
$shownfo_tray->addElement(new XoopsFormRadioYN("<br />"._MD_TAGS, "showinfo[11]", $showinfo[11], _YES, _NO));
$sform->addElement($shownfo_tray);

//** Chain Playlist Select
ob_start();
//**function makeMySelBox($title,$order="",$preset_id=0, $none=0, $sel_name="", $onchange="")			 
$linktree->makeMySelBox("title","title",$chain,1,"chain");
$linkselbox = ob_get_contents();	
ob_end_clean();		 
$sform->addElement(new XoopsFormLabel("<b>"._MD_CHAINLINK."</b><br /><span style=\"font-size:90%; font-weight: 500;\">"._MD_CHAINLINKDSC."</span>",$linkselbox));		

//**Body Text
if(file_exists(XOOPS_ROOT_PATH."/class/xoopseditor/xoopseditor.php")) {
   //** Text Editor Requires class/xoopseditor
   include_once XOOPS_ROOT_PATH."/Frameworks/xoops22/class/xoopsformloader.php";
   $editor = $xoopsModuleConfig["texteditor"];
   // options for the editor
   //required configs
   $options['name'] ='bodytext';
   //$options['value'] = empty($_REQUEST['bodytext'])? "" : $_REQUEST['bodytext'];
   $options['value'] = $bodytext;
   //optional configs
   $options['rows'] = 25; // default value = 5
   $options['cols'] = 60; // default value = 50
   $options['width'] = '550px'; // default value = 100%
   $options['height'] = '400px'; // default value = 400px
   $editor_configs = $options;
   $sform->addElement(new XoopsFormEditor(_MD_LINKTEXTC, $editor, $editor_configs, $nohtml = false, $onfailure = "textarea"), false);
}else{
   //** example XoopsFormDhtmlTextArea($caption, $name, $value, $rows=5, $cols=50, $hiddentext="xoopsHiddenText")
   $sform->addElement(new XoopsFormDhtmlTextArea("<b>"._MD_LINKTEXTC."</b>", 'bodytext',$bodytext,10,10), false);	
}

//**Player Select Box
ob_start();
//** example makeMySelBox($title,$order="",$preset_id=0, $none=0, $sel_name="", $onchange="")			 
$playertree->makeMySelBox("playertitle","playertitle",$playerid,0,"playerid");
$playerselbox = ob_get_contents();	
ob_end_clean();	
$sform->addElement(new XoopsFormLabel("<b>"._MD_PLAYER.":</b>",$playerselbox));	 

if($xoopsUser && $xoopsUser->isAdmin($xoopsModule->mid())){
   //** PLAYER LOGO IMAGE code borrowed from Article module by phppp
   $playerlogo_option_tray = new XoopsFormElementTray("<b>"._MD_PLAYERLOGOUPLOAD."</b><br /><span style=\"font-size: 85%; font-weight: 500;\">"._MD_LOGOSIZE." ".$playerlogosize."bytes<br />"._MD_LOGODIM." ".$playerlogowidth."px</span>","");
   $playerlogo_option_tray->addElement(new XoopsFormFile("", "userfile2",""));
   $sform->addElement($playerlogo_option_tray);
   unset($playerlogo_tray);
   unset($playerlogo_option_tray);
   $path_playerlogo = $xoopsModule->getVar('dirname')."/images/player";
   $playerlogo_option_tray = new XoopsFormElementTray("<b>"._MD_PLAYERLOGOSELECT."</b><br /><span style=\"font-size: 85%; font-weight: 500;\">"._MD_PLAYERLOGO_DSC."<br />".$path_playerlogo."</span>", "<br />");
   $playerlogo_array =& XoopsLists::getImgListAsArray(XOOPS_ROOT_PATH . "/modules/". $path_playerlogo."/");
   array_unshift($playerlogo_array, _NONE);
   $playerlogo_select = new XoopsFormSelect("", "playerlogo", $playerlogo);
   $playerlogo_select->addOptionArray($playerlogo_array);
   $playerlogo_select->setExtra("onchange=\"showImgSelected('plogo', 'playerlogo', '/modules/".$path_playerlogo."/', '', '" . XOOPS_URL . "')\"");
   $playerlogo_tray = new XoopsFormElementTray("", "&nbsp;");
   $playerlogo_tray->addElement($playerlogo_select);
      if (!empty($playerlogo) && file_exists(XOOPS_ROOT_PATH."/modules/".$path_playerlogo."/".$playerlogo)){
         $playerlogo_tray->addElement(new XoopsFormLabel("", "<div style=\"padding: 8px;\"><img src=\"".XOOPS_URL."/modules/".$path_playerlogo."/". $playerlogo."\" name=\"plogo\" id=\"plogo\" alt=\"\" /></div>"));
      }else{
         $playerlogo_tray->addElement(new XoopsFormLabel("", "<div style=\"padding: 8px;\"><img src=\"".XOOPS_URL ."/modules/".$path_playerlogo."/blank.gif\" name=\"plogo\" id=\"plogo\" alt=\"\" /></div>"));
      }
   $playerlogo_option_tray->addElement($playerlogo_tray);
   $sform->addElement($playerlogo_option_tray);
}

//**FLASH VARIABLES
$sform->addElement(new XoopsFormLabel("<h3>"._MD_FLASHVARS."</h3><br /><span style=\"font-size:90%; font-weight: 500;\">",_MD_FLASHVARS_DSC."</span>"));
//example XoopsFormRadioYN($caption, $name, $value=null, $yes=_YES, $no=_NO, $id="")
$sform->addElement(new XoopsFormRadioYN("<b>"._MD_START."</b><br /><span style=\"font-size:90%; font-weight: 500;\">"._MD_STARTDSC."</span>", 'start', $start, _YES, _NO));
$sform->addElement(new XoopsFormRadioYN("<b>"._MD_SHUFFLE."</b><br /><span style=\"font-size:90%; font-weight: 500;\">"._MD_SHUFFLEDSC."</span>", 'shuffle', $shuffle, _YES, _NO));
$sform->addElement(new XoopsFormRadioYN("<b>"._MD_REPEAT."</b><br /><span style=\"font-size:90%; font-weight: 500;\">"._MD_REPEATDSC."</span>", 'replay', $replay, _YES, _NO));			

if($xoopsUser && $xoopsUser->isAdmin($xoopsModule->mid())){
   //** Display Screen Link and Target
   $sform->addElement(new XoopsFormRadioYN("<b>"._MD_LINKDIS."</b><br /><span style=\"font-size:90%; font-weight: 500;\">"._MD_LINKDISDSC."</span>", 'link', $link, _YES, _NO));
   $target_tray = new XoopsFormElementTray("<b>"._MD_LINKTARGET."</b><span style=\"font-size:90%; font-weight: 500;\">"._MD_LINKTARGETDSC."</span>",'' );
   // example XoopsFormSelect($caption, $name, $value=null, $size=1, $multiple=false, $id="")
   $target=new XoopsFormSelect("", 'linktarget',$linktarget, 1, false, $linktarget);
   $target->addOption('_self','_self',false);
   $target->addOption('_blank','_blank',false);
   $target_tray->addElement($target, true);	
   $sform->addElement($target_tray);
}

//** Show Activity Icons
$sform->addElement(new XoopsFormRadioYN("<b>"._MD_SHOWICONS."</b><br /><span style=\"font-size:90%; font-weight: 500;\">"._MD_SHOWICONSDSC."</span>", 'showicons', $showicons, _YES, _NO));	

//** Show EQ for MP3 Only
if($listtype == "feed" || $srctype == "mp3") {
$sform->addElement(new XoopsFormRadioYN("<b>"._MD_SHOWEQ."</b><br /><span style=\"font-size:90%; font-weight: 500;\">"._MD_MP3_ONLY."<br />"._MD_SHOWEQDSC."</span>", 'showeq', $showeq, _YES, _NO));
} else {
$sform->addElement(new XoopsFormHidden('showeq', "0"), false);
}

//** enablejs  //Java script is disabled ATM
//if($listtype != "single"){
//$sform->addElement(new XoopsFormRadioYN("<b>"._MD_ENABLEJS."</b><br /><span style=\"font-size:90%; font-weight: 500;\">"._MD_ENABLEJSDSC."</span>", 'enablejs', $enablejs, _YES, _NO));
//}else{
$sform->addElement(new XoopsFormHidden('enablejs', "0"), false);
//}

//** Thumbnails
$sform->addElement(new XoopsFormRadioYN("<b>"._MD_THUMB."</b><br /><span style=\"font-size:90%; font-weight: 500;\">"._MD_THUMBDSC."</span>", 'thumbslist', $thumbslist, _YES, _NO));

//** Image Stretch
$stretch_tray = new XoopsFormElementTray("<b>"._MD_STRETCH."</b><br /><span style=\"font-size:90%; font-weight: 500;\">"._MD_STRETCHDSC."</span>","");
// example XoopsFormSelect($caption, $name, $value=null, $size=1, $multiple=false, $id="")
$stretch=new XoopsFormSelect("", 'stretch', $stretch, 1, false, $stretch);
$stretch->addOption('false',_MD_FALSE,false);
$stretch->addOption('fit',_MD_FIT,false);
$stretch->addOption('true',_MD_TRUE,false);
$stretch->addOption('none',_MD_NONE,false);
$stretch_tray->addElement($stretch,true);	
$sform->addElement($stretch_tray);

//** Image Rotation Time
if ($listtype != "single") {
$sform->addElement(new XoopsFormText("<b>"._MD_ROTATETIME."</b><br /><span style=\"font-size:90%; font-weight: 500;\">"._MD_ROTATETIMEDSC."</span>", 'rotatetime', 3, 2, $rotatetime), false);
}

if ($listtype != "single" & $srctype == "image") {
//** Slide Show Only (Image Rotator)
$transition_tray = new XoopsFormElementTray("<b>"._MD_TRANSITION."</b><br /><span style=\"font-size:90%; font-weight: 500;\">"._MD_IMAGES_ONLY."<br />"._MD_TRANSITIONDSC."</span>",'');
$transition=new XoopsFormSelect("", 'transition', $transition, 1, false, $transition);
$transition->addOption('0',_MD_TRANS_ROTATEOFF,false);		
$transition->addOption('fade',_MD_TRANS_FADE,false);
$transition->addOption('slowfade',_MD_TRANS_SLOWFADE,false);
$transition->addOption('bgfade',_MD_TRANS_BGFADE,false);
$transition->addOption('blocks',_MD_TRANS_BLOCKS,false);
$transition->addOption('bubbles',_MD_TRANS_BUBBLES,false);
$transition->addOption('circles',_MD_TRANS_CIRCLES,false);
$transition->addOption('fluids',_MD_TRANS_FLUIDS,false);
$transition->addOption('lines',_MD_TRANS_LINES,false);
$transition->addOption('random',_MD_TRANS_RANDOM,false);			
$transition_tray->addElement($transition, true);	
$sform->addElement($transition_tray);		
$sform->addElement(new XoopsFormRadioYN("<b>"._MD_SHOWNAV."</b><br /><span style=\"font-size:90%; font-weight: 500;\">"._MD_SHOWNAVDSC."</span>", 'shownav', $shownav, _YES, _NO));			
} else {
$sform->addElement(new XoopsFormHidden('rotatetime', 0), false);
$sform->addElement(new XoopsFormHidden('transition', 'none'), false);
$sform->addElement(new XoopsFormHidden('shownav', 0), false);
}

//** Text Captions from URL for single file video entry only
if($xoopsUser->isAdmin($xoopsModule->mid())){
   if($listtype == "single" & $srctype == "flv"){
      $sform->addElement(new XoopsFormText("<b>"._MD_CAPTIONS."</b><br /><span style=\"font-size:90%; font-weight: 500;\">"._MD_CAPTIONSDSC."</span>", 'captions', 60, 250, $captions), false);
   }else{
      $sform->addElement(new XoopsFormHidden('captions', ""), false);	
   }
}

//**List Cache
if($op == "modLinkS" & $listtype != "single") {    
   if($xoopsUser && $xoopsUser->isAdmin($xoopsModule->mid())){
      $sform->addElement(new XoopsFormLabel("<b>"._MD_LISTCACHE."</b>","<span style=\"font-size:90%; font-weight: 500;\"><a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar("dirname")."/playlist/".$listcache."\" target=\"_blank\" title=\""._MD_VIEWFORM."\">".$xoopsModule->getVar("dirname")."/playlist/".$listcache."</a></span>"));	
   }
    $sform->addElement(new XoopsFormHidden('listcache', $listcache), false);
    $cachetime_tray = new XoopsFormElementTray("<b>"._MD_LISTCACHE_TIME."</b><br /><span style=\"font-size:90%; font-weight: 500;\">"._MD_LISTCACHE_TIME_DSC."</span>",'');
    $cachetime=new XoopsFormSelect("", 'cachetime', $cachetime, 1, false, $cachetime);
    $cachetime->addOption('3600',_HOUR,false);		
    $cachetime->addOption('86400',_DAY,false);
    $cachetime->addOption('604800',_WEEK,false);
    $cachetime->addOption('2592000',_MONTH,false);		
    $cachetime_tray->addElement($cachetime, true);	
    $sform->addElement($cachetime_tray);
    $sform->addElement(new XoopsFormRadioYN("<b>"._MD_LISTCACHE_REFRESH."</b><br /><span style=\"font-size:90%; font-weight: 500;\">"._MD_LISTCACHE_REFRESHDSC."</span>", 'refreshlist', 0, _YES, _NO));   	 
} 

//** Publish/Expire code from Herve Thoussard News Module
$option_tray = new XoopsFormElementTray(_OPTIONS,'<br />');
//Set date of publish/expiration
    $check=$published>0 ? 1 :0;
    $published_checkbox = new XoopsFormCheckBox('', 'autodate',$check);
    $published_checkbox->addOption(1, _MD_SETDATETIME);
    $option_tray->addElement($published_checkbox);
    $published=$published=0 ? (time()-600) :$published;
    $option_tray->addElement(new XoopsFormDateTime(_MD_SETDATETIME, 'publish_date', 15, $published));
	
    $check=$expired>0 ? 1 :0;
    $expired_checkbox = new XoopsFormCheckBox('', 'autoexpdate',$check);
    $expired_checkbox->addOption(1, _MD_SETEXPDATETIME);
    $option_tray->addElement($expired_checkbox);
    $option_tray->addElement(new XoopsFormDateTime(_MD_SETEXPDATETIME, 'expiry_date', 15, $expired));

$sform->addElement($option_tray);

if($xoopsUser && $xoopsUser->isAdmin($xoopsModule->mid())){
   $sform -> addElement(new XoopsFormSelectGroup(_MD_ENTRYPERM, "ws_entryperm", true, $ws_entryperm, 5, true));
}else{
   $sform->addElement(new XoopsFormHidden('ws_entryperm', $ws_entryperm), false);
}
} //End block from guest
   //** CAPTCHA requires Frameworks Captcha
   // Set $xoopsModuleConfig["captcha"] in module preferences;
   /**
   *Defaults are set in Frameworks/captcha/config.php
      // example $sform->addElement(new XoopsFormCaptcha($caption, $name,$skipmember,$numchar, $minfontsize,$maxfontsize,$backgroundtype,$backgroundnum));
   **/
   $ws_captcha = $xoopsModuleConfig["captcha"];
   if($ws_captcha){
      include_once XOOPS_ROOT_PATH."/Frameworks/captcha/formcaptcha.php";
      $caption="";
      $name="wscaptcha";
      $skipmember = 1;   
      if($ws_captcha == 2){
         $skipmember = 0;     
      }
      $sform->addElement(new XoopsFormCaptcha($caption, $name,$skipmember));   
   }
   
//** Hidden Variables
$sform->addElement(new XoopsFormHidden('op', $op), false);
$sform->addElement(new XoopsFormHidden('lid', $lid), false);
	     
//** Submit buttons
$button_tray = new XoopsFormElementTray('','');
$submit_btn = new XoopsFormButton('', 'post', $btnlabel, 'submit');
$button_tray->addElement($submit_btn);
$delete_btn = "<input type=\"button\" value=\""._MD_DELETE."\" onClick=\"location='index.php?lid=$lid&amp;op=delLink'\">";
$button_tray->addElement(new XoopsFormLabel('   ',$delete_btn));
$sform->addElement($button_tray);		
$sform->display(); 
?>