<?php
// $Id: main.php,v.50 2007/03/01 19:59:00 tcnet Exp $ //
//%%%%%%		Module Name 'WebShow'		%%%%%
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
if (!defined('XOOPS_ROOT_PATH')){ exit(); }
//General Terms
define("_MD_WEBSHOW_DISCLAIMER","<b>Disclaimer: </b>By installing and using the WebShow module you agree that you will not use it to display, distribute or syndicate a third party's copyright protected media without the owner's permission.  The WebShow software is not to be used to display or syndicate illegal or copyright protected media.");
define("_MD_WEBSHOW_DSC","<b>Introduction: </b>This module plays Flash media files (swf, flv, jpg, png, gif, mp3) enclosed in an atom, xspf or rss web feed.  It will filter a media directory by file type to automatically generate and save an xspf playlist.  Plays single media files from a url.  Custom player appearance and behavior.");
define("_MD_WEBSHOW_GETSTARTED","<b>Get Started</b><br />Configure Module Preferences<br /><a href=\"category.php?op=newCat\" target=\"_self\" title=\"Set up a category\">Set up a category.</a><br /><a href=\"index.php?op=newLink\" target=\"_self\" title=\"Playlist Editor\">Add a New Entry.</a><br /><a href=\"player.php?playerid=1&op=modPlayer&lid=1\" target=\"_self\" title=\"Player Editor\">Customize the default player.</a>");
define("_MD_JWFLASH","This module uses <a href=\"http://www.jeroenwijering.com/?item=Flash_Media_Player\" target=\"_blank\">Jeroen Wijerings Flash Media Player</a> which is licensed under a <a href=\"http://creativecommons.org/licenses/by-nc-sa/2.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 2.0</a> license.  A <a href=\"http://www.jeroenwijering.com/?order=form\" target=\"_blank\">commercial license</a> must be purchased from Jeroen Wijering for commercial use.");
define("_MD_REQUIRED","<b>* = Required Field</b>");
define("_MD_EDITOR","Editor");
define("_MD_SAVE","Save Changes");
define("_MD_YES","Yes");
define("_MD_NO","No");
define("_MD_THANKSFORINFO","Thanks for the information. We'll look into your request shortly.");
define("_MD_THANKSFORHELP","Thank you for helping to maintain this directory's integrity.");
define("_MD_FORSECURITY","For security reasons your user name and IP address are temporarily recorded.");
define("_MD_SEARCHFOR","Search for");
define("_MD_ANY","ANY");
define("_MD_SEARCH","Search");
define("_MD_MAIN","Home");
define("_MD_POPULAR","Popular");
define("_MD_TOPRATED","Top Rated");
define("_MD_NEWTHISWEEK","New this week");
define("_MD_UPTHISWEEK","Updated this week");
define("_MD_POPULARITYLTOM","Popularity (Least Hits on Top)");
define("_MD_POPULARITYMTOL","Popularity (Most Hits on Top)");
define("_MD_TITLEATOZ","Title (A to Z)");
define("_MD_TITLEZTOA","Title (Z to A)");
define("_MD_DATEOLD","Date (Oldest on Top)");
define("_MD_DATENEW","Date (Latest on Top)");
define("_MD_RATINGLTOH","Rating (Lowest Score on Top)");
define("_MD_RATINGHTOL","Rating (Highest Score on Top)");
define("_MD_PAGENAV","Page: ");
define("_MD_EDITTHISLINK","Admin Panel");
define("_MD_DESCRIPTION","Description");
define("_MD_EMAILC","Email: ");
define("_MD_LASTUPDATEC","Updated: ");
define("_MD_HITSC","Hits: ");
define("_MD_RATINGC","Rating: ");
define("_MD_ONEVOTE","1 vote");
define("_MD_NUMVOTES","%s votes");
define("_MD_RATETHISSITE","Rate It");
define("_MD_MODIFY","Modify");
define("_MD_REQUESTDENIED","Request Denied.");
define("_MD_NOTOWNER","You are not the owner of this entry.");
define("_MD_NEW","New");
define("_MD_REPORTBROKEN","Broken");
define("_MD_TELLAFRIEND","Tell a Friend");
define("_MD_THEREARE","There are <b>%s</b> entries in the %s category.");
define("_MD_LATESTLIST","Latest Listings");
define("_MD_REQUESTMOD","Request Entry Modification");
define("_MD_SITETITLE","Title: ");
define("_MD_SITEURL","Website URL: ");
define("_MD_OPTIONS","Options: ");
define("_MD_NOTIFYAPPROVE", "Notify me when this entry is approved");
define("_MD_SENDREQUEST","Send Request");
define("_MD_VOTEAPPRE","Your vote is appreciated.");
define("_MD_THANKURATE","Thank you for taking the time to rate a site here at %s.");
define("_MD_VOTEFROMYOU","Input from users such as yourself will help other visitors better decide which media entry to choose.");
define("_MD_VOTEONCE","Please do not vote for the same resource more than once.");
define("_MD_RATINGSCALE","The scale is 1 - 10, with 1 being poor and 10 being excellent.");
define("_MD_BEOBJECTIVE","Please be objective, if everyone receives a 1 or a 10, the ratings aren't very useful.");
define("_MD_DONOTVOTE","Do not vote for your own resource.");
define("_MD_INTRESTLINK","Interesting media showing at %s");  // %s is your site name
define("_MD_INTLINKFOUND","Here is an interesting media clip I have found at %s");  // %s is your site name
define("_MD_RANK","Rank");
define("_MD_HITS","Hits");
define("_MD_RATING","Rating");
define("_MD_VOTE","Vote");
define("_MD_TOP10","%s Top 10"); // %s is a category title
define("_MD_SEARCHRESULTS","Search results for <b>%s</b>:"); // %s is search keywords
define("_MD_SORTBY","Sort by:");
define("_MD_DATE","Date");
define("_MD_POPULARITY","Popularity");
define("_MD_CURSORTEDBY","Currently sorted by: %s");
define("_MD_PREVIOUS","Previous");
define("_MD_NEXT","Next");
define("_MD_NOMATCH","No matches found to your query");
define("_MD_SUBMIT","Submit");
define("_MD_CANCEL","Cancel");
define("_MD_ALREADYREPORTED","You have already submitted a broken report for this resource.");
define("_MD_NORATING","No rating selected.");
define("_MD_CANTVOTEOWN","You cannot vote on the resource you submitted.<br />All votes are logged and reviewed.");
define("_MD_VOTEONCE2","Vote for the selected resource only once.<br />All votes are logged and reviewed.");

//** Submit Form
define("_MD_SUBMITLINK","Submit Media");
define("_MD_SUBMITLINKHEAD","Media Submit Form");
define("_MD_SUBMITONCE","Submit your media entry only once.");
define("_MD_ALLPENDING","Your information will be posted pending verification.");
define("_MD_DONTABUSE","Please review and abide by our Terms of Service. Do not contribute other's copyrighted materials without permission from the owner. Your User name and IP will be attached to this submission.");
define("_MD_RECEIVED","We received your media entry. Thanks!");
define("_MD_WHENAPPROVED","You'll receive an E-mail when it's approved.");
define("_MD_MUSTREGFIRST","Sorry, you don't have the permission to perform this action.<br />Please register or login first!");

//%%%%%%	Admin	  %%%%%
define("_MD_ADMINTABLE","WebShow Administration");
define("_MD_WEBSHOWCONF","WebShow Module");
define("_MD_GENERALSET","Preferences");
define("_MD_ADDMODDELETE","Add, Modify, and Delete Media Entry");
define("_MD_LINKSWAITING","Waiting Validation");
define("_MD_BROKENREPORTS","Broken Entry Reports");
define("_MD_MODREQUESTS","Entry Modification Requests");
define("_MD_GOTOMOD","Go to module");
define("_MD_SUBMITTER","Submitter");
define("_MD_VISIT","Visit");
define("_MD_WEBSITE","Link");
define("_MD_WEBFEED","Feed");
define("_MD_APPROVE","Approve");
define("_MD_DELETE","Delete");
define("_MD_NOSUBMITTED","No New Entry Submissions.");
define("_MD_TITLE","Title");
define("_MD_TITLEC","Title: ");
define("_MD_CREDITS","Credits");
define("_MD_ARTIST","Artist:");
define("_MD_ALBUM","Album:");
define("_MD_LABEL","Attribution:");
define("_MD_IMGURL","Image URL: ");
define("_MD_ADD","Add");
define("_MD_IN","in");
define("_MD_TOTALVOTES","Entry Votes (total votes: %s)");
define("_MD_USERTOTALVOTES","Registered User Votes (total votes: %s)");
define("_MD_ANONTOTALVOTES","Anonymous User Votes (total votes: %s)");
define("_MD_USER","User");
define("_MD_IP","IP Address");
define("_MD_USERAVG","User AVG Rating");
define("_MD_TOTALRATE","Total Ratings");
define("_MD_NOREGVOTES","No Registered User Votes");
define("_MD_NOUNREGVOTES","No Unregistered User Votes");
define("_MD_VOTEDELETED","Vote data deleted.");
define("_MD_NOBROKEN","No reported broken entries.");
define("_MD_IGNOREDESC","Ignore (Ignores the report and only deletes the <b>broken media entry report</b>)");
define("_MD_DELETEDESC","Delete (Deletes <b>the reported website data</b> and <b>broken entry reports</b> for the media entry.)");
define("_MD_REPORTER","Report Sender");
define("_MD_IGNORE","Ignore");
define("_MD_BROKENDELETED","Broken entry report deleted.");
define("_MD_USERMODREQ","Entry Modification Requested");
define("_MD_ORIGINAL","Original");
define("_MD_PROPOSED","Proposed");
define("_MD_OWNER","Owner: ");
define("_MD_NOMODREQ","No Modification Requested.");
define("_MD_DBUPDATED","Database Updated Successfully!");
define("_MD_MODREQDELETED","Modification Request Deleted.");
define("_MD_AVAILABLE","Available");
define("_MD_NOTAVAILABLE","Not Available");
define("_MD_CREATETHEDIR","Create the Directory.");
define("_MD_SETMPERM","Set directory permissions.");
define("_MD_PATH_LOGO","Logo Path");
define("_MD_PATH_MEDIA","Media Path");
define("_MD_PATH_PLAYLIST","Playlist Path");

//Submit Entry Form
define("_MD_ERROREXIST","ERROR: The media you provided is already in the database!");
define("_MD_ERRORTITLE","ERROR: You need to enter TITLE!");
define("_MD_ERRORDESC","ERROR: You need to enter DESCRIPTION!");
define("_MD_ERRORLINK","ERROR: You need to enter a Media Location!");
define("_MD_ERRORTIME","ERROR: Publish time and expiration time are the same!");
define("_MD_NEWLINKADDED","New media added to the Database.");
define("_MD_YOURLINK","Your Media Entry at %s");
define("_MD_YOUCANBROWSE","You can browse our media entries at %s");
define("_MD_HELLO","Hello %s");
define("_MD_WEAPPROVED","We approved your media entry submission to our directory.");
define("_MD_THANKSSUBMIT","Thanks for your submission!");
define("_MD_ISAPPROVED","We approved your media entry submission");
define("_MD_ID","ID");
define("_MD_IMAGEURL","Image URL: ");
define("_MD_FILESUCCESS","File uploaded successfully");

//** Category
define("_MD_ADMIN","WebShow Administration");
define("_MD_CATEGORYC","Category: ");
define("_MD_CATEGORY_DSC","If left blank the entry is in the data base but not in the directory.");
define("_MD_CAT","Category");
define("_MD_CATDESC","Category Description");
define("_MD_CATSELECT","Select a Category:");
define("_MD_CATTITLE","Category Title");
define("_MD_CATMGMT","Category Manager");
define("_MD_CATDELETED","Category Deleted.");
define("_MD_PARENT","Parent Category:");
define("_MD_CATNAME","Category Name");
define("_MD_CATCONF","Category Configuration");
define("_MD_MODCAT","Modify a Category");
define("_MD_ADDCAT","Add a Category");
define("_MD_ADDNEWCAT","Add New Category");
define("_MD_NEWCATADDED","New Category Added Successfully!");
define("_MD_NOCAT","Please add a category first.");
define("_MD_SUBCAT","Sub-Category");
define("_MD_ADDSUB","Add a SUB-Category");
define("_MD_WARNING","WARNING: Are you sure you want to delete this Category and ALL of its Sub-Categories, Entries and Comments?");
define("_MD_CATIMG_DSC","Category images are kept in");
define("_MD_CATIMGSELECT","Select a category image");
define("_MD_CATIMGUPLOAD","Upload a category Image");

//** Link
define("_MD_LINK","Media Entry");
define("_MD_LINKCONF","Entry Configuration");
define("_MD_LINKDELETED","Entry Deleted.");
define("_MD_LINKID","Entry ID: ");
define("_MD_LINKTITLE","Media Title");
define("_MD_LINKMGMT","Media Manager");
define("_MD_LINKWARNING","WARNING: Are you sure you want to delete this Entry?");
define("_MD_ADDNEWLINK","Add Media");
define("_MD_NEWLINK","New Entry");
define("_MD_MODLINK","Modify Entry");
define("_MD_LISTURL","Location: ");
define("_MD_LINKTEXTC","Text Body: ");

//** Player
define("_MD_PLAYER","Player");
define("_MD_PLAYERCONF","Player Configuration");
define("_MD_PLAYERREFRESH","Submit changes to refresh the Player Demo.");
define("_MD_PLAYERMGMT","Player Manager");
define("_MD_CLONE","Clone");
define("_MD_PLAYERWARNING","WARNING: Are you sure you want to delete this Player? <br />Manually edit all entries using this player before deleting it.");
define("_MD_PLAYERC","Player: ");
define("_MD_PLAYERID","Player ID: ");
define("_MD_PLAYERTITLE","Player Name: ");
define("_MD_ADDNEWPLAYER","Add New Player");
define("_MD_NEWPLAYER","New Player");
define("_MD_NEWPLAYERADDED","New Player Added");
define("_MD_MODPLAYER","Modify Player");
define("_MD_PLAYERDELETED","Player deleted");
define("_MD_PLAYERMODIFIED","Player Modified");
define("_MD_PLAYERSTYLE","Style Options");
define("_MD_PLAYERSTYLE_DSC","Select a color style option.");
define("_MD_PLAYERSTYLE_OPT1","Monochrome");
define("_MD_PLAYERSTYLE_OPT2","Color from Theme");
define("_MD_PLAYERSTYLE_OPT3","Custom Player");
define("_MD_PLAYERSTYLE_OPT4","Custom Player/Page");
define("_MD_THEMEEDITOR","Theme Color Editor");
define("_MD_THEMEEDITORDSC","Preview the found colors, edit the css or enter a color.");
define("_MD_THEMEPREVIEW","Theme Preview");
define("_MD_THEMEMODIFIED","The colors used with this theme have been modifed.");
define("_MD_THEMERESTORE","Restore from CSS");
define("_MD_THEMERESTOREDSC","Delete current colors and restore from css.");
define("_MD_THEMEFILTER","Filter This Theme");
define("_MD_THEMEFILTERALL","Filter All Themes");
define("_MD_THEMEFILTERFAIL","Failed to filter the CSS.");
define("_MD_CSS_MISSING","Missing Property! Please edit CSS.");
define("_MD_CSS_BGCLR","body { background-color: # }");
define("_MD_CSS_BKCLR","itemHead { background-color: # }");
define("_MD_CSS_FTCLR","itemHead { color: # }");
define("_MD_CSS_LTCLR","a:hover { color: # }");
define("_MD_SAVECOLORS","Save Colors");
define("_MD_PLAY","Play");
define("_MD_RESET","Reset");

//** Player Flash Vars
define("_MD_PLAYWIDTH","Player Width: ");
define("_MD_PLAYHEIGHT","Player Height: ");
define("_MD_PLAYBGCLR","Page Color: ");
define("_MD_DISPLAYHEIGHT","Screen Height: ");
define("_MD_DISPLAYWIDTH","Screen Width: ");
define("_MD_DISPLAYWIDTH_DSC","Bottom tracks:<br /> Screen = Player<br /> Side tracks:<br />Screen < Player");
define("_MD_DISBKCLR","Back Color: ");
define("_MD_DISFTCLR","Front Color: ");
define("_MD_DISLTCLR","Light Color: ");
define("_MD_SHOWDIGIT","Show Digits: ");
//define("_MD_SHOWDIGITDSC","Set this to false to hide the digits for % loaded, elapsed and remaining time in the players.");
define("_MD_SHOWFSBUTTON","Full Screen Button:");
//define("_MD_SHOWFSBUTTONDSC","Set this to true to show the fullscreen button.");
define("_MD_SCROLL","Scroll Bar Off: ");
//define("_MD_SCROLLDSC","Set this to true to let the playlist automatically scroll, based upon the mouse cursor. It defaults to false, at which you'll see a scrollbar.");
define("_MD_LARGECONTROL","Large Controls");

//** Playlist admin
//** Media File Filter
define("_MD_SRC","Media Type: ");
define("_MD_SRC_IMAGE","Image GIF, JPG, PNG");
define("_MD_SRC_FLV","Video FLV");
define("_MD_SRC_MP3","Audio MP3");
define("_MD_SRC_SWF","Flash SWF");
define("_MD_SRC_ALLMEDIA","All Flash Media");
define("_MD_SRC_DSC","What is the media file type?");
define("_MD_IMG","Image");
define("_MD_FLV","FLV");
define("_MD_MP3","MP3");
define("_MD_SWF","SWF");
define("_MD_ALLMEDIA","All Media Types");

//** Playlist Source
define("_MD_LISTTYPE","Media Source: "); 
define("_MD_LISTTYPE_FEED","Web Feed");
define("_MD_LISTTYPE_DIR","Media Directory");
define("_MD_LISTTYPE_SINGLE","Single File");
define("_MD_LISTTYPE_DSC","Where are the Flash media files?");
define("_MD_LISTTYPE_FEED_DSC","Enter the URL of a media file or web feed.");
define("_MD_LISTTYPE_DIR_DSC","Enter your folder name here. (No slash)  ");
define("_MD_LISTTYPE_DIR_LOC","FTP upload your media folder to ");
define("_MD_LISTTYPE_SINGLE_DSC","Enter a URL pointing to the media file");

//** Cache Playlist
define("_MD_LISTCACHE","Playlist Cache");
define("_MD_LISTCACHE_DELETED","Cached Playlist Deleted");
define("_MD_LISTCACHE_FILE","Cached Playlist File");
define("_MD_LISTCACHE_NAME","Cached Playlist Filename");
define("_MD_LISTCACHE_DSC","Playlist Location:");
define("_MD_LISTCACHE_PATH","Playlist Path");
define("_MD_LISTCACHE_PATH_DSC","Path to playlist cache ");
define("_MD_LISTCACHE_ERROR","Error creating cache file");
define("_MD_LISTCACHE_REFRESH","Refresh Playlist Cache");
define("_MD_LISTCACHE_REFRESHDSC","Refresh the cached playlist now.");
define("_MD_TITLECHANGE","The entry's title has been changed.");
define("_MD_LISTCACHE_NEW","A new playlist has been cached");
define("_MD_LISTCACHE_FETCH","This webfeed has been fetched and cached.");
define("_MD_LISTCACHE_FETCH_ERROR","Failed to fetch the web feed. Please confirm the web feed location and refresh the cache.");
define("_MD_LISTCACHE_CREATE","A playlist will be created when this form is submitted.");
define("_MD_LISTCACHE_EXPIRED","Playlist Expired.");
define("_MD_LISTCACHE_TIME","Cache Time");
define("_MD_LISTCACHE_TIME_DSC","How often should this playlist be refreshed?");


//** LOGO IMAGES
define("_MD_LOGOURL","Link to Logo: ");
define("_MD_LOGOURL_DSC","Enter a url pointing to the image.");
define("_MD_LOGOPATH_DSC","Image Path: ");
define("_MD_LOGOIMAGE","Logo Image");
define("_MD_LOGOIMAGE_DSC","Use one of these methods to designate an image.");
define("_MD_LOGOSELECT","Select a logo: ");
define("_MD_LOGOUPLOAD","Upload a logo: ");
define("_MD_LOGOBLANK","Leave blank for no logo.");
define("_MD_LOGODIM","Maximum dimension:");
define("_MD_LOGOSIZE","Maximum file size:");
define("_MD_WIDTH","Width");
define("_MD_HEIGHT","Height");
define("_MD_PLAYERLOGO","Player Logo Image: ");
define("_MD_PLAYERLOGO_DSC","Player Logos are in ");
define("_MD_PLAYERLOGOSELECT","Select a player logo:");
define("_MD_PLAYERLOGOUPLOAD","Upload a player logo: ");
define("_MD_GO","Go");
define("_MD_BLOCKDESCRIPTION","Block Description");
define("_MD_BLOCKDESCRIPTION_DSC","Enter one sentence for use in the catalog, blocks and meta description.");
define("_MD_CLOSE","Close");
define("_MD_POPUP","PopUp");
define("_MD_VIEWLISTING","View Entry");
define("_MD_TRANS_FADE","Fade");
define("_MD_TRANS_SLOWFADE","Slow Fade");
define("_MD_TRANS_BGFADE","Background Fade");
define("_MD_TRANS_CIRCLES","Circles");
define("_MD_TRANS_BLOCKS","Blocks");
define("_MD_TRANS_BUBBLES","Bubbles");
define("_MD_TRANS_FLUIDS","Fluids");
define("_MD_TRANS_LINES","Lines");
define("_MD_TRANS_RANDOM","Random");
define("_MD_PREVIEW","Preview");
define("_MD_PREVIEW_DSC","Save your changes first!");
define("_MD_PREVIEWLINK","Preview Source");
define("_MD_PREVIEWPLAYER","Preview Player");
define("_MD_CHAINLINK","Media Chain: ");
define("_MD_CHAINLINKDSC","Optional: Display another entry with this one.");

//** Playlist Flash Vars
define("_MD_FLASHVARS","Flash Variables");
define("_MD_FLASHVARS_DSC","Set the Flash Media Player variables. The default settings work well for most situations");
define("_MD_START","Auto Start: ");
define("_MD_STARTDSC","Yes will automatically start the player.");
define("_MD_SHUFFLE","Shuffle: ");
define("_MD_SHUFFLEDSC","Shuffle playlist items");
define("_MD_REPEAT","Repeat: ");
define("_MD_REPEATDSC","Continuous play.");
define("_MD_LINKDIS","Hyperlinks in Player Display Area: ");
define("_MD_LINKDISDSC","If you define links in your playlist and set this to true, a click on the display will jump to the link. Else a click on the display will play/pause the item.");
define("_MD_LINKTARGET","Link Target: ");
define("_MD_LINKTARGETDSC","This is the target frame in which the link and fullscreen pages will show up.");
define("_MD_SHOWICONS","Activity Icons:");
define("_MD_SHOWICONSDSC","Display Activity and Play icons in Player.");
define("_MD_STRETCH","Stretch Image/Video: ");
define("_MD_STRETCHDSC","False = Scale proportionally to fit the display.<br />Fit = Scale disproportionally to exactly fit the display.<br />True = Scale proportionally to fill the display.<br />None = Original size.<br />");
define("_MD_FALSE","False");
define("_MD_FIT","Fit");
define("_MD_TRUE","True");
define("_MD_NONE","None");
define("_MD_SHOWEQ","Show Animation: ");
define("_MD_MP3_ONLY","MP3 Only");
define("_MD_SHOWEQDSC","Display a (fake) spectrum analyzer.");
define("_MD_IMAGES_ONLY","Image Only Shows");
define("_MD_ROTATETIME","Image Rotation Time: ");
define("_MD_ROTATETIMEDSC","Rotate time in seconds.");
define("_MD_SHOWNAV","Slide Show Navigation: ");
define("_MD_SHOWNAVDSC","Display navigation bar in Slide Show Player.");
define("_MD_TRANSITION","Slide Show Transition: ");
define("_MD_TRANSITIONDSC","Selecting a transition will switch Media Player to Slide Show.");
define("_MD_TRANS_ROTATEOFF","Slide Show Player Off");
define("_MD_THUMB","Thumbnails: ");
define("_MD_THUMBDSC","Set this to yes if you want to show thumbnails of  images in the playlist. Not used for Slide Show Player");
define("_MD_CAPTIONS","Captions URL: ");
define("_MD_CAPTIONSDSC","XML Webfeed: Leave blank for captions from playlist.<br />Directory: Leave blank or enter the URL of a caption file.");
define("_MD_ENABLEJS","Enable Javascript:");
define("_MD_ENABLEJSDSC","Select yes to activate javascript functions.<br />See include/mplay.inc.js file for options.");

// Playlist Status
define("_MD_SETDATETIME","Set Publish Time: ");
define("_MD_SETEXPDATETIME","Set Expiration Time: ");
define("_MD_STATUS","Status");
define("_MD_STATUSREPORT","Status Report");
define("_MD_STATUSAUTO","Auto Publish");
define("_MD_STATUSEXPIRED","Expired");
define("_MD_STATUSWAITING","Waiting Approval");

//** Module Update
define("_MD_UPDATEMOD","Update Module");
define("_MD_MODUPDATED","Module updated.");
define("_MD_NOTEXIST","Does not exist");

//** Permissions
define("_MD_PERMFORM","Permissions Form");
define("_MD_PERMFORMNEWCAT","Set permissions after submitting the new category.");
define("_MD_APPROVEFORM","Auto Approve");
define("_MD_APPROVEFORM_DESC","Automatically approve frontside submissions by these groups.");
define("_MD_APPROVEPERM_WARN","Due to certain aspects of this module including copyright infringement, local moral or legal issues and the possibility of malicious code in submitted media files, it is recommended that automatic approval by anonymous users should not be allowed.  All submissions should be reviewed by a module admin.");
define("_MD_SUBMITFORM","Submit");
define("_MD_SUBMITFORM_DESC","Allow users to submit an entry and, if published, modify that entry.");
define("_MD_VIEWFORM","View");
define("_MD_VIEWFORM_DESC","View Category");
define("_MD_DOWNLOADFORM","Download");
define("_MD_DOWNLOADFORM_DESC","Select groups that are allowed to download");
define("_MD_ENTRYPERM","Permission to View Entry");

//**New since v.55
define("_MD_SHOWINFO","Show Information");
define("_MD_SHOWINFO_DSC","Select the infomation that should be displayed with the media entry.");
define("_MD_SHOWINFOBOX","Info Box On");
define("_MD_DOWNLOAD","Download");
define("_MD_DOWNLOAD_DSC","Yes to allow downloads.");
define("_MD_PAGELINK","Page");
define("_MD_EMBEDLINK","Embed");
define("_MD_STATISTICS","Statistics");
define("_MD_POSTERC","Poster: ");
define("_MD_POSTERTITLE","Media Show By %s");
define("_MD_POSTERVIEW","View All");
define("_MD_POSTERVIEW_DSC","View all by this poster.");
define("_MD_THEREAREBY","We have %s shows published by %s.");

//**New since v.57
define("_MD_TAGS","TAGS: ");
define("_MD_TAGS_DSC","Tag this entry with keywords.");
define("_MD_EMBEDLINKJS","Script");
define("_MD_SUBMIT_QUICK","Ouick Submit: ");
define("_MD_UTUBE_SUBMIT","YouTube");
define("_MD_UTUBE_URL","YouTube URL");
define("_MD_UTUBE_URL_DSC","Enter the URL of a YouTube video.<br />Format: http://www.youtube.com/watch?v=SpwlsCxY7vU");
define("_MD_PLAYER_ON","Play It!");
define("_MD_PLAYER_OFF","Player Off");
define("_MD_PAGE_VIEW","View Page");
define("_MD_CAPTCHA_INCORRECT","Incorrect Confirmation Code");
define("_MD_STATUSNOCACHE","Error: No Cache - Confirm that the media exist at the given location and refresh the playlist cache");
define("_MD_STATUSNOMEDIAURL","Media Location Error - Confirm that the media exist at the given location");
define("_MD_LOCATIONCHANGE","The media location has been changed");
define("_MD_STATUSEMPTYDIR","The media directory is empty");
define("_MD_STATUSNODIR","The media directory does not exist");
define("_MD_ALLOWCOMMENTS","Allow Comments");