<?php
// $Id: modinfo.php,v.50 2007/03/01 19:59:00 tcnet Exp $
// Module Info
if (!defined('XOOPS_ROOT_PATH')){ exit(); }
// The name of this module
define("_MI_WEBSHOW_NAME","Web Show");

// A brief description of this module
define("_MI_WEBSHOW_DESC","The Web Show module catalogs and plays Flash media files, directories and web feeds.");

// Names of blocks for this module (Not all module has blocks)
define("_MI_WEBSHOW_BNAME1","Playlist Links");
define("_MI_WEBSHOW_BNAME2","Play It");
define("_MI_WEBSHOW_BNAME3","Billboard");

// Sub menu titles
define("_MI_WEBSHOW_SMNAME1","Submit");
define("_MI_WEBSHOW_SMNAME2","Popular");
define("_MI_WEBSHOW_SMNAME3","Top Rated");

// Names of admin menu items
define("_MI_WEBSHOW_ADMENU1","Index");
define("_MI_WEBSHOW_ADMENU2","Category");
define("_MI_WEBSHOW_ADMENU3","Media");
define("_MI_WEBSHOW_ADMENU4","Player");
define("_MI_WEBSHOW_ADMENU5","Permissions");
define("_MI_WEBSHOW_ADMENU6","Submissions");
define("_MI_WEBSHOW_ADMENU7","Broken");
define("_MI_WEBSHOW_ADMENU8","Modify Request");
define("_MI_WEBSHOW_ADMENU9","Help");
define("_MI_WEBSHOW_ADMENU10","Module");

// Title of config items
define('_MI_WEBSHOW_POPULAR', 'Select the number of hits for links to be marked as popular.');
define('_MI_WEBSHOW_NEWLINKS', 'Select the maximum number of new listings displayed on top page.');
define('_MI_WEBSHOW_PERPAGE', 'Select the maximum number of listings displayed in each page.');
define('_MI_WEBSHOW_LOGOPATH','Path to logo: This folder must have write permission.');
define('_MI_WEBSHOW_LOGOWIDTH', 'Maximum allowed dimension of listing logo.');
define('_MI_WEBSHOW_LISTPATH','Path to Cached Playlist: This folder must have write permission.');
define('_MI_WEBSHOW_MEDIAPATH','Media directory name <br />Must be located in the webshow directory.');
define('_MI_WEBSHOW_MODDESC','Module description used on Index Page.');
define('_MI_WEBSHOW_TEMPLATE', 'Template Switch: The single link template will switch from a two column to single column format if the player width exceeds this value.');
define('_MI_WEBSHOW_CAPTCHA', 'CAPTCHA: Select Guest users only or All users to use Captcha in the frontside submit form.  Requires Frameworks.');
define('_MI_WEBSHOW_TAGS', 'TAGS: Select Yes to turn on Tags.<br />Requires Frameworks.');
define('_MI_WEBSHOW_TEXTEDITOR', 'Text Editor: Select a text editor.<br />Requires Frameworks and xoopseditors.');
define('_MI_WEBSHOW_KEYCOUNT', 'Metatag Keyword Quantity');
define('_MI_WEBSHOW_KEYLIMIT', 'Minimum Keyword Length');
define('_MI_WEBSHOW_KEYCOMMON', 'Common Word Filter');

// Description of each config items
define('_MI_WEBSHOW_POPULARDSC', '');
define('_MI_WEBSHOW_NEWLINKSDSC', '');
define('_MI_WEBSHOW_PERPAGEDSC', '');
define('_MI_WEBSHOW_LOGOPATHDSC','');
define('_MI_WEBSHOW_SHOTWIDTHDSC', '');
define('_MI_WEBSHOW_LISTPATHDSC','');
define('_MI_WEBSHOW_THEMEFROMPLAYERDSC', '');
define('_MI_WEBSHOW_MEDIAPATHDSC','');
define('_MI_WEBSHOW_MODDESCDSC','');
define('_MI_WEBSHOW_TEMPLATEDSC','');
define('_MI_WEBSHOW_KEYDSC','');

// Text for notifications
define('_MI_WEBSHOW_GLOBAL_NOTIFY', 'Global');
define('_MI_WEBSHOW_GLOBAL_NOTIFYDSC', 'Global links notification options.');

define('_MI_WEBSHOW_CATEGORY_NOTIFY', 'Category');
define('_MI_WEBSHOW_CATEGORY_NOTIFYDSC', 'Notification options that apply to the current category.');

define('_MI_WEBSHOW_LINK_NOTIFY', 'Media Entry');
define('_MI_WEBSHOW_LINK_NOTIFYDSC', 'Notification options that aply to the current media entry.');

define('_MI_WEBSHOW_GLOBAL_NEWCATEGORY_NOTIFY', 'New Category');
define('_MI_WEBSHOW_GLOBAL_NEWCATEGORY_NOTIFYCAP', 'Notify me when a new category is created.');
define('_MI_WEBSHOW_GLOBAL_NEWCATEGORY_NOTIFYDSC', 'Receive notification when a new category is created.');
define('_MI_WEBSHOW_GLOBAL_NEWCATEGORY_NOTIFYSBJ', '[{X_SITENAME}] {X_MODULE} auto-notify : New category');

define('_MI_WEBSHOW_GLOBAL_LINKMODIFY_NOTIFY', 'Entry Modification Requested');
define('_MI_WEBSHOW_GLOBAL_LINKMODIFY_NOTIFYCAP', 'Notify me of any entry modification request.');
define('_MI_WEBSHOW_GLOBAL_LINKMODIFY_NOTIFYDSC', 'Receive notification when any entry modification request is submitted.');
define('_MI_WEBSHOW_GLOBAL_LINKMODIFY_NOTIFYSBJ', '[{X_SITENAME}] {X_MODULE} auto-notify : Entry Modification Requested');

define('_MI_WEBSHOW_GLOBAL_LINKBROKEN_NOTIFY', 'Broken Link Submitted');
define('_MI_WEBSHOW_GLOBAL_LINKBROKEN_NOTIFYCAP', 'Notify me of any broken link report.');
define('_MI_WEBSHOW_GLOBAL_LINKBROKEN_NOTIFYDSC', 'Receive notification when any broken link report is submitted.');
define('_MI_WEBSHOW_GLOBAL_LINKBROKEN_NOTIFYSBJ', '[{X_SITENAME}] {X_MODULE} auto-notify : Broken Link Reported');

define('_MI_WEBSHOW_GLOBAL_LINKSUBMIT_NOTIFY', 'New Media Entry Submitted');
define('_MI_WEBSHOW_GLOBAL_LINKSUBMIT_NOTIFYCAP', 'Notify me when any new media entry is submitted (awaiting approval).');
define('_MI_WEBSHOW_GLOBAL_LINKSUBMIT_NOTIFYDSC', 'Receive notification when any new media entry is submitted (awaiting approval).');
define('_MI_WEBSHOW_GLOBAL_LINKSUBMIT_NOTIFYSBJ', '[{X_SITENAME}] {X_MODULE} auto-notify : New media entry submitted');

define('_MI_WEBSHOW_GLOBAL_NEWLINK_NOTIFY', 'New Media Entry');
define('_MI_WEBSHOW_GLOBAL_NEWLINK_NOTIFYCAP', 'Notify me when any new media entry is posted.');
define('_MI_WEBSHOW_GLOBAL_NEWLINK_NOTIFYDSC', 'Receive notification when any new media entry is posted.');
define('_MI_WEBSHOW_GLOBAL_NEWLINK_NOTIFYSBJ', '[{X_SITENAME}] {X_MODULE} auto-notify : New media entry');

define('_MI_WEBSHOW_CATEGORY_LINKSUBMIT_NOTIFY', 'New Media Entry Submitted');
define('_MI_WEBSHOW_CATEGORY_LINKSUBMIT_NOTIFYCAP', 'Notify me when a new media entry is submitted (awaiting approval) to the current category.');
define('_MI_WEBSHOW_CATEGORY_LINKSUBMIT_NOTIFYDSC', 'Receive notification when a new link is submitted (awaiting approval) to the current category.');
define('_MI_WEBSHOW_CATEGORY_LINKSUBMIT_NOTIFYSBJ', '[{X_SITENAME}] {X_MODULE} auto-notify : New media entry submitted in category');

define('_MI_WEBSHOW_CATEGORY_NEWLINK_NOTIFY', 'New Media Entry');
define('_MI_WEBSHOW_CATEGORY_NEWLINK_NOTIFYCAP', 'Notify me when a new media entry is posted to the current category.');
define('_MI_WEBSHOW_CATEGORY_NEWLINK_NOTIFYDSC', 'Receive notification when a new link is posted to the current category.');
define('_MI_WEBSHOW_CATEGORY_NEWLINK_NOTIFYSBJ', '[{X_SITENAME}] {X_MODULE} auto-notify : New media entry in category');

define('_MI_WEBSHOW_LINK_APPROVE_NOTIFY', 'Media Entry Approved');
define('_MI_WEBSHOW_LINK_APPROVE_NOTIFYCAP', 'Notify me when this media entry is approved.');
define('_MI_WEBSHOW_LINK_APPROVE_NOTIFYDSC', 'Receive notification when this media entry is approved.');
define('_MI_WEBSHOW_LINK_APPROVE_NOTIFYSBJ', '[{X_SITENAME}] {X_MODULE} auto-notify : Media Entry approved');
?>
