<?php
// $Id: index.php,v.50 2007/03/01 19:59:00 tcnet Exp $ //
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
// ------------------------------------------------------------------------- //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //
include "header.php";
$xoopsOption['template_main'] = 'webshow_poster.html';
$myts =& MyTextSanitizer::getInstance(); // MyTextSanitizer object
include XOOPS_ROOT_PATH."/header.php";
include_once XOOPS_ROOT_PATH."/class/xoopstree.php";
$mytree = new XoopsTree($xoopsDB->prefix("webshow_cat"),"cid","pid");
$xoopsTpl->assign('ws_name', $xoopsModule->getVar('name'));
$metakey = "";//Collects keyword content
$displaylid="";
$count = 1;

$uid = isset($_GET['uid']) ? intval($_GET['uid']) : '';
if($uid == ""){
redirect_header("javascript:history.go(-1)", 2, _MD_NOTEXIST);
}

$submittername = xoops_getLinkedUnameFromId($uid);  
$xoopsTpl->assign('submittername', $submittername);
$xoopsTpl->assign('submitterid', $uid);
$xoopsTpl->assign('ws_pagetitle',sprintf(_MD_POSTERTITLE,$submittername));

if (isset($_GET['show'])) {
        $show = intval($_GET['show']);
} else {
        $show = $xoopsModuleConfig['perpage'];
}
$min = isset($_GET['min']) ? intval($_GET['min']) : 0;
if (!isset($max)) {
        $max = $min + $show;
}
if(isset($_GET['orderby'])) {
   $orderby = convertorderbyin($_GET['orderby']);
} else {
    $orderby = "date DESC";
}

//** Link Listing
$numrows="";
$fullcountresult=$xoopsDB->query("select count(*) from ".$xoopsDB->prefix("webshow_links")." where submitter=".$uid." and cid>0 and status>0");
list($numrows) = $xoopsDB->fetchRow($fullcountresult);
$page_nav = '';
if($numrows == 0){
   redirect_header("javascript:history.go(-1)", 1, _MD_NOTEXIST);
}

   $xoopsTpl->assign('show_links', true);
   $xoopsTpl->assign('thereareby', sprintf(_MD_THEREAREBY,$numrows, $submittername));
   //if 2 or more items in result, show the sort menu
   if($numrows>1) {
      $xoopsTpl->assign('show_nav', true);
      $orderbyTrans = convertorderbytrans($orderby);
      $xoopsTpl->assign('lang_cursortedby', sprintf(_MD_CURSORTEDBY, convertorderbytrans($orderby)));
   }

   //** ENTRY LOOP
   $sql = "select l.lid, l.cid, l.title, l.url, l.listurl, l.srctype, l.listtype, l.listcache, l.logourl, l.submitter, l.status, l.date, l.hits, l.rating, l.votes, l.entryperm, t.description from ".$xoopsDB->prefix("webshow_links")." l, ".$xoopsDB->prefix("webshow_text")." t where l.submitter=".$uid." and l.status>0 and l.cid>0 and l.lid=t.lid order by $orderby";
   $result=$xoopsDB->query($sql,$show,$min);
   while(list($lid, $cid, $title, $url, $listurl, $srctype, $listtype, $listcache, $logourl, $submitter, $status, $time, $hits, $rating, $votes, $ws_entryperm, $description) = $xoopsDB->fetchRow($result)) {
      //**Permissions
      $groups = is_object($xoopsUser) ? $xoopsUser->getGroups() : XOOPS_GROUP_ANONYMOUS;
      $gperm_handler =& xoops_gethandler('groupperm');
      // example checkRight($gperm_name, $gperm_itemid, $gperm_groupid, $gperm_modid = 1)
      if ($gperm_handler->checkRight('webshow_view', $cid, $groups, $xoopsModule->getVar('mid'))) {
         //** Entry Permission
         $group = is_object($xoopsUser) ? $xoopsUser->getGroups() : array(XOOPS_GROUP_ANONYMOUS);
         $ws_entryperm = explode(" ",$ws_entryperm);
         if (count(array_intersect($group,$ws_entryperm)) > 0) {
            $path = $mytree->getNicePathFromId($cid, "cattitle", "viewcat.php?");
            $new = newlinkgraphic($time, $status);
            $pop = popgraphic($hits);
            $ltitle = $myts->makeTboxData4Show($title);	
            $title = $ltitle.$new.$pop;     
            $title = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/singlelink.php?lid=".$lid."\" target=\"_self\" title=\""._MD_VIEWLISTING." - ".$ltitle."\">".$title."</a>";
            $url = $myts->makeTboxData4Show($url);
            $listurl = $myts->makeTboxData4Show($listurl);
            if($listtype == "dir") { 
               $listurl =  XOOPS_URL."/modules/".$xoopsModule->getVar("dirname")."/playlist/".$listcache;
            }

            //** Block Description
            $description = $myts->makeTareaData4Show($description,0);
            $metadesc = strip_tags($description);

            //**ADMIN
            if ($xoopsUser && $xoopsUser->isAdmin($xoopsModule->mid())) {
               $isadmin = true;
               $adminlink = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/admin/index.php?op=modLink&amp;lid=".$lid."\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/editicon.gif\" border=\"0\" alt=\""._MD_EDITTHISLINK."\" /></a>";
            } else {
               $isadmin = false;
               $adminlink = "";   
            }

            //** ENTRY LOGO
            if($logourl != ""){
               $ps = strpos($logourl,"http://");
               if($ps === false) {
                  $logourl = XOOPS_URL."/".$xoopsModuleConfig['path_logo']."/".$logourl;
               }
               $logourl = $myts->makeTboxData4Show($logourl);
            }else{
               $logourl = "";
            }

            //STATISTICS
            $updated = formatTimestamp($time,"m");
            if ($votes == 1) {
              $votestring = _MD_ONEVOTE;
            } else {
              $votestring = sprintf(_MD_NUMVOTES,$votes);
            } 

            //** SUBMITTER
            $submittername = xoops_getLinkedUnameFromId($submitter);

            //** POPUP PLAYER BUTTON
            //** Java script opens popmovie.php in a new window.
            $popbutton = "<span onClick= \"window.open('popmovie.php?lid=".$lid."','popmovie".$lid."','directories=no,toolbar=no,location=no,menubar=no');return false;\" style=\"cursor:hand;\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/popbutton.png\" alt=\"".$ltitle." "._MD_POPUP." "._MD_PLAYER."\" /></span>";

            //** Link Array for loop
            $metakey .= $ltitle." ".strip_tags($description)." "; //Collect meta keywords.
            $xoopsTpl->append('links', array('id' => $lid, 'cid' => $cid, 'rating' => number_format($rating, 2), 'ltitle' => $ltitle, 'title' => $title, 'category' => $path, 'url' => $myts->makeTboxData4Show($url), 'listurl' => $myts->makeTboxData4Show($listurl), 'srctype' => $myts->makeTboxData4Show($srctype), 'logourl' => $myts->makeTboxData4Show($logourl), 'popbutton' => $popbutton, 'updated' => formatTimestamp($time,"m"), 'description' => $myts->makeTareaData4Show($description,0), 'adminlink' => $adminlink, 'hits' => $hits, 'votes' => $votestring, 'mail_subject' => rawurlencode(sprintf(_MD_INTRESTLINK,$xoopsConfig['sitename'])), 'mail_body' => rawurlencode(sprintf(_MD_INTLINKFOUND,$xoopsConfig['sitename']).':  '.XOOPS_URL.'/modules/'.$xoopsModule->getVar("dirname").'/singlelink.php?cid='.$cid.'&amp;lid='.$lid)));
         }
      }
   }

   $orderby = convertorderbyout($orderby);
   //Calculates how many pages exist.  Which page one should be on, etc...
   $linkpages = ceil($numrows / $show);
   //Page Numbering
   if ($linkpages!=1 && $linkpages!=0) {
      $uid = intval($_GET['uid']);
      $xoopsTpl->assign('lang_pagenav',_MD_PAGENAV);			
      $prev = $min - $show;
      if ($prev>=0) {
         $page_nav .= "<a href='poster.php?uid=$uid&amp;min=$prev&amp;orderby=$orderby&amp;show=$show'><b><u>&laquo;</u></b></a>&nbsp;";
      }
      $counter = 1;
      $currentpage = ($max / $show);
      while ( $counter<=$linkpages ) {
         $mintemp = ($show * $counter) - $show;
         if ($counter == $currentpage) {
            $page_nav .= "<b>($counter)</b>&nbsp;";
         } else {
            $page_nav .= "<a href='poster.php?uid=$uid&amp;min=$mintemp&amp;orderby=$orderby&amp;show=$show'>$counter</a>&nbsp;";
         }
         $counter++;
      }
      if ( $numrows>$max ) {
         $page_nav .= "<a href='poster.php?uid=$uid&amp;min=$max&amp;orderby=$orderby&amp;show=$show'>";
         $page_nav .= "<b><u>&raquo;</u></b></a>";
      }
   }
   $xoopsTpl->assign('page_nav', $page_nav);

   //** Select Menu
   ob_start();
   //** Example makeMySelBox($title,$order="",$preset_id=0, $none=0, $sel_name="", $onchange="")	
   $cattree = new XoopsTree($xoopsDB->prefix("webshow_cat"),"cid","pid");
   $cattree->makeMySelBox("cattitle","cattitle",$cid,0,"cid", 'window.location="viewcat.php?cid="+this.value');	
   $catselbox = ob_get_contents();	
   ob_end_clean();
   $xoopsTpl->assign('category_select', $catselbox);

   //** Main Path
   $pathstring = "<a href=\"index.php\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/home.png\" border=\"0\" alt=\""._MD_MAIN."\" />" ._MD_MAIN."</a>&nbsp;:&nbsp;";
   $xoopsTpl->assign('main_path', $pathstring);

   //** METATAGS modified from code by Xoops-France & Herv Thouzard
   // Page Title 
   $metatitle = strip_tags(sprintf(_MD_POSTERTITLE,$submittername));
   $metatitle = $myts->makeTboxData4Show($metatitle);
   $xoopsTpl->assign('xoops_pagetitle',$metatitle); 

   // Meta Description
   $metadesc = strip_tags(sprintf(_MD_THEREAREBY,$numrows, $submittername));
   $metadesc = $myts->makeTboxData4Show($metadesc);

   // Meta Keywords
   include_once XOOPS_ROOT_PATH . '/modules/'.$xoopsModule->getVar('dirname').'/include/functions.php';
   $metakey = webshow_extract_keywords($metatitle." ".$metadesc." ".$metakey);

   //** Assign meta tags 
   if (is_object($xoTheme)) { 
      $xoTheme->addMeta( 'meta', 'keywords',$metakey);
      $xoTheme->addMeta( 'meta', 'description',$metadesc);     
      $xoTheme->addMeta( 'meta', 'title', $metatitle); 
   } else { 
      $xoopsTpl->assign('xoops_meta_keywords',$metakey);
      $xoopsTpl->assign('xoops_meta_description',$metadesc);       
   } 

include XOOPS_ROOT_PATH.'/footer.php';
?>