<?php
// $Id: ratelink.php,v.50 2007/03/01 19:59:00 tcnet Exp $ //
// Flash Media Player by Jereon Wijering ( http://www.jeroenwijering.com ) is licensed under a Creative Commons License (http://creativecommons.org/licenses/by-nc-sa/2.0/) //
// It allows you to use and modify the script for noncommercial purposes. //
// You must share a like any modifications. // 
// For commercial use you must purchase a license from Jereon Wijering at http://www.jeroenwijering.com/?order=form. //
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //
include "header.php";
include_once XOOPS_ROOT_PATH."/class/module.errorhandler.php";
$myts =& MyTextSanitizer::getInstance(); // MyTextSanitizer object
if (!empty($_POST['submit'])) {
$eh = new ErrorHandler; //ErrorHandler object
if(empty($xoopsUser)){
$ratinguser = 0;
}else{
$ratinguser = $xoopsUser->getVar('uid');
}
//Make sure only 1 anonymous from an IP in a single day.
$anonwaitdays = 1;
$ip = getenv("REMOTE_ADDR");
$lid = intval($_GET['lid']);
$cid = intval($_POST['cid']);
$rating = intval($_POST['rating']);
// Check if Rating is Null
if ($rating=="--") {
redirect_header("ratelink.php?cid=".$cid."&amp;lid=".$lid."",4,_MD_NORATING);
exit();
}
// Check if Link POSTER is voting (UNLESS Anonymous users allowed to post)
if ($ratinguser != 0) {
$result=$xoopsDB->query("select submitter from ".$xoopsDB->prefix("webshow_links")." where lid=$lid");
while(list($ratinguserDB) = $xoopsDB->fetchRow($result)) {
if ($ratinguserDB == $ratinguser) {
redirect_header("index.php",4,_MD_CANTVOTEOWN);
exit();
}
}
// Check if REG user is trying to vote twice.
$result=$xoopsDB->query("select ratinguser from ".$xoopsDB->prefix("webshow_votedata")." where lid=$lid");
while(list($ratinguserDB) = $xoopsDB->fetchRow($result)) {
if ($ratinguserDB == $ratinguser) {
redirect_header("index.php",4,_MD_VOTEONCE2);
exit();
}
}
} else {
// Check if ANONYMOUS user is trying to vote more than once per day.
$yesterday = (time()-(86400 * $anonwaitdays));
$result=$xoopsDB->query("select count(*) FROM ".$xoopsDB->prefix("webshow_votedata")." WHERE lid=$lid AND ratinguser=0 AND ratinghostname = '$ip' AND ratingtimestamp > $yesterday");
list($anonvotecount) = $xoopsDB->fetchRow($result);
if ($anonvotecount > 0) {
redirect_header("index.php",4,_MD_VOTEONCE2);
exit();
}
}
if($rating > 10){
$rating = 10;
}
//All is well.  Add to Line Item Rate to DB.
$newid = $xoopsDB->genId($xoopsDB->prefix("webshow_votedata")."_ratingid_seq");
$datetime = time();
$sql = sprintf("INSERT INTO %s (ratingid, lid, ratinguser, rating, ratinghostname, ratingtimestamp) VALUES (%u, %u, %u, %u, '%s', %u)", $xoopsDB->prefix("webshow_votedata"), $newid, $lid, $ratinguser, $rating, $ip, $datetime);
$xoopsDB->query($sql) or $eh->show("0013");
//All is well.  Calculate Score & Add to Summary (for quick retrieval & sorting) to DB.
updaterating($lid);
$ratemessage = _MD_VOTEAPPRE."<br />".sprintf(_MD_THANKURATE,$xoopsConfig[sitename]);
redirect_header("index.php",2,$ratemessage);
exit();
} else {
$xoopsOption['template_main'] = 'webshow_ratelink.html';
include XOOPS_ROOT_PATH."/header.php";
$lid = intval($_GET['lid']);
$cid = intval($_GET['cid']);

$result=$xoopsDB->query("select title from ".$xoopsDB->prefix("webshow_links")." where lid=$lid");
list($title) = $xoopsDB->fetchRow($result);
$xoopsTpl->assign('link', array('id' => $lid, 'cid' => $cid, 'title' => $myts->makeTboxData4Show($myts->htmlSpecialChars($title))));

 //** META TAGS
//** Title
$metatitle =  $myts->makeTboxData4Show(_MD_RATETHISSITE). ' ' . $myts->makeTboxData4Show($xoopsModule->getVar('name'));
$xoopsTpl->assign('xoops_pagetitle',$metatitle); 
// Description from module config description
$metadesc = $metatitle." ".$myts->makeTareaData4Show($xoopsModuleConfig['moddesc'],0);
// Keywords
include_once XOOPS_ROOT_PATH . '/modules/'.$xoopsModule->getVar('dirname').'/include/functions.php';
$metakey = webshow_extract_keywords($metadesc);
//** Assign meta tags 
   if (is_object($xoTheme)) { 
    $xoTheme->addMeta( 'meta', 'keywords',$metakey);
    $xoTheme->addMeta( 'meta', 'description',$metadesc);     
    $xoTheme->addMeta( 'meta', 'title', $metatitle); 
    } else { 
    $xoopsTpl->assign('xoops_meta_keywords',$keywords);
    $xoopsTpl->assign('xoops_meta_description',$metadesc);       
    }  
	
include XOOPS_ROOT_PATH.'/footer.php';
}
?>
