<?php
// $Id: singlelink.php,v.50 2007/03/01 19:59:00 tcnet Exp $ //
// Flash Media Player by Jereon Wijering ( http://www.jeroenwijering.com ) is licensed under a Creative Commons License (http://creativecommons.org/licenses/by-nc-sa/2.0/) //
// It allows you to use and modify the script for noncommercial purposes. //
// You must share a like any modifications. // 
// For commercial use you must purchase a license from Jereon Wijering at http://www.jeroenwijering.com/?order=form. //
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //
//** singlelink.php displays the catalog entry, text body and flash player.

include "header.php";
$xoopsOption['template_main'] = 'webshow_singlelink.html';
include XOOPS_ROOT_PATH."/header.php";
include_once XOOPS_ROOT_PATH."/class/xoopstree.php";
$mytree = new XoopsTree($xoopsDB->prefix("webshow_cat"),"cid","pid");
$myts =& MyTextSanitizer::getInstance();// MyTextSanitizer object
$xoopsTpl->assign('ws_name', $xoopsModule->getVar('name'));
$metakey = ""; //Collects content for keyword search

if ($xoopsUser && $xoopsUser->isAdmin($xoopsModule->mid())) { 
   $isadmin = true;
} else {
   $isadmin = false;
}

$lid = isset($_GET['lid']) ? intval($_GET['lid']) : ' ';

//** Get the entry data.
$result = $xoopsDB->query("select l.lid, l.cid, l.title, l.url, l.srctype, l.listtype, l.listurl, l.showinfo, l.listcache, l.cachetime, l.logourl, l.artist, l.album, l.label, l.submitter, l.status, l.date, l.hits, l.rating, l.votes, l.comments, l.player, l.chain, l.entryperm, t.description, t.bodytext from ".$xoopsDB->prefix("webshow_links")." l, ".$xoopsDB->prefix("webshow_text")." t where l.lid=$lid and l.lid=t.lid");
list($lid, $cid, $title, $url, $srctype, $listtype, $listurl, $showinfo, $listcache, $cachetime, $logourl, $artist, $album, $label, $submitter, $status, $time, $hits, $rating, $votes, $comments, $player, $chainid, $ws_entryperm, $description, $bodytext) = $xoopsDB->fetchRow($result);

//** Offline Entry
// Redirects if status is less than 1 and user is not admin. Allows admin to view offline entry.
if($status <= 0 && !$isadmin){
redirect_header("javascript:history.go(-1)",2,_MD_NOTEXIST);
}

//** Category Permission
    $groups = is_object($xoopsUser) ? $xoopsUser->getGroups() : XOOPS_GROUP_ANONYMOUS;
    $gperm_handler =& xoops_gethandler('groupperm');
    // example checkRight($gperm_name, $gperm_itemid, $gperm_groupid, $gperm_modid = 1)
    if (!$gperm_handler->checkRight('webshow_view', $cid, $groups, $xoopsModule->getVar('mid'))) {
        redirect_header("javascript:history.go(-1)", 3, _NOPERM);
        exit();
    }

//** Category Select
ob_start();
//** example makeMySelBox($title,$order="",$preset_id=0, $none=0, $sel_name="", $onchange="")	
$mytree->makeMySelBox("cattitle","cattitle",$cid,0,"cid",'window.location="viewcat.php?cid="+this.value');	
$catselbox = ob_get_contents();
ob_end_clean();	
$xoopsTpl->assign('category_select', $catselbox);		

//** Category Image
$result=$xoopsDB->query("SELECT cattitle, imgurl FROM ".$xoopsDB->prefix("webshow_cat")." WHERE cid = $cid ");
list($cattitle, $imgurl) = $xoopsDB->fetchRow($result);
	if ($imgurl != ""){
	   //$imgurl = $myts->makeTboxData4Edit($imgurl);
         $category_image = "<img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/category/".$imgurl."\" border=\"0\" alt=\"".$cattitle."\" />";		
	} else {
	$category_image = "";
	}
$cattitle = $myts->makeTboxData4Show($cattitle);	
$xoopsTpl->assign('cattitle', $cattitle);

//** Path Links - Breadcrumb
$mainpath = "<a href=\"index.php\" title=\"".$xoopsModule->getVar('name')." "._MD_MAIN."\" /><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/home.png\" border=\"0\" alt=\""._MD_MAIN."\">" .$xoopsModule->getVar('name')."</a>:&nbsp;";
$xoopsTpl->assign('main_path', $mainpath);
$catpath = $category_image."<a href=\"viewcat.php?cid=".$cid."\" title=\"".$cattitle."\">".$cattitle."</a>:&nbsp;";
$xoopsTpl->assign('category_path', $catpath);

$path = $mytree->getPathFromId($cid, "cattitle");
$path = substr($path, 1);
$path = str_replace("/"," <img src='".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/arrow.gif' border='0' alt=''> ",$path);

//** Entry Permission
$group = is_object($xoopsUser) ? $xoopsUser->getGroups() : array(XOOPS_GROUP_ANONYMOUS);
$ws_entryperm = explode(" ",$ws_entryperm);
if (count(array_intersect($group,$ws_entryperm)) < 1)
{
        redirect_header("javascript:history.go(-1)", 3, _NOPERM);
        exit();
}

$ltitle = $myts->makeTboxData4Show($title);
$new = newlinkgraphic($time, $status);
$pop = popgraphic($hits);
$title = $ltitle.$new.$pop;
if ($url !="") {
$title = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/visit.php?cid=".$cid."&amp;lid=".$lid."\" target=\"_blank\" title=\""._MD_VISIT." ".$ltitle." "._MD_WEBSITE."\">".$title."</a>";
}
$url = $myts->makeTboxData4Show($url);
$listurl = $myts->makeTboxData4Show($listurl);

//**Set listurl to listcache for directory to cloak the directory location.
if($listtype == "dir") { 
  $listurl =  XOOPS_URL."/modules/".$xoopsModule->getVar("dirname")."/playlist/".$listcache;
}

//** PLAYLIST CHAIN
if($chainid != 0) {
//** Get chain data
$chainresult = $xoopsDB->query("select l.cid, l.title, l.srctype, l.listtype, l.listurl, l.listcache, l.logourl, l.player, t.description from ".$xoopsDB->prefix("webshow_links")." l, ".$xoopsDB->prefix("webshow_text")." t where l.lid=$chainid and l.lid=t.lid and status>0");
list($chaincid, $chaintitle, $chainsrctype, $chainlisttype, $chainlisturl, $chainlistcache, $chainlogourl, $chainplayer, $chaindescription) = $xoopsDB->fetchRow($chainresult);
$xoopsTpl->assign('chain', array('id' => $chainid, 'cid' => $chaincid, 'ltitle' => $myts->makeTboxData4Show($chaintitle), 'description' => $myts->makeTareaData4Show($chaindescription,0)));
}

//** LOAD MEDIA PLAYERS 
$styleoption = ""; 
include "include/movie.php";
$xoopsTpl->assign('movie',$movie);
$xoopsTpl->assign('chainmovie',$chainmovie);
$xoopsTpl->assign('themefromplayer',$themefromplayer);

//** ADMIN
if ($isadmin == true) {
   $adminlink = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/admin/index.php?op=modLink&amp;lid=".$lid."\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/editicon.gif\" border=\"0\" alt=\""._MD_EDITTHISLINK."\" /></a>";

$admintable = "<div style='width: 99%; text-align:center;'>
<table class='outer' style=\"font-size: 90%;\">
<th colspan='2'>"._MD_ADMINTABLE."</th>
<tr class='head' colspan='2'><td>"._MD_STATUS."</td><td>"._MD_STATUSREPORT."</td></tr>";

if($status != 1){
      if($status == 0){
         $statusreport = _MD_STATUSREPORT._MD_STATUSWAITING;
         $statuslink = "admin/index.php?op=listNewLinks";
         $statusicon = "waiting.gif";   
      }
      if($status == -1){
         $statusreport = _MD_STATUSREPORT._MD_STATUSAUTO;
         $statuslink = "admin/index.php?op=modLink&amp;lid=".$lid;
         $statusicon = "offline.gif";   
      }
      if($status == -2){
         $statusreport = _MD_STATUSREPORT._MD_STATUSEXPIRED;
         $statuslink = "admin/index.php?op=modLink&amp;lid=".$lid;
         $statusicon = "offline.gif";
      } 
      if($status == -3){
         $statusreport = _MD_STATUSNOMEDIAURL;
         $statuslink = "admin/index.php?op=modLink&amp;lid=".$lid;
         $statusicon = "offline.gif";    
      }
      if($status == -4){
         $statusreport = _MD_STATUSNOCACHE;
         $statuslink = "admin/index.php?op=modLink&amp;lid=".$lid;
         $statusicon = "offline.gif";    
      }   
   $admintable .= "<tr colspan='2'>
   <td class = 'even'><a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/".$statuslink."\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/".$statusicon."\"></a></td>
   <td class = 'odd'>
   <a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/".$statuslink."\">".$statusreport."</a>     
   </td></tr>";     				 
}

//Cache Report is a message for admin from playlist.php cache process.
if($cachereport){
   $admintable .= "<tr colspan='2'>
   <td class = 'even'><a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/admin/index.php?op=modLink&amp;lid=".$lid."\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/".$statusicon."\"></a></td>
   <td class = 'odd'>
   <a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/admin/index.php?op=modLink&amp;lid=".$lid."\">".$cachereport."</a>     
   </td></tr>";
}

//** MOD REQUESTED
$modresult = $xoopsDB->query("COUNT * FROM ".$xoopsDB->prefix("webshow_mod")." WHERE lid=$lid");      
if($modresult !=""){
   $admintable .= "<tr colspan='2'>
   <td class = 'even'><a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/admin/index.php?op=listModReq\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/online.gif\"></a></td>
   <td class = 'odd'>
   <a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/admin/index.php?op=listModReq\">"._MD_USERMODREQ."</a>     
   </td></tr>";     				 
}

$admintable .= "</table></div><br />";
$xoopsTpl->assign('admintable', $admintable);  
} else {
   $adminlink = "";
   $admintable = "";
}

//** MODIFY LINK. Display to admin and submitter only.
if ($xoopsUser) {
$user = $xoopsUser->getVar('uid');
   if ($user == $submitter | $isadmin) {
       $modlink = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/modlink.php?lid=".$lid."\" title=\""._MD_MODIFY."\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/modify.gif\" border=\"0\" alt=\""._MD_MODIFY."\" /></a>";  
   } else {
       $modlink = "";
   }
}

//** SHOWINFO  Displays selected information.
$showinfo = explode('|', $showinfo);

//** INFORMATION BOX OFF
$infobox = 1;
if ($showinfo[0] != 1) {
   $infobox="";
}

//** Block Description
$description = $myts->makeTareaData4Show($description,0);
$metadesc = strip_tags($description);
if(!$showinfo[1]){
   $description = "";
}

//** ENTRY LOGO
if($showinfo[2] == 1 & $logourl != ""){
   $ps = strpos($logourl,"http://");
   if($ps === false) {
      $logourl = XOOPS_URL."/".$xoopsModuleConfig['path_logo']."/".$logourl;
   }
   $logourl = $myts->makeTboxData4Show($logourl);
}else{
$logourl = "";
}

//** CREDITS (C) //Needs work for enablejs
if($showinfo[3] == 1){
  //** Javascript enabled.  If enablejs is true in movie.php then include/mplayjs.inc.php.  Replaces credits from db with credits from xml playlist.
  if($mplayjs !="") {
     $xoopsTpl->assign('mplayjs',$mplayjs);
  }else{
     $artist = $myts->makeTboxData4Show($artist);
     $album = $myts->makeTboxData4Show($album);
     $label = $myts->makeTboxData4Show($label);
  }
}else{
  $artist = "";
  $album = "";
  $label = "";
} 

//STATISTICS
if($showinfo[4] == 1){
$updated = formatTimestamp($time,"m");
   if ($votes == 1) {
        $votestring = _MD_ONEVOTE;
   } else {
        $votestring = sprintf(_MD_NUMVOTES,$votes);
   } 
}else{
$hits = "";
$votestring = "";
$updated = "";
}

//** SUBMITTER
$submittername = "";
if($showinfo[5] == 1){
   $submittername = xoops_getLinkedUnameFromId($submitter);
}

//** PAGE LINK
$pagelink = "";
if($showinfo[6] == 1){
$pagelink = 1;
}

//** WEB SITE LINK & BUTTON
$sitelink = "";
$sitebutton = "";
if($showinfo[7] == 1 &&$url !="" ){
   $sitelink = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/visit.php?cid=".$cid."&amp;lid=".$lid."\" target=\"_blank\" title=\""._MD_VISIT." "._MD_WEBSITE.": ".$url."\">"._MD_WEBSITE."</a>";
   $sitebutton = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/visit.php?cid=".$cid."&amp;lid=".$lid."\" target=\"_blank\" title=\""._MD_VISIT." "._MD_WEBSITE.": ".$url."\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/link.gif\" border=\"0\" alt=\""._MD_VISIT." "._MD_WEBSITE." ".$url."\"> </a>";
}

//** EMBED LINK BOX
//if $listurl is from this domain, show embed link
$embed = "";
$embedjs = "";
if($showinfo[8] == 1){
   $ps = strpos(strtolower($listurl), XOOPS_URL); //Embed link for local media only.
   if (!($ps === false)) {
      $embed = "<object codebase=\"http://fpdownload.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=8,0,0,0\" width=\"".$width."\" height=\"".$height."\" classid=\"clsid:d27cdb6e-ae6d-11cf-96b8-444553540000\">
      <param value=\"".XOOPS_URL."/modules/".$xoopsModule->getVar("dirname")."/mediaplayer.swf\" name=\"movie\" />
      <param value=\"false\" name=\"menu\" />
      <param value=\"low\" name=\"quality\" />
      <param value=\"file=".$listurl."&amp;autostart=false&amp;displayheight=".$displayheight."&amp;displaywidth=".$displaywidth."\" name=\"flashvars\" /></object>";
      //** Embed javascript
      $embedjs = htmlEntities($movie);
   }
}
   
//** DOWNLOAD LINK AND BUTTON.  For single file entry only.  Other entries use web feed link and button instead.
$downlink = "";
$downbutton = "";
if($showinfo[9] == 1){
//** Download Permission
$groups = is_object($xoopsUser) ? $xoopsUser->getGroups() : XOOPS_GROUP_ANONYMOUS;
$gperm_handler =& xoops_gethandler('groupperm');
   if ($gperm_handler->checkRight('webshow_download', $cid, $groups, $xoopsModule->getVar('mid'))) {    
      if($listtype == "single"){
         //** If the file is from the wf downloads module.
         $searchstring = strToLower($listurl);
         $searchpattern = "wfdownloads/visit";
         $wfdwnok = strpos($searchstring,$searchpattern);
         if($wfdwnok != ""){
            $downlink = "<a href=\"#\" title=\"".$ltitle." "._MD_DOWNLOAD."\" onClick= \"location='".$listurl."'\">"._MD_DOWNLOAD."</a>";
            $downbutton = "<a href=\"#\" title=\"".$ltitle." "._MD_DOWNLOAD."\" onClick= \"location='".$listurl."'\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/download.png\" border=\"0\" alt=\"".$ltitle." "._MD_DOWNLOAD."\" /> </a>"; 
         } else {
            //** Allowed file extensions
            //$allowext = " mp3 | jpg | gif | png | swf | flv";
            //$ext = strToLower(substr($listurl,strlen($listurl)-3, 3));
            //$extok = strpos($allowext,$ext);
            //if($extok != ""){
               $downlink = "<a href=\"#\" title=\"".$ltitle." "._MD_DOWNLOAD."\" onClick= \"location='".XOOPS_URL."/modules/".$xoopsModule->getVar("dirname")."/wsdwnlod.php?lid=".$lid."'\">"._MD_DOWNLOAD."</a>";
               $downbutton = "<a href=\"#\" title=\"".$ltitle." "._MD_DOWNLOAD."\" onClick= \"location='".XOOPS_URL."/modules/".$xoopsModule->getVar("dirname")."/wsdwnlod.php?lid=".$lid."'\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/download.png\" border=\"0\" alt=\"".$ltitle." "._MD_DOWNLOAD."\" /> </a>"; 
            //}
         }     
      } 
   }
}
       
//** WEB FEED LINK & BUTTON
$feedlink = "";
$feedbutton = "";
if($showinfo[9] == 1 && $listtype != "single") {
  $feedlink = "<a href=\"".$listurl."\" target=\"_blank\" title=\"".$ltitle." "._MD_WEBFEED."\">"._MD_WEBFEED."</a>"; 
  $feedbutton = "<a href=\"".$listurl."\" target=\"_blank\" title=\"".$ltitle." "._MD_WEBFEED."\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/webfeed.png\" border=\"0\" alt=\"".$ltitle." "._MD_WEBFEED."\" /> </a>"; 
}

//** POPUP PLAYER BUTTON
//** Java script opens popmovie.php in a new window.
if ($showinfo[10] == 1) {
   $popbutton = "<span onClick= \"window.open('popmovie.php?lid=".$lid."','popmovie".$lid."','directories=no,toolbar=no,location=no,menubar=no');return false;\" style=\"cursor:hand;\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/popbutton.png\" alt=\"".$ltitle." "._MD_POPUP." "._MD_PLAYER."\" /></span>";
}else{
   $popbutton ="";  
}

//** TAGS
if($xoopsModuleConfig['tags']){
   if ($showinfo[11] == 1) {
      $itemid = $lid;
      $catid = 0; //$cid; NEEDS WORK
      include_once XOOPS_ROOT_PATH."/modules/tag/include/tagbar.php";
      $tagbar = tagBar($itemid, $catid);
      if($tagbar){
         $xoopsTpl->assign('tagbar',$tagbar);
         $metakey .= implode(' ',$tagbar["tags"]);
      }
   }
}

//** Body Text
$bodytext = $myts -> displayTarea( $bodytext, 1 );

// LINK ARRAY
$xoopsTpl->assign('link', array('id' => $lid, 'cid' => $cid, 'rating' => number_format($rating, 2), 'ltitle' => $ltitle, 'title' => $title, 'srctype'=> $srctype, 'listtype'=> $listtype, 'url'=> $url, 'category' => $path, 'listurl' => $listurl, 'infobox' => $infobox, 'description' => $description, 'artist' => $artist, 'album' => $album, 'label' => $label, 'logourl' => $logourl, 'hits' => $hits, 'votes' => $votestring, 'updated' => $updated, 'submitter' => $submitter, 'submittername' => $submittername, 'pagelink' => $pagelink, 'sitelink'=>$sitelink, 'sitebutton'=>$sitebutton, 'embed'=>$embed, 'embedjs'=>$embedjs, 'downlink' => $downlink, 'downbutton' => $downbutton, 'feedlink' => $feedlink, 'feedbutton' => $feedbutton, 'popbutton'=>$popbutton, 'bodytext' => $bodytext, 'adminlink' => $adminlink, 'modlink' => $modlink, 'comments' => $comments, 'mail_subject' => rawurlencode(sprintf(_MD_INTRESTLINK,$xoopsConfig['sitename'])), 'mail_body' => rawurlencode(sprintf(_MD_INTLINKFOUND,$xoopsConfig['sitename']).':  '.XOOPS_URL.'/modules/'.$xoopsModule->getVar("dirname").'/singlelink.php?lid='.$lid)));

//** Page Title Hack by Xoops-France & Herv Thouzard
$metatitle = $myts->makeTboxData4Show($ltitle)." ".$myts->makeTboxData4Show($xoopsModule->getVar('name'));
$xoopsTpl->assign('xoops_pagetitle',$metatitle); 
 
$metadesc = $myts->makeTboxData4Show($metadesc); //Uses entry description
include_once XOOPS_ROOT_PATH . '/modules/'.$xoopsModule->getVar('dirname').'/include/functions.php';

$metakey = webshow_extract_keywords($metatitle." ".$metakey." ".$metadesc);

if (is_object($xoTheme)) { 
    $xoTheme->addMeta( 'meta', 'keywords',$metakey);
    $xoTheme->addMeta( 'meta', 'description',$metadesc);     
    $xoTheme->addMeta( 'meta', 'title', $metatitle); 
} else { 
    $xoopsTpl->assign('xoops_meta_keywords',$metakey);
    $xoopsTpl->assign('xoops_meta_description',$metadesc);       
} 

include XOOPS_ROOT_PATH.'/include/comment_view.php';
include XOOPS_ROOT_PATH.'/footer.php';
?>