<?php
// $Id: topten.php,v.50 2007/03/01 19:59:00 tcnet Exp $ //

//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
// ------------------------------------------------------------------------- //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //
include "header.php";
$myts =& MyTextSanitizer::getInstance(); // MyTextSanitizer object
include_once XOOPS_ROOT_PATH."/class/xoopstree.php";
$mytree = new XoopsTree($xoopsDB->prefix("webshow_cat"),"cid","pid");
$xoopsOption['template_main'] = 'webshow_topten.html';
include XOOPS_ROOT_PATH."/header.php";
$content=""; //keyword string
//generates top 10 charts by rating and hits for each main category

if(!empty($_GET['rate'])){
	$sort = _MD_RATING;
	$sortDB = "rating";
}else{
	$sort = _MD_HITS;
	$sortDB = "hits";
}
$xoopsTpl->assign('lang_sortby' ,$sort);

$arr=array();
$result=$xoopsDB->query("select cid, cattitle from ".$xoopsDB->prefix("webshow_cat")." where pid=0");
$e = 0;
$rankings = array();
while(list($cid, $ctitle)=$xoopsDB->fetchRow($result)){
$content .= $ctitle." ";
//**Permissions
$groups = is_object($xoopsUser) ? $xoopsUser->getGroups() : XOOPS_GROUP_ANONYMOUS;
$gperm_handler =& xoops_gethandler('groupperm');
// example checkRight($gperm_name, $gperm_itemid, $gperm_groupid, $gperm_modid = 1)
if ($gperm_handler->checkRight('webshow_view', $cid, $groups, $xoopsModule->getVar('mid'))) {
	$rankings[$e]['title'] = sprintf(_MD_TOP10, $myts->htmlSpecialChars($ctitle));
	$query = "select lid, cid, title, hits, rating, votes, entryperm from ".$xoopsDB->prefix("webshow_links")." where status>0 and (cid=$cid";
	// get all child cat ids for a given cat id
	$arr=$mytree->getAllChildId($cid);
	$size = count($arr);
	for($i=0;$i<$size;$i++){
		$query .= " or cid=".$arr[$i]."";
	}
	$query .= ") order by ".$sortDB." DESC";
	$result2 = $xoopsDB->query($query,10,0);
	$rank = 1;
      $group = is_object($xoopsUser) ? $xoopsUser->getGroups() : array(XOOPS_GROUP_ANONYMOUS);	
	while(list($lid,$lcid,$ltitle,$hits,$rating,$votes,$ws_entryperm)=$xoopsDB->fetchRow($result2)){
	 //** Entry Permission
      $ws_entryperm = explode(" ",$ws_entryperm);
         if (count(array_intersect($group,$ws_entryperm)) > 0)
         {
		$catpath = $mytree->getPathFromId($lcid, "cattitle");
		$catpath= substr($catpath, 1);
		$catpath = str_replace("/"," <span class='fg2'>&raquo;</span> ",$catpath);
		$rankings[$e]['links'][] = array('id' => $lid, 'cid' => $cid, 'rank' => $rank, 'title' => $myts->htmlSpecialChars($ltitle), 'category' => $catpath, 'hits' => $hits, 'rating' => number_format($rating, 2), 'votes' => $votes);
		$content .= $ltitle;
		$rank++;
        }
	}
	$e++;
  }
}
$xoopsTpl->assign('rankings', $rankings);

//** META TAGS
//** Title
if(isset($_GET["hit"]) && intval($_GET["hit"])==1) {
$metatitle = $myts->makeTboxData4Show($xoopsModule->getVar('name') . ' ' . $myts->makeTboxData4Show(_MD_POPULAR));
}
if(isset($_GET["rate"]) && intval($_GET["rate"])==1) {
$metatitle = $myts->makeTboxData4Show($xoopsModule->name() . ' ' . $myts->makeTboxData4Show(_MD_TOPRATED));
}
$xoopsTpl->assign('xoops_pagetitle',$metatitle); 
// Description from module config description
$metadesc = $metatitle." ".$content." ".$myts->makeTareaData4Show($xoopsModuleConfig['moddesc'],0);
// Keywords
include_once XOOPS_ROOT_PATH . '/modules/'.$xoopsModule->getVar('dirname').'/include/functions.php';
$metakey = webshow_extract_keywords($metadesc);
//** Assign meta tags 
   if (is_object($xoTheme)) { 
    $xoTheme->addMeta( 'meta', 'keywords',$metakey);
    $xoTheme->addMeta( 'meta', 'description',$metadesc);     
    $xoTheme->addMeta( 'meta', 'title', $metatitle); 
    } else { 
    $xoopsTpl->assign('xoops_meta_keywords',$keywords);
    $xoopsTpl->assign('xoops_meta_description',$metadesc);       
    } 
    
include XOOPS_ROOT_PATH.'/footer.php';
?>
