<?php
// $Id: viewcat.php,v.50 2007/03/01 19:59:00 tcnet Exp $ //
// Flash Media Player by Jereon Wijering ( http://www.jeroenwijering.com ) is licensed under a Creative Commons License (http://creativecommons.org/licenses/by-nc-sa/2.0/) //
// It allows you to use and modify the script for noncommercial purposes. //
// You must share a like any modifications. // 
// For commercial use you must purchase a license from Jereon Wijering at http://www.jeroenwijering.com/?order=form. //
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
// ------------------------------------------------------------------------- //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //
include "header.php";
$xoopsOption['template_main'] = 'webshow_viewcat.html';
include XOOPS_ROOT_PATH."/header.php";
include_once XOOPS_ROOT_PATH."/class/xoopstree.php";
$myts =& MyTextSanitizer::getInstance(); // MyTextSanitizer object
$mytree = new XoopsTree($xoopsDB->prefix("webshow_cat"),"cid","pid");
$xoopsTpl->assign('ws_name', $xoopsModule->getVar('name'));
$metakey = "";//Collects keyword content
$cid = intval($_GET['cid']);

if($cid == ""){
redirect_header("javascript:history.go(-1)", 2, _MD_NOTEXIST);
}

//**Permissions
    $groups = is_object($xoopsUser) ? $xoopsUser->getGroups() : XOOPS_GROUP_ANONYMOUS;
    $gperm_handler =& xoops_gethandler('groupperm');
    // example checkRight($gperm_name, $gperm_itemid, $gperm_groupid, $gperm_modid = 1)
    if (!$gperm_handler->checkRight('webshow_view', $cid, $groups, $xoopsModule->getVar('mid'))) {
        redirect_header("javascript:history.go(-1)", 3, _NOPERM);
        exit();
    }

if (isset($_GET['show'])) {
        $show = intval($_GET['show']);
} else {
        $show = $xoopsModuleConfig['perpage'];
}
$min = isset($_GET['min']) ? intval($_GET['min']) : 0;
if (!isset($max)) {
        $max = $min + $show;
}
if(isset($_GET['orderby'])) {
   $orderby = convertorderbyin($_GET['orderby']);
} else {
    $orderby = "date DESC";
}

//** Category Select
ob_start();
//** Example makeMySelBox($title,$order="",$preset_id=0, $none=0, $sel_name="", $onchange="")	
$mytree->makeMySelBox("cattitle","cattitle",$cid,0,"cid", 'window.location="viewcat.php?cid="+this.value');	
$catselbox = ob_get_contents();	
ob_end_clean();
$xoopsTpl->assign('category_select', $catselbox);

//** Selected Category
$result=$xoopsDB->query("SELECT cid, cattitle, catdesc, imgurl FROM ".$xoopsDB->prefix("webshow_cat")." WHERE cid = $cid ");
list($cid, $cattitle, $catdesc, $imgurl) = $xoopsDB->fetchRow($result);

$catid = $myts->makeTboxData4Show($cid);
$xoopsTpl->assign('catid', $catid);
$cattitle = $myts->makeTboxData4Show($cattitle);
$xoopsTpl->assign('cattitle', $cattitle);
$catdesc = $myts->makeTareaData4Show($catdesc);
$xoopsTpl->assign('catdesc', $catdesc);
if ($imgurl && $imgurl != "") {
   $imgurl = $myts->makeTboxData4Show($imgurl);
   $category_image = "<img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/category/".$imgurl."\" border=\"0\" alt=\"".$cattitle."\" />";		
} else {
$category_image = "";
}

//** Path Links - Breadcrumb
$mainpath = "<a href=\"index.php\" title=\"".$xoopsModule->getVar('name')." "._MD_MAIN."\" /><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/home.png\" border=\"0\" alt=\""._MD_MAIN."\">" .$xoopsModule->getVar('name')."</a>:&nbsp;";
$xoopsTpl->assign('main_path', $mainpath);
$catpath = $category_image."<a href=\"viewcat.php?cid=".$cid."\" title=\"".$cattitle."\">".$cattitle."</a>:&nbsp;";
$xoopsTpl->assign('category_path', $catpath);

// get child category objects
$arr=array();
$arr=$mytree->getFirstChild($cid, "cattitle");
 if ( count($arr) > 0 ) {
    $scount = 1;
    foreach($arr as $ele){
      if ($gperm_handler->checkRight('webshow_view', $ele['cid'], $groups, $xoopsModule->getVar('mid'))) {    
		$sub_arr=array();
		$sub_arr=$mytree->getFirstChild($ele['cid'], "cattitle");
		$sub_arr=$mytree->getFirstChild($ele['cid'], "imgurl");
		$space = 0;
		$chcount = 0;
		$infercategories = "";
		foreach($sub_arr as $sub_ele){
               if ($gperm_handler->checkRight('webshow_view', $sub_ele['cid'], $groups, $xoopsModule->getVar('mid'))) {
			$chtitle=$myts->makeTboxData4Show($sub_ele['cattitle']);
			if ($chcount>5){
				$infercategories .= "...";
				break;
			}
			if ($space>0) {
				$infercategories .= "<br />";
			}
			$infercategories .= "----<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/viewcat.php?cid=".$sub_ele['cid']."\">".$chtitle."</a>";
			$space++;
			$chcount++;
		    }
		}
      $xoopsTpl->append('subcategories', array('cattitle' => $myts->makeTboxData4Show($ele['cattitle']), 'id' => $ele['cid'], 'imgurl'=> $myts->makeTboxData4Show($ele['imgurl']), 'infercategories' => $infercategories, 'totallinks' => getTotalItems($ele['cid'], 1), 'count' => $scount));
      $scount++;
      }
    }
 } 
//** Link Listing
$fullcountresult=$xoopsDB->query("select count(*) from ".$xoopsDB->prefix("webshow_links")." where cid=$cid and status>0");
list($numrows) = $xoopsDB->fetchRow($fullcountresult);
$page_nav = '';
if($numrows>0){
    $xoopsTpl->assign('show_links', true);
    //if 2 or more items in result, show the sort menu
    if($numrows>1) {
        $xoopsTpl->assign('show_nav', true);
        $orderbyTrans = convertorderbytrans($orderby);
        $xoopsTpl->assign('lang_cursortedby', sprintf(_MD_CURSORTEDBY, convertorderbytrans($orderby)));
    }
    
$sql = "select l.lid, l.cid, l.title, l.url, l.listurl, l.showinfo, l.srctype, l.listtype, l.listcache, l.logourl, l.submitter, l.status, l.date, l.hits, l.rating, l.votes, l.comments, l.entryperm, t.description from ".$xoopsDB->prefix("webshow_links")." l, ".$xoopsDB->prefix("webshow_text")." t where cid=$cid and l.lid=t.lid and status>0 order by $orderby";
$result=$xoopsDB->query($sql,$show,$min);
while(list($lid, $cid, $title, $url, $listurl, $showinfo, $srctype, $listtype, $listcache, $logourl, $submitter, $status, $time, $hits, $rating, $votes, $comments, $ws_entryperm, $description) = $xoopsDB->fetchRow($result)) {
   
 //** Entry Permission
 $group = is_object($xoopsUser) ? $xoopsUser->getGroups() : array(XOOPS_GROUP_ANONYMOUS);
 $ws_entryperm = explode(" ",$ws_entryperm);
 if (count(array_intersect($group,$ws_entryperm)) > 0)
 {
   
   //** ADMIN
   if ($xoopsUser && $xoopsUser->isAdmin($xoopsModule->mid())) {
      $isadmin = true;
      $adminlink = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/admin/index.php?op=modLink&amp;lid=".$lid."\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/editicon.gif\" border=\"0\" alt=\""._MD_EDITTHISLINK."\" /></a>";
   } else {
      $isadmin = false;
      $adminlink = "";
   }

   //** MODIFY ENTRY LINK. Display to admin and submitter only.
   if ($xoopsUser) {
   $user = $xoopsUser->getVar('uid');
      if ($user == $submitter | $isadmin) {
          $modlink = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/modlink.php?lid=".$lid."\" title=\""._MD_MODIFY."\">"._MD_MODIFY."<img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/modify.gif\" border=\"0\" alt=\""._MD_MODIFY."\" /></a>";  
      } else {
          $modlink = "";
      }
   }

   $ltitle = $myts->makeTboxData4Show($title);
   $new = newlinkgraphic($time, $status);
   $pop = popgraphic($hits);
   $title = $ltitle.$new.$pop;
   $title = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/singlelink.php?lid=".$lid."\" target=\"_self\" title=\""._MD_VIEWLISTING." - ".$ltitle."\">".$title."</a>";
   $url = $myts->makeTboxData4Show($url);
   $listurl = $myts->makeTboxData4Show($listurl);
   if($listtype == "dir") { 
     $listurl =  XOOPS_URL."/modules/".$xoopsModule->getVar("dirname")."/playlist/".$listcache;
   }

   $path = $mytree->getNicePathFromId($cid, "cattitle", "viewcat.php?");
   $path = substr($path, 1);
   $path = str_replace("/"," <img src='".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/arrow.gif' border='0' alt=''> ",$path);

   //** SHOWINFO  Displays selected information.
   //$showinfo = explode("|",$showinfo);
   
   //** INFORMATION BOX OFF
   // From singlelink.php
   //$infobox = 1;
   //if ($showinfo[0] != 1) {
   //   $infobox="";
   //}

   //** Block Description
   $description = $myts->makeTareaData4Show($description,0);
   $metadesc = strip_tags($description);
   if(!$showinfo[1]){
      $description = "";
   }

   //** ENTRY LOGO
   if($showinfo[2] == 1 & $logourl != ""){
      $ps = strpos($logourl,"http://");
      if($ps === false) {
         $logourl = XOOPS_URL."/".$xoopsModuleConfig['path_logo']."/".$logourl;
      }
      $logourl = $myts->makeTboxData4Show($logourl);
   }else{
   $logourl = "";
   }

   //** CREDITS (C) //Needs work for enablejs
   if($showinfo[3] == 1){
     //** Javascript enabled.  If enablejs is true in movie.php then include/mplayjs.inc.php.  Replaces credits from db with credits from xml playlist.
     if($mplayjs !="") {
        $xoopsTpl->assign('mplayjs',$mplayjs);
     }else{
        $artist = $myts->makeTboxData4Show($artist);
        $album = $myts->makeTboxData4Show($album);
        $label = $myts->makeTboxData4Show($label);
     }
   }else{
     $artist = "";
     $album = "";
     $label = "";
   } 

   //STATISTICS
   if($showinfo[4] == 1){
   $updated = formatTimestamp($time,"m");
      if ($votes == 1) {
           $votestring = _MD_ONEVOTE;
      } else {
           $votestring = sprintf(_MD_NUMVOTES,$votes);
      } 
   }else{
   $hits = "";
   $votestring = "";
   $updated = "";
   }

   //** SUBMITTER
   $submittername = "";
   if($showinfo[5] == 1){
      $submittername = xoops_getLinkedUnameFromId($submitter);
   }

   //** PAGE LINK
   $pagelink = "";
   if($showinfo[6] == 1){
      $pagelink = 1;
   }

   //** WEB SITE LINK & BUTTON
   $sitelink = "";
   $sitebutton = "";
   if($showinfo[7] == 1 &&$url !="" ){
      $sitelink = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/visit.php?cid=".$cid."&amp;lid=".$lid."\" target=\"_blank\" title=\""._MD_VISIT." "._MD_WEBSITE.": ".$url."\">"._MD_WEBSITE."</a>";
      $sitebutton = "<a href=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/visit.php?cid=".$cid."&amp;lid=".$lid."\" target=\"_blank\" title=\""._MD_VISIT." "._MD_WEBSITE.": ".$url."\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/link.gif\" border=\"0\" alt=\""._MD_VISIT." "._MD_WEBSITE." ".$url."\"> </a>";
   }

   //** EMBED LINK BOX
   //if $listurl is from this domain, show embed link
   // Disabled.  Only used in singlelink.php atm.
//   $embed = "";
//   if($showinfo[8] == 1){
 //     $ps = strpos(strtolower($listurl), XOOPS_URL); //Embed link for local media only.
 //     if (!($ps === false)) {  
 //        $embed = "&lt;embed src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar("dirname")."/mediaplayer.swf\" width=\"".$width."\" height=\"".$height."\" type=\"application/x-shockwave-flash\" pluginspage=\"http://www.macromedia.com/go/getflashplayer\" flashvars=\"file=".$listurl."&displayheight=".$displayheight."\" /&gt;";
//      }
//   }
   
   //** DOWNLOAD LINK AND BUTTON.  For single file entry only.  Other entries use web feed link and button instead.
   $downlink = "";
   $downbutton = "";
   if($showinfo[9] == 1){
   //** Download Permission
   $groups = is_object($xoopsUser) ? $xoopsUser->getGroups() : XOOPS_GROUP_ANONYMOUS;
   $gperm_handler =& xoops_gethandler('groupperm');
      if ($gperm_handler->checkRight('webshow_download', $cid, $groups, $xoopsModule->getVar('mid'))) {    
         if($listtype == "single"){
            //** Allowed file extensions
            $allowext = " mp3 | jpg | gif | png | swf | flv";
            $ext = strToLower(substr($listurl,strlen($listurl)-3, 3));
            $extok = strpos($allowext,$ext);
            if($extok != ""){
               $downlink = "<a href=\"#\" title=\"".$ltitle." "._MD_DOWNLOAD."\" onClick= \"location='".XOOPS_URL."/modules/".$xoopsModule->getVar("dirname")."wsdwnlod.php?lid=".$lid."'\">"._MD_DOWNLOAD."</a>";
               $downbutton = "<a href=\"#\" title=\"".$ltitle." "._MD_DOWNLOAD."\" onClick= \"location='".XOOPS_URL."/modules/".$xoopsModule->getVar("dirname")."wsdwnlod.php?lid=".$lid."'\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/download.png\" border=\"0\" alt=\"".$ltitle." "._MD_DOWNLOAD."\" /> </a>"; 
            }
         } 
      }
   }
       
   //** WEB FEED LINK & BUTTON
   $feedlink = "";
   $feedbutton = "";
   if($showinfo[9] == 1 && $listtype != "single") {
     $feedlink = "<a href=\"".$listurl."\" target=\"_blank\" title=\"".$ltitle." "._MD_WEBFEED."\">"._MD_WEBFEED."</a>"; 
     $feedbutton = "<a href=\"".$listurl."\" target=\"_blank\" title=\"".$ltitle." "._MD_WEBFEED."\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/webfeed.png\" border=\"0\" alt=\"".$ltitle." "._MD_WEBFEED."\" /> </a>"; 
   }

   //** POPUP PLAYER BUTTON
   //** Java script opens popmovie.php in a new window.
   if ($showinfo[10] == 1) {
      $popbutton = "<span onClick= \"window.open('popmovie.php?lid=".$lid."','popmovie".$lid."','directories=no,toolbar=no,location=no,menubar=no');return false;\" style=\"cursor:hand;\"><img src=\"".XOOPS_URL."/modules/".$xoopsModule->getVar('dirname')."/images/popbutton.png\" alt=\"".$ltitle." "._MD_POPUP." "._MD_PLAYER."\" /></span>";
   }else{
      $popbutton ="";  
   }

   //** TAGS disabled used in singlelink view.
  // if($xoopsModuleConfig['tags']){
  //    if ($showinfo[11] == 1) {
  //       $itemid = $lid;
  //       include_once XOOPS_ROOT_PATH."/modules/tag/include/tagbar.php";
   //      $tagbar = tagBar($itemid, $catid = 0);
    //     $xoopsTpl->assign('tagbar',$tagbar);
    //  }
   //}

   $xoopsTpl->append('links', array('id' => $lid, 'cid' => $cid, 'rating' => number_format($rating, 2), 'ltitle' => $ltitle, 'title' => $title, 'category' => $path, 'url' => $url, 'listurl' => $listurl, 'srctype' =>$srctype, 'logourl' => $logourl, 'popbutton' => $popbutton, 'sitelink' => $sitelink, 'sitebutton' => $sitebutton, 'downlink' => $downlink, 'downbutton' => $downbutton, 'feedlink' => $feedlink, 'feedbutton' => $feedbutton, 'updated' => $updated, 'description' => $description, 'adminlink' => $adminlink, 'hits' => $hits, 'comments' => $comments, 'votes' => $votestring, 'mail_subject' => rawurlencode(sprintf(_MD_INTRESTLINK,$xoopsConfig['sitename'])), 'mail_body' => rawurlencode(sprintf(_MD_INTLINKFOUND,$xoopsConfig['sitename']).':  '.XOOPS_URL.'/modules/'.$xoopsModule->getVar("dirname").'/singlelink.php?cid='.$cid.'&amp;lid='.$lid)));      
   $metakey .= $ltitle." ".$description." ";
 }
}

    $orderby = convertorderbyout($orderby);
    //Calculates how many pages exist.  Which page one should be on, etc...
    $linkpages = ceil($numrows / $show);
    //Page Numbering
    if ($linkpages!=1 && $linkpages!=0) {
		$cid = intval($_GET['cid']);
    		$xoopsTpl->assign('lang_pagenav',_MD_PAGENAV);			
        $prev = $min - $show;
        if ($prev>=0) {
            $page_nav .= "<a href='viewcat.php?cid=$cid&amp;min=$prev&amp;orderby=$orderby&amp;show=$show'><b><u>&laquo;</u></b></a>&nbsp;";
        }
        $counter = 1;
        $currentpage = ($max / $show);
        while ( $counter<=$linkpages ) {
            $mintemp = ($show * $counter) - $show;
            if ($counter == $currentpage) {
                $page_nav .= "<b>($counter)</b>&nbsp;";
            } else {
                $page_nav .= "<a href='viewcat.php?cid=$cid&amp;min=$mintemp&amp;orderby=$orderby&amp;show=$show'>$counter</a>&nbsp;";
            }
            $counter++;
        }
        if ( $numrows>$max ) {
            $page_nav .= "<a href='viewcat.php?cid=$cid&amp;min=$max&amp;orderby=$orderby&amp;show=$show'>";
            $page_nav .= "<b><u>&raquo;</u></b></a>";
        }
    }
}
$xoopsTpl->assign('page_nav', $page_nav);

//** METATAGS
// Page Title by Xoops-France & Herv Thouzard
$metatitle = $cattitle." ".$myts->makeTboxData4Show($xoopsModule->getVar('name'));
$xoopsTpl->assign('xoops_pagetitle',$metatitle); 
// Meta Description from category description
$metadesc = strip_tags($catdesc);
$metadesc = $myts->makeTboxData4Show($metadesc);
// Meta Keywords
include_once XOOPS_ROOT_PATH . '/modules/'.$xoopsModule->getVar('dirname').'/include/functions.php';
$metakey = webshow_extract_keywords($metatitle." ".$metadesc." ".$metakey);
//** Assign meta tags 
   if (is_object($xoTheme)) { 
    $xoTheme->addMeta( 'meta', 'keywords',$metakey);
    $xoTheme->addMeta( 'meta', 'description',$metadesc);     
    $xoTheme->addMeta( 'meta', 'title', $metatitle); 
    } else { 
    $xoopsTpl->assign('xoops_meta_keywords',$metakey);
    $xoopsTpl->assign('xoops_meta_description',$metadesc);       
    } 

include XOOPS_ROOT_PATH.'/footer.php';
?>