<?php
// $Id: wsdownlod.php, WebShow v.57 2007/06/24 19:59:00 tcnet Exp $ //
// Flash Media Player by Jereon Wijering ( http://www.jeroenwijering.com ) is licensed under a Creative Commons License (http://creativecommons.org/licenses/by-nc-sa/2.0/) //
// It allows you to use and modify the script for noncommercial purposes. //
// You must share a like any modifications. // 
// For commercial use you must purchase a license from Jereon Wijering at http://www.jeroenwijering.com/?order=form. //
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //
/*
WebShow Downloader 
*/
include "header.php";
include XOOPS_ROOT_PATH."/header.php";

$myts = & MyTextSanitizer :: getInstance(); // MyTextSanitizer object
if ( file_exists("language/".$xoopsConfig['language']."/main.php") ) {
	include "language/".$xoopsConfig['language']."/main.php";
} else {
	include "language/english/main.php";
}
global $xoopsUser, $xoopsModuleConfig, $myts;
if(!isset($_POST['lid'])) {
	$lid = isset($_GET['lid']) ? intval($_GET['lid']) : ' ';
} else {
	$lid = intval($_POST['lid']);
}
$result = $xoopsDB->query("select cid, listurl, listtype, status, entryperm from ".$xoopsDB->prefix("webshow_links")." where lid=$lid ");
list($cid, $listurl, $listtype, $status, $ws_entryperm) = $xoopsDB->fetchRow($result);
if ($lid == "" || $status <= 0 || $cid == 0) {
  redirect_header("javascript:history.go(-1)", 2,_MD_NOTEXIST);  
}

//* Permissions
$groups = is_object($xoopsUser) ? $xoopsUser->getGroups() : XOOPS_GROUP_ANONYMOUS;
$gperm_handler =& xoops_gethandler('groupperm');
// example checkRight($gperm_name, $gperm_itemid, $gperm_groupid, $gperm_modid = 1)
if (!$gperm_handler->checkRight('webshow_download', $cid, $groups, $xoopsModule->getVar('mid'))) {
   redirect_header("javascript:history.go(-1)",3, _NOPERM);
   exit();
}

//** Entry Permission
$group = is_object($xoopsUser) ? $xoopsUser->getGroups() : array(XOOPS_GROUP_ANONYMOUS);
$ws_entryperm = explode(" ",$ws_entryperm);
if (count(array_intersect($group,$ws_entryperm)) < 1)
{
        redirect_header("javascript:history.go(-1)",3, _NOPERM);
        exit();
}

if($listtype != "single") {
 redirect_header("javascript:history.go(-1)",2,_MD_REQUESTDENIED);  
}
//** Allowed file extensions
$ext = strToLower(substr($listurl,strlen($listurl)-3, 3));
if ($ext == "mp3" ) { $ctype = "audio/x-mp3"; } 
else if ($ext == "jpg") { $ctype = "image/jpeg"; }
else if ($ext == "gif") { $ctype = "image/gif"; }
else if ($ext == "png") { $ctype = "image/png"; }
else if ($ext == "swf") { $ctype = "application/x-shockwave-flash"; }
else if ($ext == "flv") { $ctype = "video/flv"; }
else { redirect_header("javascript:history.go(-1)",2,_MD_REQUESTDENIED);  }
if(ini_get('zlib.output_compression')){
ini_set('zlib.output_compression', 'Off');
}
header("Pragma: public"); 
header("Expires: 0"); 
header("Cache-Control: must-revalidate, post-check=0, pre-check=0"); 
header("Cache-Control: private",false); 
header("Content-Type: $ctype"); 
header("Content-Disposition: attachment; filename=\"".basename($listurl)."\";"); 
header("Content-Transfer-Encoding: binary"); 
//header("Content-Length: ".filesize($listurl)); // Needs work causes error
set_time_limit(0); 
readfile("$listurl") or redirect_header("javascript:history.go(-1)",2,_MD_NOTEXIST);
exit();
include XOOPS_ROOT_PATH.'/footer.php';
?>